Package: bioCancer
Title: Interactive Multi-Omics Cancers Data Visualization and Analysis
Version: 1.41.0
Date: 2024-02-14
Authors@R: person("Karim", "Mezhoud", role=c("aut", "cre"), email="kmezhoud@gmail.com")
Description: This package is a Shiny App to visualize and analyse interactively
    Multi-Assays of Cancer Genomic Data.
Depends: R (>= 4.1.0), radiant.data (>= 0.9.1), cBioPortalData, XML (>=
        3.98)
Imports: R.oo, R.methodsS3, DT (>= 0.3), dplyr (>= 0.7.2), tidyr, shiny
        (>= 1.0.5), AlgDesign (>= 1.1.7.3), import (>= 1.1.0), methods,
        AnnotationDbi, shinythemes, Biobase, geNetClassifier,
        org.Hs.eg.db, org.Bt.eg.db, DOSE, clusterProfiler, reactome.db,
        ReactomePA, DiagrammeR(<= 1.01), visNetwork, htmlwidgets, plyr,
        tibble, GO.db
Suggests: BiocStyle, prettydoc, rmarkdown, knitr, testthat (>= 0.10.0)
VignetteBuilder: knitr
URL: https://kmezhoud.github.io/bioCancer/
BugReports: https://github.com/kmezhoud/bioCancer/issues
License: AGPL-3 | file LICENSE
LazyData: true
biocViews: GUI, DataRepresentation, Network, MultipleComparison,
        Pathways, Reactome, Visualization,GeneExpression,GeneTarget
RoxygenNote: 7.3.1
Encoding: UTF-8
git_url: https://git.bioconductor.org/packages/bioCancer
git_branch: devel
git_last_commit: adaad4e
git_last_commit_date: 2026-04-28
Repository: Bioconductor 3.24
Date/Publication: 2026-04-28
NeedsCompilation: no
Packaged: 2026-04-28 21:30:18 UTC; biocbuild
Author: Karim Mezhoud [aut, cre]
Maintainer: Karim Mezhoud <kmezhoud@gmail.com>

# bioCancer - Interactive Multi-OMICS Cancers Data Visualization and Analysis

[![Travis-CI Build Status](https://travis-ci.org/kmezhoud/bioCancer.svg?branch=master)](https://travis-ci.org/kmezhoud/bioCancer)
[![releaseVersion](https://img.shields.io/badge/release%20version-3.2.11-green.svg?style=flat)](https://bioconductor.org/packages/bioCancer) [![develVersion](https://img.shields.io/badge/devel%20version-3.3.6-green.svg?style=flat)](https://github.com/bioCancer)
[![Bioc](http://www.bioconductor.org/shields/years-in-bioc/bioCancer.svg)](https://www.bioconductor.org/packages/devel/bioc/html/bioCancer.html#since)
[![total](https://img.shields.io/badge/downloads-1594/total-blue.svg?style=flat)](https://bioconductor.org/packages/stats/bioc/bioCancer)
<!--[![Coverage Status](https://img.shields.io/coveralls/kmezhoud/bioCancer.svg)](https://coveralls.io/r/kmezhoud/bioCancer?branch=master) -->


[bioCancer](
http://kmezhoud.github.io/bioCancer/
) is a browser-based interface for Cancer Genomics Data analysis and visualization developped by [R](http://www.r-project.org/), and based on the [Shiny](http://www.rstudio.com/shiny/) package. Example of bioCancer server is hosted at http://46.101.227.???:3838/bioCancer/

#### Interactivities

bioCancer is listening user setting. Results are updated immediately when inputs are changed (i.e., no separate dialog boxes).

#### Context

bioCancer focuses on Cancer Genomics data visualisation and Genes Classifications.

## Circomics: Pull User genetic profiles with existing Cancer studies

<img src="./inst/extdata/Circomics_demo.gif">
<!--
It is inspired from [radiant](https://github.com/vnijs/radiant) developed by <a href="http://rady.ucsd.edu/faculty/directory/nijs/" target="\_blank">Dr. Vincent Nijs</a>. 
-->

## Preprocessing and Plotting

<img src="./inst/extdata/S3Video2.gif">


## Genes Classification and Biological terms Clustering

<img src="./inst/extdata/S4Video3.gif">


## Network modeling example
<!--
![Network modeling](./inst/extradata/imgs/demoReactome.gif)
-->
<img src="./inst/extdata/S5Video4.gif">

<!--
## Key features

- Explore: Quickly and easily summarize, visualize, and analyze your data
- Cross-platform: It runs in a browser on Windows, Mac, and Linux
- Reproducible: Recreate results and share work with others as a state file or an [Rmarkdown](http://rmarkdown.rstudio.com/) report
- Programming: Integrate bioCancer's analysis functions into your own R-code
- Context: Data and examples focus on business applications

<iframe width="640" height="375" src="https://www.youtube.com/embed/ioHopyfD2f0" frameborder="0" allowfullscreen></iframe>
-->

<!--
#### Reproducible

Simply saving output is not enough. You need the ability to recreate results for the same data and/or when new data become available. Moreover, others may want to review your analysis and results. Save and load the state of the application to continue your work at a later time or on another computer. Share state files with others and create reproducible reports using [Rmarkdown](http://rmarkdown.rstudio.com/). See also the section on `Saving and loading state` below
-->

<!--
#### Programming

Although bioCancer's web-interface can Processing quite a few data and analysis tasks, at times you may prefer to write your own code. bioCancer provides a bridge to programming in R(studio) by exporting the functions used for analysis. For more information about programming, see Radiant [programming](http://vnijs.github.io/radiant/programming.html) page on the documentation site.
-->



## How to install bioCancer


- Required: [R](http://cran.rstudio.com/) version 3.2 or later
- Required: A modern browser (e.g., [Chrome](https://www.google.com/intl/en/chrome/browser/desktop/) or Safari). Internet Explorer (version 11 or higher) should work as well
- Recommended: [Rstudio](http://www.rstudio.com/products/rstudio/download/)

bioCancer courant release:
```r
 if (!requireNamespace("BiocManager", quietly=TRUE))
     install.packages("BiocManager")
 BiocManager::install("bioCancer")
```

bioCancer is under development:
```r
 devtools::install_github("kmezhoud/bioCancer")
 library("bioCancer")
```


When bioCancer starts you will see a table of available Cancer Studies.  To close the application click on `Quit` in the Navigation bar and then click the `Quit` button on the left of the screen. The bioCancer process will stop and the browser window will close (or gray-out).



## Documentation


Documentation and tutorials are available in the bioCancer web interface (the `?` icons and the `Help` menu).

<!--
## Saving and loading state from bioCancer
To save your analyses save the state of the app to a file by clicking on the <i title='Save' class='fa fa-save'></i> icon in the navbar and then on `Save state` (see also the `Data > Processing > Manage` tab). You can open this state file at a later time or on another computer to continue where you left off. You can also share the file with others that may want to replicate your analyses. As an example, load the state_file [`example.rda`](https://github.com/vnijs/radiant/blob/master/inst/examples/RadiantState.rda?raw=true) through the Data > Manage tab. Go to `Processing > View`, `Processing > Visualize` to see some of the settings. There is also a report in `R > Report` that was created using the bioCancer interface. The html file [`ExampleState.html`](https://github.com/vnijs/radiant/blob/master/inst/examples/RadiantState.html?raw=true) contains the output.


Loading and saving state also works with Rstudio. If you start bioCancer from Rstudio and use <i title='Power off' class='fa fa-power-off'></i> > `Stop` to stop the app, lists called `r_data` and `r_state` will be put into Rstudio's global workspace. If you start bioCancer again using `bioCancer()` it will use these lists to restore state. This can be convenient if you want to make changes to a data file in Rstudio and load it back into bioCancer. Also, if you load a state file directly into Rstudio it will be used when you start bioCancer to recreate a previous state.

```r
numericInput("sm_comp_value", "Comparison value:", state_init('sm_comp_value',sm_args$comp_value))
```
-->
## Acknowledgment


bioCancer is a collaborative work . Processing panel is adapted from [radiant](https://github.com/vnijs/radiant). I would like to thank <a href="http://rady.ucsd.edu/faculty/directory/nijs/" target="\_blank"> Dr. Vincent Nijs</a> for sharing his work for R community.

<!--
## License

bioCancer is licensed under the <a href="http://www.tldrlegal.com/l/AGPL3" target="\_blank">AGPLv3</a>. The documentation and videos on this site and the bioCancer help files are licensed under the creative commons attribution, non-commercial, share-alike license <a href="http://creativecommons.org/licenses/by-nc-sa/4.0/" target="_blank">CC-NC-SA</a>.

As a summary, the AGPLv3 license requires, attribution, including copyright and license information in copies of the software, stating changes if the code is modified, and disclosure of all source code.

-->

#' get Edges dataframe for Gene/Disease association from geNetClassifier
#'
#' @return A data frame with egdes attributes
#' @export
#'
#' @usage Edges_Diseases_obj(genesclassdetails)
#' @param genesclassdetails  a dataframe from geNetClassifier
#'
#' @examples
#' GenesClassDetails <- structure(list(Genes = c("FANCF", "MLH1", "MSH2", "ATR", "PARP1",
#' "CHEK2", "RAD51"), ranking = c(1L, 1L, 1L, 2L, 3L, 1L, 2L), class = c("brca_tcga",
#' "gbm_tcga", "lihc_tcga", "lihc_tcga", "lihc_tcga", "lusc_tcga",
#' "lusc_tcga"), postProb = c(1, 0.99, 1, 0.99, 0.99, 1,
#' 0.98), exprsMeanDiff = c(180, 256, -373, -268,
#' -1482, 258, 143), exprsUpDw = c("UP", "UP", "DOWN",
#' "DOWN", "DOWN", "UP", "UP")), .Names = c("Genes", "ranking",
#' "class", "postProb", "exprsMeanDiff", "exprsUpDw"),
#' class = "data.frame", row.names = c(NA,-7L))
#'
#' Ed_Diseases_obj <- Edges_Diseases_obj(genesclassdetails=GenesClassDetails)
#'
Edges_Diseases_obj <- function(genesclassdetails){

  Ed_Diseases_obj <- data.frame(from = genesclassdetails$class,
                                to= genesclassdetails$Genes,
                                title="GDA",
                                arrows="to",
                                width= 0.3,
                                dashes=TRUE,
                                smooth=FALSE,
                                shadow=FALSE
                                #length= NULL
  )
  return(Ed_Diseases_obj)
}


#' Attributes shape to Nodes
#'
#' @return A data frame with egdes attributes
#' @export
#' @usage attriShape2Node(gene, genelist)
#' @param gene symbol "TP53"
#' @param genelist a vector of gene symbol
#'
#' @examples
#' GeneList <- c("DKK3" , "NBN"  , "MYO6" , "TP53" , "PML"  , "IFI16" ,"BRCA1")
#' NodeShape <- attriShape2Gene("DKK3", GeneList)
#'
attriShape2Node <- function(gene, genelist){

  if(gene %in% genelist){
    paste0("circle")
  }else{
    paste0("box")
  }

}

#' Attributes size to Nodes depending on number of interaction
#'
#' @return A data frame with nodes size attributes
#' @export
#'
#' @usage Node_df_FreqIn(genelist, freqIn)
#' @param genelist a vector of genes
#' @param freqIn dataframe with Node interaction frequencies
#'
#' @examples
#' Node_df_FreqIn
#' \dontrun{
#' r_data <- new.env()
#' r_data[["FreqIn"]] <- structure(list(Genes = c("ATM", "ATR", "BRCA1", "BRCA2", "CHEK1",
#' "CHEK2", "FANCF", "MDC1", "RAD51"), FreqSum = c(0.04, 0.05, 0.05,
#'  0.03, 0.05, 0.04, 0.03, 0.03, 0.02)), .Names = c("Genes", "FreqSum"),
#'  class = "data.frame", row.names = c(NA, -9L))
#' GeneList <- whichGeneList("DNA_damage_Response")
#' node_df <- Node_df_FreqIn(GeneList, r_data$FreqIn)
#'}
Node_df_FreqIn <- function(genelist, freqIn){

  FreqIn <- freqIn
  #FreqIn[["shape"]]<- unname(sapply(FreqIn$Genes,  function(x) attriShape2Node(x, genelist)))
  FreqIn$FreqSum  <- freqIn$FreqSum/10
  #names(FreqIn) <- c("id", "value","shape")
  names(FreqIn) <- c("id", "value")
  #FreqIn[["label"]] <- FreqIn$id
  GeneFreq <- FreqIn[,2]
  return(GeneFreq)

}

#' Attributes color and shape to Nodes of Diseases
#'
#' @return A data frame with nodes Shapes and colors
#' @export
#'
#' @usage Node_Diseases_obj(genesclassdetails)
#' @param genesclassdetails  a dataframe from geNetClassifier function
#'
#' @examples
#' GenesClassDetails <- structure(list(Genes = c("FANCF", "MLH1", "MSH2", "ATR", "PARP1",
#' "CHEK2", "RAD51"), ranking = c(1L, 1L, 1L, 2L, 3L, 1L, 2L), class = c("brca_tcga",
#' "gbm_tcga", "lihc_tcga", "lihc_tcga", "lihc_tcga", "lusc_tcga",
#' "lusc_tcga"), postProb = c(1, 0.99, 1, 0.99, 0.99, 1,
#' 0.98), exprsMeanDiff = c(180, 256, -373, -268,
#' -1482, 258, 143), exprsUpDw = c("UP", "UP", "DOWN",
#' "DOWN", "DOWN", "UP", "UP")), .Names = c("Genes", "ranking",
#' "class", "postProb", "exprsMeanDiff", "exprsUpDw"),
#' class = "data.frame", row.names = c(NA,-7L))
#' Node_Diseases_df <- Node_Diseases_obj(genesclassdetails= GenesClassDetails)
#'
Node_Diseases_obj <- function(genesclassdetails){
  if(is.null(genesclassdetails)){
    msgNoClassifier <- paste("Gene Classes Details is not found, please run gene Classifier before...")
    stop(msgNoClassifier)
  }else{
    V <- as.numeric(factor(genesclassdetails[,3]))
    set.seed(17)
    C <- sample(colors(),length(unique(genesclassdetails[,3])))
    C <- gsub('[0-9]+', '', C)
    Node_Diseases_df <- data.frame(id= unique(genesclassdetails[,3]),
                                   shape= "ellipse",
                                   label=unique(genesclassdetails[,3]),
                                   color=unique(C[V]),
                                   value="0.5"
    )
    return(Node_Diseases_df)

  }
}

output$coffeewheels <- renderUI({

  tagList(
    #                        if('CNA' %in% input$CircosDimensionID ){
    #                          plot_downloader("SaveMetabologram_CNA", pre = "")},
    #
    if('CNA' %in% input$CircosDimensionID ){
      tagList(
        div(class="row",
            div(class="col-xs-6",
                DT::dataTableOutput(outputId = "Sequenced_SampleSize")),
            div(class="col-xs-6",
                DT::dataTableOutput(outputId = "CNA_Max"))
        ),
        tagList(
          actionButton("saveCircosCNA", "Save as png", style='padding:4px; font-size:80%'),
          column(12, align="center",
                 coffeewheelOutput('getCoffeeWheel_CNA', width = 600, height = 600)
          ))
      )
    },
    # if('Methylation' %in% input$CircosDimensionID ){
    #   plot_downloader("SaveMetabologram_Met", pre = "")
    # },
    if('Methylation' %in% input$CircosDimensionID ){
      tagList(
        div(class="row",
            div(class="col-xs-6",
                DT::dataTableOutput(outputId = "Sequenced_SampleSize")),
            div(class="col-xs-6",
                DT::dataTableOutput(outputId = "Methylation_mean"))
        ),
        tagList(
          actionButton("saveCircosMet", "Save as png", style='padding:4px; font-size:80%'),
          #  h3("Correlation of silencing gene by Methylation: (0:1)")
          column(12, align="center",
                 coffeewheelOutput('getCoffeeWheel_Met', width = 600, height = 600)
          ))
      )
    },
    #                        if('mRNA' %in% input$CircosDimensionID ){
    #                          plot_downloader("SaveMetabologram_mRNA", pre = "")
    #                        },
    if('mRNA' %in% input$CircosDimensionID ){
      tagList(
        div(class="row",
            div(class="col-xs-6",
                DT::dataTableOutput(outputId = "Sequenced_SampleSize")),
            div(class="col-xs-6",
                DT::dataTableOutput(outputId = "mRNA_mean"))
        ),
        tagList(
          actionButton("saveCircosMRNA", "Save as png", style='padding:4px; font-size:80%'),
          #h3("Gene Expression"),
          column(12, align="center",
                 coffeewheelOutput('getCoffeeWheel_mRNA', width = 600, height = 600)
          ))
      )
    },
    #                        if('Mutation' %in% input$CircosDimensionID ){
    #                          plot_downloader("SaveMetabologram_Mut", pre = "")
    #                        },
    if('Mutation' %in% input$CircosDimensionID ){

      tagList(

        div(class="row",
            div(class="col-xs-6",
                DT::dataTableOutput(outputId = "Sequenced_SampleSize")),
            div(class="col-xs-6",
                DT::dataTableOutput(outputId = "FreqMutSummary"))
        ),


        h3(paste0("Mutation Percentage: (Min = ", suppressWarnings(min(r_info$Freq_DfMutData, na.rm = TRUE)) ,
                  "%, Max = ", suppressWarnings(max(r_info$Freq_DfMutData, na.rm = TRUE))  ,"%)", sep=""),  align="center"),
        tagList(
          actionButton("saveCircosMut", "Save as png", style='padding:4px; font-size:80%'),

          column(12, align="center",
                 coffeewheelOutput('getCoffeeWheel_Mut', width = 600, height = 600)
          ))
      )
    },
    #                        if('miRNA' %in% input$CircosDimensionID ){
    #                          plot_downloader("SaveMetabologram_miRNA", pre = "")
    #                        },

    if('miRNA' %in% input$CircosDimensionID ){
      tagList(
        actionButton("saveCircosMiRNA", "Save as png", style='padding:4px; font-size:80%'),
        #h3("Protein phosphorylation:")
        column(12, align="center",
               coffeewheelOutput('getCoffeeWheel_miRNA', width = 600, height = 600)
        ))
    },
    #                        if('RPPA' %in% input$CircosDimensionID ){
    #                          plot_downloader("SaveMetabologram_RPPA", pre = "")
    #                        },

    if('RPPA' %in% input$CircosDimensionID ){
      tagList(
        actionButton("saveCircosRPPA", "Save as png", style='padding:4px; font-size:80%'),
        #h3("Protein phosphorylation:")
        column(12, align="center",
               coffeewheelOutput('getCoffeeWheel_RPPA', width = 600, height = 600)
        )
      )
    },
    # if('All' %in% input$CircosDimensionID ){
    #   plot_downloader("SaveMetabologram_All", pre = "")
    # },
    if('All' %in% input$CircosDimensionID ){
      tagList(
        actionButton("saveCircosAll", "Save as png", style='padding:4px; font-size:80%'),
        #h3("Profiles Data: CNA, Exp, RPPA, miRNA: (Up, Down)")
        column(12, align="center",
               #downloadLink("dl_metabologram_All"),
               #plot_downloader("dl_metabologram_All", pre = ""),
               coffeewheelOutput('getCoffeeWheel_All', width = 800, height = 800)
        )
      )
    }
  )
})

output$Enrichment <- renderUI({
  tagList(
    includeCSS(file.path(getOption("radiant.path.bioCancer"),"app/www/switchButton.css")),
    includeCSS(file.path(getOption("radiant.path.bioCancer"),"app/www/style.css")),
    sidebarLayout(
      sidebarPanel(

        selectizeInput("GeneListIDEnrichment", "Gene List:", input$GeneListID),

        conditionalPanel("input.tabs_Enrichment == 'Circomics'",
                         uiOutput("ui_Circomics")),
        conditionalPanel("input.tabs_Enrichment == 'Classifier'",
                         uiOutput("ui_Classifier")),
        conditionalPanel("input.tabs_Enrichment == 'Networking'",
                         uiOutput("ui_Reactome"))

      ),
      mainPanel(
        tabsetPanel(id = "tabs_Enrichment",

                    tabPanel("Circomics",
                            # tags$hr(),

                             uiOutput('coffeewheels'),
                             conditionalPanel("input.CircosDimensionID == 'All'",
                                              column(12, align="center",

                                                     metabologramOutput('metabologram_All'))
                             ),

                             conditionalPanel(condition = "input.loadListProfDataCircosId == true",# && input.CircosDimensionID == null ",
                                              h3("Profiles Data Information", align="center"),
                                              verbatimTextOutput("StrListProfDataCircos")

                             ),
                             conditionalPanel(condition = "input.ViewProfDataCircosID==true",
                                              h3("Available Profiles data in select Studies", align="center"),
                                              DT::dataTableOutput(outputId ="CircosAvailability")
                             ),
                             conditionalPanel("input.loadListProfDataCircosId==false",
                                              verbatimTextOutput("CircomicsHowto")
                             )

                    ),

                    #               tabPanel("Network",
                    #                        h3("Simple Network"),
                    #                        networkD3::simpleNetworkOutput("simpleNetwork"),
                    #                        h3("Forced Network"),
                    #                        networkD3::forceNetworkOutput("forceNetwork")
                    #               ),
                    tabPanel("Classifier",
                             #conditionalPanel("input.ClassID=='None'",
                             conditionalPanel("input.runSamplingBox == false",
                                              verbatimTextOutput("ClassifierHowto")
                             ),
                             #conditionalPanel("input.ClassID =='Samples' && input.runClassificationBox == false",
                             conditionalPanel("input.runSamplingBox == true && input.runClassificationBox == false",
                                              h4("Enter sampling size smaller than in Cases"),
                                              #tableOutput("viewTableCases"),
                                              DT::dataTableOutput("viewTableCases")

                                              # h4("Filtering Studies with mRNA data", align="center"),
                                              # fluidRow(
                                              #   column(6,
                                              #          uiOutput("list_Cases")),
                                              #   column(6,
                                              #          uiOutput("list_GenProfs")
                                              #   )
                                              # )

                                              # chooserInput("mychooser", "Available frobs", "Selected frobs",
                                              #              row.names(USArrests), c(), size = 10, multiple = TRUE
                                              # ),
                                              #  verbatimTextOutput("selection")
                                              # textOutput("PrintCases")


                             ),
                             #conditionalPanel("input.ClassID == 'Classifier'",
                             conditionalPanel("input.runClassificationBox == true",
                                              downloadLink("dl_GenesClassDetails_tab", "", class = "fa fa-download alignright"),
                                              #tableOutput("viewTablegetGenesClassifier")),
                                              DT::dataTableOutput("getGenesClassifier"),

                                              # conditionalPanel("input.ClassID=='Plot'",

                                              conditionalPanel("input.ClusterPlotsID=='GeneList/Diseases'",
                                                               h4("Which Diseases are involving your Genes list", align='center'),
                                                               plot_downloader("Plot_enrich", pre = ""),
                                                               plotOutput("Plot_enricher")
                                              ),
                                              conditionalPanel("input.ClusterPlotsID=='Disease Ontology'",
                                                               h4("Diseases Studies Genes associations", align='center'),
                                                               plot_downloader("compareClusterDO", pre=""),
                                                               plotOutput("compareClusterDO")
                                              ),
                                              conditionalPanel("input.ClusterPlotsID=='Reactome'",
                                                               h4("Reactome Pathway cluster Enrichment", align='center'),
                                                               plot_downloader("compareClusterReactome", pre=""),
                                                               plotOutput("compareClusterReactome")
                                              ),
                                              conditionalPanel("input.ClusterPlotsID=='GO'",
                                                               h4("Cancer / Gene Ontolgy associations", align='center'),
                                                               plot_downloader("compareClusterGO", pre=""),
                                                               plotOutput("compareClusterGO")
                                              ),
                                              conditionalPanel("input.ClusterPlotsID=='KEGG'",
                                                               h4("KEGG Pathway Enrichment", align='center'),
                                                               plot_downloader("compareClusterKEGG", pre=""),
                                                               plotOutput("compareClusterKEGG")
                                              ),
                                              conditionalPanel("input.ClusterPlotsID=='Cellular Component'",
                                                               h4("Cellular Component Enrichment", align='center'),
                                                               plot_downloader("compareClusterCC", pre=""),
                                                               plotOutput("compareClusterCC")
                                              )
                             )
                             #)
                    ),
                    tabPanel("Networking",
                             conditionalPanel(condition = "input.plotDiagrammeRSwithButtonId == false",
                                              verbatimTextOutput("ReactomeHowto")
                             ),
                             conditionalPanel(condition = "input.plotDiagrammeRSwithButtonId== true",
                                              #plot_downloader("ld_diagrammeR_plot", pre=""),
                                              downloadButton('Save_diagrammeR_plot', 'HTML',style='padding:4px; font-size:80%'),
                                              #actionLink("ReactomeFI_save_plot", "", class = "fa fa-download alignright", onclick = "window.print();"),
                                              DiagrammeR::grVizOutput('diagrammeR'),
                                              conditionalPanel(condition= "input.TypeGeneSetID == 'Pathway'||
                                                               input.TypeGeneSetID == 'BP'||
                                                               input.TypeGeneSetID == 'CC'||
                                                               input.TypeGeneSetID == 'MF'",
                                                               #tableOutput("GeneSetLegend")
                                                               downloadLink("dl_GeneSet_Legend", "", class = "fa fa-download alignright"),
                                                               DT::dataTableOutput("GeneSet_Legend")
                                              )


                                              #                         conditionalPanel(condition= "input.NodeAttri_ReactomeID == 'FreqInt./GeneSet'",
                                              #                                          #tableOutput("GeneSetLegend")
                                              #                                          DT::dataTableOutput("GeneSet_Legend")
                                              #                         )

                             ),
                             conditionalPanel(condition= "input.ReacLegendId == true",
                                              h4("Legend", align="center"),
                                              imageOutput("ReactomeLegend")
                             ),

                             conditionalPanel(condition = "input.ViewProfDataReactomeID==true",
                                              h3("Available Profiles data in select Studies", align="center"),
                                              DT::dataTableOutput(outputId ="ReactomeAvailability")
                             ),
                             conditionalPanel( condition = "input.plotVisNetworkSwithButtonId == true",
                                               visNetwork::visNetworkOutput("network",height = "600px"),
                                               actionButton('saveVisNetworkWidget',  'HTML',style='padding:4px; font-size:80%')
                             ),
                             conditionalPanel(condition = "input.getlistProfDataIDReactome ==true",
                                              h3("Loaded Profiles Data", align="center"),
                                              #uiOutput("StrListProfDataCircos")
                                              verbatimTextOutput("StrListProfDataReactome")
                                              #htmlOutput("StrListProfData")


                             )
                             #
                             #          #                    conditionalPanel(condition = "input.getlistProfDataID == 'Availability'",
                             #          #                                     h3("Available Profiles data in select Studies", align="center"),
                             #          #                                     DT::dataTableOutput(outputId ="ReactomeView")),
                             #          #
                             #          #                    conditionalPanel(condition = "input.getlistProfDataID == 'Load'",
                             #          #                                     h3("Load Profiles Data", align="center"),
                             #          #                                     verbatimTextOutput("StrListProfData")
                             #          #                   )
                             #
                             #
                    )
                    # # tabPanel("Network",
                    # #          conditionalPanel( condition = "input.NetworkRunId== true",
                    # #          visNetworkOutput("network",height = "600px")
                    # #          )
                    # # )

        )
      )
    )
  )
})

output$ui_clipboard_load_Clinical <- renderUI({
  if (getOption("radiant.local")) { ## running local or on a server
    actionButton('loadClipDataClinical', 'Paste data')
  } else {
    tagList(tags$textarea(class="form-control",
                          id="load_cdata", rows="5"
    ),
    actionButton('loadClipDataClinical', 'Paste data'))
  }
})

output$ui_Clinical_vars <- renderUI({
  shiny::withProgress(message = 'loading Clinical Data from cBioPortal server...', value = 1, {
  ##### get Clinical Data for selected Study
  req(input$StudiesID)
  r_info[['ClinicalData']] <- cBioPortalData::clinicalData(api = cgds, studyId = input$StudiesID)

  Clinical_vars <- names(r_info[['ClinicalData']])
  #r_data[['Clinical_vars']] <- Clinical_vars

  selectInput("Clinical_varsID", "Select variables to show:", choices  = Clinical_vars,
               multiple = TRUE, selected = state_multiple("Clinical_vars",Clinical_vars, Clinical_vars),
              selectize = FALSE, size = min(8, length(Clinical_vars)))
  })
})


output$ui_ClinicalData <- renderUI({

  list(
    wellPanel(
      uiOutput("ui_Clinical_vars")
    ),

    wellPanel(
      radioButtons(inputId = "ClinicalDataID", label = "Export for Processing:",
                   c("Load ClinicalData"="ClinicalData","clipboard" = "clipboard_Clin"),
                   selected = "ClinicalData", inline = TRUE),


      conditionalPanel(condition = "input.ClinicalDataID == 'ClinicalData'",
                       actionButton('loadClinicalData', 'Export to Datasets',
                                    icon('arrow-up'), style="float:center")

      ),
      conditionalPanel(condition = "input.ClinicalDataID == 'clipboard_Clin'",
                       uiOutput("ui_clipboard_load_Clinical")
      )
    ),

    #help_modal_km('Clinical Data','ClinicalHelp',inclMD(file.path(r_path,"base/tools/help/Clinical.md")))
    help_and_report(modal_title = "Clinical Data", fun_name = "ClinicalHelp",
                    author = "Karim Mezhoud",
                    help_file = inclRmd(file.path(
                      getOption("radiant.path.bioCancer"),"app/tools/help/Clinical.md")))
  )
})


observe({
  # 'reading' data from clipboard
  if (not_pressed(input$loadClipDataClinical)) return()
  isolate({
    loadClipboardData()
    updateRadioButtons(session = session, inputId = "ClinicalDataID",
                       label = "Export Clincial Data to Datasets:",
                       c("Load ClinicalData" = "ClinicalData","clipboard" = "clipboard_Clin"),
                       selected = "ClinicalData", inline = TRUE)

    updateSelectInput(session, "dataset", label = "Datasets:",
                      choices = r_data$datasetlist, selected = "xls_data")
  })
})

## Load Clinical data in datasets
observe({
  if (not_pressed(input$loadClinicalData)) return()
  isolate({

    loadInDatasets(fname="ClinicalData", header=TRUE)

    # sorting files alphabetically
    r_info[['datasetlist']] <- sort(r_info[['datasetlist']])

    updateSelectInput(session, "dataset", label = "Datasets:",
                      choices = r_info$datasetlist,
                      selected = "ClinicalData")

  })
})

#' Display dataframe in table using DT package
#'
#' @usage displayTable(df)
#' @param df a dataframe
#'
#' @return A table
#'
#' @examples
#' cgds <- cBioPortal(
#' hostname = "www.cbioportal.org",
#' protocol = "https",
#' api = "/api/v2/api-docs"
#' )
#' \dontrun{
#' getDataByGenes( api =  cgds,
#' studyId = "gbm_tcga_pub",
#' genes = c("NF1", "TP53", "ABL1"),
#' by = "hugoGeneSymbol",
#' molecularProfileIds = "gbm_tcga_pub_mrna"
#' )
#'}
#'@export
displayTable <- function(df){
  # action = DT::dataTableAjax(session, dat, rownames = FALSE, toJSONfun = my_dataTablesJSON)
  action = DT::dataTableAjax(session, df, rownames = FALSE)

  #DT::datatable(dat, filter = "top", rownames =FALSE, server = TRUE,
  table <- DT::datatable(df, filter = list(position = "top", clear = FALSE, plain = TRUE),
                rownames = FALSE, style = "bootstrap", escape = FALSE,
                # class = "compact",
                options = list(
                  ajax = list(url = action),
                  search = list(search = "",regex = TRUE),
                  columnDefs = list(list(className = 'dt-center', targets = "_all")),
                  autoWidth = FALSE,
                  processing = FALSE,
                  pageLength = 10,
                  lengthMenu = list(c(10, 25, 50, -1), c('10','25','50','All'))
                )
  )
  return(table)
}

#' Verify which gene list is selected
#'
#' @usage whichGeneList(geneListLabel)
#'
#' @param geneListLabel The label of GeneList. There are three cases:
#'        "Genes" user gene list,
#'        "Reactome_GeneList" GeneList plus genes from reactomeFI
#'       "file name" from Examples
#'
#' @return Gene List label
#'
#' @examples
#' How <- "runManually"
#' \dontrun{
#' whichGeneList("102")
#'}
#' @export
whichGeneList <- function(geneListLabel){
  if(geneListLabel == "User_Genes"){
    GeneList <- r_data$User_Genes
  }else if(geneListLabel == "Reactome_GeneList"){
    GeneList <- t(r_data$Reactome_GeneList)
  #}else if(r_path == "inst"){
    ## For server
   # GeneList <- t(unique(read.table(paste0(r_path,"/base/data/GeneList/",geneListLabel,".txt" ,sep=""))))
  } else{
    ## For R package
    #GeneList <- t(unique(read.table(paste0(path.package('bioCancer'),"/base/data/GeneList/",geneListLabel,".txt" ,sep=""))))
    GeneList <- t(unique(read.table(paste0( system.file(package = "bioCancer"),"/extdata/GeneList/",geneListLabel,".txt" ,sep=""))))
  }
  return(GeneList)

}

#' Capture html output widget as .png in R
#'
#' @return  3 files .html, .js and .png
#'
#' @usage widgetThumbnail(p, thumbName, width = 1024, height = 1024)
#' @param p is the html widget
#' @param thumbName is the name of the new png file
#' @param width 1024
#' @param height 1024
#'
#' @examples
#' How <- "runManually"
#' \dontrun{
#' # Load package
#' library(networkD3)
#' library(htmlwidgets)
#' # Create fake data
#' src <- c("A", "A", "A", "A", "B", "B", "C", "C", "D")
#' target <- c("B", "C", "D", "J", "E", "F", "G", "H", "I")
#' networkData <- data.frame(src, target)
#' # Plot
#' plot = simpleNetwork(networkData)
#' # Save html as png
#' widgetThumbnail(p = plot, thumbName = "plot", width = 1024, height = 1024)
#' }
#' @export
#'
widgetThumbnail <- function(p, thumbName, width = 1024, height = 1024){
  phantom <- findPhantom()

  success <- FALSE
  if(phantom == "") {
    message("** phantomjs dependency could not be found - thumbnail cannot be generated.
            Please visit this page to install phantomjs on your system: http://phantomjs.org/download.html)")
  } else {
    res <- try({
      ff <- paste0(thumbName, ".html")
      ffjs <- paste0(thumbName, ".js")

      # don't want any padding
      p$sizingPolicy$padding <- 0
      suppressMessages(htmlwidgets::saveWidget(p, ff, selfcontained = FALSE))

      js <- paste0("var page = require('webpage').create();
                   page.viewportSize = { width: ", width,", height: ", height," };
                   page.clipRect = { top: 0, left: 0, width: ", width,", height: ", height," };
                   page.open('", ff, "', function(status) {
                   console.log(\"Status: \" + status);
                   if(status === \"success\") {
                   page.render('", thumbName, ".png', {format: 'png', quality: '100'});
                   }
                   phantom.exit();
    });")
      cat(js, file = ffjs)
      ## this line generate png file from JS
      base::system2(phantom,ffjs )

      ## delete files .html; .js, plot_files and .png
      #unlink(paste0(thumbName, '.html', sep=""), recursive = FALSE)
      unlink(paste0(thumbName, '.js', sep=""), recursive = FALSE)
      unlink(paste0(thumbName, '_files', sep=""), recursive = TRUE)
    })
    if(!inherits(res, "try-error")) {
      success <- TRUE
    }
    if(!file.exists(paste0(thumbName, ".png"))) {
      success <- FALSE
    }
  }

  if(!success) {
    message("** could not create htmlwidget thumbnail... creating an empty thumbnail...")
  }
  }

#' Check if PhantomJS is installed. Similar to webshot
#' @return Logic object
#' @usage findPhantom()
#' @examples
#' How <- "runManually"
#' \dontrun{
#' findPhantom()
#' }
#' @export
findPhantom <- function(){

  phantom <- Sys.which("phantomjs")

  if(Sys.which("phantomjs") == "") {
    if(identical(.Platform$OS.type, "windows")) {
      phantom <- Sys.which(file.path(Sys.getenv("APPDATA"), "npm", "phantomjs.cmd"))
    }
  }

  phantom

}

#' get list of cases of each selected study in Classifier panel
#' @usage getList_Cases(checked_Studies)
#' @param checked_Studies checked studies
#'
#' @return A list of cases
#' @export
#'
#' @examples
#' cgds <- cBioPortal(
#' hostname = "www.cbioportal.org",
#' protocol = "https",
#' api = "/api/v2/api-docs"
#' )
#' \dontrun{
#' getDataByGenes( api =  cgds,
#' studyId = "gbm_tcga_pub",
#' genes = c("NF1", "TP53", "ABL1"),
#' by = "hugoGeneSymbol",
#' molecularProfileIds = "gbm_tcga_pub_mrna"
#' )
#'}
#'
getList_Cases <- function(checked_Studies){
  listCases <- lapply(checked_Studies, function(x) cBioPortalData::sampleLists(cgds,x) |>
                                                    pull("sampleListId"))
  names(listCases) <- checked_Studies
  listCases <- lapply(listCases, function(x) x[grep("v2_mrna", x)])
  listCases <- listCases[lapply(listCases,length)>0]

  return(listCases)
}


#' get list of genetic profiles of each selected study in Classifier panel
#' @usage getList_GenProfs(checked_Studies)
#' @param checked_Studies checked studies
#'
#' @return A list of genetics profiles
#' @export
#'
#' @examples
#' cgds <- cBioPortal(
#' hostname = "www.cbioportal.org",
#' protocol = "https",
#' api = "/api/v2/api-docs"
#' )
#' \dontrun{
#' getDataByGenes( api =  cgds,
#' studyId = "gbm_tcga_pub",
#' genes = c("NF1", "TP53", "ABL1"),
#' by = "hugoGeneSymbol",
#' molecularProfileIds = "gbm_tcga_pub_mrna"
#' )
#'}
#'
getList_GenProfs <- function(checked_Studies){

  listGenProfs <- lapply(checked_Studies, function(x) cBioPortalData::molecularProfiles(cgds,x)|>
                                                        pull("molecularProfileId"))
  names(listGenProfs) <- checked_Studies
  listGenProfs <- lapply(listGenProfs, function(x) x[grep("v2_mrna$", x)])
  listGenProfs <- listGenProfs[lapply(listGenProfs,length)>0]
  return(listGenProfs)
}


#' get genes classification
#' @usage getGenesClassification(checked_Studies, GeneList,
#'  samplesize, threshold, listGenProfs, listCases)
#' @param checked_Studies checked studies
#' @param GeneList gene list
#' @param samplesize sample size
#' @param threshold  p-value threshold
#' @param listGenProfs list of genetic profiles
#' @param listCases list of cases
#'
#' @return A table with genes classed by study
#' @export
#'
#' @examples
#' cgds <- cBioPortal(
#' hostname = "www.cbioportal.org",
#' protocol = "https",
#' api = "/api/v2/api-docs"
#' )
#' \dontrun{
#' getDataByGenes( api =  cgds,
#' studyId = "gbm_tcga_pub",
#' genes = c("NF1", "TP53", "ABL1"),
#' by = "hugoGeneSymbol",
#' molecularProfileIds = "gbm_tcga_pub_mrna"
#' )
#'}
#'
getGenesClassification <- function(checked_Studies,
                                   GeneList,
                                   samplesize,
                                   threshold,
                                   listGenProfs,
                                   listCases){
  if(length(listCases) < length(checked_Studies)){
    GenesClassDetails_df <-
      as.data.frame("Some selected study does not have mRNA data.
                    Select only study witn mRNA data.")
    return(GenesClassDetails_df)

  }else{
    SamplingProfsData <- 0
    DiseasesType <- 0
    for (s in checked_Studies){

      #GenProf <- input$GenProfsIDClassifier[s]
      #Case <- input$CasesIDClassifier[s]
      GenProf <- listGenProfs[[s]]
      Case <- listCases[[s]]

      ProfData <- cBioPortalData::getDataByGenes(api =  cgds,
                                                 studyId = s,
                                                 genes = GeneList,
                                                 by = "hugoGeneSymbol",
                                                 molecularProfileIds = GenProf,
                                                 sampleListId = Case) |>
        unname() |>
        as.data.frame() |>
        dplyr::select("hugoGeneSymbol","sampleId", "value") |>
        tidyr::spread("hugoGeneSymbol", "value") |>
        tibble::column_to_rownames("sampleId")


      ProfData <- t(ProfData)
      ##remove all NAs rows
      if (inherits(try(ProfData<- ProfData[which(apply( !( apply(ProfData,1,is.na) ),2,sum)!=0 ),] ,
                       silent=FALSE),"try-error"))
      {
        print("Reselect Cases and Genetic Profiles from Samples. Maybe some studies do not have mRNA data.")
      } else{
        ProfData<- ProfData[which( apply( !( apply(ProfData,1,is.na) ),2,sum)!=0 ),]
      }

      if(ncol(ProfData) < input$SampleSizeClassifierID){

        msgBigSampl <- paste(s, "has only",
                             ncol(ProfData),"samples.",
                             "\nSelect at Max: ",ncol(ProfData), "samples")

        shiny::withProgress(message= msgBigSampl, value = 0.1,
                            {p1 <- proc.time()
                            Sys.sleep(2) # wait 2 seconds
                            proc.time() - p1 })

        print(msgBigSampl)
      }
      set.seed(1234)
      SamplingProfData <- t(apply(ProfData, 1,function(x)sample(x[!is.na(x)],input$SampleSizeClassifierID)))

      SamplingColnamesProfData <- sample(colnames(ProfData), input$SampleSizeClassifierID)

      colnames(SamplingProfData) <- SamplingColnamesProfData
      SamplingProfsData <- cbind.na(SamplingProfsData,SamplingProfData)
      print(paste("Sampling from ",Case))
      ##Extracting Disease Type
      DiseaseType  <- as.matrix(rep(s,times=input$SampleSizeClassifierID))
      DiseasesType <- c(DiseasesType, DiseaseType)

    }

    SamplingProfsData <- SamplingProfsData[,-1]
    DiseasesType <- DiseasesType[-1]
    DiseasesType <- as.data.frame(DiseasesType)
    print("converting DiseaseType as DataFrame...")

    if (inherits(try(rownames(DiseasesType) <- colnames(SamplingProfsData) , silent=FALSE),"try-error"))
    {
      msgDuplicateSamples <- paste("Duplicate sample names are not allowed. Do no select two studies from the same disease.")
      shiny::withProgress(message= msgDuplicateSamples, value = 0.1,
                          {p1 <- proc.time()
                          Sys.sleep(2) # wait 2 seconds
                          proc.time() - p1 })
      print(msgDuplicateSamples)
    } else{
      print(paste("SamplingProfsData:", dim(SamplingProfsData)))
      print(paste("DiseasesType:", dim(DiseasesType)))
      rownames(DiseasesType) <- colnames(SamplingProfsData)
    }


    print("adding rownames to DiseasesType...")
    ## create labelDescription for columns of phenoData.
    ## labeldescription is used by Biobase packages
    ## In our case labelDescription is Equal to column names
    ## Bioconductor’s Biobase package provides a class called AnnotatedDataFrame
    metaData <- data.frame(labelDescription= "DiseasesType", row.names="DiseasesType")

    print("getting metaData...")
    ##that conveniently stores and manipulates
    ##the phenotypic data and its metadata in a coordinated fashion.
    phenoData <- new("AnnotatedDataFrame", data=DiseasesType, varMetadata=metaData)
    print("getting phenoData...")
    ##Assembling an ExpressionSet
    eSetClassifier <- Biobase::ExpressionSet(assayData=SamplingProfsData, phenoData=phenoData, annotation="GO")
    print("getting eSetClassifier...")
    if(min(Biobase::exprs(eSetClassifier), na.rm=TRUE)<0){
      print("There are negative values. Translating values by adding the absolute of minimum value to all matrix")
      Biobase::exprs(eSetClassifier) <- Biobase::exprs(eSetClassifier)+(abs(min(Biobase::exprs(eSetClassifier), na.rm=TRUE)))
    }

    if (inherits(try(signGenesRank_DiseaseType<-
                     geNetClassifier::calculateGenesRanking(eSetClassifier[,1:(input$SampleSizeClassifierID*length(checked_Studies))],
                                                            sampleLabels="DiseasesType", lpThreshold= input$ClassifierThresholdID,
                                                            returnRanking="significant", plotLp = FALSE), silent=TRUE),"try-error"))
    {
      msgNoSignificantDiff <- paste("The current genes don't differentiate the classes (Cancers)..")

      shiny::withProgress(message= msgNoSignificantDiff, value = 0.1,
                          {p1 <- proc.time()
                          Sys.sleep(2) # wait 2 seconds
                          proc.time() - p1 })

      print(msgNoSignificantDiff)
    } else{

      signGenesRank_DiseaseType <-
        geNetClassifier::calculateGenesRanking(eSetClassifier[,1:(input$SampleSizeClassifierID*length(checked_Studies))],
                                               sampleLabels="DiseasesType", lpThreshold= input$ClassifierThresholdID,
                                               returnRanking="significant", plotLp = FALSE)
    }

    ## this line display the rank of postprob of all genes
    #apply(-signGenesRank_DiseaseType@postProb[,-1,drop=FALSE],2,rank, ties.method="random")

    GenesClassDetails <- geNetClassifier::genesDetails(signGenesRank_DiseaseType)
    r_data[['GenesClassDetailsForPlots']] <- GenesClassDetails
    #GenesClassDetails_bkp1 <<- GenesClassDetails

    print("getting Genes Details...")
    GenesClassDetails_ls <- lapply(GenesClassDetails, function(x) x %>%
                                     tibble::rownames_to_column("Genes"))
    GenesClassDetails_df <- plyr::ldply(GenesClassDetails_ls)
    #r_data[['GenesClassDetails']] <- GenesClassDetails_df[,-1]

    #GenesClassTab <- do.call(rbind.data.frame, GenesClassDetails)
    #GenesClassTab <- t(t(as.data.frame.matrix(GenesClassTab)))

    return(GenesClassDetails_df[,-1])
  }
}

# Annotation translation functions
#'
#' \tabular{ll}{
#' Package:  \tab  AnnotationFuncs\cr
#' Type:  \tab  Package\cr
#' Version:  \tab  1.3.0\cr
#' Date:  \tab  2011-06-10\cr
#' License:  \tab  GPL-2\cr
#' LazyLoad:  \tab  yes\cr
#' }
#'
#' Functions for handling translations between different identifieres using
#' the Biocore Data Team data-packages (e.g. \code{org.Bt.eg.db}).
#' Primary functions are \code{\link{translate}} for translating
#' and \code{\link{getOrthologs}} for efficient lookup of homologes
#' using the Inparanoid databases.
#' Other functions include functions for selecting Refseqs or Gene Ontologies (GO).
#'
#' @name  AnnotationFuncs
#' @aliases  AnnotationFuncs
#' @title Annotation translation functions
#' @author  Stefan McKinnon Edwards  \email{stefan.hoj-edwards@@agrsci.dk}
#' @references
#' \url{https://www.iysik.com/index.php?page=annotation-functions}
#' @keywords  package
#' @seealso  \code{\link{translate}}, \code{\link{getOrthologs}}
#' @examples
#' library(org.Bt.eg.db)
#' gene.symbols <- c('DRBP1','SERPINA1','FAKE','BLABLA')
#' # Find entrez identifiers of these genes.
#' eg <- translate(gene.symbols, org.Bt.egSYMBOL2EG)
#' # Note that not all symbols were translated.
#'
#' # Go directly to Refseq identifiers.
#' refseq <- translate(gene.symbols, from=org.Bt.egSYMBOL2EG, to=org.Bt.egREFSEQ)
#' # Pick the proteins:
#'  pickRefSeq(refseq, priorities=c('NP','XP'), reduce='all')
NULL

#' Translate between different identifiers
#'
#' Function for translating from one annotation to another, eg. from RefSeq to
#' Ensemble.  This function takes a vector of annotation values and translates
#' first to the primary annotation in the Biocore Data Team package (ie. entrez gene identifier for org.Bt.eg.db)
#' and then to the desired product, while removing non-translated annotations
#' and optionally reducing the result so there is only a one-to-one relation.
#'
#' If you want to do some further mapping on the result, you will have to use
#' either \code{unlist} og \code{lapply}, where the first returns all the end-products
#' of the first mapping, returning a new list, and the latter produces a list-within-list.
#'
#' If \code{from} returns GO identifiers (e.g. \code{from = org.Bt.egGO}), then the
#' returned resultset is more complex and consists of several layers of lists instead of
#' the usual list of character vectors. If \code{to} has also been specified, the GO IDs
#' must be extracted (internally) and you have the option of filtering for evidence and category at this point.
#' See \code{\link{pickGO}}.
#'
#' @note Requires user to deliver the annotation packages such as org.Bt.egREFSEQ.
#' @param values Vector of annotations that needs translation. Coerced to character vector.
#' @param from Type of annotation \code{values} are given in. NB! take care in the
#'         orientation of the package, ie. if you have RefSeq annotations, use
#'         \code{org.Bt.egREFSEQ2EG} or (in some cases) \code{revmap(org.Bt.egREFSEQ)}.
#' @param to Desired goal, eg. \code{org.Bt.egENSEMBLPROT}. If \code{NULL} (default), goal
#'         if the packages primary annotation (eg. entrez gene for org.Bt.eg.db).
#'         Throws a warning if the organisms in \code{from} and \code{to} are not the same.
#' @param reduce Reducing method, either return all annotations (one-to-many relation)
#'         or the first or last found annotation. The reducing step is applied
#'         after translating to the goal:
#'         \code{all}: returns all annotations
#'         \code{first} or \code{last}: choose first or last of arbitrarily ordered list.
#' @param return.list Logical, when \code{TRUE}, returns the translation as a list where names
#         are the given values that could be translated. The function works
#         on lists, so this is just as easy to return.
#         When \code{FALSE}, a table.  Convenience for calling on the result.
#' @param remove.missing Logical, whether to remove non-translated values, defaults \code{TRUE}.
#' @param simplify Logical, unlists the result. Defaults to FALSE. Usefull when using \code{translate} in
#'                 a \code{lapply} or \code{sapply}.
#' @param ... Additional arguments sent to \code{\link{pickGO}} if \code{from} returns GO set.
#' @return List; names of elements are \code{values} and the elements are the translated elements,
#'        or \code{NULL} if not translatable with \code{remove.missing = TRUE}.
#' @author Stefan McKinnon Edwards \email{stefan.hoj-edwards@@agrsci.dk}
#' @seealso \code{\link{pickRefSeq}}, \code{\link{pickGO}}
#' @export
#' @examples
#' library(org.Bt.eg.db)
#' genes <- c(280705, 280706, 100327208)
#' translate(genes, org.Bt.egSYMBOL)
#'
#' symbols <- c("SERPINA1","KERA","CD5")
#' refseq <- translate(symbols, from=org.Bt.egSYMBOL2EG, to=org.Bt.egREFSEQ)
#' # Pick the proteins:
#' pickRefSeq(refseq, priorities=c('NP','XP'), reduce='all')
#'
#' # If you wanted do do some further mapping on the result from
#' # translate, simply use lapply.
#'
#' library(GO.db)
#' GO <- translate(genes, org.Bt.egGO)
translate <- function(values, from, to=NULL,
                      reduce=c('all','first','last'),
                      return.list = TRUE,
                      remove.missing=TRUE,
                      simplify=FALSE,
                      ...) {
  # Roadmap:
  # Check validity of attributes.
  # Check that the organisms of from and to match.
  # Translate to primary annotation.
  # Optionally translate to end.
  # Optionally reduce result.
  # Optionally unstack.

  ###
  # Check validity of attributes
  ###
  values <- unique(as.vector(values, mode='character'))
  values <- values[!is.na(values)]
  values <- values[which(sapply(values, nchar)>0)]  # Removes zero-length entries.
  reduce <- match.arg(reduce)
  return.list <- as.logical(return.list)

  #l <- NULL # R compiler complains about l not being binded? Half a year later and I am still not sure what this does.

  ###
  # Check organisms - throw warning if not.
  ###
  if (!is.null(to)) {
    # Compare taxid:
    org.from <- NULL
    org.to <- NULL
    try( org.from <- dbmeta(dbconn(from), "ORGANISM"), silent=TRUE)
    try( org.to <- dbmeta(dbconn(to), "ORGANISM"), silent=TRUE)
    if (!is.null(org.from) & !is.null(org.to)) {
      if (org.from != org.to) {
        warning(sprintf("TAXID for 'to' and 'from' does not match! We found:
\t From:\t%s
\tTo:\t%s
\tFor cross species (ie. homologes) look at e.g. hom.Hs.inp.db.", org.from, org.to))
        # End of warning message.
      }
    }
  }

  ###
  # Translate to primary id:
  ###
  primary <- AnnotationDbi::mget(values, from, ifnotfound=NA)
  # primary is now a list.
  # Remove nulls and NAs
  primary <- primary[!is.na(primary)]
  # primary is now a list with non-empty, multiple length entries

  # Provide a method for reducing.
  pickOne <- switch(reduce,
                    all = function(x) x,
                    first = function(x) x[1],
                    last = function(x) x[length(x)])

  ###
  # Translate all primary ids to goal annotation
  ###
  if (is.null(to) == FALSE) {
    # Check for special case where the from-package is into GO.
    # If it is, then the primary must be reduced to only the GO identifiers and not the set of GO ID, evidence and category.
    isGO <- FALSE
    try(isGO <- from@objName == 'GO', silent=TRUE)
    if (isGO) {
      primary <- pickGO(primary, ...)
    }
    # Remember to unlist, so we get every entry of primary, which is every
    # possible translation of the starting values.
    goal <- AnnotationDbi::mget(unlist(primary, use.names=F), to, ifnotfound=NA)
    # Map all goal-annotations to the starting annotations:
    # lapply over primary, so we get primary's names.
    goal <- lapply(primary, function(x) {
      x <- unlist(goal[x], use.names=FALSE) # x is vector, so we get all entries in goal for all x.
      if (length(x) == 0 || is.na(x[1]))
        return(NA)
      x <- pickOne(x)
      return(x)
    })
  } else {
    # If goal is primary annotation, reduce accordingly.
    goal <- primary
    if (reduce != 'all')
      goal <- lapply(goal, pickOne)
  }

  ###
  # Remove nulls and NAs
  ###
  if (remove.missing) {
    goal <- goal[!is.na(goal)]
  } else {
    missing <- values[!(values %in% names(goal))]
    #missing.list <- as.list(rep(NA, length(missing)))
    #names(missing.list) <- missing
    #goal <- c(goal, missing.list)
    goal[missing] <- NA
  }

  ###
  # Return result if a list is desired,
  # else unstack to a table.
  ###
  if (simplify) return(unlist(goal, use.names=FALSE))
  if (return.list) {
    return(goal)
  } else {
    if (length(goal) == 0)
      return(data.frame(from=factor(),to=factor()))
    goal <- stack(goal)
    new.c <- c('from','to') # Matching 'ind' and 'values'.
    colnames(goal) <- new.c[match(c('ind','values'), colnames(goal))]
    return(goal)
  }
}

#' Picks a prioritised RefSeq identifier from a list of identifiers
#'
#' When translating to RefSeq, typically multiple identifiers are returned,
#' referring to different types of products, such as genomic molecule, mature
#' mRNA or the protein, and they can be predicted, properties that can be read
#' from the prefix (\url{https://www.ncbi.nlm.nih.gov/refseq/}).  E.g. "XM_" is
#' predicted mRNA and "NP_" is a protein. Run \code{?org.Bt.egREFSEQ}.
#'
#' @param l  Vector or list of RefSeqs accessions to pick from.  If list given, applies the
#'            prioritation to each element in the list.
#' @param priorities Character vector of prioritised prefixes to pick by. Eg. \code{c("NP","NM")}
#'             returns RefSeqs starting 'NP', and if none found, those starting
#'             'NM'.  If no RefSeqs are found according to the priorities, Null
#'             is returned, unless the last element in priorities is '*'.
#'             Uses grepl, so see these for pattern matching.
#'             Default: c('NP','XP','NM','XM')
#' @param reduce Reducing method, either return all annotations (one-to-many relation)
#'         or the first or last found annotation.  The reducing step is applied
#'         after translating to the goal:
#'         \code{all}: returns all annotations
#'         \code{first} or \code{last}: choose first or last of arbitrarily ordered list.
#' @return If vector given, returns vector.  If list given, returns list without element where nothing could be picked.
#' @author Stefan McKinnon Edwards \email{stefan.hoj-edwards@@agrsci.dk}
#' @export
#' @examples
#' library(org.Bt.eg.db)
#' symbols <- c("SERPINA1","KERA","CD5")
#' refseq <- translate(symbols, from=org.Bt.egSYMBOL2EG, to=org.Bt.egREFSEQ)
#' mRNA <- pickRefSeq(refseq, priorities=c('NM','XM'))
#' proteins <- pickRefSeq(refseq, priorities=c('NP','XP'))
pickRefSeq <- function(l, priorities=c('NP','XP','NM','XM'),
                       reduce=c('all','first','last')) {
  if (is.list(l)) {
    res <- lapply(l, .pickRef, priorities=priorities, reduce=reduce)
    res <- res[!sapply(res, is.null)]
    return(res)
  } else {
    return(.pickRef(l, priorities = priorities, reduce=reduce))
  }
}

#' Secret function that does the magic for pickRefSeq.
#'
#' Do not use it, use \code{\link{pickRefSeq}}!
#'
#' @param l List.
#' @param priorities How to prioritize.
#' @param reduce How to reduce.
#' @return List.
#' @note Hey, you found a secret function! Keep it that way!
#' @author Stefan McKinnon Edwards \email{stefan.hoj-edwards@@agrsci.dk}
#' @seealso \code{\link{pickRefSeq}}
.pickRef <- function(l, priorities, reduce=c('all','first','last')){
  # Roadmap:
  # Check attributes
  # Get prioritised element
  # Reduce

  ###
  # Check attributes
  ###
  l <- as.vector(l, mode="character")
  reduce <- match.arg(reduce)

  ###
  # Get prioritised element, by iterating over 'priorities' and grepping by it.
  ###
  for (p in priorities) {
    res <- grep(p, l, ignore.case=TRUE, value=TRUE)
    if (length(res) > 0) break
  }
  if (length(res) == 0) return(NULL)

  ###
  # Reduce
  ###
  # Provide a method for reducing.
  pickOne <- switch(reduce,
                    all = function(x) x,
                    first = function(x) x[1],
                    last = function(x) x[length(x)])
  return(pickOne(res))
}


#' Replaces contents of list A with elements of list B
#'
#' Combines two lists, \code{A} and \code{B}, such that \code{names(A)} are preserved, mapping to the
#' values of \code{B}, using \code{names(B)} as look up.  Ie. replaces values in \code{A} with values
#' in \code{B}, using \code{names(B)} as look up for values in \code{A}.
#' Once more?  See examples.
#' \emph{NB!} None-mapped entries are returned as NA, but can be removed using \code{\link{removeNAs}}.
#' @param A List, elements are coerced to character for mapping to B.
#' @param B List.
#' @param removeNAs Boolean, whether to remove the \code{NA}s that occur because an element was not found in \code{B}.
#' @return List.
#' @seealso \code{\link{removeNAs}}
#' @author Stefan McKinnon Edwards \email{stefan.hoj-edwards@@agrsci.dk}
#' @export
#' @examples
#' A <- list('a1'='alpha','a2'='beta','a3'=c('gamma','delta'))
#' B <- list('alpha'='b1', 'gamma'=c('b2', 'b3'), 'delta'='b4')
#' mapLists(A, B)
#  # Returns: list('a1'='b1', 'a2'=NA, 'a3'=c('b2','b3','b4'))
mapLists <- function(A, B, removeNAs=TRUE) {
  res <- lapply(A, function(x) {
    x <- unlist(B[as.character(x)], use.names=FALSE)
    if (length(x) == 0 || is.na(x[1])) return(NA)
    return(x)
  })
  if (removeNAs) res <- removeNAs(res)
  return(res)
}

#' Removes entries equal \code{NA} from list or vector
#'
#' Removes entries equal \code{NA}, but not mixed entries containing, amongst others, \code{NA}.
#' Good for use after \code{\link{mapLists}} that might return entries equal \code{NA}.
#' @param l Vector or list.
#' @author Stefan McKinnon Edwards \email{stefan.hoj-edwards@@agrsci.dk}
#' @export
#' @examples
#' removeNAs(list('a'=NA, 'b'=c(NA, 'B'), 'c'='C'))
removeNAs <- function(l) { return(l[!is.na(l)]) }

#' Cleans up result from org.Xx.egGO and returns specific GO identifiers
#'
#' Cleans up result from org.Xx.egGO and returns GO identifier for  either
#' biological process (BP), cellular component (CC), or molecular function (MF).
#' Can be used on list of GOs from \code{\link{translate}}, or a single list of GOs from an annotation package.
#' May reduce list, if the (sub)list does not contain the chosen class!
#' @param l Character vector, or list of GO identifiers.
#' @param evidence Character vector, filters on which kind of evidence to return; for a larger list see \code{\link{getEvidenceCodes}}. \\*
#'                 Evidence codes may be: \code{c('IMP','IGI','IPI','ISS','IDA','IEP','IEA','TAS','NAS','ND','IC')}. \\*
#'				   Leave as \code{NA} to ignore filtering on this part.
#' @param category Character vector, filters on which ontology to return: biological process (BP), cellular component (CC), or molecular function (MF). \\*
#'				   Leave as \code{NA} to ignore filtering on this part.
#' @return List with only the picked elements.
#' @author Stefan McKinnon Edwards \email{stefan.hoj-edwards@@agrsci.dk}
#' @seealso \code{\link{pickRefSeq}}, \code{\link{getEvidenceCodes}}, \code{\link{translate}}
#' @export
#' @examples
#' library(org.Bt.eg.db)
#' genes <- c(280705, 280706, 100327208)
#' translate(genes, org.Bt.egSYMBOL)
#'
#' symbols <- c("SERPINA1","KERA","CD5")
#' refseq <- translate(symbols, from=org.Bt.egSYMBOL2EG, to=org.Bt.egREFSEQ)
#' # Pick the proteins:
#' pickRefSeq(refseq, priorities=c('NP','XP'), reduce='all')
#'
#' # If you wanted do do some further mapping on the result from
#' # translate, simply use lapply.
#'
#' library(GO.db)
#' GO <- translate(genes, org.Bt.egGO)
#' # Get all biological processes:
#' \dontrun{
#' pickGO(GO, category='BP')
#'  # $`280705`
#'  # [1] "GO:0006826" "GO:0006879"
#'  # $`280706`
#' # [1] "GO:0006590" "GO:0007165" "GO:0042446"
#' # Get all ontologies with experimental evidence:
#' pickGO(GO, evidence=c('IMP','IGI','IPI','ISS','IDA','IEP','IEA'))
#'  # $`280705`
#'  # [1] "GO:0006826" "GO:0006879" "GO:0005615" "GO:0008199"
#'  # $`280706`
#'  # [1] "GO:0006590" "GO:0007165" "GO:0042446" "GO:0005615" "GO:0005179" "GO:0042393"
#' }
pickGO <- function(l, evidence=NA, category=NA) {
  evidence <- toupper(evidence)
  category <- toupper(category)

  if (length(l) == 3) {
    if (names(l) == c('GOID','Evidence','Ontology')) {
      if (is.list(l)) l <- unlist(l, use.names=FALSE)
      if (is.na(evidence)) evidence = l[2]
      if (is.na(category)) category = l[3]
      if (l[2] %in% evidence & l[3] %in% category) return(l[1])
      return(NA)
    }
  }
  if (all(substr(names(l), 1, 3) == 'GO:')) {
    gos <- l[which(substr(names(l), 1, 3) == 'GO:')]
    gos <- matrix(unlist(gos, use.names=FALSE), ncol=3, byrow=TRUE)
    if (length(evidence) == 1 && is.na(evidence)) {
      from.evi <- rep(TRUE, nrow(gos))
    } else {
      from.evi <- gos[,2] %in% evidence
    }
    if (length(category) == 1 && is.na(category)) {
      from.cat <- rep(TRUE, nrow(gos))
    } else {
      from.cat <- gos[,3] %in% category
    }
    return(gos[from.evi & from.cat,1])
  }
  lapply(l, pickGO, evidence=evidence, category=category)
}

#' Returns GO evidence codes.
#'
#' @references \code{?org.Bt.egGO}
#' @return Matrix of two columns, first column with codes, second column with description of codes.
#' @seealso \code{\link{pickGO}}
#' @export
#' @author Stefan McKinnon Edwards \email{stefan.hoj-edwards@@agrsci.dk}
#' @examples
#' getEvidenceCodes()
getEvidenceCodes <- function() {
  codes <- c('IMP','inferred from mutant phenotype',
             'IGI','inferred from genetic interaction',
             'IPI','inferred from physical interaction',
             'ISS','inferred from sequence similarity',
             'IDA','inferred from direct assay',
             'IEP','inferred from expression pattern',
             'IEA','inferred from electronic annotation',
             'TAS','traceable author statement',
             'NAS','non-traceable author statement',
             'ND','no biological data available',
             'IC','inferred by curator ')
  return(matrix(codes, ncol=2, byrow=TRUE, dimnames=list(c(), c('Code','Description'))))
}

#' Performs quicker lookup for orthologs in homologe data packages
#'
#' Using the INPARANOID data packages such as \code{hom.Hs.inp.db} is very, very slow and can take up to 11 min (on this particular developers workstation).
#' This function introduces a new method that can do it in just 20 seconds (on the developers workstation).
#' In addition, it includes options for translating between different identifers both before and after the mapping.
#'
#' @param values Vector, coerced to character vector, of values needed mapping by homology.
#' @param mapping Homology mapping object, such as \code{hom.Hs.inpBOSTA} or \code{revmap(hom.Hs.inpBOSTA)}.
#' @param genus Character vector. 5 character INPARANOID style genus name of the mapping object, e.g. 'BOSTA' for both \code{hom.Hs.inpBOSTA} and \code{revmap(hom.Hs.inpBOSTA)}.
#' @param threshold Numeric value between 0 and 1. Only clustered homologues with a parwise score above the threshold is included.
#'                  The native implementation has this set to 1.
#' @param pre.from Mapping object if \code{values} needs translation before mapping.
#'             E.g. \code{values} are entrez and \code{hom.Hs.inpBOSTA} requires ENSEMBLPROT, \code{hom.Hs.inpAPIME} requires Refseq (?).
#'             Arguments \code{from} and \code{to} are just like in \code{\link{translate}}.
#' @param pre.to Second part of translation before mapping.
#' @param post.from Translate the result from homology mapping to a desired id; just like in \code{\link{translate}}.
#' @param post.to Second part of translation after mapping.
#' @param ... Additional arguments sent to \code{\link{translate}}.
#' @return List. Names of list corresponds to \code{values}, except those that could not be mapped nor translated.
#'               Entries are character vectors.
#' @references \code{?hom.Hs.inp.db} - \url{https://inparanoidb.sbc.su.se/}
#'
#'  Berglund, A.C., Sjolund, E., Ostlund, G., Sonnhammer, E.L.L. (2008)
#'  InParanoid 6: eukaryotic ortholog clusters with inparalogs
#'  \emph{Nucleic Acids Res.} \bold{36}:D263--266
#'
#'  O'Brien, K.P., Maido, R., Sonnhammer, E.L.L (2005)
#'  Inparanoid: A Comprehensive Database of Eukaryotic Orthologs
#'  \emph{NAR} \bold{33}:D476--D480
#'
#'  Remm, M., Storm, C.E.V, Sonnhammer, E.L.L (2001)
#'  Automatic clustering of orthologs and in-paralogs from pairwise species comparisons
#'  \emph{J. Mol. Biol.} \bold{314}:1041--1052
#'
#' @seealso \code{\link{translate}}, \code{\link{.getTableName}}, \code{\link{mapLists}}
#' @export
#' @author Stefan McKinnon Edwards \email{stefan.hoj-edwards@@agrsci.dk}
#' @examples
#' tmp <-1
#'

getOrthologs <- function(values, mapping, genus, threshold=1,
                         pre.from=NULL, pre.to=NULL,
                         post.from=NULL, post.to=NULL,
                         ...) {
  values <- as.character(values)
  values <- unique(values)

  threshold <- as.numeric(threshold)
  threshold <- max(0, min(threshold, 1))

  # Check if we do some translating first:
  if (!is.null(pre.from)) {
    trans1 <- translate(values, pre.from, pre.to, ...)
    values <- unlist(trans1, use.names=F)
  }

  # Check validity of `mapping` and genus.
  stopifnot(dbmeta(dbconn(mapping), "DBSCHEMA") == 'INPARANOID_DB')
  stopifnot(nchar(genus) == 5)
  .dbEscapeString(genus)
  genus <- toupper(genus)

  # Get the table name and check that it exists
  tbl <- .getTableName(genus)

  if ((length(tbl) == 0) | !(tbl %in% dbListTables(dbconn(mapping))))
    stop('Provided genus was not recognized for the mapping object.')

  # Do the DB magic
  conn <- dbConnect(dbDriver('SQLite'), '')   # Create a temporary table.
  dbSendQuery(conn, paste("ATTACH DATABASE '",dbfile(mapping),"' AS hom", sep=''))
  res <- dbSendQuery(conn, 'CREATE TABLE input (id1 TEXT);')
  dbClearResult(res)
  dbWriteTable(conn, 'input', data.frame(id1=values), row.names = FALSE, overwrite=FALSE, append=TRUE )
  #dbSendQuery(conn, 'BEGIN TRANSACTION')
  #bwahh <- sapply(values, function(s) dbSendQuery(conn, paste('INSERT INTO input (id1) VALUES ("',s,'")', sep='')))
  #dbSendQuery(conn, 'COMMIT TRANSACTION')

  # Proceed as normal, now that we have loaded our data. :)
  dbSendQuery(conn, sprintf('CREATE TABLE clusters AS SELECT id1, clust_id FROM input INNER JOIN hom.%s as inp ON inp.inp_id=id1 WHERE inp.score >= %i AND inp.seed_status = "100%%"', tbl, threshold))
  #res <- dbGetQuery(conn, sprintf('SELECT id1, clust_id FROM input INNER JOIN hom.%s as inp ON inp.inp_id=id1', tbl))
  isnot <- ifelse(direction(mapping) == 1, 'IS', 'IS NOT')
  res <- dbGetQuery(conn, sprintf('SELECT id1, inp_id FROM clusters INNER JOIN hom.%s as inp ON inp.clust_id=clusters.clust_id WHERE inp.score >= %i AND inp.species %s "%s" AND inp.seed_status = "100%%"', tbl, threshold, isnot, genus))

  dbDisconnect(conn)

  # A bit of cleaning up
  #res.list <- unstack(res, res$inp_id ~ res$id1)
  res.list <- split(res$inp_id, f=factor(res$id1, levels=unique(res$id1)))

  if (!is.null(pre.from)) {
    res.list <- mapLists(trans1, res.list)
  }
  if (!is.null(post.from)) {
    trans2 <- translate(res$inp_id, post.from, post.to, ...)
    res.list <- mapLists(res.list, trans2)
  }
  res.list <- lapply(res.list, unique)

  return(res.list)
}


#'  Gets the table name from the INPARANOID style genus names.
#' @param genus 5 character INPARANOID genus name, such as "BOSTA", "HOMSA" or "MUSMU".
#' @return Table name for genus.
#' @references \url{https://www.bioconductor.org/packages/release/bioc/html/AnnotationDbi.html}
#' @author Stefan McKinnon Edwards \email{stefanm.edwards@@agrsci.dk}
.getTableName <- function(genus) {
  # Find the AnnotationDbi source
  # Open createAnnObjs.INPARANOID_DB.R
  # Find the long bit of code that create variable 'fields' with all the species and the 5-character genus names.
  # Create variable fields from it and use the next three lines to swap names and values.
  # tmp <- fields
  # fields <- names(fields)
  # names(fields) <- tmp
  # Execute 'fix(fields)' and paste the result down here:
  fields <- structure(c("Acyrthosiphon_pisum", "Aedes_aegypti", "Anopheles_gambiae",
                        "Apis_mellifera", "Arabidopsis_thaliana", "Aspergillus_fumigatus",
                        "Batrachochytrium_dendrobatidis", "Bombyx_mori", "Bos_taurus",
                        "Branchiostoma_floridae", "Brugia_malayi", "Caenorhabditis_brenneri",
                        "Caenorhabditis_briggsae", "Caenorhabditis_elegans", "Caenorhabditis_japonica",
                        "Caenorhabditis_remanei", "Candida_albicans", "Candida_glabrata",
                        "Canis_familiaris", "Capitella_spI", "Cavia_porcellus", "Chlamydomonas_reinhardtii",
                        "Ciona_intestinalis", "Ciona_savignyi", "Coccidioides_immitis",
                        "Coprinopsis_cinereus", "Cryptococcus_neoformans", "Cryptosporidium_hominis",
                        "Cryptosporidium_parvum", "Culex_pipiens", "Cyanidioschyzon_merolae",
                        "Danio_rerio", "Daphnia_pulex", "Debaryomyces_hansenii", "Dictyostelium_discoideum",
                        "Drosophila_ananassae", "Drosophila_grimshawi", "Drosophila_melanogaster",
                        "Drosophila_mojavensis", "Drosophila_pseudoobscura", "Drosophila_virilis",
                        "Drosophila_willistoni", "Entamoeba_histolytica", "Equus_caballus",
                        "Escherichia_coliK12", "Fusarium_graminearum", "Gallus_gallus",
                        "Gasterosteus_aculeatus", "Giardia_lamblia", "Helobdella_robusta",
                        "Homo_sapiens", "Ixodes_scapularis", "Kluyveromyces_lactis",
                        "Leishmania_major", "Lottia_gigantea", "Macaca_mulatta", "Magnaporthe_grisea",
                        "Monodelphis_domestica", "Monosiga_brevicollis", "Mus_musculus",
                        "Nasonia_vitripennis", "Nematostella_vectensis", "Neurospora_crassa",
                        "Ornithorhynchus_anatinus", "Oryza_sativa", "Oryzias_latipes",
                        "Ostreococcus_tauri", "Pan_troglodytes", "Pediculus_humanus",
                        "Physcomitrella_patens", "Phytophthora_ramorum", "Phytophthora_sojae",
                        "Plasmodium_falciparum", "Plasmodium_vivax", "Pongo_pygmaeus",
                        "Populus_trichocarpa", "Pristionchus_pacificus", "Puccinia_graminis",
                        "Rattus_norvegicus", "Rhizopus_oryzae", "Saccharomyces_cerevisiae",
                        "Schistosoma_mansoni", "Schizosaccharomyces_pombe", "Sclerotinia_sclerotiorum",
                        "Sorghum_bicolor", "Stagonospora_nodorum", "Strongylocentrotus_purpuratus",
                        "Takifugu_rubripes", "Tetrahymena_thermophila", "Tetraodon_nigroviridis",
                        "Thalassiosira_pseudonana", "Theileria_annulata", "Theileria_parva",
                        "Tribolium_castaneum", "Trichomonas_vaginalis", "Trichoplax_adhaerens",
                        "Trypanosoma_cruzi", "Ustilago_maydis", "Xenopus_tropicalis",
                        "Yarrowia_lipolytica"), .Names = c("ACYPI", "AEDAE", "ANOGA",
                                                           "APIME", "ARATH", "ASPFU", "BATDE", "BOMMO", "BOSTA", "BRAFL",
                                                           "BRUMA", "CAEBRE", "CAEBR", "CAEEL", "CAEJA", "CAERE", "CANAL",
                                                           "CANGL", "CANFA", "CAPSP", "CAVPO", "CHLRE", "CIOIN", "CIOSA",
                                                           "COCIM", "COPCI", "CRYNE", "CRYHO", "CRYPA", "CULPI", "CYAME",
                                                           "DANRE", "DAPPU", "DEBHA", "DICDI", "DROAN", "DROGR", "DROME",
                                                           "DROMO", "DROPS", "DROVI", "DROWI", "ENTHI", "EQUCA", "ESCCO",
                                                           "FUSGR", "GALGA", "GASAC", "GIALA", "HELRO", "HOMSA", "IXOSC",
                                                           "KLULA", "LEIMA", "LOTGI", "MACMU", "MAGGR", "MONDO", "MONBR",
                                                           "MUSMU", "NASVI", "NEMVE", "NEUCR", "ORNAN", "ORYSA", "ORYLA",
                                                           "OSTTA", "PANTR", "PEDPA", "PHYPA", "PHYRA", "PHYSO", "PLAFA",
                                                           "PLAVI", "PONPY", "POPTR", "PRIPA", "PUCGR", "RATNO", "RHIOR",
                                                           "SACCE", "SCHMA", "SCHPO", "SCLSC", "SORBI", "STANO", "STRPU",
                                                           "TAKRU", "TETTH", "TETNI", "THAPS", "THEAN", "THEPA", "TRICA",
                                                           "TRIVA", "TRIAD", "TRYCR", "USTMA", "XENTR", "YARLI"))

  genus <- toupper(genus)
  return(removeNAs(fields[genus]))
}

#'  Private Escape string
#'
#'  Does not escape strings, but raises an error if any character expect normal letters and underscores are found in the string.
#' @param str String to test
#' @param raise.error Logical, whether to raise an error or not.
#' @return Invisible logical
#'
.dbEscapeString <- function(str, raise.error=TRUE) {
  matches <- grepl('[^A-Za-z0-9_]+', str)
  res <- any(matches)
  if (raise.error & res) stop('Supplied SQL string contains illegal characters!')
  invisible(res)
}

## Welcome message
output$Welcome <- renderUI({
  wellPanel(
    h5("Welcome to bioCancer!", align="center"),
    HTML("Help is available on each page by clicking the <i title='Help' class='fa fa-question'></i> icon on the bottom left of your screen."),
    checkboxInput(
      'overview_id', 'Pipeline Overview', value = FALSE
    )
  )
})

output$pipeline <- renderUI({
  tagList(
    h4("Schematic view of bioCancer pipeline:"),
    h5(" The pipeline consists of three major panels:"),
    h5("1- Portal loads own gene list and explore profiles data of cancer studies."),
    h5("2- Processing exchanges data with user computer, Portal section, and Circomics tab.
       It provides useful tools for pre-processing, processing, and plotting graphs."),
    h5("3- Enrichment integrates methods for classification and clustering and displays the results as interactive graphs.")
    )
})

output$overview <- renderImage({

  list(src = file.path( getOption("radiant.path.bioCancer"),"app/tools/help/figures/overview_methods.png"),
       contentType = 'image/png',
       width = 600,
       height = 500,
       deleteFile = FALSE,
       alt = "This is alternate text"
  )}, deleteFile = FALSE
)


output$dl_Studies_tab <- shiny::downloadHandler(
  filename = function() { paste0("Studies_tab.csv") },
  content = function(file) {
    # append _rows_all to StudiesTable ID of the "Studies" dataframe
    get_data(Studies[input$StudiesTable_rows_all,], vars = NULL,
            rows = NULL,
            na.rm = FALSE) %>%
      write.csv(file, row.names = FALSE)
  }
)

output$ui_Studies <- renderUI({
  #help_modal_km('Workflow Overview','StudiesHelp',inclMD(file.path(r_path,"base/tools/help/Studies.md")))
  help_and_report(modal_title = "Workflow Overview", fun_name = "Studies",
                  author = "Karim Mezhoud",
                  help_file = inclRmd(file.path(
                    getOption("radiant.path.bioCancer"),"app/tools/help/Studies.md")))

})

output$StudiesTable <- DT::renderDataTable({
  shiny::withProgress(message = 'loading Studies from cBioPortal server...', value = 1, {

  displayTable(Studies)
  })

})

######### ## functions that are not longer used by radiant.data ###########


## check if a button was pressed
pressed <- function(x) !is.null(x) && (is.list(x) || x > 0)

## check if a button was NOT pressed
not_pressed <- function(x) !pressed(x)



plot_downloader <- function(plot_name,
                            width = plot_width,
                            height = plot_height,
                            pre = ".plot_",
                            po = "dl_",
                            fname = plot_name) {
  ## link and output name
  lnm <- paste0(po, plot_name)
  ## create an output
  output[[lnm]] <- downloadHandler(
    filename = function() {
      paste0(fname, ".png")
    },
    content = function(file) {
      ## download graphs in higher resolution than shown in GUI (504 dpi)
      pr <- 5
      ## fix for https://github.com/radiant-rstats/radiant/issues/20
      w <- if (any(c("reactiveExpr", "function") %in% class(width))) width() * pr else width * pr
      h <- if (any(c("reactiveExpr", "function") %in% class(height))) height() * pr else height * pr
      plot <- try(get(paste0(pre, plot_name))(), silent = TRUE)
      if (is(plot, "try-error") || is.character(plot) || is.null(plot)) {
        plot <- ggplot() + labs(title = "Plot not available")
        pr <- 1
        w <- h <- 500
      }
      png(file = file, width = w, height = h, res = 96 * pr)
      print(plot)
      dev.off()
    }
  )
  downloadLink(lnm, "", class = "fa fa-download alignright")
}

## Avoid `XQuartz` requirement in radiant.data
## request XQuartz
## see https://github.com/tidyverse/ggplot2/issues/2655
if(!identical(getOption("bitmapType"), "cairo") && isTRUE(capabilities()[["cairo"]])) {
  options(bitmapType = "cairo")
}

  #############################################
  #  FUNCTIONS can not load from radiant.data #
  #############################################

#
# if (getOption("radiant.shinyFiles", FALSE)) {
#   download_link <- function(id) {
#     uiOutput(paste0("ui_", id))
#   }
#
#   download_button <- function(id, ...) {
#     uiOutput(paste0("ui_", id))
#   }
#
#   download_handler <- function(
#     id, label = "", fun = id, fn, type = "csv", caption = "Save to csv",
#     class = "", ic = "download", btn = "link", ...
#   ) {
#     ## create observer
#     shinyFiles::shinyFileSave(input, id, roots = sf_volumes, session = session)
#
#     ## create renderUI
#     if (btn == "link") {
#       output[[paste0("ui_", id)]] <- renderUI({
#         if (is.function(fn)) fn <- fn()
#         if (is.function(type)) type <- type()
#         shinyFiles::shinySaveLink(
#           id, label, caption, filename = fn, filetype = type,
#           class = "alignright", icon = icon(ic)
#         )
#       })
#     } else {
#       output[[paste0("ui_", id)]] <- renderUI({
#         if (is.function(fn)) fn <- fn()
#         if (is.function(type)) type <- type()
#         shinyFiles::shinySaveButton(
#           id, label, caption, filename = fn, filetype = type,
#           class = class, icon = icon("download")
#         )
#       })
#     }
#
#     observeEvent(input[[id]], {
#       if (is.integer(input[[id]])) return()
#       path <-  shinyFiles::parseSavePath(sf_volumes, input[[id]])
#       if (!inherits(path, "try-error") && !is_empty(path$datapath)) {
#         fun(path$datapath, ...)
#       }
#     })
#   }
# } else {
#   download_link <- function(id) {
#     downloadLink(id, "", class = "fa fa-download alignright")
#   }
#   download_button <- function(id, label = "Save", ic = "download", class = "", ...) {
#     downloadButton(id, label, class = class)
#   }
#   download_handler <- function(
#     id, label = "", fun = id, fn, type = "csv", caption = "Save to csv",
#     class = "", ic = "download", btn = "link", ...
#   ) {
#     output[[id]] <- downloadHandler(
#       filename = function() {
#         if (is.function(fn)) fn <- fn()
#         if (is.function(type)) type <- type()
#         paste0(fn, ".", type)
#       },
#       content = function(path) { fun(path, ...) }
#     )
#   }
# }

#' Launch bioCancer with default browser
#'
#' @return  web page of bioCancer Shiny App
#' @usage bioCancer()
#' @description The Main function to run bioCancer App
#'
#' @examples
#' ShinyApp <-  1
#' \dontrun{
#' bioCancer()
#' }
#' @name bioCancer
#' @docType package
#' @import cBioPortalData
#' @import radiant.data
#' @importFrom utils capture.output read.table tail stack
#' @importFrom geNetClassifier calculateGenesRanking
#' @importFrom geNetClassifier genesDetails
#' @importFrom Biobase ExpressionSet
#' @importFrom Biobase exprs
#' @importFrom AnnotationDbi mget dbmeta dbconn
#' @importFrom org.Hs.eg.db org.Hs.egSYMBOL2EG
#' @import DOSE
#' @importFrom clusterProfiler enricher
#' @importFrom clusterProfiler compareCluster
#' @importFrom clusterProfiler enrichGO
#' @importFrom clusterProfiler enrichKEGG
#' @import reactome.db
#' @import ReactomePA
#' @import DiagrammeR
#' @importFrom DiagrammeR grViz
#' @importFrom DiagrammeR renderGrViz
#' @importFrom DiagrammeR grVizOutput
#' @importFrom XML xmlInternalTreeParse
#' @importFrom XML xmlValue
#' @importFrom visNetwork renderVisNetwork visNetwork visNodes visEdges visOptions
#' @importFrom visNetwork visHierarchicalLayout visExport visLegend visPhysics visNetworkOutput visExport
#' @importFrom dplyr select
#' @importFrom tidyr spread
#' @importFrom methods   new
#' @import AlgDesign GO.db R.methodsS3 import org.Bt.eg.db shinythemes
#' @export

bioCancer <- function(){
  if ("package:bioCancer" %in% search()){
    shiny::runApp(system.file( "app", package = "bioCancer"), launch.browser = TRUE)
    #shiny::runApp(system.file("app", package = "bioCancer"), launch.browser = TRUE)
  }else{
    stop("Install and load bioCancer package before to run it.")
  }
}

#' Default dataset of bioCancer
#'
#' @author Karim Mezhoud \email{kmezhoud@gmail.com}
"epiGenomics"

#' Example of Copy Number Alteration (CNA) dataset
#'
#' @author Karim Mezhoud \email{kmezhoud@gmail.com}
"user_CNA"

#' Example of Methylation HM27 dataset
#'
#' @author Karim Mezhoud \email{kmezhoud@gmail.com}
"user_MetHM27"

#' Example of Methylation HM450 dataset
#'
#' @author Karim Mezhoud \email{kmezhoud@gmail.com}
"user_MetHM450"

#' Example of Mutation dataset
#'
#' @author Karim Mezhoud \email{kmezhoud@gmail.com}
"user_Mut"

#' Example of mRNA expression dataset
#'
#' @author Karim Mezhoud \email{kmezhoud@gmail.com}
"user_mRNA"

cbind.na <- function (..., deparse.level = 1)
{
  na <- nargs() - (!missing(deparse.level))
  deparse.level <- as.integer(deparse.level)
  stopifnot(0 <= deparse.level, deparse.level <= 2)
  argl <- list(...)
  while (na > 0 && is.null(argl[[na]])) {
    argl <- argl[-na]
    na <- na - 1
  }
  if (na == 0)
    return(NULL)
  if (na == 1) {
    if (isS4(..1))
      return(cbind2(..1))
    else return(matrix(...))  ##.Internal(cbind(deparse.level, ...)))
  }
  if (deparse.level) {
    symarg <- as.list(sys.call()[-1L])[1L:na]
    Nms <- function(i) {
      if (is.null(r <- names(symarg[i])) || r == "") {
        if (is.symbol(r <- symarg[[i]]) || deparse.level ==
            2)
          deparse(r)
      }
      else r
    }
  }
  ## deactivated, otherwise no fill in with two arguments
  if (na == 0) {
    r <- argl[[2]]
    fix.na <- FALSE
  }
  else {
    nrs <- unname(lapply(argl, nrow))
    iV <- sapply(nrs, is.null)
    fix.na <- identical(nrs[(na - 1):na], list(NULL, NULL))
    ## deactivated, otherwise data will be recycled
    #if (fix.na) {
    #    nr <- max(if (all(iV)) sapply(argl, length) else unlist(nrs[!iV]))
    #    argl[[na]] <- cbind(rep(argl[[na]], length.out = nr),
    #        deparse.level = 0)
    #}
    if (deparse.level) {
      if (fix.na)
        fix.na <- !is.null(Nna <- Nms(na))
      if (!is.null(nmi <- names(argl)))
        iV <- iV & (nmi == "")
      ii <- if (fix.na)
        2:(na - 1)
      else 2:na
      if (any(iV[ii])) {
        for (i in ii[iV[ii]]) if (!is.null(nmi <- Nms(i)))
          names(argl)[i] <- nmi
      }
    }
    
    ## filling with NA's to maximum occuring nrows
    nRow <- as.numeric(sapply(argl, function(x) NROW(x)))
    maxRow <- max(nRow, na.rm = TRUE)
    argl <- lapply(argl, function(x)  if (is.null(nrow(x))) c(x, rep(NA, maxRow - length(x)))
                   else rbind.na(x, matrix(, maxRow - nrow(x), ncol(x))))
    r <- do.call(cbind, c(argl[-1L], list(deparse.level = deparse.level)))
  }
  d2 <- dim(r)
  r <- cbind2(argl[[1]], r)
  if (deparse.level == 0)
    return(r)
  ism1 <- !is.null(d1 <- dim(..1)) && length(d1) == 2L
  ism2 <- !is.null(d2) && length(d2) == 2L && !fix.na
  if (ism1 && ism2)
    return(r)
  Ncol <- function(x) {
    d <- dim(x)
    if (length(d) == 2L)
      d[2L]
    else as.integer(length(x) > 0L)
  }
  nn1 <- !is.null(N1 <- if ((l1 <- Ncol(..1)) && !ism1) Nms(1))
  nn2 <- !is.null(N2 <- if (na == 2 && Ncol(..2) && !ism2) Nms(2))
  if (nn1 || nn2 || fix.na) {
    if (is.null(colnames(r)))
      colnames(r) <- rep.int("", ncol(r))
    setN <- function(i, nams) colnames(r)[i] <- if (is.null(nams))
      ""
    else nams
    if (nn1)
      setN(1, N1)
    if (nn2)
      setN(1 + l1, N2)
    if (fix.na)
      setN(ncol(r), Nna)
  }
  r
}

# for cBioPortal

cgds <- cBioPortalData::cBioPortal(
        hostname = "www.cbioportal.org",
        protocol = "https",
        api = "/api/v2/api-docs"
)
#Studies<- getCancerStudies.CGDS(cgds)
Studies <- cBioPortalData::getStudies(cgds)[c("name", "description", "studyId")]


#updateSelectizeInput(session, 'StudiesID', choices = Studies[,1], selected = "gbm_tcga_pub")

## get Cases in side bar panel
output$ui_Cases <- renderUI({
  shiny::withProgress(message = 'loading Cases from cBioPortal server...', value = 1, {
  #Sys.sleep(0.25)
  req(input$StudiesID)
  CaseLists <- cBioPortalData::sampleLists(cgds, studyId = input$StudiesID) |>
               pull(sampleListId)

  selectInput("CasesID", "Cases for selected study",
              choices= CaseLists,
              selected = "" #CaseLists[1]
  )
  })
})

## get Genetic Profiles in side bar panel
output$ui_GenProfs <- renderUI({
  shiny::withProgress(message = 'loading Genetic Profiles from cBioPortal server...', value = 1, {
  #Sys.sleep(0.25)
  req(input$StudiesID)
  GeneticProfiles <- cBioPortalData::molecularProfiles(api = cgds,
                                                       studyId = input$StudiesID) |>
                     pull(molecularProfileId)

  selectInput("GenProfID", "Genetic Profiles:",
              choices = GeneticProfiles,
              selected = "" #GeneticProfiles[1]
  )

  })
})

## get Gene List in side bar panel

output$ui_GeneList <- renderUI({
  shiny::withProgress(message = 'loading default Gene List ...', value = 1, {
    #Sys.sleep(0.25)
  selectInput("GeneListID", "Gene List:", r_data$genelist)
  })
})


output$ui_loadGeneList <- renderUI({
  wellPanel(
    conditionalPanel("input.GeneListID == 'DNA_damage_Response' && input.loadClip_GeneList%2 == 1",
                     p("Gene List is empty!",align="center",style = "color:red")
    ),

    radioButtons(inputId = "loadGeneListID", label = "Load Gene List:",
                 c( "examples" = "ExampleGeneList",  "clipboard" = "clipboard_GeneList"),
                 selected = state_multiple("loadGeneListID", "DNA_damage_Response"), inline = TRUE),

    conditionalPanel(condition = "input.loadGeneListID == 'clipboard_GeneList'",
                     actionButton('loadClip_GeneList', 'Paste Gene List')
                     #uiOutput("ui_clipboard_load_ProfData")
    ),
    conditionalPanel(condition = "input.loadGeneListID == 'ExampleGeneList'",
                     actionButton('loadExampleGeneList', 'Load examples')
    )

  )


})

# loading all examples files (linked to helpfiles)
observe({
  if (not_pressed(input$loadExampleGeneList)) return()
  isolate({

    # loading gene list
    data_path <- file.path( system.file(package = "bioCancer"),"extdata/GeneList")
    examples <- list.files(data_path)

    for (ex in examples) loadUserData(ex, file.path(data_path,ex), 'txt')

    # sorting files alphabetically
    r_data[['genelist']] <- sort(r_data[['genelist']])

    updateSelectInput(session, "GeneListID", label = "Gene List:",
                      choices = r_data$genelist,
                      selected = r_data$genelist[1])
  })
  #  A <<- r_data$genelist
})

## load genelist from clipBoard
observe({
  # 'reading' data from clipboard
  if (not_pressed(input$loadClip_GeneList)) return()
  isolate({
    loadClipboard_GeneList(tab=input$loadClip_GeneList)
    updateRadioButtons(session = session, inputId = "GeneListID",
                       label = "Paste Genes:",
                       c( "examples" = "ExampleGeneList",  "clipboard" = "clipboard_GeneList"),
                       #selected = "Genes",
                       inline = TRUE)
    updateSelectInput(session, "GeneListID", label = "Gene List:",
                      choices = r_data$genelist)
  })
})

#' get Edges dataframe for visNetwork function
#' @usage Edges_df()
#'
#' @return A data frame with egdes attributes
#'
#' @examples
#' example <- "run manually"
#' \dontrun{
#'  string1 <- "https://wiki.ubuntu.com/kmezhoud/bioCancer?"
#'  string2 <- "action=AttachFile&do=get&target=ListProfData.RData"
#'  link <- curl::curl(paste0(string1,string2, sep=""))
#'  load(link)
#' ##load(paste(path.package("bioCancer"),"/extdata/ListProfData.RData", sep=""))
#' Edges_df()
#' }
#'
#'
Edges_df <- function(){

  if(is.null(r_data$ReactomeFI)){
    shiny::withProgress(message = 'Loading ReactomeFI...', value = 1, {


      if("package:bioCancer" %in% search()) {
        r_data[['ReactomeFI']]  <- readRDS(paste0(system.file(package = "bioCancer"), "/extdata/ReactomeFI2021.RDS", sep=""))
      }else{
        r_data[['ReactomeFI']]  <- readRDS(file.path(paste(getOption("radiant.path.bioCancer"),"/extdata/ReactomeFI2021.RDS", sep="")))
      }

    })
  }

  #GeneList <- c("DKK3", "NBN", "MYO6", "TP53","PML", "IFI16", "BRCA1")
  GeneList <- whichGeneList(input$GeneListID)

  ## Edges Attributes
  shiny::withProgress(message = 'load FI for GeneList...', value = 1, {

    fis <- getReactomeFI(2021,genes=GeneList, use.linkers = input$UseLinkerId) # input$UseLinkerNetId
  })
  shiny::withProgress(message = 'load gene relationships...', value = 1, {


    names(fis) <- c("Gene1", "Gene2")
    Edges_obj1 <- merge(r_data$ReactomeFI, fis, by=c("Gene1","Gene2"))
    names(fis) <- c("Gene2", "Gene1")
    Edges_obj2 <- merge(r_data$ReactomeFI, fis, by=c("Gene1","Gene2"))
    Edges_obj <- rbind(Edges_obj1,Edges_obj2)

    #     > head(Edges_obj)
    #     from to                                    Annotation Direction Score
    #     1  EGR1  TP53 expression regulated by; expression regulates       <->  1.00
    #     2  EGR1   UBB                          expression regulates        ->  1.00
    #     3  MYO6   UBB                                     predicted         -  0.61
    #     4   PML  TP53       complex; expression regulated by; input        <-  1.00
    #     5  TP53   UBB                  catalyze; complex; predicted        ->  1.00
    #     6 BRCA1  EGR1                       expression regulated by        <-  1.00

    ## Filter Annotation interaction
    #  Edges_obj <- Edges_obj[- grep(c("predic",activat), Edges_obj$Annotation),]
    #  Edges_obj <- Edges_obj[!grepl("predict|activat|binding|complex|indirect",Edges_obj$Annotation),]

    Edges_obj <- Edges_obj[grepl(paste0(input$FIs_AttId, collapse="|"),Edges_obj$Annotation),] #input$FIs_AttNetworkId

    ## skip infinity loop when load Reactome_Genelist
    if(is.null(r_data$Reactome_GeneList)){
      r_data[['Reactome_GeneList']] <- union(Edges_obj$Gene1, Edges_obj$Gene2)
    }else if (all(length(r_data$Reactome_GeneList) == length(union(Edges_obj$Gene1, Edges_obj$Gene2)))
              && all(r_data$Reactome_GeneList == union(Edges_obj$Gene1, Edges_obj$Gene2))
    ){

    }else{
      r_data[['Reactome_GeneList']] <- union(Edges_obj$Gene1, Edges_obj$Gene2)
    }
    ## Get interaction Frequency in dataframe FreqIn

    FreqIn <- rbind(t(t(table(as.character(Edges_obj$Gene2)))), t(t(table(as.character(Edges_obj$Gene1)))))
    colnames(FreqIn) <- "Freq"
    #FreqIn <- as.data.frame(FreqIn) %>% tibble::rownames_to_column("Genes")

    rnames <- rownames(FreqIn)
    rownames(FreqIn) <- NULL
    FreqIn <- as.data.frame(FreqIn)
    FreqIn <- cbind("Genes"= rnames, FreqIn)
    r_data[['FreqIn']] <- plyr::ddply(FreqIn,~Genes, dplyr::summarise,FreqSum=sum(Freq))


    rownames(Edges_obj) <- NULL

    Edges_obj <- as.data.frame(lapply(Edges_obj, function(x) gsub("<\\->","from;to", x)))
    Edges_obj <- as.data.frame(lapply(Edges_obj, function(x) gsub("\\|\\->","from;to", x)))
    Edges_obj <- as.data.frame(lapply(Edges_obj, function(x) gsub("<\\-\\|","to;from", x)))
    Edges_obj <- as.data.frame(lapply(Edges_obj, function(x) gsub("->","to", x)))
    Edges_obj <- as.data.frame(lapply(Edges_obj, function(x) gsub("<-","from", x)))
    Edges_obj <- as.data.frame(lapply(Edges_obj, function(x) gsub("\\|\\-","from", x)))
    Edges_obj <- as.data.frame(lapply(Edges_obj, function(x) gsub("\\-\\|","to", x)))
    Edges_obj <- as.data.frame(lapply(Edges_obj, function(x) gsub("-","none", x)))

    colnames(Edges_obj)<- c("from", "to","title","arrows" ,"width")

    #Edges_obj <- Edges_obj[1:150,]
  })
  ## add 3 column used with geneset enrichment
  Edges_obj <- cbind(Edges_obj,
                     dashes=FALSE,
                     smooth=FALSE,
                     shadow=FALSE
                     #length= NULL
  )
  return(Edges_obj)
}

#' Data frame with Nodes id
#'
#' @return A data frame with nodes id
#'
#' @usage Node_df(genelist, freqIn)
#' @param genelist a vector of genes
#' @param freqIn dataframe with Node interaction frequencies
#'
#' @examples
#'
#' example <- "run Manually"
#' \dontrun{
#'  string1 <- "https://wiki.ubuntu.com/kmezhoud/bioCancer?"
#'  string2 <- "action=AttachFile&do=get&target=ListProfData.RData"
#'  link <- curl::curl(paste0(string1,string2, sep=""))
#'  load(link)
#' node_df <- Node_df(GeneList, FreqIn )
#'}
#'
# FreqIn
# Genes FreqSum
# 1   ATM       4
# 2   ATR       5
# 3 BRCA1       5
# 4 BRCA2       3

Node_df <- function(genelist, freqIn){
  FreqIn <- freqIn
  FreqIn[["shape"]]<- unname(sapply(FreqIn$Genes,  function(x) attriShape2Node(x, genelist)))
  FreqIn$FreqSum  <- FreqIn$FreqSum / 10
  names(FreqIn) <- c("id","FreqSum","shape")
  FreqIn[["label"]] <- FreqIn$id
  GeneFreq <- FreqIn[,c(1,3,4)]
  #GeneFreq <- data.frame(lapply(GeneFreq[,names(GeneFreq)] , as.factor))
  if(exists("r_data") && !is.null(r_data[['GenesClassDetails']])){
    if(input$NodeAttri_ClassifierID == 'mRNA'|| input$NodeAttri_ClassifierID == 'mRNA/Studies'){
      colorsVector <- sapply(r_data$GenesClassDetails$exprsMeanDiff,
                             function(x) as.character(attriColorVector(x,r_data$GenesClassDetails$exprsMeanDiff ,colors=c("blue","white","red"), feet=1)))
      colors_df <- data.frame(id = r_data$GenesClassDetails$Genes,color = colorsVector)
      colors_df <- data.frame(lapply(colors_df, as.character), stringsAsFactors=FALSE)
      merge1 <- dplyr::inner_join(GeneFreq, colors_df, by="id")
      merge1 <- data.frame(merge1, value= "1")
      diff1 <- dplyr::anti_join(GeneFreq, colors_df, by="id")
      diff1 <- data.frame (diff1, color= "lightgrey", value= "1")
      GeneFreq <- rbind(merge1, diff1)
    }
  }else{
    GeneFreq <- cbind(GeneFreq,color="lightgrey", value="1")
  }
  return(GeneFreq)
}

#' Gene Set enrichment using Reactome FI methods
#'
#' @return A data frame with Gene Set enrichment: BP,MF, CC, Pathway, pval, FDR
#' @usage getAnnoGeneSet_df(genelist, type)
#' @param genelist vector of genes
#' @param type "BP", "pathway","CC", "MF"
#'
#' @examples
#' GeneList <- whichGeneList("DNA_damage_Response")
#' geneSet_df <- getAnnoGeneSet_df(GeneList, "BP")
#'
getAnnoGeneSet_df <- function(genelist,type){
  # type = c("Pathway", "BP", "CC", "MF")
  # type <- input$TypeGeneSetID
  #type <- match.arg(type)

  ## Query GeneSet Annotation
  AnnoGeneSet <- queryAnnotateGeneSet(2014, t(genelist) ,type)

  if(nrow(AnnoGeneSet)== 0){
    GeneSet_df <- data.frame(from = "",
                             to = "",
                             title= "",
                             arrows= "",
                             width = "0",
                             dashes = TRUE,
                             smooth = FALSE,
                             shadow = FALSE
                             #length = NULL
    )
  }else{

    ## Filter significant annotation using FDR
    AnnoGeneSet <- AnnoGeneSet[AnnoGeneSet$fdr < input$GeneSetFDRID,]  #input$GeneSetFDRID

    r_data[['AnnoGeneSet']] <- AnnoGeneSet

    if(nrow(AnnoGeneSet)== 0){
      GeneSet_df <- data.frame(from = "",
                               to = "",
                               title= "",
                               arrows= "",
                               width = "0",
                               dashes = TRUE,
                               smooth = FALSE,
                               shadow = FALSE
                               #length = NULL
      )
    } else{

      #r_data[['MinGeneSetFDR']] <- min(AnnoGeneSet$fdr, na.rm = TRUE)

      ## Split hits to a list
      key0 <- strsplit(AnnoGeneSet$hits, ",")

      ## from Martin Morgan  http://stackoverflow.com/questions/12837462/how-to-subset-data-with-advance-string-matching

      Index_Gene <- data.frame(index = rep(seq_along(key0), sapply(key0, length)),ID = unlist(key0))

      ## Maybe useful add GeneList with index and genes
      #ref_GeneSet  <-  cbind(GeneSet = AnnoGeneSet_hits[subset[,1],2],subset)

      GeneSet_df <- data.frame(from = Index_Gene[,1],
                               to = Index_Gene[,2],
                               title= input$TypeGeneSetID,
                               arrows= "to",
                               width = "0.3",
                               dashes = TRUE,
                               smooth = FALSE,
                               shadow = FALSE
                               #length = NULL
      )

    }
  }
  return(GeneSet_df)
}


output$network <- visNetwork::renderVisNetwork({
  GeneList <- whichGeneList(input$GeneListID)

  edges <- Edges_df()
  nodes <-  Node_df(genelist = GeneList, freqIn = r_data$FreqIn)

  # if(input$NodeAttri_ReactomeID == 'Freq. Interaction'){ #input$NodeAttri_NetworkID
  #   ## Nodes Frequncy interaction Attributes
  #   value <- Node_df_FreqIn(genelist = GeneList, freqIn = r_data$FreqIn)
  #   nodes[['value']] <- value
  # }
  #if(input$NodeAttri_ReactomeID == 'FreqInt./GeneSet'||input$NodeAttri_ReactomeID == 'GeneSet'){ #input$NodeAttri_NetworkID
  ## Nodes Attributes
  value <- Node_df_FreqIn(GeneList, freqIn = r_data$FreqIn)
  nodes[['value']] <- value

  #if(input$NodeAttri_ReactomeID == 'GeneSet'){
  if(input$TypeGeneSetID =="None"){

  }else if(input$TypeGeneSetID =="Pathway" ||
           input$TypeGeneSetID =="BP" ||
           input$TypeGeneSetID =="CC" ||
           input$TypeGeneSetID =="MF"
  ){
    GeneSetAnno_df <- getAnnoGeneSet_df(GeneList,type = input$TypeGeneSetID)  #input$TypeGeneSetID== BP, Pathway, CC, FN
    GeneSetAnno_df[,1] <- as.factor(GeneSetAnno_df[,1])

    edges<- rbind(edges, GeneSetAnno_df)

    nodesForGeneSet <- data.frame(id=unique(GeneSetAnno_df[,1]),
                                  shape= "text",
                                  label= paste(input$TypeGeneSetID,unique(GeneSetAnno_df[,1]), sep=""),
                                  color= "lightgrey",
                                  value= "0.4"
    )
    nodes <- rbind(nodes, nodesForGeneSet)
  }
  #}
  #}

  ###### Attributes from geNetClassifier
  if(exists("r_data") && !is.null(r_data[['GenesClassDetails']])){
    if(input$NodeAttri_ClassifierID == 'mRNA/Studies' ||
       input$NodeAttri_ClassifierID == 'mRNA'  ){
      nodes <- rbind(nodes, Node_Diseases_obj(genesclassdetails = r_data$GenesClassDetails)) #r_data$GenesClassDetails
      edges <- rbind(edges, Edges_Diseases_obj(r_data$GenesClassDetails))
    }
  }

  #
  #   lnodes <- data.frame(label = c("Gr A", "Gr B"),
  #                        shape = c( "circle","square"), color = c("red", "blue"),
  #                        title = "mRNA", id = 1:2)
  #
  #   ledges <- data.frame(color = c("lightblue", "red"),
  #                        label = c("reverse", "depends"), arrows =c("to", "from"))



  graphe <- visNetwork::visNetwork(nodes, edges, height = "100%",width = "100%") #%>%


  ## resizing nodes is not possible without scaling option. this is useful for circle, box shape
  ## see https://github.com/DataKnowledge/visNetwork/issues/49
  visNetwork::visNodes(graph = graphe, scaling = list(label = list(enabled = TRUE)))#%>%
  visNetwork::visNodes(graph = graphe, color = list(label = list(enabled = TRUE)))#%>%
  #visEdges(scaling = list(label = list(enabled = TRUE)))%>%
  graphe <- visNetwork::visOptions(graph= graphe, manipulation = TRUE,
                                   #selectedBy = "group",
                                   highlightNearest = TRUE )#%>%

  r_data[['graphe']] <- graphe
  # visNetwork::visHierarchicalLayout(graph = graphe,enabled =  as.logical(input$enableHierarchiId),
  #                      direction = input$Hierarchi_AttId,
  #                     sortMethod= input$MethodHierarchiId)#%>%
  #
  # visNetwork::visPhysics(graph = graphe, solver = input$PhysicLayoutId  ## ’barnesHut’, ’repulsion’, ’hierarchicalRepulsion’, ’forceAtlas2Based’
  #            #,forceAtlas2Based = "avoidOverlap"
  #            )

  #     visNodes(color = list(border =  '#2B7CE9',background = '#97C2FC',highlight = "red"),
  #              font = '10px arial red',
  #              labelHighlightBold = NULL,
  #              borderWidth=3.5 ,
  #              #scaling = c(10,15,13,17,2.0,2.3,6,3,2.3,11),
  #              borderWidthSelected = 7) %>%
  #
  # visNetwork::visSave(graph= graphe, file = "network.html") #%>%
  visNetwork::visExport(graph= graphe,type = "png", name = "network",
                        label = paste0("Export as png"), background = "#fff",
                        float = "left", style = NULL, loadDependencies = TRUE)

  #visNetwork::visLegend(graph = graphe,
  #                     addNodes= nodes,
  #                    addEdges= edges,
  #useGroups= TRUE,
  #                   position="left")

})

observe({
  network <- visNetwork::visNetworkProxy("network")
  #  if(input$enableHierarchiId){
  conditionalPanel("input.enableHierarchiId==true",
                   visNetwork::visHierarchicalLayout(network, enabled= input$enableHierarchiId,
                                                     direction = input$Hierarchi_AttId,
                                                     sortMethod= input$MethodHierarchiId)
  )
  # }else{
  conditionalPanel("input.enableHierarchiId==false",
                   visNetwork::visPhysics(network, solver = input$PhysicLayoutId )

  )
  #}

})

observeEvent(input$saveVisNetworkWidget, {

  # temporarily switch to the temp dir, in case you do not have write
  # permission to the current working directory
  #owd <- setwd(tempdir())
  #on.exit(setwd(owd))

  if(Sys.info()["sysname"] == "Windows") {
    setwd(Sys.getenv("R_USER"))
  }else{
    setwd('~/')
  }
  ###  DO NOT CAPTURE NETWORK

  # widgetThumbnail(r_data$graphe, "visNetwork")
  # showModal(modalDialog(
  #   size = "s",
  #   title = "save success : html, png",
  #   paste0( " The file is saved successfully in ", getwd(), " folder as visNetwok.png file.", sep = "  ")
  # ))

  ## BEST SOLUTION
  htmlwidgets::saveWidget(r_data$graphe, file="graphe.html", selfcontained = F)

  showModal(modalDialog(
    size = "s",
    title = "save success : html",
    paste0( " The file is saved successfully in ", getwd(), " folder as graphe.html file.", sep = "  ")
  ))

  ##  webshot Not working
  #webshot::webshot(paste0(getwd(),"/grpahe.html"), file = "Rplot.png", cliprect = "viewport")
  #file.copy("Rplot.png",file,overwrite = TRUE)
  #download.file(getwd() , 'graphe.html')
})

#' Return message when the filter formula is not correct (mRNA > 500)
#'
#' @return  text message
#' @usage returnTextAreaInput(inputId,
#'                           label= NULL,
#'                           rows = 2,
#'                          placeholder = NULL,
#'                          resize= "vertical",
#'                          value = "")
#'
#' @param inputId The ID of the object
#' @param label Text describes the box area
#' @param rows  Number of rows
#' @param placeholder  Error message if needed 
#' @param resize orientation of text
#' @param value default text in the area box
#' 
#' @examples
#' ShinyApp <-  1
#' \dontrun{
#' returnTextAreaInput(inputId = "data-filter",
#'                     label = "Error message",
#'                     rows =  2,
#'                     placeholder = "Provide a filter (e.g., Genes == 'ATM') and press return",
#'                     resize = "vertical",
#'                     value="")
#' }
returnTextAreaInput <- function(inputId,
                                label = NULL,
                                rows = 2,
                                placeholder = NULL,
                                resize = "vertical",
                                value = "") {
  tagList(
    tags$label(label, `for` = inputId), br(),
    tags$textarea(
      value,
      id = inputId,
      type = "text",
      rows = rows,
      placeholder = placeholder,
      resize = resize,
      class = "returnTextArea form-control"
    )
  )
}

############################################
#    SOURCING FROM  radiant.data PACKAGE   #
############################################

## Must be in global.R before sourcing from bioCancer
options(radiant.path.data = system.file(package = "radiant.data"))
source(file.path(getOption("radiant.path.data"), "app/global.R"),
       encoding = getOption("radiant.encoding", default = "UTF-8"), local = TRUE)

## Setting bioCancer package path
options(radiant.path.bioCancer = system.file(package = "bioCancer"))

## option to change theme
options(radiant.nav_ui =
          list(windowTitle = "bioCancer" ,theme= shinythemes::shinytheme("cerulean") , id = "nav_radiant",
               inverse = TRUE, collapsible = TRUE, tabPanel("Workspace", withMathJax(), uiOutput("ui_data"))))



## change help menu function
## function to generate help, must be in global because used in ui.R
help_menu <- function(hlp) {
  tagList(
    navbarMenu("", icon = icon("question-circle"),
               tabPanel("Help", uiOutput(hlp), icon = icon("question")),
               #tabPanel("Videos", uiOutput("help_videos"), icon = icon("film")),
               tabPanel("About", uiOutput("help_about"), icon = icon("info")),
               tabPanel(tags$a("", href = "http://kmezhoud.github.io/bioCancer/", target = "_blank",
                               list(icon("globe"), "BioCancer docs"))),
               #tabPanel(tags$a("", href = "https://github.com/kmezhoud/bioCancer/issues", target = "_blank",
                #               list(icon("github"), "Report issue")))
    ),
    tags$head(
      tags$script(src = "js/session.js"),
      tags$script(src = "js/returnTextAreaBinding.js"),
      tags$script(src = "js/returnTextInputBinding.js"),
      tags$script(src = "js/video_reset.js"),
      tags$script(src = "js/message-handler.js"),
      tags$script(src = "js/run_return.js"),
      # tags$script(src = "js/draggable_modal.js"),
      tags$link(rel = "shortcut icon", href = "imgs/icon.png")
    )
  )
}
## needed to change author in the helps of the Menu help
options(radiant.help.cc = "&copy; Karim Mezhoud (2024) <a rel='license' href='http://creativecommons.org/licenses/by-nc-sa/4.0/'
        target='_blank'><img alt='Creative Commons License' style='border-width:0' src ='imgs/80x15.png' /></a></br>")


## set path for package
ifelse(grepl("bioCancer", getwd()) && file.exists("../../inst") , "..",
        system.file(package = "bioCancer")) %>%
  options(radiant.path.bioCancer = .)

## loading urls and ui
source(file.path(getOption("radiant.path.bioCancer"), "app/init.R"),
       encoding = getOption("radiant.encoding"), local = TRUE)

## loading functions no longer used by radiant.data
source(file.path(getOption("radiant.path.bioCancer"), "app/radiant_old.R"),
       encoding = getOption("radiant.encoding"), local = TRUE)


## needed to change figures in helps
addResourcePath("figures", file.path(getOption("radiant.path.bioCancer"), "app/tools/help/figures/"))
addResourcePath("imgs", file.path(getOption("radiant.path.bioCancer"), "app/www/logo/"))
#addResourcePath("js", file.path(getOption("radiant.path.bioCancer"), "app/www/js/"))
#addResourcePath("js", file.path(getOption("radiant.path.bioCancer"), "htmlwidgets/"))
#addResourcePath("js", file.path(getOption("radiant.path.bioCancer"), "htmlwidgets/tooltipster/"))

## set example data
options(radiant.example.data = "bioCancer")




## cleanup the global environment if stop button is pressed in Rstudio
## based on barbara's reply to
## https://community.rstudio.com/t/rstudio-viewer-window-not-closed-on-shiny-stopapp/4158/7?u=vnijs
onStop(function() {
  ## don't run if the stop button was pressed in Radiant
  if (!exists("r_data")) {
    unlink("~/r_figures/", recursive = TRUE)
    clean_up_list <- c(
      "r_sessions", "help_menu", "make_url_patterns", "import_fs",
      "init_data", "navbar_proj", "knit_print.data.frame", "withMathJax"
    )
    suppressWarnings(
      suppressMessages({
        res <- try(sapply(clean_up_list, function(x) if (exists(x, envir = .GlobalEnv)) rm(list = x, envir = .GlobalEnv)), silent = TRUE)
        rm(res)
      })
    )
    message("Stopped bioCancer\n")
    stopApp()
  }
})

output$cBioPortal <- renderUI({
  tagList(
    includeCSS(file.path(getOption("radiant.path.bioCancer"),"app/www/style.css")),
    sidebarLayout(
      sidebarPanel(
        wellPanel(
          conditionalPanel("input.tabs_cbioportal == 'Studies'",
                           uiOutput("Welcome"),
                           uiOutput("ui_Studies")),
          conditionalPanel("input.tabs_cbioportal != 'Studies'",
                           selectizeInput('StudiesID', 'Select a Study',
                              choices = Studies %>% pull(studyId),
                              selected = "gbm_tcga_pub",
                              multiple = FALSE
                           ),
                           uiOutput("ui_Cases"),
                           conditionalPanel("input.tabs_cbioportal != 'Clinical'",
                                            uiOutput("ui_GenProfs"),
                                            uiOutput("ui_GeneList"),
                                            uiOutput("ui_loadGeneList")

                           )
          ),

          conditionalPanel("input.tabs_cbioportal == 'Clinical'", uiOutput("ui_ClinicalData")),
          #conditionalPanel("input.tabs_cbioportal == 'ProfData'", uiOutput("ui_ProfData")),
          conditionalPanel("input.tabs_cbioportal == 'Profiles'", uiOutput("ui_MutData"))

        )
      ),
      mainPanel(
        conditionalPanel("input.overview_id == true",
                         uiOutput("pipeline"),
                         imageOutput("overview")
        ),

       # tags$hr(),

        tabsetPanel(id = "tabs_cbioportal",

                    tabPanel("Studies",
                             downloadLink("dl_Studies_tab", "", class = "fa fa-download alignright"),
                             DT::dataTableOutput(outputId = "StudiesTable")
                    ),
                    tabPanel("Clinical",
                             downloadLink("dl_Clinical_tab", "", class = "fa fa-download alignright"),
                             DT::dataTableOutput(outputId="ClinicalDataTable")

                    ),
                    # tabPanel("ProfData",
                    #          downloadLink("dl_ProfData_tab", "", class = "fa fa-download alignright"),
                    #          DT::dataTableOutput(outputId ="ProfDataTable")
                    #
                    # ),
                    tabPanel("Profiles",
                             downloadLink("dl_MutData_tab", "", class = "fa fa-download alignright"),
                             DT::dataTableOutput(outputId ="MutDataTable")
                    )
        )
      )
    )
  )
})

output$CircomicsHowto <- renderPrint({
  cat("
      1 - Select Studies
      2 - Check availability
      3 - Load Genetic Profiles
      4 - Select Dimension
      5 - Compare colors with legend
      ")
})


### It is not necessary. le ListProfData is loaded when the output$StrListProfDataCircos <- renderPrint({}) is printed
# observe({
#   if(not_pressed(input$loadListProfDataCircosId)) return()
#   isolate({
#     shiny::withProgress(message = 'loading Profiles Data... ', value = 0.1, {
#       Sys.sleep(0.25)
#       getListProfData(panel='Circomics',input$GeneListID)
#     })
#
#   })
# })


observe({
  if (not_pressed(input$pullUserDataButtonId)) return()
  isolate({
    if('CNA' %in% input$userDataID ){
      #if(ncol(r_data[[input$UserData_CNA_id]]) -1 == length(r_data[[input$GeneListID]])){
      if(all(apply(r_data[[input$UserData_CNA_id]][-1],2, function(x)class(x)=='integer'))){
        r_info$ListProfData$CNA[['UserData']] <- r_data[[input$UserData_CNA_id]][-1] # [-1] rm first column
        # }
      }
    }
    if('mRNA' %in% input$userDataID ){
      if(all(apply(r_data[[input$UserData_mRNA_id]][-1],2, function(x)class(x)=='numeric'))){
        r_info$ListProfData$Expression[['UserData']] <- r_data[[input$UserData_mRNA_id]][-1]
      }
    }
    if('MetHM27' %in% input$userDataID ){
      if(all(apply(r_data[[input$UserData_MetHM27_id]][-1],2, function(x)class(x)=='numeric'))){
        r_info$ListProfData$Met_HM27[['UserData']] <- r_data[[input$UserData_MetHM27_id]][-1]
        r_info$ListMetData$HM27[['UserData']] <- r_data[[input$UserData_MetHM27_id]][-1]
      }
    }
    if( 'MetHM450' %in% input$userDataID2){
      if(all(apply(r_data[[input$UserData_MetHM450_id]][-1],2, function(x)class(x)=='numeric'))){
        r_info$ListProfData$Met_HM450[['UserData']] <- r_data[[input$UserData_MetHM450_id]][-1]
        r_info$ListMetData$HM450[['UserData']] <- r_data[[input$UserData_MetHM450_id]][-1]
      }
    }
    if( 'miRNA' %in% input$userDataID2){
      if(all(apply(r_data[[input$UserData_miRNA_id]][-1],2, function(x)class(x)=='numeric'))){
        r_info$ListProfData$miRNA[['UserData']] <- r_data[[input$UserData_miRNA_id]][-1]
      }
    }
    if( 'RPPA' %in% input$userDataID2){
      if(all(apply(r_data[[input$UserData_RPPA_id]][-1],2, function(x)class(x)=='numeric'))){
        r_info$ListProfData$RPPA[['UserData']] <- r_data[[input$UserData_RPPA_id]][-1]
      }
    }
    if( 'Mutation' %in% input$userDataID){
      # gene_symbol mutation_type amino_acid_change
      ## works for a list of data frame
      #if(any(sapply(r_data[[input$UserData_FreqMut_id]], function(x) sapply(names(x), function(y) grepl(paste("gene_symbol","mutation_type", "amino_acid_change", sep = "|"), y))))){
      if(length(grep('TRUE',sapply(names(r_data[[input$UserData_FreqMut_id]]), function(y) grepl(paste("gene_symbol","mutation_type", "amino_acid_change", sep = "|"), y))))==3){
        r_info$ListMutData[['UserData']] <- r_data[[input$UserData_FreqMut_id]][-1]
      }
    }
  })
})

observe({
  if (not_pressed(input$pullUserDataButtonId)) #return()
  isolate({
    r_info$ListProfData$CNA[['UserData']] <- NULL
    r_info$ListProfData$Expression[['UserData']] <- NULL
    r_info$ListProfData$Met_HM27[['UserData']] <- NULL
    r_info$ListMetData$HM27[['UserData']] <- NULL
    r_info$ListProfData$Met_HM450[['UserData']] <- NULL
    r_info$ListMetData$HM450[['UserData']] <- NULL
    r_info$ListProfData$miRNA[['UserData']] <- NULL
    r_info$ListProfData$RPPA[['UserData']] <- NULL
    r_info$ListMutData[['UserData']] <- NULL
  })
})


# output$StrProfData <- renderPrint({
#
#                    r_data$ListProfData$CNA[['UserData']] <- r_data[[input$UserData_CNA_id]]
#                    #cat("PROFILES DATA:\n",str(r_data$ListProfData$CNA),sep = " " )
#
# })
#
# output$CNATable <- DT::renderDataTable({
#   #r_data$ListProfData$CNA[['UserData']] <- r_data[[input$UserData_CNA_id]]
#
#   dat <- r_data[[input$UserData_CNA_id]]
#
#   displayTable(dat)
#
# })


## get Wheel for Profiles Data
output$getCoffeeWheel_All <- renderCoffeewheel({
  shiny::withProgress(message = 'Creating Wheel. Waiting...', value = 1, {

    CoffeewheelTreeProfData <- reStrDimension(r_info$ListProfData)
    r_info[['TreeListProfData']] <- CoffeewheelTreeProfData
    title<- paste("Profiles Data: CNA, Met,Exp, RPPA, miRNA")
    coffeewheel(CoffeewheelTreeProfData, width=600, height=600, partitionAttribute="value", main=title)
  })

})

## get Wheel for Methylation
output$getCoffeeWheel_Met <- renderCoffeewheel({
  shiny::withProgress(message = 'Creating Wheel. Waiting...', value = 1, {

    CoffeewheelTreeMetData <- reStrDimension(r_info$ListMetData)
    r_info[['TreeMetData']] <- CoffeewheelTreeMetData
    title<- paste("Methylations: HM450 and HM27")
    coffeewheel(CoffeewheelTreeMetData, width=600, height=600, main=title)
    #coffeewheel(r_info$TreeMetData, width=600, height=600, main=title)
  })

})

## get Wheel for CNA
output$getCoffeeWheel_CNA <- renderCoffeewheel({
  shiny::withProgress(message = 'Creating Wheel. Waiting...', value = 1, {

    CoffeewheelTreeCNAData <- reStrDisease(r_info$ListProfData$CNA)
    r_info[['TreeCNAData']] <- CoffeewheelTreeCNAData
    title<- paste("Copy Number Alteration [-2, +2]")
    coffeewheel(CoffeewheelTreeCNAData, width=600, height=600,main=title)
  })

})

## get Wheel for mRNA
output$getCoffeeWheel_mRNA <- renderCoffeewheel({
  shiny::withProgress(message = 'Creating Wheel. Waiting...', value = 1, {

    CoffeewheelTreeExpData <- reStrDisease(r_info$ListProfData$Expression)
    r_info[['TreeMRNAData']] <- CoffeewheelTreeExpData
    title<- paste("mRNA expression")
    coffeewheel(CoffeewheelTreeExpData, width=600, height=600, main=title)
  })

})

## get Wheel for miRNA
output$getCoffeeWheel_miRNA <- renderCoffeewheel({
  shiny::withProgress(message = 'Creating Wheel. Waiting...', value = 1, {

    CoffeewheelTreeMiRNAData <- reStrDisease(r_info$ListProfData$miRNA)
    r_info[['TreeMiRNAData']] <- CoffeewheelTreeMiRNAData
    title<- paste("miRNA Expression")
    coffeewheel(CoffeewheelTreeMiRNAData, width=600, height=600, main= title)
  })

})

## get Wheel for RPPA
output$getCoffeeWheel_RPPA <- renderCoffeewheel({
  shiny::withProgress(message = 'Creating Wheel. Waiting...', value = 1, {

    CoffeewheelTreeRPPAData <- reStrDisease(r_info$ListProfData$RPPA)
    r_info[['TreeRPPAData']] <- CoffeewheelTreeRPPAData
    title<- paste("Reverse Phase Protein Arrays")
    coffeewheel(CoffeewheelTreeRPPAData, width=600, height=600,main=title)
  })

})

## get Wheel for Mutation
output$getCoffeeWheel_Mut <- renderCoffeewheel({
  shiny::withProgress(message = 'Creating Wheel. Waiting...', value = 1, {

    ## get Gene Mutation Frequency
    print("Start getting Frequency of Mutation ...")
    Freq_DfMutData <- getFreqMutData(list = r_info$ListMutData, geneListLabel = input$GeneListID)
    r_info[['Freq_DfMutData']] <- Freq_DfMutData
    print("End getting Mutation Frequency...")
    listMut_df <- apply(r_info$Freq_DfMutData,2,function(x)as.data.frame(t(x)))
    TreeMutData <- reStrDisease(listMut_df)
    r_info[['TreeMutData']] <- TreeMutData
    coffeewheel(TreeMutData, width=1024, height=600
                #,main= paste0("Mutation Frequency: (Min = ", min(r_data$Freq_DfMutData) ,", Max = ", max(r_data$Freq_DfMutData)  ,")", sep="")
    )
  })

})


### render static circos "metabologram"
output$metabologram_All <- renderMetabologram({

  CoffeewheelTreeData <- reStrDimension(r_info$ListProfData)

  title<- paste("All genomic profiles")

  metabologram(CoffeewheelTreeData, width=600, height=600, main=title,
               showLegend = FALSE, fontSize = 8, legendBreaks=c("Down", "0", "Up", "NA"),
               legendColors=c("blue","white","red", "black") , legendText="Legend")

})


output$CircosAvailability <- DT::renderDataTable({

  shiny::withProgress(message = 'Loading Data...', value = 1, {

    dat <- checkDimensions(StudyID= input$StudiesIDCircos )
    ## remove rownames to column
    dat <- dat %>% tibble::rownames_to_column("Samples")

    # action = DT::dataTableAjax(session, dat, rownames = FALSE, toJSONfun = my_dataTablesJSON)
    action = DT::dataTableAjax(session, dat, rownames = FALSE)

    DT::datatable(dat, filter = list(position = "top", clear = FALSE, plain = TRUE),
                  rownames = FALSE, style = "bootstrap", escape = FALSE,
                  # class = "compact",
                  options = list(
                    ajax = list(url = action),
                    search = list(regex = TRUE),
                    columnDefs = list(list(className = 'dt-center', targets = "_all")),
                    autoWidth = TRUE,
                    processing = FALSE,
                    pageLength = 14,
                    lengthMenu = list(c(10, 25, 50, -1), c('10','25','50','All'))
                  )
    )%>%  DT::formatStyle(names(dat),
                          color = DT::styleEqual("No", 'red'))#, backgroundColor = 'white', fontWeight = 'bold'




  })
})

output$Sequenced_SampleSize <- DT::renderDataTable({

  shiny::withProgress(message = 'Computing Sample sizes...', value = 1, {

    dat <- getSequensed_SampleSize(StudiesID = input$StudiesIDCircos)

    DT::datatable(dat,
                  caption= "Table 1: Sample Sizes by study",
                  autoHideNavigation = getOption("DT.autoHideNavigation")
    )
  })
})

output$FreqMutSummary <- DT::renderDataTable({
  # dat <- r_data$Freq_DfMutData %>% tibble::rownames_to_column("Genes")
  # rnames <- rownames(r_data$Freq_DfMutData)
  # rownames(r_data$Freq_DfMutData) <- NULL
  # FreqIn <- as.data.frame(r_data$Freq_DfMutData)
  # dat <- cbind("Genes"= rnames, r_data$Freq_DfMutData)
  DT::datatable(r_info$Freq_DfMutData,
                caption="Table 2: Percentage (%) of mutation by gene in each study",
                autoHideNavigation = getOption("DT.autoHideNavigation")
  )
})

output$mRNA_mean <- DT::renderDataTable({
  # if (inherits(try(lapply(r_info$ListProfData$Expression, function(x) lapply(x, function(y) colMeans(y))), silent=TRUE),"try-error")){
  #   r_data$ListProfData$ListMetData[['UserData']] <- NULL
  # }
  dat <- lapply(r_info$ListProfData$Expression, function(x) colMeans(x))
  dat <- as.data.frame(do.call(cbind,dat))
  dat <- round(dat, digits = 0)
  DT::datatable(dat,
                caption="Table 2: Means of mRNA expression",
                autoHideNavigation = getOption("DT.autoHideNavigation")
  )
})
output$CNA_Max <- DT::renderDataTable({
  # check if all dataframe have interger in each column
  #if(all(sapply((lapply(r_data$ListProfData$CNA,function(x) sapply(x, function(y) class(y)=='integer'))), function(f) all()))){
  #if (inherits(try(lapply(r_data$ListProfData$CNA,function(x) apply(x,2, function(y) as.data.frame(table(y[order(y)])))), silent=TRUE),"try-error")){
  # r_data$ListProfData$CNA[['UserData']] <- NULL
  #}
  ls <- lapply(r_info$ListProfData$CNA,function(x) apply(x,2, function(y) as.data.frame(table(y[order(y)]))))
  WhichMax <- lapply(ls, function(x) as.data.frame(do.call(cbind,lapply(x, function(y) y[,1][which(y[,2]== max(y[,2]))]))))
  genes_names <- lapply(WhichMax, function(x) names(x))[1]
  names(genes_names) <- 'Genes'
  WhichMax <- lapply(WhichMax, function(x) as.numeric(as.matrix(x)))
  WhichMax <-   as.data.frame(do.call(cbind, WhichMax))  # as.data.frame(WhichMax)
  dat <- cbind(Genes= genes_names , WhichMax )
  DT::datatable(dat, rownames = FALSE,
                caption="Table 2: The most frequent CNA prolife",
                autoHideNavigation = getOption("DT.autoHideNavigation")
  )
  # }
})

output$Methylation_mean <- DT::renderDataTable({
  # if (inherits(try(lapply(r_data$ListMetData, function(x) lapply(x, function(y) colMeans(y))), silent=TRUE),"try-error")){
  # r_data$ListProfData$ListMetData[['UserData']] <- NULL
  # }
  #dat <- list(r_data$ListMetData,r_data$ListProfData$Met_HM450)
  dat <- lapply(r_info$ListMetData, function(x) lapply(x, function(y) colMeans(y)))
  dat <- as.data.frame(dat)
  dat <- round(dat, digits = 3)
  DT::datatable(dat,
                caption="Table 2: Correlation of silencing gene by Methylation: (0:1)",
                autoHideNavigation = getOption("DT.autoHideNavigation")
  )
})


## REPORT
observeEvent(input$CircomicsHelp_report, {

  cmdAll <- paste0("```{r}\n",
                 paste0("if(is.null(r_info$TreeListProfData)){
                         r_info[['TreeListProfData']] <- reStrDimension(r_info$ListProfData)
                          }
                         title<- paste('All genomics data available')
                        wdgt <- metabologram(r_info$TreeListProfData, width=600, height=600, main=title,
                         showLegend = FALSE, fontSize = 8, legendBreaks=c('Down', '0', 'Up', 'NA'),
                         legendColors=c('blue','white','red', 'black') , legendText='Legend')
                         wdgt
                        ") ,
                 "\n",
                 "\n```\n"
  )

  cmdCNA <- paste0("```{r}\n",
                   paste0("if(is.null(r_info$TreeCNAData)){
                         r_info[['TreeCNAData']] <- reStrDisease(r_info$ListProfData$CNA)
                          }
                         title<- paste('Gene Copy Number Alteration')
                        wdgt <- metabologram(r_info$TreeCNAData, width=600, height=600, main=title,
                         showLegend = FALSE, fontSize = 8, legendBreaks=c('Down', '0', 'Up', 'NA'),
                         legendColors=c('blue','white','red', 'black') , legendText='Legend')
                         wdgt
                        ") ,
                   "\n",
                   "\n```\n"
  )

  cmdMet <- paste0("```{r}\n",
                   paste0("if(is.null(r_info$TreeMetData)){
                          r_info[['TreeMetData']] <- reStrDimension(r_info$ListMetData)
}
  title<- paste('Methylation HM450, HM27')
  wdgt <- metabologram(r_info$TreeMetData, width=600, height=600, main=title,
  showLegend = FALSE, fontSize = 8, legendBreaks=c('Down', '0', 'Up', 'NA'),
  legendColors=c('blue','white','red', 'black') , legendText='Legend')
  wdgt
  ") ,
                   "\n",
                   "\n```\n"
                   )

  cmdMut <- paste0("```{r}\n",
                   paste0("if(is.null(r_info$TreeMutData)){
    Freq_DfMutData <- getFreqMutData(list = r_info$ListMutData, geneListLabel = input$GeneListID)
    listMut_df <- apply(Freq_DfMutData,2,function(x)as.data.frame(t(x)))
    r_info[['TreeMutData']] <- reStrDisease(listMut_df)
}
title<- paste('Mutation')
wdgt <- metabologram(r_info$TreeMutData, width=600, height=600, main=title,
showLegend = FALSE, fontSize = 8, legendBreaks=c('Down', '0', 'Up', 'NA'),
legendColors=c('blue','white','red', 'black') , legendText='Legend')
wdgt
") ,
                   "\n",
                   "\n```\n"
                   )

  cmdMRNA <- paste0("```{r}\n",
                   paste0("if(is.null(r_info$TreeMRNAData)){
                          r_info[['TreeMRNAData']] <- reStrDisease(r_info$ListProfData$Expression)
}
title<- paste('mRNA expression')
wdgt <- metabologram(r_info$TreeMRNAData, width=600, height=600, main=title,
showLegend = FALSE, fontSize = 8, legendBreaks=c('Down', '0', 'Up', 'NA'),
legendColors=c('blue','white','red', 'black') , legendText='Legend')
wdgt
") ,
                   "\n",
                   "\n```\n"
                   )

  cmdRPPA <- paste0("```{r}\n",
                   paste0("if(is.null(r_info$TreeRPPAData)){
                          r_info[['TreeRPPAData']] <- reStrDisease(r_info$ListProfData$RPPA)
}
title<- paste('RPPA')
wdgt <- metabologram(r_info$TreeRPPAData, width=600, height=600, main=title,
showLegend = FALSE, fontSize = 8, legendBreaks=c('Down', '0', 'Up', 'NA'),
legendColors=c('blue','white','red', 'black') , legendText='Legend')
wdgt
") ,
                   "\n",
                   "\n```\n"
                   )

  cmdMiRNA <- paste0("```{r}\n",
                   paste0("if(is.null(r_info$TreeMiRNAData)){
                          r_info[['TreeMiRNAData']] <- reStrDisease(r_info$ListProfData$miRNA)
}
title<- paste('miRNA')
wdgt <- metabologram(r_info$TreeMiRNAData, width=600, height=600, main=title,
showLegend = FALSE, fontSize = 8, legendBreaks=c('Down', '0', 'Up', 'NA'),
legendColors=c('blue','white','red', 'black') , legendText='Legend')
wdgt
") ,
                   "\n",
                   "\n```\n"
                   )
  update_report_fun(cmdAll)
  update_report_fun(cmdCNA)
  update_report_fun(cmdMet)
  update_report_fun(cmdMut)
  update_report_fun(cmdMRNA)
  update_report_fun(cmdRPPA)
  update_report_fun(cmdMiRNA)

})

## Save circular layouts as png

# output$dl_metabologram_All <- shiny::downloadHandler(
#   filename = function() { },
#   content = function(file) {
#
#
#
#     wdgt <- metabologram(r_data$TreeListProfData, width=600, height=600, main='title',
#                  showLegend = FALSE, fontSize = 8, legendBreaks=c('Down', '0', 'Up', 'NA'),
#                  legendColors=c('blue','white','red', 'black') , legendText='Legend')
#     # temporarily switch to the temp dir, in case you do not have write
#     # permission to the current working directory
#     #owd <- setwd(tempdir())
#     #on.exit(setwd(owd))
#
#      #widgetThumbnail(wdgt, "temp")
#     saveWidget(wdgt, file="temp.html", selfcontained = F)
#
#
#     webshot::webshot("temp.html", file = "Rplot.png",
#                      cliprect = "viewport")
#   }
# )


observeEvent(input$saveCircosAll, {
  wdgt <- metabologram(r_info$TreeListProfData, width=1024, height=1024, main='All genomic profiles',
                       showLegend = FALSE, fontSize = 12, legendBreaks=c('Down', '0', 'Up', 'NA'),
                       legendColors=c('blue','white','red', 'black') , legendText='Legend')
  # temporarily switch to the temp dir, in case you do not have write
  # permission to the current working directory
  #owd <- setwd(tempdir())
  #on.exit(setwd(owd))
    if(Sys.info()["sysname"] == "Windows"){
      setwd(Sys.getenv("R_USER"))
    }else{
        setwd('~/')
    }

  widgetThumbnail(wdgt, "CircosAll")
  showModal(modalDialog(
    size = "s",
    title = "save success : html, png",
    paste0( " The file is saved successfully in ", getwd(), " folder as CircosAll.png file.", sep = "  ")
  ))
  #saveWidget(wdgt, file="temp.html", selfcontained = F)

  #webshot::webshot("temp.html", file = "Rplot.png", cliprect = "viewport")
  #file.copy("Rplot.png",file,overwrite = TRUE)
  #download.file(owd , 'temp.png')
})

observeEvent(input$saveCircosMet, {
  wdgt <- metabologram(r_info$TreeMetData, width=1024, height=1024, main='Methylation',
                       showLegend = FALSE, fontSize = 12, legendBreaks=c('Down', '0', 'Up', 'NA'),
                       legendColors=c('blue','white','red', 'black') , legendText='Legend')

  if(Sys.info()["sysname"] == "Windows"){
    setwd(Sys.getenv("R_USER"))
  }else{
    setwd('~/')
  }

  widgetThumbnail(wdgt, "CircosMet")
  showModal(modalDialog(
    size = "s",
    title = "save success : html, png",
    paste0( " The file is saved successfully in ", getwd(), " folder as CircosMet.png file.", sep = "  ")
  ))

})

observeEvent(input$saveCircosCNA, {
  wdgt <- metabologram(r_info$TreeCNAData, width=1024, height=1024, main='Copy Number Alteration',
                       showLegend = FALSE, fontSize = 12, legendBreaks=c('Down', '0', 'Up', 'NA'),
                       legendColors=c('blue','white','red', 'black') , legendText='Legend')

  if(Sys.info()["sysname"] == "Windows"){
    setwd(Sys.getenv("R_USER"))
  }else{
    setwd('~/')
  }

  widgetThumbnail(wdgt, "CircosCNA")
  showModal(modalDialog(
    size = "s",
    title = "save success : html, png",
    paste0( " The file is saved successfully in ", getwd(), " folder as CircosCNA.png file.", sep = " ")
  ))

})

observeEvent(input$saveCircosMRNA, {
  wdgt <- metabologram(r_info$TreeExpData, width=1024, height=1024, main='mRNA Expression',
                       showLegend = FALSE, fontSize = 12, legendBreaks=c('Down', '0', 'Up', 'NA'),
                       legendColors=c('blue','white','red', 'black') , legendText='Legend')

  if(Sys.info()["sysname"] == "Windows"){
    setwd(Sys.getenv("R_USER"))
  }else{
    setwd('~/')
  }

  widgetThumbnail(wdgt, "CircosMRNA")
  showModal(modalDialog(
    size = "s",
    title = "save success : html, png",
    paste0( " The file is saved successfully in ", getwd(), " folder as CircosMRNA.png file.", sep = " ")
  ))

})

observeEvent(input$saveCircosMiRNA, {
  wdgt <- metabologram(r_info$TreeMiRNAData, width=1024, height=1024, main='Micro RNA expression',
                       showLegend = FALSE, fontSize = 12, legendBreaks=c('Down', '0', 'Up', 'NA'),
                       legendColors=c('blue','white','red', 'black') , legendText='Legend')

  if(Sys.info()["sysname"] == "Windows"){
    setwd(Sys.getenv("R_USER"))
  }else{
    setwd('~/')
  }

  widgetThumbnail(wdgt, "CircosMiRNA")
  showModal(modalDialog(
    size = "s",
    title = "save success : html, png",
    paste0( " The file is saved successfully in ", getwd(), " folder as CircosMiRNA.png file.", sep = " ")
  ))

})

observeEvent(input$saveCircosRPPA, {
  wdgt <- metabologram(r_info$TreeRPPAData, width=1024, height=1024, main='Reverse Phase Protein Activity',
                       showLegend = FALSE, fontSize = 12, legendBreaks=c('Down', '0', 'Up', 'NA'),
                       legendColors=c('blue','white','red', 'black') , legendText='Legend')

  if(Sys.info()["sysname"] == "Windows"){
    setwd(Sys.getenv("R_USER"))
  }else{
    setwd('~/')
  }

  widgetThumbnail(wdgt, "CircosRPPA")
  showModal(modalDialog(
    size = "s",
    title = "save success : html, png",
    paste0( " The file is saved successfully in ", getwd(), " folder as CircosRPPA.png file.", sep = " ")
  ))

})

observeEvent(input$saveCircosMut, {
  wdgt <- metabologram(r_info$TreeMutData, width=1024, height=1024, main='Mutation',
                       showLegend = FALSE, fontSize = 12, legendBreaks=c('Down', '0', 'Up', 'NA'),
                       legendColors=c('blue','white','red', 'black') , legendText='Legend')

  if(Sys.info()["sysname"] == "Windows"){
    setwd(Sys.getenv("R_USER"))
  }else{
    setwd('~/')
  }

  widgetThumbnail(wdgt, "CircosMut")
  showModal(modalDialog(
    size = "s",
    title = "save success : html, png",
    paste0( " The file is saved successfully in ", getwd(), " folder as CircosMut.png file.", sep = " ")
  ))

})

serviceURL <- function(version){

  #base.url = "http://reactomews.oicr.on.ca:8080/"
  base.url = "http://cpws.reactome.org/"

  if (version == "2005") {
    serv.url <- paste0(base.url, "caBigR3WebApp2015/FIService/network/")
  } else if (version == "2016") {
    serv.url <- paste0(base.url, "caBigR3WebApp2016/FIService/network/")
  } else  if (version == "2017"){
    serv.url <- paste0(base.url, "caBigR3WebApp2017/FIService/network/")
  } else if (version == "2018"){
    serv.url <- paste0(base.url, "caBigR3WebApp2018/FIService/network/")
  } else{
    serv.url <- paste0(base.url, "caBigR3WebApp2021/FIService/network/")
  }
  return(serv.url)
}

#' @export
queryBuildNetwork <- function(version, genes){
  service.url <- paste0(serviceURL(version), "buildNetwork")
  genes.str <- paste(genes, collapse = "\t")
  doc <- getPostXML(service.url, genes.str)
  return(extractFIs(doc))
}

extractFIs <- function(doc) {
  interactions <- XML::xpathApply(doc, "//interaction", function(x) {
    info <- XML::xmlChildren(x)
    first.protein <- XML::xmlValue(XML::xmlChildren(info$firstProtein)$name)
    second.protein <- XML::xmlValue(XML::xmlChildren(info$secondProtein)$name)
    data.frame(first.protein = first.protein,
               second.protein = second.protein, stringsAsFactors = FALSE)
  })
  fis <- do.call(rbind, interactions)
  if (is.null(fis)) return(data.frame())
  return(fis)
}

getPostXML <- function(url, body) {
  text.gatherer <- RCurl::basicTextGatherer()
  opts <- list(httpheader = c("Content-Type" = "text/plain;charset=UTF-8",
                              "Accept" = "application/xml"))
  RCurl::curlPerform(postfields = body, url = url, .opts = opts,
              .encoding = "UTF-8", writefunction = text.gatherer$update)
  xml <- XML::xmlInternalTreeParse(text.gatherer$value())
  return(xml)
}

queryFIs <- function(version, genes){
  service.url <- paste0(serviceURL(version), "queryFIs")
  genes.str <- paste(genes, collapse = "\t")
  doc <- getPostXML(service.url, genes.str)
  return(extractFIs(doc))
}

getReactomeFI <- function(version, genes, use.linkers = FALSE){
  if (length(genes) > 1) {

    if (use.linkers) {
      fis <- queryBuildNetwork(version, genes)
    } else {
      fis <- queryFIs(version, genes)
    }
  }
  version
  fis
}


#################### Get CLUSTER###########
fis2str <- function(fis) {
  fis[, "first.protein"] <- as.character(fis[, "first.protein"])
  fis[, "second.protein"] <- as.character(fis[, "second.protein"])
  fis <- cbind(data.frame(id = 1:nrow(fis)), fis)

  fis.list = c()
  for (i in 1:nrow(fis)) {
    first.protein <- fis[i, "first.protein"]
    second.protein <- fis[i, "second.protein"]
    if (first.protein < second.protein) {
      fi.str <- paste(first.protein, second.protein, sep = "\t")
    } else {
      fi.str <- paste(second.protein, first.protein, sep = "\t")
    }
    fi.str <- paste(fis[i, "id"], fi.str, sep = "\t")
    fis.list <- c(fis.list, fi.str)
  }
  fis.str <- paste(fis.list, collapse = "\n")
  return(fis.str)
}

queryCluster<-  function(version, fis) {
  service.url <- paste0(serviceURL(object), "cluster")
  fis.str <- fis2str(fis)
  doc <- getPostXML(service.url, fis.str)
  modules <- XML::xpathApply(doc, "//geneClusterPairs", function(x) {
    info <- XML::xmlChildren(x)
    module <- XML::xmlValue(info$cluster)
    gene <- XML::xmlValue(info$geneId)
    data.frame(gene = gene, module = module, stringsAsFactors = FALSE)
  })
  modules <- do.call(rbind, modules)
  modules$module <- as.numeric(modules$module)
  return(modules)
}


####################  Get ANNOTATION #############

extractAnnotations <- function(xml.node) {
  annotations <- XML::xpathApply(xml.node, "./annotations", function(x) {
    info <- XML::xmlChildren(x)
    data.frame(topic = XML::xmlValue(info$topic),
               hit.num = XML::xmlValue(info$hitNumber),
               number.in.topic = XML::xmlValue(info$numberInTopic),
               ratio.of.topic = XML::xmlValue(info$ratioOfTopic),
               p.value = XML::xmlValue(info$PValue),
               fdr = XML::xmlValue(info$fdr),
               hits = paste(XML::xpathSApply(x, "./hitIds", xmlValue),
                            collapse = ","),
               stringsAsFactors = FALSE)
  })
  annotations <- do.call(rbind, annotations)

  if (is.null(annotations)) return(data.frame())

  annotations$hit.num <- as.numeric(annotations$hit.num)
  annotations$number.in.topic <- as.numeric(annotations$number.in.topic)
  annotations$ratio.of.topic <- as.numeric(annotations$ratio.of.topic)
  annotations$p.value <- as.numeric(annotations$p.value)
  annotations$fdr <- gsub("<", "", annotations$fdr)
  annotations$fdr <- as.numeric(annotations$fdr)
  return(annotations[order(annotations$fdr), ])
}
queryAnnotateGeneSet <-  function(object, genes, type = c("Pathway", "BP", "CC", "MF")){
  type <- match.arg(type)
  service.url <- paste0(serviceURL(object), "annotateGeneSet/", type)
  genes.str <- paste(genes, collapse = "\n")
  doc <- getPostXML(service.url, genes.str)
  annot.node <- XML::xmlChildren(doc)$moduleGeneSetAnnotations
  annot.node <- XML::xmlChildren(annot.node)$moduleGeneSetAnnotation
  annotations <- extractAnnotations(annot.node)
  return(annotations)
}

annotate <- function(version, GeneList,fis,type = c("Pathway", "BP", "CC", "MF"),
                     include.linkers = FALSE) {
  if (nrow(fis) == 0) {
    warning("No FI network data found. Please build the network first.")
    return(object)
  }

  #fis <- fis(object)
  fi.genes <- union(fis$first.protein, fis$second.protein)

  if (!include.linkers) {
    fi.genes <- fi.genes[fi.genes %in% GeneList]
  }

  type <- match.arg(type)

  return(queryAnnotateGeneSet(object, fi.genes, type))
}


####  Get Annotation Module  #####

df2tsv <- function(dat) {
  for (i in 1:ncol(dat)) {
    if (class(dat[, i]) == "numeric") {
      dat[, i] <- format(dat[, i], trim = TRUE)
    }
  }
  tsv <- apply(dat, 1, function(x) paste(x, collapse = "\t"))
  tsv <- paste(tsv, collapse = "\n")
  return(tsv)
}



queryAnnotateModules <- function(object, module.nodes,type = c("Pathway", "BP", "CC", "MF")){
  type <- match.arg(type)
  service.url <- paste0(serviceURL(object), "annotateModules/", type)
  query <- df2tsv(module.nodes)
  doc <- getPostXML(service.url, query)
  module.annotations <- XML::xpathApply(doc, "//moduleGeneSetAnnotation",
                                   function(x) {
                                     module <- XML::xmlValue(XML::xmlChildren(x)$module)
                                     annotations <- extractAnnotations(x)
                                     if (all(is.na(annotations))) return(annotations)
                                     cbind(data.frame(module = module), annotations)
                                   })
  module.annotations <- module.annotations[!is.na(module.annotations)]
  module.annotations <- do.call(rbind, module.annotations)
  module.annotations$module <- as.numeric(module.annotations$module)
  module.annotations$module <- module.annotations$module - 1
  return(module.annotations)
}


##### FIs Between###

queryFIsBetween <- function(object, fis) {
  service.url <- paste0(serviceURL(object), "queryFIsBetween")
  gene.pairs <- as.matrix(fis)
  first.str <- paste(gene.pairs[, 1], collapse = ",")
  second.str <- paste(gene.pairs[, 2], collapse = ",")
  pairs.str <- paste(first.str, second.str, sep = "\n")
  doc <- getPostXML(service.url, pairs.str)
  return(extractFIs(doc))
}

#### EDGE #####

#' extract Protein Info
#
#' Extract protein information including accession ID and DB name, protein
#'  name, and sequence.
#
#' @param protein.node XML node containing protein information
#' @return data.frame Data frame where each row corresponds to a protein and
#'  the columns contain the information mentioned above.
extractProteinInfo <- function(protein.node) {
  accession <- XML::xmlValue(XML::xmlChildren(protein.node)$accession)
  db.name <- XML::xmlValue(XML::xmlChildren(protein.node)$dbName)
  name <- XML::xmlValue(XML::xmlChildren(protein.node)$name)
  short.name <- XML::xmlValue(XML::xmlChildren(protein.node)$shortName)
  prot.seq <- XML::xmlValue(XML::xmlChildren(protein.node)$sequence)
  info <- data.frame(accession = accession,
                     db.name = db.name,
                     short.name = short.name,
                     name = name,
                     sequence = prot.seq,
                     stringsAsFactors = FALSE)
  return(info)
}

#queryEdge(2012, "TP53", "BRCA1")
queryEdge <-  function(object, name1, name2) {
  service.url <- paste0(serviceURL(object), "queryEdge")
  edge.str <- paste(name1, name2, sep = "\t")
  doc <- getPostXML(service.url, edge.str)
  first.prot <- getNodeSet(doc, "//firstProtein", fun = extractProteinInfo)
  second.prot <- getNodeSet(doc, "//secondProtein", fun = extractProteinInfo)
  return(do.call(rbind, c(first.prot, second.prot)))
}

context("bioCancer functions\n")

#test_that("set_class", {
# foo <- . %>% .^2 %>% set_class(c("foo", class(.)))
#expect_equal(3 %>% foo %>% class,c("foo","numeric"))
#})

testthat::test_that("cBioPortal connection",
                    {
                      #mycgds <- CGDS("http://www.cbioportal.org/")
                      cgds <- cBioPortalData::cBioPortal(
                        hostname = "www.cbioportal.org",
                        protocol = "https",
                        api = "/api/v2/api-docs"
                      )

                      test.CGDS(cgds)
                    })

testthat::test_that("ReactomeFI connection",
                    {
                      checkEq <- function(a,b) { if (identical(a,b)) "OK\n" else "FAILED!\n" }
                      source(paste0(system.file(package = "bioCancer"), "/app/tools/bioCancer/getReactomeFUN.R"),
                          local = TRUE)
                      ReactomeResult <- getReactomeFI(2021, genes = c("TP53","BRCA1"))
                      cat('ReactomeFI connection... ',
                          checkEq(colnames(ReactomeResult), c("first.protein","second.protein"))
                      )
                    }
)

# output$Tools <- renderUI({
#   tagList(
#  # includeCSS(file.path(getOption("radiant.path.bioCancer"),"app/www/style.css")),
#   sidebarLayout(
#     sidebarPanel(
#       wellPanel(
#       conditionalPanel("input.tabs_Tools == 'Transform'",
#                        ## needed to modify radiant helps
#                        help_modal("Transform","transform_help",author = "Karim Mezhoud",
#                                   inclMD(file.path(getOption("radiant.path.bioCancer"),"app/tools/help/transform.md"))),
#                        uiOutput("ui_Transform")),
#       conditionalPanel("input.tabs_Tools == 'Combine'",
#                        ## needed to modify radiant helps
#                        help_modal("Combine","combine_help",author = "Karim Mezhoud",
#                                   inclMD(file.path(getOption("radiant.path.bioCancer"),"app/tools/help/combine.md"))),
#                        uiOutput("ui_Combine"))
#       #uiOutput("ui_Transform")
#       )
#       ),
#     mainPanel(
#       tabsetPanel(id = "tabs_Tools",
#
#           tabPanel("Transform",
#                    htmlOutput("transform_data"),
#                    verbatimTextOutput("transform_summary"),
#                    uiOutput("ui_tr_log")
#
#         ),
#         tabPanel("Combine",
#                  htmlOutput("cmb_data1"),
#                  htmlOutput("cmb_data2"),
#                  htmlOutput("cmb_possible"),
#                  htmlOutput("cmb_data")
#         )#,
#         #tabPanel("Tools")
#      )
#     )
#   )
#   )
# })

updateSelectizeInput(session, 'ClusterPlotsID',
                     choices=c("None","GeneList/Diseases","Disease Ontology","Pathway","GO","KEGG"),
                     selected = "None")

updateSelectizeInput(session, 'ClassID',
                     choices= c("None"="None", "Samples"="Samples" ,"Classifier" = "Classifier"),
                     selected = "None")

output$ui_Classifier <- renderUI({

  updateSelectizeInput(session, 'StudiesIDClassifier', choices = Studies["studyId"],
                       selected = c("brca_tcga","gbm_tcga","lihc_tcga","lusc_tcga"))

  wellPanel(

    #conditionalPanel("input.tabs_Enrichment == 'Classifier'",

    selectizeInput('StudiesIDClassifier', 'Studies  to Classify', choices=NULL, multiple = TRUE),

    # selectizeInput(inputId = "ClassID", label="Sampling",
    #                choices= c("None"="None","Samples"="Samples"), #,"Classifier" = "Classifier"
    #                multiple=FALSE
    # ),

    div(class="row",
        div(class="col-xs-8",
            conditionalPanel("input.StudiesIDClassifier != null  && input.runSamplingBox==false",
                             h5('Sampling')),
            conditionalPanel("input.StudiesIDClassifier != null && input.runSamplingBox==true",
                             h5('Sampling', style = "color:#428bca")
            )
        ),
        div(class="col-xs-4",
            conditionalPanel("input.StudiesIDClassifier != null",
                             switchButton(inputId = "runSamplingBox",
                                          value = FALSE, col = "GB", type = "OO"))
        )
    ),
   # tags$hr(),
    #conditionalPanel( "input.ClassID == 'Samples'",
    conditionalPanel( "input.runSamplingBox == true ",
                      div(class="col-xs-6",
                          numericInput("SampleSizeClassifierID",
                                       "Samples",
                                       "50",min = 0, max = 200 , step = 10)),
                      div(class="col-xs-6",
                          numericInput("ClassifierThresholdID",
                                       "PostProb",
                                       "0.95",min = 0.9, max = 1 , step = 0.01)),

                      conditionalPanel("input.runSamplingBox == true",
                                       #div(class="col-xs-12",
                                      #     checkboxInput('runClassificationBox', 'Classification')
                                      # ),

                                       div(class="row",
                                           div(class="col-xs-8",
                                               conditionalPanel("input.runSamplingBox == true  && input.runClassificationBox==false",
                                                                h5('Run classification')),
                                               conditionalPanel("input.StudiesIDClassifier != null && input.runClassificationBox==true",
                                                                h5('Run classification', style = "color:#428bca")
                                               )
                                           ),
                                           div(class="col-xs-4",
                                               conditionalPanel("input.runSamplingBox == true",
                                                                switchButton(inputId = "runClassificationBox",
                                                                             value = FALSE, col = "GB", type = "OO"))
                                           )
                                       )
                      )

    ),
    br(),

    #  ),
    #conditionalPanel("input.ClassID=='Classifier'",
    conditionalPanel("input.runClassificationBox == true",

                     selectizeInput('ClusterPlotsID', 'Biological terms clusters',
                                    choices=c("None","GeneList/Diseases","Disease Ontology","Reactome","GO","KEGG", "Cellular Component"),
                                    multiple= FALSE)

    ),
    br(),
    help_and_report(modal_title = "Classifier", fun_name = "ClassifierHelp",
                    author = "Karim Mezhoud",
                    help_file = inclRmd(file.path(
                      getOption("radiant.path.bioCancer"),"app/tools/help/Classifier.md")))
  )
})



# observe({
#   if(not_pressed(input$runClassificationButton)) return()
#   isolate({
#     shiny::withProgress(message = 'running geNetClassifier... ', value = 0.1, {
#       Sys.sleep(0.25)
#       getListProfData(panel='Circomics',input$GeneListID)
#     })
#
#   })
# })

#' This is an htmlwidgets-based visualization tool for hierarchical data.
#' It is zoomable, meaning that you can interact with the hierarchy and zoom in/out accordingly.
#'
#' @return  A circular layout with genetic profile.
#'
#' @usage coffeewheel(treeData, width=600, height=600, main="", partitionAttribute="value")
#' @param treeData A hierarchical tree data as in example
#' @param width 600
#' @param height 600
#' @param main Title
#' @param partitionAttribute "value"
#'
#' @examples
#' How <- "runManually"
#' \dontrun{
#'  coffeewheel(treeData = sampleWheelData)
#'  }
#' @export
#'
coffeewheel <- function(treeData, width=600, height=600, main="", partitionAttribute="value"){
  x <- list(
    treeData = treeData,
    main = main,
    partitionAttribute = partitionAttribute
  )

  # create widget
  htmlwidgets::createWidget(
    name = 'coffeewheel',
    x,
    width = width,
    height = height,
    package = 'bioCancer'
  )
}

#' Widget output function for use in Shiny
#'@return  A circular layout with genetic profile in Shiny App.
#'
#' @usage coffeewheelOutput(outputId, width=700, height=700)
#' @param outputId id
#' @param width 700
#' @param height 700
#'
#' @examples
#' How <- "runManually"
#' \dontrun{
#' coffeewheel(treeData = sampleWheelData)
#' }
#' @export
#'
coffeewheelOutput <- function(outputId, width=700, height=700) {
  htmlwidgets::shinyWidgetOutput(outputId, 'coffeewheel', width, height, package = 'bioCancer')
}

#' Widget render function for use in Shiny
#'@return  A circular layout with genetic profile in Shiny App.
#'
#' @usage renderCoffeewheel(expr,env =  parent.frame(),  quoted = FALSE)
#' @param expr id
#' @param env parent.frame()
#' @param quoted FALSE
#'
#' @examples
#' How <- "runManually"
#' \dontrun{
#' coffeewheel(treeData = sampleWheelData)
#' }
#' @export
#'
renderCoffeewheel <- function(expr, env = parent.frame(), quoted = FALSE){
  if (!quoted) { expr <- substitute(expr) } # force quoted
  htmlwidgets::shinyRenderWidget(expr, coffeewheelOutput, env = parent.frame(),  quoted = TRUE)
}

#' @title  Sample data for wheel initialization
#'
#' @description Example of data structure
#'
#' @format lists of lists hierarchical data
#'  @examples
#' \dontrun{
#' data(sampleWheelData)
#'}
# sampleWheelData <- list(
#   list(
#     name="R",
#     children=list(
#       list(name="R_1", colour="#110000"),
#       list(name="R_3", colour="#330000"),
#       list(name="R_5", colour="#550000"),
#       list(name="R_7", colour="#770000"),
#       list(name="R_9", colour="#990000"),
#       list(name="R_b", colour="#bb0000"),
#       list(name="R_d", colour="#dd0000"),
#       list(name="R_f", colour="#ff0000")
#     )
#   ),
#   list(
#     name="G",
#     children=list(
#       list(name="G_1", colour="#001100"),
#       list(name="G_3", colour="#003300"),
#       list(name="G_5", colour="#005500"),
#       list(name="G_7", colour="#007700"),
#       list(name="G_9", colour="#009900"),
#       list(name="G_b", colour="#00bb00"),
#       list(name="G_d", colour="#00dd00"),
#       list(name="G_f", colour="#00ff00")
#     )
#   ),
#   list(
#     name="B",
#     children=list(
#       list(name="B_1", colour="#000011"),
#       list(name="B_3", colour="#000033"),
#       list(name="B_5", colour="#000055"),
#       list(name="B_7", colour="#000077"),
#       list(name="B_9", colour="#000099"),
#       list(name="B_b", colour="#0000bb"),
#       list(name="B_d", colour="#0000dd"),
#       list(name="B_f", colour="#0000ff")
#     )
#   )
# )

#' search and get genetic profiles (CNA,mRNA, Methylation, Mutation...)
#'
#' @details See \url{https://github.com/kmezhoud/bioCancer/wiki}
#'
#' @return A data frame with Genetic profile
#'
#' @usage getProfData(study,genProf, listGenProf, GeneList, Mut)
#' @param study  Study ID
#' @param genProf Genetic Profile id (cancer_study_id_[mutations, cna, methylation, mrna ]).
#' @param listGenProf A list of Genetic Profiles for one study.
#' @param GeneList A list of genes
#' @param Mut Condition to set if the genetic profile is mutation or not (0,1)
#'
#' @examples
#' cgds <- cBioPortal(
#' hostname = "www.cbioportal.org",
#' protocol = "https",
#' api = "/api/v2/api-docs"
#' )
#' \dontrun{
#' getDataByGenes( api =  cgds,
#' studyId = "gbm_tcga_pub",
#' genes = c("NF1", "TP53", "ABL1"),
#' by = "hugoGeneSymbol",
#' molecularProfileIds = "gbm_tcga_pub_mrna"
#' )
#'}
#'@export
getProfData<-function(study, genProf, listGenProf, GeneList, Mut){


  if(length(grep(genProf, listGenProf))!= 0){

    ProfData_X <- cBioPortalData::getDataByGenes(api =  cgds,
                                                 studyId = study,
                                                 genes = GeneList,
                                                 by = "hugoGeneSymbol",
                                                 molecularProfileIds = genProf) |>
      unname() |>
      as.data.frame()

    # avoid error if no profile data exist for geneList
    if(nrow(ProfData_X)<1){
       #all(dim(ProfData_X)==c(0,1) ||
       #nrow(ProfData_X)==0)== TRUE){ #length(ProfData_X)== 0 ||

      #print(paste0("No Profile Data available for:", genProf))

      ## built empty data frame with gene Symbol in colnames
      if(Mut==0){

        ProfData_X <- as.data.frame(setNames(replicate(length(GeneList),numeric(1),
                                                       simplify = FALSE),
                                             GeneList[order(GeneList)]))
        return(ProfData_X)

      }else if (Mut==1){
        ## built emty data.frame as the same form of MutData
        hugoGeneSymbol <- as.vector(GeneList)
        proteinChange <- rep(character(1), length(GeneList))
        variantType <- rep(character(1), length(GeneList))
        MutData <- data.frame(hugoGeneSymbol, proteinChange, variantType)

        return(MutData)
      }

    }else if(Mut== 0){

      ProfData_X <- ProfData_X |>
        #.[[1]] |>
        select("sampleId", "hugoGeneSymbol", "value") |>
        spread("hugoGeneSymbol", "value") |>
        tibble::column_to_rownames("sampleId")
      ##  check the order of geneList and add gene with empty data NA.
      missing <- setdiff(GeneList[order(GeneList)], names(ProfData_X))
      ProfData_X[missing] <- NA
      ProfData_X |> select(GeneList[order(GeneList)])

      return(ProfData_X)

    } else if(Mut==1){

      #print(paste0("Getting Mutation Data of ", study ," ..."))

      MutData <- ProfData_X  |>
        #.[[1]] |>
        select("hugoGeneSymbol", "proteinChange", "variantType")

      return(MutData)

    }
  }else{
    shiny::withProgress(message=
                          paste("There is no genetic Profiles: ",
                                genProf ), value = 1,
                        {p1 <- proc.time()
                        Sys.sleep(2) # wait 2 seconds
                        proc.time() - p1 })
    print(paste("There is no genetic Profiles: ", genProf ))

    ProfData_X <- as.data.frame(setNames(replicate(
      length(GeneList),numeric(1), simplify = FALSE),
      GeneList[order(GeneList)]))

    return(ProfData_X)
  }
}



#' get list of data frame with profiles data (CNA,mRNA, Methylation, Mutation...)
#'
#' @usage getListProfData(checked_Studies, geneListLabel)
#'
#' @param checked_Studies checked studies in corresponding panel (input$StudiesIDCircos, input$StudiesIDReactome).
#' @param geneListLabel The label of GeneList. There are three cases:
#'        "Genes" user gene list,
#'        "Reactome_GeneList" GeneList plus genes from reactomeFI
#'       "file name" from Examples
#'
#' @return A LIST of profiles data (CNA, mRNA, Methylation, Mutation, miRNA, RPPA).
#'         Each dimension content a list of studies.
#'
#'@examples
#' cgds <- cBioPortal(
#' hostname = "www.cbioportal.org",
#' protocol = "https",
#' api = "/api/v2/api-docs"
#' )
#' \dontrun{
#' getDataByGenes( api =  cgds,
#' studyId = "gbm_tcga_pub",
#' genes = c("NF1", "TP53", "ABL1"),
#' by = "hugoGeneSymbol",
#' molecularProfileIds = "gbm_tcga_pub_mrna"
#' )
#'}
#' @export
getListProfData <- function(checked_Studies, geneListLabel){

  GeneList <- whichGeneList(geneListLabel)


  ListProfData <- NULL
  r_info$ListProfData <- NULL #reinit tree for circomics
  ListMetData <- NULL
  ListMutData <- NULL
  i <- 0
  for(s in checked_Studies){
    i<-i+1
    #Si = myGlobalEnv$checked_StudyIndex[s]
     shiny::withProgress(message= paste(s,":"), value = 1, {

     incProgress(0.1, detail=paste(round((i/length(checked_Studies))*100, 0),"% of Profiles Data"))
     Sys.sleep(0.1)

    ### get Cases and Genetic Profiles  with cBioportal references
    GenProf_CNA <- paste(s,"_gistic", sep="")
    #Case_CNA   <- paste(s,"_cna", sep="")

    GenProf_Exp <- paste(s,"_rna_seq_v2_mrna", sep="")
    #Case_Exp   <- paste(s,"_rna_seq_v2_mrna", sep="")

    GenProf_Met_HM450 <- paste(s,"_methylation_hm450", sep="")
    #Case_Met_HM450   <- paste(s,"_methylation_hm450", sep="")

    GenProf_Met_HM27 <- paste(s,"_methylation_hm27", sep="")
    #Case_Met_HM27   <- paste(s,"_methylation_hm27", sep="")

    GenProf_RPPA <- paste(s,"_rppa", sep="")
    #Case_RPPA   <- paste(s,"_rppa", sep="")

    GenProf_miRNA <- paste(s,"_mirna", sep="")
    #Case_miRNA   <- paste(s,"_microrna", sep="")

    GenProf_Mut<- paste(s,"_mutations", sep="")
    #Case_Mut   <- paste(s,"_sequenced", sep="")

    ## get Genetics Profiles for selected each Study
    GenProfsRefStudies <- unname(unlist(apply(
      as.data.frame(s), 1,
      function(x) molecularProfiles(api = cgds, studyId = x)[,"molecularProfileId"])))


    ProfData_CNA <- getProfData(s, GenProf_CNA,
                                GenProfsRefStudies, GeneList, Mut=0)
    ProfData_Exp <- getProfData(s, GenProf_Exp,
                                GenProfsRefStudies, GeneList, Mut=0)
    ProfData_Met_HM450 <- getProfData(s, GenProf_Met_HM450,
                                      GenProfsRefStudies, GeneList, Mut=0)
    ProfData_Met_HM27 <- getProfData(s, GenProf_Met_HM27,
                                     GenProfsRefStudies, GeneList, Mut=0)
    ProfData_RPPA <- getProfData(s, GenProf_RPPA,
                                 GenProfsRefStudies, GeneList, Mut=0)
    ProfData_miRNA <- getProfData(s, GenProf_miRNA,
                                  GenProfsRefStudies, GeneList, Mut=0)
    MutData <- getProfData(s,GenProf_Mut,
                           GenProfsRefStudies,GeneList, Mut=1)


    ListProfData$CNA[[s]] <- ProfData_CNA
    ListProfData$Expression[[s]] <- ProfData_Exp
    ListProfData$Met_HM450[[s]] <- ProfData_Met_HM450
    ListProfData$Met_HM27[[s]] <- ProfData_Met_HM27
    ListMetData$HM450[[s]] <- ProfData_Met_HM450
    ListMetData$HM27[[s]] <- ProfData_Met_HM27
    ListProfData$RPPA[[s]] <- ProfData_RPPA
    ListProfData$miRNA[[s]] <- ProfData_miRNA
    ListMutData[[s]] <- MutData


    #print(" End Getting Profiles Data... ")
    })
  }
  r_info[['ListProfData']] <- ListProfData
  r_info[['ListMetData']] <- ListMetData
  r_info[['ListMutData']] <- ListMutData
  #}
}

output$ui_Mut_vars <- renderUI({
  req(input$GenProfID)
  req(input$CasesID)
  #shiny::withProgress(message = 'loading Variables of Mutation Data from cgdsr server...', value = 1, {

  GeneList <- whichGeneList(input$GeneListID)

  if (ncol(GeneList)==0){
    dat <- as.data.frame("Gene List is empty!")
  }else{

    if(inherits(try(
      dat <- cBioPortalData::getDataByGenes(api =  cgds,
                                            studyId = input$StudiesID,
                                            genes = GeneList,
                                            by = "hugoGeneSymbol",
                                            molecularProfileIds = input$GenProfID,
                                            sampleListId = input$CasesID),
      silent=FALSE),"try-error")){
      dat <- as.data.frame("There is no data for selected Genetic profile.")
    }else{
      shiny::withProgress(message = 'loading ProfData from cBioPortal server...', value = 1, {
        #Sys.sleep(time = 1)
        #req(input$StudiesID)
        #req(input$GenProfID)

        dat <- cBioPortalData::getDataByGenes(api =  cgds,
                                              studyId = input$StudiesID,
                                              genes = GeneList,
                                              by = "hugoGeneSymbol",
                                              molecularProfileIds = input$GenProfID,
                                              sampleListId = input$CasesID) |>
          #.[[1]] |>
          unname() |>
          as.data.frame()
        #select(-c(uniqueSampleKey, uniquePatientKey, molecularProfileId, patientId, studyId))
        #tidyr::spread(hugoGeneSymbol, value)

      })
  ## avoid error when geneList is empty
  if(nrow(dat)==0){

    dat <- as.data.frame(paste0("There is no ", input$GenProfID ," for selected Gene list."))

    selectInput("Mut_varsID", "Select variables to show:",
                choices  = "No Data Available for this Genetic Profile",
                #selected = state_multiple("Mut_vars",Mut_vars, Mut_vars),
                multiple = FALSE,
                selectize = FALSE,
                size = min(2)
                )
  }else{

    r_info[["MutData"]] <- dat
    Mut_vars <- names(dat)

    selectInput("Mut_varsID", "Select variables to show:",
                choices  = Mut_vars,
                selected = state_multiple("Mut_vars",Mut_vars, Mut_vars),
                multiple = TRUE,
                selectize = FALSE,
                size = min(6, length(Mut_vars)))
  }
    }
  }
  #})

})

output$ui_MutData <- renderUI({

  list(
    # wellPanel(
    #
    #   conditionalPanel("input.GeneListID == 'DNA_damage_Response' && input.loadClipMut_GeneList%2 == 1 ",
    #                    p("Gene List is empty!", align="center",style = "color:red")
    #   ),
    #
    #   radioButtons(inputId = "loadGeneListID_Mut", label = "Load Gene List:",
    #                c( "examples" = "ExampleGeneList",  "clipboard" = "clipboard_GeneList"),
    #                selected = "Genes", inline = TRUE),
    #
    #   conditionalPanel(condition = "input.loadGeneListID_Mut == 'clipboard_GeneList'",
    #                    actionButton('loadClipMut_GeneList', 'Paste Gene List')
    #                    #uiOutput("ui_clipboard_load_MutData")
    #   ),
    #   conditionalPanel(condition = "input.loadGeneListID_Mut == 'ExampleGeneList'",
    #                    actionButton('loadExampleGeneList_MutData', 'Load examples')
    #   )
    #
    # ),
    wellPanel(
      #if (length(grep("mutation", input$GenProfID))!=0){
        uiOutput("ui_Mut_vars")
      #}
    ),

    wellPanel(
      checkboxInput(inputId = "MutData", "Export for Processing:" ,value = FALSE),
      #radioButtons(inputId = "MutData", label = "Load Mutations to Datasets:",
      #            c("MutData"="MutData"), selected = FALSE, inline =TRUE),
      conditionalPanel(condition = "input.MutData == true",
                       actionButton('loadMutData', 'Export to Datasets', icon('arrow-up'))

      )
    ),
    #help_modal_km('Mutation Data','MutationHelp',inclMD(file.path(r_path,"base/tools/help/Mutation.md")))
    help_and_report(modal_title = "Mutation Data", fun_name = "MutationHelp",
                    author = "Karim Mezhoud",
                    help_file = inclRmd(file.path(
                      getOption("radiant.path.bioCancer"),"app/tools/help/Mutation.md")))
  )
})
####################

# # loading all examples files (linked to helpfiles)
# observe({
#   if (not_pressed(input$loadExampleGeneList_MutData)) return()
#   isolate({
#
#     # loading data bundled with bioCancer
#     data_path <- file.path( system.file(package = "bioCancer"),"extdata/GeneList")
#     examples <- list.files(data_path)
#
#     for (ex in examples) loadUserData(ex, file.path(data_path,ex), 'txt')
#
#     # sorting files alphabetically
#     r_data[['genelist']] <- sort(r_data[['genelist']])
#
#     updateSelectInput(session, "GeneListID", label = "Gene List Examples:",
#                       choices = r_data$genelist,
#                       selected = r_data$genelist[1])
#   })
#
# })
#
# ## load genelist from clipBoard
# observe({
#   # 'reading' data from clipboard
#   if (not_pressed(input$loadClipMut_GeneList)) return()
#   isolate({
#     loadClipboard_GeneList(tab = input$loadClipMut_GeneList)
#     updateRadioButtons(session = session, inputId = "GeneListID",
#                        label = "Paste Genes:",
#                        c( "examples" = "ExampleGeneList",  "clipboard" = "clipboard_GeneList"),
#                        #selected = "Genes",
#                        inline = TRUE)
#     updateSelectInput(session, "GeneListID", label = "Pasted Genes:",
#                       choices = r_data$genelist)
#   })
# })


## Load Mutation data in datasets
observe({
  if (not_pressed(input$loadMutData)) return()
  isolate({

    loadInDatasets(fname="MutData", header=TRUE)

    # sorting files alphabetically
    r_info[['datasetlist']] <- sort(r_info[['datasetlist']])

    updateSelectInput(session, "dataset", label = "Datasets:",
                      choices = r_info$datasetlist,
                      selected = "MutData")

  })
})

# output$LegendCircos <- renderPlot({
#   #my.colors = colorRampPalette(c("blue3","cyan","white","yellow", "red","black"))
#   my.colors = colorRampPalette(c("blue3", "white", "red"))
#   z=matrix(1:100,nrow=1)
#   x=1
#   y=seq(3,2345,len=100) # supposing 3 and 2345 are the range of your data
#   image(x,y,z,col=my.colors(100),axes=FALSE,xlab="",ylab="")
#   #axis(2)
#   #mtext(text=c("Min","Low","middle","High","Max","NA"), line=1.8, las=2, side=4, at=c(50,500,900, 1400,1900,2300),adj = 1)
#   #mtext(text=c("Down","Low","0","High","Up","NA"), line=0.5, las=2, side=2, outer = FALSE, at=c(50,500,900, 1400,1900,2300),adj = 1)
#   mtext(text=c("Min","Medium","Max"), line=1.8, las=2, side=4, at=c(50,1150, 2300),adj = 1)
#   mtext(text=c("Down","0","Up"), line=0.5, las=2, side=2, outer = FALSE, at=c(50,1150, 2300),adj = 1)
# })

output$CircosLegend <- renderImage({
  # When input$n is 3, filename is ./images/image3.jpeg
  filename <- paste(path.package('bioCancer'),"/extdata/imgs/CircosLegend.png", sep="")

  # Return a list containing the filename and alt text
  list(src = filename,
       contentType = 'image/png',
       width = 200,
       height = 250,
       alt = paste("Image number"))

}, deleteFile = FALSE)


# pull user data to r_data$ListProfData
output$uiPullUserDataCNA <- renderUI({
  selectInput(inputId = "UserData_CNA_id", label='CNA:',
              choices=  r_info$datasetlist, selected= "", multiple=FALSE,
              selectize = FALSE
  )
})

output$uiPullUserDatamRNA <- renderUI({
  selectInput(inputId = "UserData_mRNA_id", label='mRNA:',
              choices=  r_info$datasetlist, selected= "", multiple=FALSE,
              selectize = FALSE
  )
})
output$uiPullUserDataMetHM27 <- renderUI({
  selectInput(inputId = "UserData_MetHM27_id", label='Methylation HM27',
              choices= r_info$datasetlist, selected= NULL, multiple=FALSE,
              selectize = FALSE
  )
})
output$uiPullUserDataMetHM450 <- renderUI({
  selectInput(inputId = "UserData_MetHM450_id", label='Methylation HM450',
              choices= r_info$datasetlist, selected= NULL, multiple=FALSE,
              selectize = FALSE
  )
})
output$uiPullUserDataFreqMut <- renderUI({
  selectInput(inputId = "UserData_FreqMut_id", label='Mutation Frequency',
              choices= r_info$datasetlist, selected= NULL, multiple=FALSE,
              selectize = FALSE
  )
})
output$uiPullUserDatamiRNA <- renderUI({
  selectInput(inputId = "UserData_miRNA_id", label='miRNA',
              choices= r_info$datasetlist, selected= NULL, multiple=FALSE,
              selectize = FALSE
  )
})
output$uiPullUserDataRPPA <- renderUI({
  selectInput(inputId = "UserData_RPPA_id", label='RPPA',
              choices= r_info$datasetlist, selected= NULL, multiple=FALSE,
              selectize = FALSE
  )
})



output$ui_CircosDimension <- renderUI({

  Dimension <- c("CNA","Methylation", "mRNA","Mutation","miRNA","RPPA", "All" )
  selectizeInput("CircosDimensionID", label= "Select Dimension:", choices= Dimension,
                 selected = "", multiple=TRUE)
})

output$StrListProfDataCircos <- renderPrint({

  withProgress(message = 'loading Profiles Data from cBioPortal server... ', value = 1, {

    getListProfData(checked_Studies= input$StudiesIDCircos,
                    geneListLabel = input$GeneListID)

    #print("Start getting Frequency of Mutation ...")
    # r_info[['Freq_DfMutData']] <- getFreqMutData(list = r_info$ListMutData,
    #                                               geneListLabel = input$GeneListID)
    #print("End getting Mutation Frequency...")

    })

  ## don't use r_data$ListProfData => cause réinitiate wheel
  #      if(is.null(r_data$ListProfData)){
  #        c("Gene List is empty. copy and paste genes from text file (Gene/line) or use gene list from examples.")
  #     }else{
  #
  c("STUDIES:", input$StudiesIDCircos,
    "Genetic Profiles: mRNA, Methylation, CNA, miRNA, Mutation, RPPA",
    "Gene List:", input$GeneListID
  )
  # }
})

output$ui_userDataMergeDimension <- renderUI({
  tagList(
    if('CNA' %in% input$userDataID){
      uiOutput("uiPullUserDataCNA")
    },
    if('mRNA' %in% input$userDataID){
      uiOutput("uiPullUserDatamRNA")
    },
    if('Mutation' %in% input$userDataID){
      uiOutput("uiPullUserDataFreqMut")
    },
    if('MetHM27' %in% input$userDataID){
      uiOutput("uiPullUserDataMetHM27")
    },
    if('MetHM450' %in% input$userDataID2){
      uiOutput("uiPullUserDataMetHM450")
    },
    if('miRNA' %in% input$userDataID2){
      uiOutput("uiPullUserDatamiRNA")
    },
    if('RPPA' %in% input$userDataID2){
      uiOutput("uiPullUserDataRPPA")
    }
  )
  # conditionalPanel(condition="input.userDataID== 'mRNA'",
  #                  uiOutput("uiPullUserDatamRNA")
  # )
  # conditionalPanel(condition="input.userDataID== 'MetHM27'",
  #                  uiOutput("uiPullUserDataMetHM27")
  # )
  # conditionalPanel(condition="input.userDataID== 'MetHM450'",
  #                  uiOutput("uiPullUserDataMetHM450")
  # )
  # conditionalPanel(condition="input.userDataID2== 'Mutation'",
  #                  uiOutput("uiPullUserDataFreqMut")
  # )
  # conditionalPanel(condition="input.userDataID2== 'miRNA'",
  #                  uiOutput("uiPullUserDatamiRNA")
  # )
  # conditionalPanel(condition="input.userDataID2== 'RPPA'",
  #                  uiOutput("uiPullUserDataRPPA")
  # )
})


output$ui_userDataMergeSwithButton <- renderUI({
  if(!is.null(input$userDataID) || !is.null(input$userDataID2)){
    div(class="row",
        div(class="col-xs-8",
            conditionalPanel(condition = "input.StudiesIDCircos != null && input.pullUserDataButtonId ==false",
                             h5('Merge user data to wheel')),
            conditionalPanel(condition = "input.StudiesIDCircos != null && input.pullUserDataButtonId ==true",
                             h5('Merge User data to wheel',  style = "color:#428bca"))
        ),
        div(class="col-xs-4",
            conditionalPanel(condition = "input.StudiesIDCircos != null",
                             switchButton(inputId = "pullUserDataButtonId",
                                          value = FALSE, col = "GB", type = "OO")
            )
        )
    )
  }
})

output$ui_bad_userData_message <- renderUI({
  # if user data is in ListProfData
  if(any(grepl('UserData', lapply(r_info$ListProfData, function(x) names(x)))) || any(grepl('UserData', names(r_info$ListMutData)))){
    h5("+ User data",align="center", style = "color:#428bca;font-size:100%")
  }else{
    h5(" select correct User data",align="center", style = "color:red;font-size:100%")
  }
})


output$ui_Circomics <- renderUI({

  ## get Studies for Circomics
  updateSelectizeInput(session, 'StudiesIDCircos', choices = Studies["studyId"],
                       selected = c("luad_tcga_pub","blca_tcga_pub"))
  #,"prad_tcga_pub","ucec_tcga_pub"

  conditionalPanel("input.tabs_Enrichment == 'Circomics'",

                   wellPanel(
                     selectizeInput('StudiesIDCircos', 'Studies in Wheel', choices= Studies["studyId"],
                                    selected = c("luad_tcga_pub","blca_tcga_pub"), multiple = TRUE),
                     conditionalPanel(condition = "input.StudiesIDCircos == null",
                                      h5("Select at less two studies",align="center",style = "color:red")
                     ),
                     # if(length(input$StudiesIDCircos)==1){

                     div(class="row",
                         div(class="col-xs-8",
                             conditionalPanel(condition = "input.StudiesIDCircos != null && input.ViewProfDataCircosID==false",
                                              h5('Check for availability')),
                             conditionalPanel(condition = "input.StudiesIDCircos != null && input.ViewProfDataCircosID==true",
                                              h5('Check for availability', style = "color:#428bca")
                             )
                         ),
                         div(class="col-xs-4",
                             conditionalPanel(condition = "input.StudiesIDCircos != null",
                                              switchButton(inputId = "ViewProfDataCircosID",
                                                           value = FALSE, col = "GB", type = "OO"))
                         )
                     ),
                     div(class="row",
                         div(class="col-xs-8",
                             conditionalPanel(condition = "input.StudiesIDCircos != null && input.loadListProfDataCircosId ==false",
                                              h5('Load genetic profiles')),
                             conditionalPanel(condition = "input.StudiesIDCircos != null && input.loadListProfDataCircosId ==true",
                                              h5('Load genetic profiles',  style = "color:#428bca"))
                         ),
                         div(class="col-xs-4",
                             conditionalPanel(condition = "input.StudiesIDCircos != null",
                                              switchButton(inputId = "loadListProfDataCircosId",
                                                           value = FALSE, col = "GB", type = "OO")
                             )
                         )
                     ),
                     div(class="row",
                         div(class="col-xs-8",
                             conditionalPanel(condition= 'input.loadListProfDataCircosId == true && input.pushListProfData == false',
                                              h5('Import data to Workspace')),
                             conditionalPanel(condition= 'input.loadListProfDataCircosId == true && input.pushListProfData == true',
                                              h5('Import data to Workspace',  style = "color:#428bca"))
                         ),
                         div(class='col-xs-4',
                             conditionalPanel(condition = 'input.loadListProfDataCircosId == true',
                                              switchButton(inputId = "pushListProfData",
                                                           value = FALSE, col = "GB", type = "OO")
                             )
                         )
                     ),
                     conditionalPanel(condition = "input.pushListProfData==true",
                                      h5("The data sets are loaded to Workspace.",align="center", style = "color:#428bca")
                     ),
                     conditionalPanel(condition = "input.pullUserDataButtonId==true",
                                      #
                                      uiOutput("ui_bad_userData_message")
                                      #
                     ),
                     #}

                     conditionalPanel("input.loadListProfDataCircosId == true",
                                      wellPanel(
                                        ################
                                        # radioButtons("CircosDimensionID", "Choose Dimensions:",           #checkboxGroupInput
                                        #              choiceNames =
                                        #                list("Copy Number Alteration","Methylation HM27 HM450","mRNA expression",
                                        #                     "Mutation","miRNA expression", "RPPA", "ALL"),
                                        #              choiceValues =
                                        #                list("CNA","Met", "mRNA", "Mutation", "miRNA", "RPPA", "All")
                                        #              ,selected = character(0)
                                        # )

                                        uiOutput("ui_CircosDimension")

                                        #
                                      )

                     ),

                     conditionalPanel("input.CircosDimensionID != null",
                                      wellPanel(
                                        h4("Merge user data to wheel:"),
                                        div(class="row",
                                            div(class="col-xs-6",
                                                checkboxGroupInput("userDataID", label = NULL,
                                                                   choices =
                                                                     list("CNA", "mRNA","Mutation","MetHM27")
                                                )
                                            ),
                                            div(class="col-xs-6",
                                                checkboxGroupInput("userDataID2", label= NULL,
                                                                   choices =
                                                                     list("MetHM450", "miRNA", "RPPA")
                                                )
                                            )
                                        ),
                                        # div(class="row",
                                        #     div(class="col-xs-3",
                                        #         checkboxInput('UserDataCNAID', 'CNA', FALSE)),
                                        #     div(class="col-xs-3",
                                        #         checkboxInput('UserDatamRNAID', 'mRNA', FALSE)),
                                        #     div(class="col-xs-2",
                                        #         checkboxInput('UserDataFreqMutID', 'Mut', FALSE)),
                                        #     div(class="col-xs-2",
                                        #         checkboxInput('UserDataMet27ID', 'Met27', FALSE))
                                        # ),
                                        # div(class="row",
                                        #     div(class="col-xs-4",
                                        #         checkboxInput('UserDataMet450ID', 'Met450', FALSE)),
                                        #     div(class="col-xs-4",
                                        #         checkboxInput('UserDatamiRNAID', 'miRNA', FALSE)),
                                        #     div(class="col-xs-4",
                                        #         checkboxInput('UserDataRPPAID', 'RPPA', FALSE))
                                        # ),

                                        uiOutput("ui_userDataMergeDimension"),

                                        uiOutput("ui_userDataMergeSwithButton")


                                        # div(class="row",
                                        #     div(class="col-xs-6",
                                        #         actionButton('pullUserDataButtonId', 'Add to wheel', icon('arrow-down'),style='padding:4px; font-size:80%')),
                                        #     div(class="col-xs-6",
                                        #         #checkboxInput("getlistProfDataCircosID", "Load", value = FALSE))
                                        #         actionButton('UnpullUserDataButtonId', 'Remove',style='padding:4px; font-size:80%')
                                        #     )
                                        #     #checkboxInput('confirmPullUserDataID', 'Confirm Pull', FALSE)
                                        # )
                                        # }
                                      )



                     ),
                     #################

                                        # conditionalPanel("input.CircosDimensionID == 'All'",
                                        #                  #plot_downloader("SaveMetabologram_All", pre = ""),
                                        #                  downloadButton('Save_Metabologram_All', 'All')
                                        #
                                        # ),

                     checkboxInput("CircosLegendID", "Legend", value=FALSE),
                     #                    radioButtons(inputId = "WheelID", label = "Wheel Style:",
                     #                                 c("Summary"="init" ,"Zoom" = "Zoom",  "Static" = "Static"),
                     #                                 selected = "", inline = TRUE),

                     #                    radioButtons(inputId = "saveWheelID", label = "Save Wheel:",
                     #                                 c("SVG" = "SVG", "Gif" = "Gif"),
                     #                                 selected = "SVG", inline = TRUE),
                     #
                     #                    conditionalPanel(condition = "input.saveWheelID == 'SVG'",
                     #                                     downloadButton('SaveSVG', 'SVG')),
                     #
                     #                    conditionalPanel(condition = "input.saveWheelID == 'Gif'",
                     #                                     downloadButton("SaveGif")),


                     conditionalPanel("input.CircosLegendID==true",
                                      #               wellPanel(
                                      #plotOutput("LegendCircos")
                                      imageOutput("CircosLegend")
                                      #                )
                                      #                    h4("Wheel Legend"),
                                      #                    p(span("Black", style="color:black"),": Non available data."),
                                      #                    p(span("White", style="color:black"),": Non significant rate."),
                                      #                    p(span("Cyan", style="color:deepskyblue"),": Middle Negative significant rate."),
                                      #                    p(span("Blue", style="color:blue"),": Negative significant rate."),
                                      #                    p(span("Yellow", style="color:gold"),": Middle Positive significant rate."),
                                      #                    p(span("Red", style="color:red"),": Positive significant rate.")
                     ),

                     help_and_report(modal_title = "Circomics", fun_name = "CircomicsHelp",
                                     author = "Karim Mezhoud",
                                     help_file = inclRmd(file.path(
                                       getOption("radiant.path.bioCancer"),"app/tools/help/Circomics.md")))
                   )
  )
})

## Load Profile data in datasets to Processing panel
observe({
  if (not_pressed(input$pushListProfData)) return()
  isolate({

    loadInDatasets(fname="xCNA", header=TRUE)
    loadInDatasets(fname="xmRNA", header=TRUE)
    loadInDatasets(fname="xMetHM450", header=TRUE)
    loadInDatasets(fname="xMetHM27", header=TRUE)
    loadInDatasets(fname="xMut", header=TRUE)
    loadInDatasets(fname="xFreqMut", header=TRUE)
    loadInDatasets(fname="xmiRNA", header=TRUE)
    loadInDatasets(fname="xRPPA", header=TRUE)

    #### Updating datasets generate error with vars view tab
    # sorting files alphabetically
    #r_data[['datasetlist']] <- sort(r_data[['datasetlist']])
    #updateSelectInput(session, "dataset", label = "Datasets:",
    #                 choices = r_data$datasetlist,
    #                selected = "")

  })
})

observe({
  if (not_pressed(input$pushListProfData)) #return()
    isolate({
      r_data[['xCNA']] <- NULL
      r_data[['xmRNA']] <- NULL
      r_data[['xMetHM27']] <- NULL
      #r_data$ListMetData[['xMetHM27']] <- NULL
      r_data[['xMetHM450']] <- NULL
      #r_data$ListMetData[['xMetHM450']] <- NULL
      r_data[['xmiRNA']] <- NULL
      r_data[['xRPPA']] <- NULL
      r_data[['xMut']] <- NULL
      r_data[['xFreqMut']] <- NULL
    })
})

# observe({
#
#   if (not_pressed(input$SaveSVG)) return()
#   isolate({
#     library(metabologram)
#     CoffeewheelTreeData <- reStrDimension(r_data$ListProfData)
#     metabologram(CoffeewheelTreeData, width=500, height=500, main="metabologram", showLegend = TRUE, fontSize = 12, legendBreaks=c("NA","Min","Negative", "0", "Positive", "Max"), legendColors=c("black","blue","cyan","white","yellow","red") , legendText="Legend")
#
#   })
# })


#
# output$SaveGif = downloadHandler(
#   filename = function(){'random.png'},
#   content  = function(file){
#     CoffeewheelTreeData <- reStrDimension(r_data$ListProfData)
#     ggsave(file,metabologram(CoffeewheelTreeData, width=500, height=500, main="metabologram", showLegend = TRUE, fontSize = 12, legendBreaks=c("NA","Min","Negative", "0", "Positive", "Max"), legendColors=c("black","blue","cyan","white","yellow","red") , legendText="Legend"))
#     #file.rename('random.gif', file)
# }
#     )

output$ClinicalDataTable <- DT::renderDataTable({

  ##  needed to make silence the error
  if (inherits(try( dat <- r_info$ClinicalData[input$Clinical_varsID], silent=TRUE),"try-error")){
    dat <- r_info$ClinicalData
  }else{
    dat <- r_info$ClinicalData[input$Clinical_varsID]
  }
  displayTable(dat)
})



output$dl_Clinical_tab <- shiny::downloadHandler(

  filename = function() { paste0("Clinical_tab.csv") },
  content = function(file) {
   # data_filter <- if (input$show_filter) input$data_filter else ""
    get_data(r_info$ClinicalData[input$ClinicalDataTable_rows_all,], vars = input$Clinical_varsID,
            #rows = r_data$ClinicalData[grepl(paste0(data_filter, collapse="|"),r_data$ClinicalData),],
            na.rm = FALSE) %>%
      write.csv(file, row.names = FALSE)
  }
)


observeEvent(input$ClinicalHelp_report, {

  cmd <- paste0("```{r fig.width=10.46, fig.height=5.54, dpi =72}\n",
                 paste0(" get_data(ClinicalData[input$ClinicalDataTable_rows_all,], vars = input$Clinical_varsID,
                        na.rm = FALSE)"),
                 "\n",
                "\n```\n"
)
  update_report_fun(cmd)
})

help_cBioPortal<- c("Studies" = "Studies.md", "Clinical" = "Clinical.md", "Profiles" = "Profiles.md",
                    "Mutation" = "Mutation.md")

help_enrichment <- c("Circomics" = "Circomics.md", "Classifier" = "Classifier.md", "Networking" = "Reactome.Rmd")

help_data <- c("Datasets" = "manage.md","View" = "view.md", "Plots" = "visualize.md",
               "Regroup" = "pivotr.md", "Statistics" = "explore.md", "Transform" = "transform.md",
               "Combine" = "combine.md", "Report" = "report.md", "Code" = "code.md")

output$help_cBioPortal <- reactive(append_help("help_cBioPortal", file.path(getOption("radiant.path.bioCancer"),"app/tools/help"), Rmd = TRUE))
output$help_enrichment <- reactive(append_help("help_enrichment", file.path(getOption("radiant.path.bioCancer"),"app/tools/help"), Rmd = TRUE))

## needed to reread new helps version
output$help_data <- reactive(append_help("help_data", file.path(getOption("radiant.path.bioCancer"),"app/tools/help/"), Rmd = TRUE))

observeEvent(input$help_cBioPortal_all, {help_switch(input$help_cBioPortal_all, "help_cBioPortal")})
observeEvent(input$help_cBioPortal_none,{help_switch(input$help_cBioPortal_none, "help_cBioPortal", help_on = FALSE)})

observeEvent(input$help_enrichment_all, {help_switch(input$help_enrichment_all, "help_enrichment")})
observeEvent(input$help_enrichment_none,{help_switch(input$help_enrichment_none, "help_enrichment", help_on = FALSE)})

## needed to redefine help_data_panel avec re-defining help_data
help_data_panel <-
  wellPanel(
    HTML("<label>Workspace: <i id='help_data_all' title='Check all' href='#' class='action-button glyphicon glyphicon-ok'></i>
         <i id='help_data_none' title='Uncheck all' href='#' class='action-button glyphicon glyphicon-remove'></i></label>"),
    checkboxGroupInput("help_data", NULL, help_data, selected = state_group("help_data"), inline = TRUE)
    )

help_cBioPortal_panel <- tagList(
  wellPanel(
    HTML("<label>cBioPortal Menu: <i id='help_cBioPortal_all' title='Check all' href='#' class='action-button glyphicon glyphicon-ok'></i>
         <i id='help_cBioPortal_none' title='Uncheck all' href='#' class='action-button glyphicon glyphicon-remove'></i></label>"),
    checkboxGroupInput("help_cBioPortal", NULL, help_cBioPortal,
                       selected = state_group("help_cBioPortal"), inline = TRUE)
    )
  )


help_enrichment_panel <- tagList(
  wellPanel(
    HTML("<label>Enrichment Menu: <i id='help_enrichment_all' title='Check all' href='#' class='action-button glyphicon glyphicon-ok'></i>
         <i id='help_enrichment_none' title='Uncheck all' href='#' class='action-button glyphicon glyphicon-remove'></i></label>"),
    checkboxGroupInput("help_enrichment", NULL, help_enrichment,
                       selected = state_group("help_enrichment"), inline = TRUE)
    )
  )

output$help_about <- renderUI({
  file.path(getOption("radiant.path.bioCancer"),"app/tools/help/about.md") %>% inclMD %>% HTML
})


stop_radiant <- function() {
  ## quit R, unless you are running an interactive session
  if (interactive()) {
    ## flush input and r_data into Rgui or Rstudio
    isolate({
      LiveInputs <- toList(input)
      r_state[names(LiveInputs)] <- LiveInputs
      r_state$nav_radiant <- r_info[["nav_radiant"]]
      assign("r_state", r_state, envir = .GlobalEnv)
      ## convert environment to a list and then back to an environment
      ## again to remove active bindings https://github.com/rstudio/shiny/issues/1905
      ## using an environment so you can "attach" and access data easily
      rem_non_active() ## keep only the active bindings (i.e., data, datalist, etc.)
      assign("r_data", list2env(mget(ls(r_data), r_data)), envir = .GlobalEnv)
      assign("r_info", toList(r_info), envir = .GlobalEnv)
      ## removing r_sessions and functions defined in global.R
      if (exists("r_sessions")) rm(r_sessions, envir = .GlobalEnv)
      unlink("~/r_figures/", recursive = TRUE)
      sshhr(try(rm(help_menu, make_url_patterns, import_fs, init_data, navbar_proj, knit_print.data.frame, withMathJax, envir = .GlobalEnv), silent = TRUE))
      message("\nStopped bioCancer. State information is available in the r_state and r_info lists and the r_data environment. Use attach(r_data) to access data loaded into bioCancer.\n")
      stopApp()
    })
  } else {
    stopApp()
    q("no")
  }
}

# to avoid 'no visible binding for global variable' NOTE
globalVariables(c("r_data", "V1", "input", "p", "incProgress", "setNames", "tags", "br",
                  "stats","tagList","Freq","a","b","d", "e","GeneList", "cgds", "session",
                  "setNames", "stats", "SubMegaGeneList","getMegaProfData", "cbind.na",
                  "saveWidget", "downloadLink", "dbListTables", "dbConnect", "dbDriver",
                  "dbSendQuery", "dbfile", "dbClearResult", "dbWriteTable", "direction",
                  "dbGetQuery", "dbDisconnect", ".", "pull"))

# output$ui_fileUploadProfData <- renderUI({
#
#   if (is.null(input$loadGeneListID)) return()
#   if (input$loadGeneListID == "csv") {
#     fileInput('uploadfile', '', multiple=TRUE,
#               accept = c('text/csv','text/comma-separated-values',
#                          'text/tab-separated-values',
#                          'text/plain','.csv','.tsv'))
#   } else if (input$loadGeneListID == "rda") {
#     fileInput('uploadfile', '', multiple=TRUE,
#               accept = c(".rda",".rds",".rdata"))
#   }
# })

output$ui_clipboard_load_ProfData <- renderUI({
  if (getOption("radiant.local")) {
    actionButton('loadClipProfData', 'Paste data')
  } else {
    tagList(tags$textarea(class="form-control",
                          id="load_cdata", rows="5"
    ),
    actionButton('loadClipProfData', 'Paste data'))
  }
})


output$ui_ProfData <- renderUI({
  list(

    # wellPanel(
    #   conditionalPanel("input.GeneListID == 'DNA_damage_Response' && input.loadClipProf_GeneList%2 == 1",
    #                    p("Gene List is empty!",align="center",style = "color:red")
    #   ),
    #
    #   radioButtons(inputId = "loadGeneListID_ProfData", label = "Load Gene List:",
    #                c( "examples" = "ExampleGeneList_ProfData",  "clipboard" = "clipboard_GeneList_ProfData"),
    #                selected = state_multiple("loadGeneListID_ProfData", "DNA_damage_Response"), inline = TRUE),
    #
    #   conditionalPanel(condition = "input.loadGeneListID_ProfData == 'clipboard_GeneList_ProfData'",
    #                    actionButton('loadClipProf_GeneList', 'Paste Gene List')
    #                    #uiOutput("ui_clipboard_load_ProfData")
    #   ),
    #   conditionalPanel(condition = "input.loadGeneListID_ProfData == 'ExampleGeneList_ProfData'",
    #                    actionButton('loadExampleGeneList_ProfData', 'Load examples')
    #   )
    #
    # ),

    wellPanel(
      checkboxInput(inputId = "ProfData", "Export for Processing" ,value = FALSE),
      # radioButtons(inputId = "ProfData", label = "Load ProfData to Datasets:",
      #             c("ProfData"="ProfData"), selected = "ProfData", inline =TRUE),
      conditionalPanel(condition = "input.ProfData == true",
                       actionButton('loadProfData', 'Export to Datasets', icon('arrow-up')))
    ),
    #help_modal_km('Profiles Data','ProfilesHelp',inclMD(file.path(r_path,"base/tools/help/Profiles.md")))
    help_and_report(modal_title = "Profiles Data", fun_name = "ProfilesHelp",
                    author = "Karim Mezhoud",
                    help_file = inclRmd(file.path(
                      getOption("radiant.path.bioCancer"),"app/tools/help/Profiles.md")))
  )
})
####################

# # loading all examples files (linked to helpfiles)
# observe({
#   if (not_pressed(input$loadExampleGeneList_ProfData)) return()
#   isolate({
#
#     # loading gene list
#     data_path <- file.path( system.file(package = "bioCancer"),"extdata/GeneList")
#     examples <- list.files(data_path)
#
#     for (ex in examples) loadUserData(ex, file.path(data_path,ex), 'txt')
#
#     # sorting files alphabetically
#     r_data[['genelist']] <- sort(r_data[['genelist']])
#
#     updateSelectInput(session, "GeneListID", label = "Gene List Examples:",
#                       choices = r_data$genelist,
#                       selected = r_data$genelist[1])
#   })
#   #  A <<- r_data$genelist
# })
#
# ## load genelist from clipBoard
# observe({
#   # 'reading' data from clipboard
#   if (not_pressed(input$loadClipProf_GeneList)) return()
#   isolate({
#     loadClipboard_GeneList(tab=input$loadClipProf_GeneList)
#     updateRadioButtons(session = session, inputId = "GeneListID",
#                        label = "Paste Genes:",
#                        c( "examples" = "ExampleGeneList",  "clipboard" = "clipboard_GeneList"),
#                        #selected = "Genes",
#                        inline = TRUE)
#     updateSelectInput(session, "GeneListID", label = "Pasted Genes:",
#                       choices = r_data$genelist)
#   })
# })

## Load Profile data in datasets
observe({
  if (not_pressed(input$loadProfData)) return()
  isolate({

    loadInDatasets(fname="ProfData", header=TRUE)

    # sorting files alphabetically
    r_info[['datasetlist']] <- sort(r_info[['datasetlist']])

    updateSelectInput(session, "dataset", label = "Datasets:",
                      choices = r_info$datasetlist,
                      selected = "ProfData")

  })
})

output$MutDataTable <- DT::renderDataTable({
  req(input$StudiesID)
   req(input$Mut_varsID)
    ##  needed to make silence the error
    if (inherits(try( dat <- r_info$MutData[input$Mut_varsID], silent=TRUE),"try-error")){

      dat <- as.data.frame(paste0("There is no data with this genetic profile: ", input$GenProfID ," for selected Gene list."))
    }else{
      dat <- r_info$MutData[input$Mut_varsID]
    }
    displayTable(dat) %>%
      DT::formatStyle(names(dat),
                      color = DT::styleEqual(paste0("There is no ", input$GenProfID ," for selected Gene list."),
                                             'red'))#, backgroundColor = 'white', fontWeight = 'bold'

})


# output$MutDataTable <- DT::renderDataTable({
#   ## check if GenProf is mutation
#
#   # if (length(grep("mutation", input$GenProfID))==0){
#   #
#   #   dat <- as.data.frame("Please select mutations from Genetic Profiles")
#   #
#   # }else{
#     GeneList <- whichGeneList(input$GeneListID)
#
#     ##### Get Mutation Data for selected Case and Genetic Profile
#      if (inherits(try(dat <- cBioPortalData::getDataByGenes(api = cgds,
#                                                   studyId = input$StudiesID,
#                                                   genes = GeneList,
#                                                   by = "hugoGeneSymbol",
#                                                   molecularProfileIds = input$GenProfID
#                             ), silent=FALSE),"try-error")){
#
#       dat <- as.data.frame("There are some Gene Symbols not supported by cbioportal.
#                            Or the gene list is empty.
#                            Or bioCancer is not connected to cBioPortal server (check connection).")
#     }else{
#       shiny::withProgress(message = 'loading Mutation Data from cBioPortal server...', value = 1, {
#
#         dat <- cBioPortalData::getDataByGenes(api = cgds,
#                               studyId = input$StudiesID,
#                               genes = GeneList,
#                               by = "hugoGeneSymbol",
#                               molecularProfileIds = input$GenProfID) #%>%
#         #.[[1]] |>
#           #select(-c(uniqueSampleKey, uniquePatientKey, molecularProfileId, patientId, studyId))
#
#
#         if(dim(dat)[1]==0){
#           ## avoide error when GeneList is empty
#           ## Error..No.cancer.study..cancer_study_id...or.genetic.profile..genetic_profile_id..or.case.list.or..case_list..case.set..case_set_id..provid
#           dat <- as.data.frame("Gene List is empty.
#                                Or The Gene Symbols are not supported by cbioportal.
#                                Copy and paste genes from text file (Gene/line) or use gene list from examples.")
#         }else{
#           req(input$Mut_varsID)
#
#           dat <- dat[input$Mut_varsID]
#           r_data[['MutData']] <- dat
#         }
#       })
#     }
#   #}
#   displayTable(dat)%>% DT::formatStyle(names(dat),
#                                        color = DT::styleEqual("Gene List is empty. copy and paste genes from text file (Gene/line) or use gene list from examples.",
#                                                               'red'))#, backgroundColor = 'white', fontWeight = 'bold'
# })


output$dl_MutData_tab <- shiny::downloadHandler(
  filename = function() { paste0("MutData_tab.csv") },
  content = function(file) {
    #data_filter <- if (input$show_filter) input$data_filter else ""
    get_data(r_data$MutData[input$MutDataTable_rows_all,], vars = input$Mut_varsID,
            rows = NULL, na.rm = FALSE) %>%
      write.csv(file, row.names = FALSE)
  }
)


observeEvent(input$MutationHelp_report, {

  cmd <- paste0("```{r fig.width=10.46, fig.height=5.54, dpi =72}\n",
                paste0(" get_data(MutData[input$MutDataTable_rows_all,], vars = input$Mut_varsID,
                       na.rm = FALSE)"),
                "\n",
                "\n```\n"
  )
  update_report_fun(cmd)
})

output$ui_visPhysic <- renderUI({
  h4("Dynamic Layouts:")
  enableHierarchi <- c('TRUE', 'FALSE')
  PhysicLayout <-c('barnesHut', 'repulsion', 'hierarchicalRepulsion', 'forceAtlas2Based')
  MethodHierarchi <- c("hubsize", "directed")
  Hierarchi_Att <- c("LR","RL","UD","DU")

  tagList(
    checkboxInput("enableHierarchiId",label="Hierarchi", value = FALSE),
    #selectizeInput("enableHierarchiId", label = " Enable Hierarchi", choices = enableHierarchi,
     #              selected= 'FALSE', multiple= FALSE),
    selectizeInput("MethodHierarchiId",label="Layout Method", choices = MethodHierarchi,
                   selected= "hubsize", multiple = FALSE),
    selectizeInput("Hierarchi_AttId", label = "Direction", choices = Hierarchi_Att,
                   selected= 'LR', multiple = FALSE),

    selectizeInput("PhysicLayoutId",label="Physics Options", choices = PhysicLayout,
                   selected= 'hierarchicalRepulsion', multiple = FALSE)


)
})



# output$ui_FIsFilterNetwork <- renderUI({
#   FIs_Att <- c("activat","inhibit","predicted","catalyze","reaction","phosphoryl","regulat","express",
#                "complex","regulat","binding","compound","input","dissociation","indirect","ubiquitinated" )
#
#
#   selectizeInput("FIs_AttNetworkId", label = "FIs Attributes:", choices = FIs_Att,
#                  selected = state_multiple("FIs_AttNetworkId",FIs_Att, "activat"), multiple = TRUE)
#
# })
#
# output$ui_UseLinkerNetwork <- renderUI({
#   UseLinkers <- c("FALSE", "TRUE")
#
#
#   selectizeInput("UseLinkerNetId", label = "Use Linkers:", choices = UseLinkers,
#                  selected = "FALSE", multiple = FALSE)
#
# })
#
# output$ui_NodeAttri_NetworkFI <- renderUI({
#   NetworkEnrich <- c("None","Freq. Interaction", "GeneSet", "FreqInt./GeneSet")
#   selectizeInput("NodeAttri_NetworkID", label= "From ReactomeFI:", choices= NetworkEnrich,
#                  selected= "None", multiple=FALSE)
# })


# output$ui_ReacLayout <- renderUI({
#   Layouts <- c("dot","neato","twopi","circo")
#
#
#   selectizeInput("ReacLayoutId", label = "Layouts:", choices = Layouts,
#                  selected = "dot", multiple = FALSE)
#
# })

#
# output$ui_NodeAttri_ReactomeFI <- renderUI({
#   ReactomeEnrich <- c("None","Freq. Interaction", "GeneSet", "FreqInt./GeneSet")
#   selectizeInput("NodeAttri_ReactomeID", label= "From ReactomeFI:", choices= ReactomeEnrich,
#                  selected= "None", multiple=FALSE)
# })
#
# output$ui_AnnoGeneSet_ReactomeFI <- renderUI({
#   type <- c("None","Pathway", "BP","CC","MF")
#   selectizeInput("TypeGeneSetID", label="Type of enrichment:", choices=type,
#                  selected ="None", multiple=FALSE
#   )
# })
#
# output$ui_GeneSetFDR <- renderUI({
#   #if(is.null(r_data$MinGeneSetFDR)){
#   sliderInput("GeneSetFDRID", "FDR of enrichment", 0.025, min =0.0005,
#               max=0.05, step=0.0005 )
#   #}else{
#   #sliderInput("GeneSetFDRID", "FDR", 0.005, min =r_data$MinGeneSetFDR,
#   #            max=0.05, step=0.0005 )
#   #}
# })
#
# output$ui_NodeAttri_Classifier <- renderUI({
#   ClassEnrich <- c("None","mRNA","Studies", "mRNA/Studies")
#   selectizeInput("NodeAttri_ClassifierID", label= "From Classifier:", choices= ClassEnrich,
#                  selected= "None", multiple=FALSE)
# })
#
# output$ui_NodeAttri_ProfData <- renderUI({
#
#   Dimension <- c("None","CNA","Met_HM27", "Met_HM450","Mutation" )
#   selectizeInput("NodeAttri_ProfDataID", label= "Select Profiles Data:", choices= Dimension,
#                  selected= "None", multiple=TRUE)
# })
# output$ui_Freq_MutSlider <- renderUI({
#   #div(style="height: 27px;",
#   sliderInput("FreqMutSliderID", "Mutation Percentage", 25, min = 1,
#               max = 100, step = 1)
#   #)
#
# })
#
# output$ui_MetSliderHM450 <- renderUI({
#   sliderInput("ThresholdMetHM450ID", "Silencing gene rate HM450", 0.8, min =0,
#               max=1, step=0.05 )
# })
#
# output$ui_MetSliderHM27 <- renderUI({
#   sliderInput("ThresholdMetHM27ID", "Silencing gene rate HM27", 0.8, min =0,
#               max=1, step=0.05 )
# })

#
# output$ui_Network <- renderUI({
#   updateSelectizeInput(session, 'StudiesIDNetwork', choices = Studies[,1], selected = c("brca_tcga","gbm_tcga","lihc_tcga","lusc_tcga"))
#
#   tagList(
# #     conditionalPanel(condition = "input.NetworkRunId==true",
# #                      actionButton("ReacGeneListId", "load Reactome Genes")
# #     ),
#     h4("Edges Attributes:"),
#     wellPanel(
#       uiOutput("ui_FIsFilterNetwork"),
#       uiOutput("ui_UseLinkerNetwork")
#       #uiOutput("ui_Hierarchi")
#     ),
#     h4("Nodes Attributes"),
#     wellPanel(
#       uiOutput("ui_NodeAttri_NetworkFI")
# #       conditionalPanel("input.NodeAttri_ReactomeID =='GeneSet' ||
# #                        input.NodeAttri_ReactomeID =='FreqInt./GeneSet'",
# #                        uiOutput("ui_AnnoGeneSet_ReactomeFI"),
# #                        uiOutput("ui_GeneSetFDR")
# #       )
#     ),
# #     div(class="row",
# #         div(class="col-xs-4",
# #             checkboxInput("NetworkRunId", "Run" ,value = FALSE)),
# #         div(class="col-xs-4",
# #             checkboxInput("ReacLegendId", "Legend", value=FALSE))
# #     ),
#     help_modal_km('Reactome','ReactomeHelp',inclMD(file.path(r_path,"base/tools/help/Reactome.md")))
#   )
#
#
# })

## How to create RDS file reactomeFI.RDS

# download.file("http://cpws.reactome.org/caBigR3WebApp2018/FIsInGene_122718_with_annotations.txt.zip", tmp <- tempfile())
# db = read.delim(unzip(tmp))
# OR
# db <- read.delim("FIsInGene_122718_with_annotations.txt", header = T)
# saveRDS(db, "ReactomeFI2018.RDS");
# file.size("xxx.RDS")


output$ReactomeHowto <- renderPrint({
  cat("
      1 - Select Gene list from `Portal/Profiles`
      2 - Set Edges attributes
      3 - Set GeneSet enrichment from ReactomeFI
      4 - Set Nodes attributes from Classifier panel
      This step needs to classiy genes by studies (mRNA, Studies)
      5 - Set Nodes attributes from Profiles data (CNA, Methylation, Mutation, miRNA, RPPA)
      6 - Run
      ")
})

#' get Edges object for grVis function
#'
#' @usage Edges_obj()
#'
#' @return A data frame with egdes attributes
#'
#' @examples
#'example <- "runManually"
#' \dontrun{
#'  string1 <- "https://wiki.ubuntu.com/kmezhoud/bioCancer?"
#'  string2 <- "action=AttachFile&do=get&target=ListProfData.RData"
#'  link <- curl::curl(paste0(string1,string2, sep=""))
#'  load(link)
#' ##load(paste(system.file(package="bioCancer"),"/extdata/ListProfData.RData", sep=""))
#' ReactomeFI <- readRDS(paste0(system.file(package = "bioCancer"),"/extdata/ReactomeFI2017.RDS"))
#' Ed_obj <- Edges_obj()
#'}
#'
Edges_obj <- reactive({

  #if(!'ReactomeFI' %in% r_data){
  if(is.null(r_data$ReactomeFI)){
    shiny::withProgress(message = 'Loading ReactomeFI...', value = 1, {

      #r_data[['ReactomeFI']] <- read.csv("https://raw.githubusercontent.com/kmezhoud/ReactomeFI/master/FIsInGene_121514_with_annotations.txt", header=TRUE, sep="\t")
      #r_data[['ReactomeFI']]  <- read.delim("inst/extdata/FIsInGene_121514_with_annotations.txt")

      if ("package:bioCancer" %in% search()) {
        r_data[['ReactomeFI']]  <- readRDS(paste0(system.file(package = "bioCancer"),
                                                  "/extdata/ReactomeFI2021.RDS", sep=""))
      }else{
        r_data[['ReactomeFI']]  <- readRDS(file.path(paste(getOption("radiant.path.bioCancer"),
                                                           "/extdata/ReactomeFI2021.RDS", sep="")))
      }

    })
  }

  #GeneList <- c("DKK3", "NBN", "MYO6", "TP53","PML", "IFI16", "BRCA1")
  GeneList <- whichGeneList(input$GeneListID)
  #GeneList <- c("SPRY2","FOXO1","FOXO3")
  ## Edges Attributes
  shiny::withProgress(message = 'load FI for GeneList...', value = 1, {

    fis <- getReactomeFI(2018,genes=GeneList, use.linkers = input$UseLinkerId)
  })
  shiny::withProgress(message = 'load gene relationships...', value = 1, {

    names(fis) <- c("Gene1", "Gene2")
    Edges_obj1 <- merge(r_data$ReactomeFI, fis, by=c("Gene1","Gene2"))
    names(fis) <- c("Gene2", "Gene1")
    Edges_obj2 <- merge(r_data$ReactomeFI, fis, by=c("Gene1","Gene2"))
    Edges_obj <- rbind(Edges_obj1,Edges_obj2)

    #     > head(Edges_obj)
    #     Gene1 Gene2                                    Annotation Direction Score
    #     1  EGR1  TP53 expression regulated by; expression regulates       <->  1.00
    #     2  EGR1   UBB                          expression regulates        ->  1.00
    #     3  MYO6   UBB                                     predicted         -  0.61
    #     4   PML  TP53       complex; expression regulated by; input        <-  1.00
    #     5  TP53   UBB                  catalyze; complex; predicted        ->  1.00
    #     6 BRCA1  EGR1                       expression regulated by        <-  1.00

    ## Filter Annotation interaction
    #  Edges_obj <- Edges_obj[- grep(c("predic",activat), Edges_obj$Annotation),]
    #  Edges_obj <- Edges_obj[!grepl("predict|activat|binding|complex|indirect",Edges_obj$Annotation),]
    Edges_obj <- Edges_obj[grepl(paste0(input$FIs_AttId, collapse="|"),Edges_obj$Annotation),]

    ## skip infinity loop when load Reactome_Genelist
    if(is.null(r_data$Reactome_GeneList)){
      r_data[['Reactome_GeneList']] <- union(Edges_obj$Gene1, Edges_obj$Gene2)
    }else if (all(length(r_data$Reactome_GeneList) == length(union(Edges_obj$Gene1, Edges_obj$Gene2)))
              && all(r_data$Reactome_GeneList == union(Edges_obj$Gene1, Edges_obj$Gene2))
    ){

    }else{
      r_data[['Reactome_GeneList']] <- union(Edges_obj$Gene1, Edges_obj$Gene2)
    }
    ## Get interaction Frequency in dataframe FreqIn

    FreqIn <- rbind(t(t(table(as.character(Edges_obj$Gene2)))), t(t(table(as.character(Edges_obj$Gene1)))))
    colnames(FreqIn) <- "Freq"
    #FreqIn <- as.data.frame(FreqIn) %>% tibble::rownames_to_column("Genes")
    rnames <- rownames(FreqIn)
    rownames(FreqIn) <- NULL
    FreqIn <- as.data.frame(FreqIn)
    FreqIn <- cbind("Genes"= rnames, FreqIn)

    r_data[['FreqIn']] <- plyr::ddply(FreqIn,~Genes,dplyr::summarise,FreqSum=sum(Freq))

    rownames(Edges_obj) <- NULL

    Edges_obj <- as.data.frame(lapply(Edges_obj, function(x) gsub("<\\->","dir=both,arrowhead = normal,", x)))
    Edges_obj <- as.data.frame(lapply(Edges_obj, function(x) gsub("\\|\\->","dir=both,arrowtail = tee,", x)))
    Edges_obj <- as.data.frame(lapply(Edges_obj, function(x) gsub("<\\-\\|","dir=both,arrowhead = tee,", x)))
    Edges_obj <- as.data.frame(lapply(Edges_obj, function(x) gsub("->","dir = forward,", x)))
    Edges_obj <- as.data.frame(lapply(Edges_obj, function(x) gsub("<-","dir = back, arrowtail = normal,", x)))
    Edges_obj <- as.data.frame(lapply(Edges_obj, function(x) gsub("\\|\\-","dir= back, arrowtail = tee,", x)))
    Edges_obj <- as.data.frame(lapply(Edges_obj, function(x) gsub("\\-\\|","dir = forward, arrowhead = tee,", x)))
    Edges_obj <- as.data.frame(lapply(Edges_obj, function(x) gsub("-","dir = none,", x)))
    ## Egdes relationships
    Edges_obj <- as.data.frame(lapply(Edges_obj, function(x) gsub(".*complex.*","arrowhead=diamond,", x)))
    Edges_obj <- as.data.frame(lapply(Edges_obj, function(x) gsub(".*catalyze.*","arrowhead=curve,", x)))
    Edges_obj <- as.data.frame(lapply(Edges_obj, function(x) gsub(".*reaction.*","arrowhead=curve,", x)))
    Edges_obj <- as.data.frame(lapply(Edges_obj, function(x) gsub(".*phosphoryl.*","arrowhead=dot,", x)))
    Edges_obj <- as.data.frame(lapply(Edges_obj, function(x) gsub(".*activat.*","arrowhead=normal,", x)))
    Edges_obj <- as.data.frame(lapply(Edges_obj, function(x) gsub(".*inhibit.*","arrowhead=tee,", x)))
    # Edges_obj <- as.data.frame(lapply(Edges_obj, function(x) gsub(".*expression.*","arrowhead=normal,", x)))
    Edges_obj <- as.data.frame(lapply(Edges_obj, function(x) gsub(".*express.*","arrowhead=normal,", x)))
    Edges_obj <- as.data.frame(lapply(Edges_obj, function(x) gsub(".*regulat.*","arrowhead=normal,", x)))
    Edges_obj <- as.data.frame(lapply(Edges_obj, function(x) gsub(".*binding.*","dir = none,", x)))
    Edges_obj <- as.data.frame(lapply(Edges_obj, function(x) gsub(".*input.*","dir = none,", x)))
    Edges_obj <- as.data.frame(lapply(Edges_obj, function(x) gsub(".*dissociation.*"," arrowhead= inv", x)))
    Edges_obj <- as.data.frame(lapply(Edges_obj, function(x) gsub(".*compound.*","dir = none,", x)))
    Edges_obj <- as.data.frame(lapply(Edges_obj, function(x) gsub(".*predicted.*","style = dashed,", x)))
    Edges_obj <- as.data.frame(lapply(Edges_obj, function(x) gsub(".*indirect.*","style = dashed,", x)))
    Edges_obj <- as.data.frame(lapply(Edges_obj, function(x) gsub(".*ubiquitinated.*","style = dashed,", x)))

    Edges_obj[,5] <-  paste("penwidth=", Edges_obj[,5],"]", sep=" ")
    #Edges_obj$int <- "->"
    Edges_obj[,1] <- paste(Edges_obj[,1], "->", sep=" ")
    Edges_obj[,2] <- paste(Edges_obj[,2],"[", sep=" ")
    Edges_obj$arrowsize <- "arrowsize=0.5,"
    #Edges_obj$croch2 <- "]"

    Edges_obj<- Edges_obj[c("Gene1", "Gene2","Direction","Annotation","arrowsize" ,"Score")]
    #Edges_obj <- Edges_obj[1:150,]
  })
  #Edges_objbkp <<- Edges_obj

  ## Attribute number of interaction to size of nodes
  GeneAttri_df <- Node_obj_FreqIn(GeneList)
  #BRCA1[shape = box, style= filled, fillcolor="blue", color=red, penwidth=3, peripheries=2 ]
  Edges_obj<- rbind(Edges_obj, GeneAttri_df)

  return(Edges_obj)
})


getAnnoGeneSet_obj <- function(genelist,type, fdr){
  # type = c("Pathway", "BP", "CC", "MF")
  # type <- input$TypeGeneSetID
  #type <- match.arg(type)
  if (inherits(try(
    AnnoGeneSet <- queryAnnotateGeneSet(2014, t(genelist) ,type),   #Legend_GeneSet <-
    silent=TRUE),"try-error") ){
    GeneSet_obj <- data.frame(Gene1 = "",
                              Gene2 = "",
                              Direction = "",
                              Annotation = "",
                              arrowsize = "",
                              Score = ""
    )
    r_data[['AnnoGeneSet']] <- as.data.frame("Select type of enrichment.")

    GeneSet_obj <- NULL
  }else{
    ## Query GeneSet Annotation
    AnnoGeneSet <- queryAnnotateGeneSet(2021, t(genelist) ,type)
    #AnnoGeneSet_bkp <<- AnnoGeneSet
    if(nrow(AnnoGeneSet)== 0){
      GeneSet_obj <- data.frame(Gene1 = "",
                                Gene2 = "",
                                Direction = "",
                                Annotation = "",
                                arrowsize = "",
                                Score = "")
      r_data[['AnnoGeneSet']] <- as.data.frame("No GeneSet found.")
      GeneSet_obj <- NULL
    }else{

      ## Filter significant annotation using FDR
      AnnoGeneSet <- AnnoGeneSet[AnnoGeneSet$fdr < fdr,]
      #AnnoGeneSetbkp <<- AnnoGeneSet

      if(nrow(AnnoGeneSet)== 0){
        GeneSet_obj <- data.frame(Gene1 = "",
                                  Gene2 = "",
                                  Direction = "",
                                  Annotation = "",
                                  arrowsize = "",
                                  Score = "")
        r_data[['AnnoGeneSet']] <- as.data.frame("No significant GeneSet found.")
        GeneSet_obj <- NULL
      }else{

        r_data[['AnnoGeneSet']] <- AnnoGeneSet

        #r_data[['MinGeneSetFDR']] <- min(AnnoGeneSet$fdr, na.rm = TRUE)

        ## Split hits to a list
        key0 <- strsplit(AnnoGeneSet$hits, ",")

        ## from Martin Morgan  http://stackoverflow.com/questions/12837462/how-to-subset-data-with-advance-string-matching

        Index_Gene <- data.frame(index = rep(seq_along(key0), sapply(key0, length)),ID = unlist(key0))
        #Index_Genebkp <<- Index_Gene
        ## Maybe useful add GeneList with index and genes
        #ref_GeneSet  <-  cbind(GeneSet = AnnoGeneSet_hits[subset[,1],2],subset)

        GeneSet_obj <- data.frame(Gene1 = paste(input$TypeGeneSetID,Index_Gene[,1], sep=""),
                                  Gene2 = "->",
                                  Direction = Index_Gene[,2],
                                  Annotation = "[arrowhead=none,",
                                  arrowsize = "color=Gray,",
                                  Score = "penwidth=0.2]"
        )

      }
    }
  }
  return(GeneSet_obj)
}

output$dl_GeneSet_Legend <- shiny::downloadHandler(
  filename = function() { paste0("GeneSet_Legend.csv") },
  content = function(file) {
    data_filter <- if (input$show_filter) input$data_filter else ""
    get_data(r_data$GeneSet_Legend, vars = NULL, filt = data_filter,
            rows = NULL, na.rm = FALSE) %>%
      write.csv(file, row.names = FALSE)
  }
)

output$GeneSet_Legend <- DT::renderDataTable({

  if(nrow(r_data$AnnoGeneSet)==1){ # 1 corresponds to r_data[['AnnoGeneSet']] <- as.data.frame("No GeneSet found.")
    dat  <- as.data.frame('There is no significant enrichment found. Change FDR.')
    colnames(dat) <- 'There is no significant enrichment found. Change FDR.'
  }else{
    ## Attribute index to pathway
    if (inherits(try(
      Legend_GeneSet <- cbind(Node = paste(input$TypeGeneSetID,
                                           seq_len(nrow(r_data$AnnoGeneSet)),
                                           sep=""),
                              r_data$AnnoGeneSet[,names(r_data$AnnoGeneSet) != "hits"]),
      silent=TRUE),"try-error")){

      dat <- as.data.frame("Select one type of enrichment.")

    }else{

      Legend_GeneSet <- cbind(Node = paste(input$TypeGeneSetID,
                                           seq_len(nrow(r_data$AnnoGeneSet)),
                                           sep=""),
                              r_data$AnnoGeneSet[,names(r_data$AnnoGeneSet) != "hits"])


      #Legend_GeneSet_bkp <<- Legend_GeneSet
      Legend_GeneSet[,4:7] <- round(Legend_GeneSet[,4:7], digits=2)
      colnames(Legend_GeneSet)[c(3,4,6)] <- c("nhit","nGenes","pval")
      dat <- Legend_GeneSet[,c(1,2,3,4,6,7)]
    }
  }
  r_data[['GeneSet_Legend']] <- dat

  displayTable(dat)
})


#' get graph object for grViz
#' @usage graph_obj(NodeAttri_Reactome,NodeAttri_Classifier,NodeAttri_ProfData)
#'
#' @param NodeAttri_Reactome  Node attribute from Reactome database ('Freq. Interaction')
#' @param NodeAttri_Classifier Node attributes from geNetClassifier ('mRNA','Studies','mRNA/Studies')
#' @param NodeAttri_ProfData Node attributes from Profiles Data ('Mutation', 'CNA', 'Met_HM450', 'Met_HM27')
#'
#' @return Object graph for grViz with Nodes and Edges attributes
#'
#' @examples
#'example <- "runManually"
#' \dontrun{
#'  string1 <- "https://wiki.ubuntu.com/kmezhoud/bioCancer?"
#'  string2 <- "action=AttachFile&do=get&target=ListProfData.RData"
#'  link <- curl::curl(paste0(string1,string2, sep=""))
#'  load(link)
#' ##load(paste(system.file(package="bioCancer"),"/extdata/ListProfData.RData", sep=""))
#' ReactomeFI <- readRDS(paste0(system.file(package = "bioCancer"),"/extdata/DisGeNet.RDS"))
#' gr_obj <- graph_obj('Freq.Interaction', 'mRNA', 'Met_HM450')
#'}
#'
#' @importFrom RCurl basicTextGatherer
#'
graph_obj <- reactive({

  GeneList <- whichGeneList(input$GeneListID)

  Edges_obj <- Edges_obj()

  # if(input$NodeAttri_ReactomeID == 'Freq. Interaction'){
  #   ## Nodes Attributes
  #   GeneAttri_df <- Node_obj_FreqIn(GeneList)
  #   #BRCA1[shape = box, style= filled, fillcolor="blue", color=red, penwidth=3, peripheries=2 ]
  #   Edges_obj<- rbind(Edges_obj, GeneAttri_df)
  # }
  #if(input$NodeAttri_ReactomeID == 'FreqInt./GeneSet'){
  ## Nodes Attributes
  GeneFreqIn_df <- Node_obj_FreqIn(GeneList)
  if(input$TypeGeneSetID =="None"){

  }else if(input$TypeGeneSetID =="Pathway" ||
           input$TypeGeneSetID =="BP" ||
           input$TypeGeneSetID =="CC" ||
           input$TypeGeneSetID =="MF"
  ){
    GeneSetAnno_df <- getAnnoGeneSet_obj(GeneList,input$TypeGeneSetID,input$GeneSetFDRID)

    GeneAttri_df <- rbind(GeneFreqIn_df,GeneSetAnno_df)
    #BRCA1[shape = box, style= filled, fillcolor="blue", color=red, penwidth=3, peripheries=2 ]
    Edges_obj<- rbind(Edges_obj, GeneAttri_df)
  }

  # }

  #if(input$NodeAttri_ReactomeID == 'GeneSet'){

  # if(input$TypeGeneSetID =="None"){
  #
  # }else if(input$TypeGeneSetID =="Pathway" ||
  #          input$TypeGeneSetID =="BP" ||
  #          input$TypeGeneSetID =="CC" ||
  #          input$TypeGeneSetID =="MF"
  # ){
  #   GeneSetAnno_df <- getAnnoGeneSet_obj(GeneList,input$TypeGeneSetID,input$GeneSetFDRID) #input$TypeGeneSetID
  #   Edges_obj <- rbind(Edges_obj, GeneSetAnno_df)
  #   # Edges_obj_bkp <<- Edges_obj
  # }
  # #  }

  if(exists("r_data") && !is.null(r_data[['GenesClassDetails']])){
    if(input$NodeAttri_ClassifierID == 'mRNA'){

      ## Nodes Attributes
      GeneAttri_df1 <- Node_obj_mRNA_Classifier(GeneList, r_data$GenesClassDetails)
      #GeneAttri_df2 <- Node_obj_FreqIn(GeneList)
      #BRCA1[shape = box, style= filled, fillcolor="blue", color=red, penwidth=3, peripheries=2 ]
      #GeneAttri_df <- rbind(GeneAttri_df1, GeneAttri_df2)
      #GeneAttri_bkp <<- GeneAttri_df
      Edges_obj <- rbind(Edges_obj, GeneAttri_df1)
      #Edges_obj_bkp <<- Edges_obj
    }

    if (input$NodeAttri_ClassifierID =='Studies'){
      Disease_Net <- Studies_obj(df=r_data$GenesClassDetails)
      Edges_obj<- rbind(Edges_obj, Disease_Net)

    }

    if (input$NodeAttri_ClassifierID == 'mRNA/Studies'){

      ## Nodes Attributes
      GeneAttri_mRNA <- Node_obj_mRNA_Classifier(GeneList, r_data$GenesClassDetails)
      #GeneAttri_FreqIn <- Node_obj_FreqIn(GeneList)
      Studies_Net <- Studies_obj(df=r_data$GenesClassDetails)
      #FreqMut_obj <- Mutation_obj()

      #BRCA1[shape = box, style= filled, fillcolor="blue", color=red, penwidth=3, peripheries=2 ]
      GeneAttri_df <- rbind(GeneAttri_mRNA, Studies_Net)
      # GeneAttri_df <- rbind(GeneAttri_df,Studies_Net)
      #GeneAttri_df <- rbind(GeneAttri_df, FreqMut_obj)

      #GeneAttri_bkp <<- GeneAttri_df
      Edges_obj <- rbind(Edges_obj, GeneAttri_df)
      #Edges_obj_bkp <<- Edges_obj
    }
  }
  if('Mutation' %in% input$NodeAttri_ProfDataID ){

    FreqMut_obj <- Mutation_obj(list = r_info$ListMutData, FreqMutThreshold=input$FreqMutSliderID, geneListLabel = input$GeneListID)
    Edges_obj <- rbind(Edges_obj, FreqMut_obj)

  }
  if('CNA' %in% input$NodeAttri_ProfDataID){

    CNA_obj <- Node_obj_CNA_ProfData(list=r_info$ListProfData$CNA)
    Edges_obj <- rbind(Edges_obj, CNA_obj)

  }

  if('Met_HM450' %in% input$NodeAttri_ProfDataID){

    Met_obj <- Node_obj_Met_ProfData(list= r_info$ListProfData$Met_HM450,
                                     type ='HM450',
                                     input$ThresholdMetHM450ID )
    Edges_obj <- rbind(Edges_obj, Met_obj)

  }

  if('Met_HM27' %in% input$NodeAttri_ProfDataID ){

    Met_obj <- Node_obj_Met_ProfData(list= r_info$ListProfData$Met_HM27,
                                     type='HM27',
                                     input$ThresholdMetHM27ID)
    Edges_obj <- rbind(Edges_obj, Met_obj)

  }


  ## convert Dataframe to graph object
  #cap <- capture.output(print(Edges_obj, row.names = FALSE)[-1])
  cap <- apply(Edges_obj, 1, function(x) paste(x, sep="\t", collapse=" "))
  ca <- paste(cap,"", collapse=";")
  obj <- paste0("\n","digraph{",
                "graph [layout=", input$ReacLayoutId,"]",
                "\n", ca, "\n","}", sep="")

  return(obj)

})

#' Plot network with nodes and edges attributes
#'
#' @usage diagrammeR(NodeAttri_Reactome,NodeAttri_Classifier,NodeAttri_ProfData)
#' @param NodeAttri_Reactome  Node attribute from Reactome database ('Freq. Interaction')
#' @param NodeAttri_Classifier Node attributes from geNetClassifier ('mRNA','Studies','mRNA/Studies')
#' @param NodeAttri_ProfData Node attributes from Profiles Data ('Mutation', 'CNA', 'Met_HM450', 'Met_HM27')
#'
#' @return plot
#'
#' @examples
#'example <- "runManually"
#' \dontrun{
#'  string1 <- "https://wiki.ubuntu.com/kmezhoud/bioCancer?"
#'  string2 <- "action=AttachFile&do=get&target=ListProfData.RData"
#'  link <- curl::curl(paste0(string1,string2, sep=""))
#'  load(link)
#' ##load(paste(system.file(package="bioCancer"),"/extdata/ListProfData.RData", sep=""))
#' ReactomeFI <- readRDS(paste0(system.file(package = "bioCancer"),"/extdata/DisGeNet.RDS"))
#' diagrammeR('Freq.Interaction', 'mRNA', 'Met_HM450')
#'}
output$diagrammeR <- DiagrammeR::renderGrViz({

  DiagrammeR::grViz(
    #     digraph{
    ## Edge Atrributes

    #         BRCA1  -> IFI16   [arrowhead = normal, color= LightGray, alpha=30, penwidth= 0.2] ;
    #         BRCA1  ->   NBN [arrowhead = normal] ;
    #         BRCA1  ->  TP53   [color= LightGray] ;
    #         IFI16  ->  TP53 [arrowtail = normal] ;
    #         PML  ->  TP53 [arrowtail = normal];


    ## Node Attributes

    #        BRCA1[node_id="BRCA1_id" ,shape = box, style= filled, fillcolor="#0007CD", color=red, penwidth=3, peripheries=2 ]

    #    },
    graph_obj(),
    ## Engine argument do not work in the future (update viz.js)
    ## https://github.com/rich-iannone/DiagrammeR/issues/150
    #engine =  input$ReacLayoutId,   #dot, neato|twopi|circo|
    width = 600
  )

})


# ld_diagrammeR_plot<- function(){
#   DiagrammeR::grViz(
#     graph_obj(),
#     #engine =  input$ReacLayoutId,   #dot, neato|twopi|circo|
#     width = 1200
#   )
# }

output$Save_diagrammeR_plot <- downloadHandler(
  filename = function() {
    paste0("Reactomeplot.html", sep="")
  },
  content = function(file) {
    htmlwidgets::saveWidget(
      DiagrammeR::grViz(
        graph_obj(),
        #engine =  input$ReacLayoutId,   #dot, neato|twopi|circo|
        width = 600
      ), file)

    #webshot::webshot("temp.html", file = "Rplot.png",
    #       cliprect = "viewport")

  }

  # browseURL(paste('file://',getwd(),"Reactomeplot.html", sep="/"))
  ## wait 1 sd before delete
  # p1 <- proc.time()
  # Sys.sleep(1)
  # proc.time() - p1
  #unlink(paste(getwd(),"Reactomeplot.html", sep="/"))

)

output$ReactomeLegend <- renderImage({
  # When input$n is 3, filename is ./images/image3.jpeg
  filename <- paste(getOption("radiant.path.bioCancer"),"/extdata/imgs/ReactomeLegend.png", sep="")

  # Return a list containing the filename and alt text
  list(src = filename,
       contentType = 'image/png',
       width = 500,
       height = 300,
       alt = paste("Image number"))

}, deleteFile = FALSE)


## REPORT
observeEvent(input$ReactomeHelp_report, {

DiagrammeR_net <- paste0("## Static network \n
```{r}\n",
                   paste0(" DiagrammeR::grViz(
        graph_obj(),
        width = 600
                   )
  ") ,
                   "\n",
                   "\n```\n"
  )


visNetwork <- paste0("## Dynamic network \n
```{r}\n",
                       paste0("visNetwork::visHierarchicalLayout(r_data$graphe,
                              enabled= input$enableHierarchiId,     # TRUE, FALSE
                              direction = input$Hierarchi_AttId,    # 'LR', 'RL', 'UD', 'DU'
                              sortMethod= input$MethodHierarchiId   # 'directed' or 'hubsize'
                       )"),
                       "\n",
                       "\n```\n"
                       )


  update_report_fun(DiagrammeR_net)
  update_report_fun(visNetwork)
})

output$ClassifierHowto <- renderPrint({
  cat("
      1 - Select Studies
      2 - Set Samples size
      3 - Run Classification
      4 - Plot Cluster profiles
      ")
})



# output$list_Cases <- renderUI({
#   shiny::withProgress(message = 'loading Cases...', value = 0.1, {
#     Sys.sleep(0.25)
#     checked_Studies <- input$StudiesIDClassifier
#     listCases <- lapply(checked_Studies, function(x) getCaseLists(cgds,x)[,1])
#     names(listCases) <- checked_Studies
#     listCases <- lapply(listCases, function(x) x[grep("v2_mrna", x)])
#     listCases <- listCases[lapply(listCases,length)>0]
#     r_data[['listCases']] <- listCases
#     selectizeInput('CasesIDClassifier','Select one Cases by Study', choices = listCases, multiple=TRUE)
#     #selected=c("brca_tcga_rna_v2_mrna", "gbm_tcga_rna_v2_mrna","lihc_tcga_rna_v2_mrna","lusc_tcga_rna_v2_mrna")
#     #updateSelectizeInput(session, 'CasesIDClassifier', choices = listCases,selected = listCases[1])
#   })
# })
#
# output$list_GenProfs <- renderUI({
#   shiny::withProgress(message = 'loading Genetic Profiles...', value = 0.1, {
#     Sys.sleep(0.25)
#     checked_Studies <- input$StudiesIDClassifier
#     listGenProfs <- lapply(checked_Studies, function(x) getGeneticProfiles(cgds,x)[,1])
#     names(listGenProfs) <- checked_Studies
#     listGenProfs <- lapply(listGenProfs, function(x) x[grep("v2_mrna$", x)])
#     listGenProfs <- listGenProfs[lapply(listGenProfs,length)>0]
#     r_data[['listGenProfs']] <- listGenProfs
#     selectizeInput('GenProfsIDClassifier', 'Select one Genetic Profile by Study', listGenProfs, multiple = TRUE)
#     #  selected=c("brca_tcga_rna_v2_mrna", "gbm_tcga_rna_v2_mrna","lihc_tcga_rna_v2_mrna","lusc_tcga_rna_v2_mrna")
#   })
# })


# output$selection <- renderPrint(
#   input$mychooser
# )

TableCases <- reactive({
  shiny::withProgress(message = 'loading Sample size...', value = 1, {

    checked_Studies <- input$StudiesIDClassifier
    ## get cases for checked studies and pull only description and sampleLitsId column
    listCases <- lapply(checked_Studies, function(x)  sampleLists(cgds, x)[,c("description", "sampleListId")] |>
                          unite(description_sampleListId, c("description", "sampleListId"), sep = "-") |>
                          pull(description_sampleListId))
    ## extract only cases with mrna
    matchedCases <- lapply(listCases, function(x) x[grepl("mrna", x ,ignore.case = TRUE)])

    ## remove emply list
    matchedCases <- matchedCases[lapply(matchedCases,length)>0]
    #matchedGenProf <- matchedGenProf[lapply(matchedGenProf,length)>0]
    if(length(matchedCases) < 2){
      dat <- as.data.frame('Check Cases for selected studies. Some ones do not have samples of mRNA expression.')
    }else if (length(matchedCases) < 3){
      dat <- as.data.frame('It is recommended to select at less 3 studies with mRNA data.')
    }else if (length(checked_Studies) > length(matchedCases)){
      dat <- as.data.frame('Some selected study does not have mRNA data. Select only study with mRNA data.')
    }else{
      dat <- NULL
      for(s in seq(matchedCases)){

        samples <- paste(checked_Studies[s], matchedCases[[s]], sep="-")|>
          as_tibble() |>
          separate(col = value, into = c("Study", "description", "sampleListId"),sep =  "-")
        dat <- rbind(dat, samples)
      }
    }
    return(dat)
  })
})


output$viewTableCases <- DT::renderDataTable({
  dat <-   TableCases()
  displayTable(dat) %>% DT::formatStyle(names(dat),
                  color = DT::styleEqual('Check Cases for selected studies. Some ones do not have samples of mRNA expression.',
                                        'red'))#, backgroundColor = 'white', fontWeight = 'bold'

})




output$getGenesClassifier <- DT::renderDataTable({

  shiny::withProgress(message = 'loading Genetic Profiles...', value = 1, {

    listGenProfs <-  getList_GenProfs(input$StudiesIDClassifier)
  })

  shiny::withProgress(message = 'loading Cases...', value = 1, {

    listCases <- getList_Cases(input$StudiesIDClassifier)
  })

  shiny::withProgress(message = 'geNetClassifier is running...', value = 1, {

    dat <-   getGenesClassification(checked_Studies = input$StudiesIDClassifier,
                                    GeneList = whichGeneList(input$GeneListID),
                                    samplesize = input$SampleSizeClassifierID,
                                    threshold = input$ClassifierThresholdID,
                                    listGenProfs= listGenProfs,
                                    listCases = listCases
    )
  })
  r_data[['GenesClassDetails']] <- dat
  displayTable(dat)%>% DT::formatStyle(names(dat),
                                       color = DT::styleEqual("Gene List is empty. copy and paste genes from text file (Gene/line) or use gene list from examples.",
                                                              'red'))#, backgroundColor = 'white', fontWeight = 'bold'
})


output$dl_GenesClassDetails_tab <- shiny::downloadHandler(
  filename = function() { paste0("Classification_tab.csv") },
  content = function(file) {
    get_data(r_data$GenesClassDetails, vars = NULL,
            rows = NULL, na.rm = FALSE) %>%
      write.csv(file, row.names = FALSE)
  }
)

## Render Gene-Disease Association using DisGeNet database
output$Plot_enricher <- renderPlot({
  shiny::withProgress(message = 'Genes Diseases Association...', value = 1, {

    GeneList <- whichGeneList(input$GeneListID)

    ## clusterProfile package
    #GeneID = bitr(GeneList, fromType="SYMBOL", toType="ENTREZID", annoDb="org.Hs.eg.db")[,2]
    ## Symbol2GeneID
    GeneID<- unname(unlist(bioCancer::translate(GeneList, org.Hs.eg.db::org.Hs.egSYMBOL2EG)))


    ## How to create DisGeNet.RDS file
    # download all_gene_disease_associations.tsv.gz from  http://www.disgenet.org/web/DisGeNET/menu/downloads
    # db <- read.delim("all_gene_disease_associations.tsv.gz")
    # saveRDS(db, "DisGeNet0918.RDS")
    # str(readRDS("DisGeNet0918.RDS))

    ## use disgenet2r package to get last version
    # install manually SPARKL from archive https://cran.r-project.org/src/contrib/Archive/SPARQL/
    # install disgenet2r from bitbuket
    # library(devtools)
    # install_bitbucket("ibi_group/disgenet2r")
    # get all gene list from Gene Association Tab: https://www.disgenet.org/downloads
    # Extract only Gene list
    # DisGeNet_2023 <- read.csv2("~/Downloads/gene_associations.tsv", header = TRUE, sep = "\t")
    # geneList <- DisGeNet_2023$geneSymbol
    # libsrary(disgenet2r)
    # disgenet_api_key <-get_disgenet_api_key(email = "kmezhoud@gmail.com", password = "$Chocolat01", verbose = FALSE, warnings = TRUE)

    # get_all_gene_disease_association <- function(genelist){
    #   gene2disease(
    #     genelist,
    #     vocabulary = "HGNC",
    #     database = "CURATED",
    #     score = c(0, 1),
    #     api_key = disgenet_api_key,
    #     verbose = FALSE,
    #     warnings = FALSE
    #   )
    # }
    #
    # map_output <- purrr::map(split(geneList,
    #                                ceiling(seq_along(geneList)/500)),
    #                          get_all_gene_disease_association)
    #
    # # remove umpty elemnt in list
    # map_output <- map_output[lapply(map_output,class)=='DataGeNET.DGN']
    #
    # # extract slot qresult from a list and  merge them in dataframe
    # DisGeNet2023  <- plyr::ldply(map_output, slot, "qresult") |>
    #   dplyr::select(geneid, gene_symbol, diseaseid, disease_name ) |>
    #   dplyr::rename(geneId = geneid, geneSymbol = gene_symbol, diseaseId= diseaseid, diseaseName = disease_name)


    ## download DisGeNet.RDS file from ubuntu/kmezhoud/bioCancer
    if(is.null(r_data$gda)){
      shiny::withProgress(message = 'Loading DisGeNet.RDS...', value = 1, {

        #download.file("https://wiki.ubuntu.com/kmezhoud/bioCancer?action=AttachFile&do=get&target=DisGeNet.RDS",tmp <- tempfile())
        download.file("https://github.com/kmezhoud/bioCancer/raw/master/inst/extdata/DisGeNet0223.RDS",tmp <- tempfile())
        gda <- readRDS(tmp)
        r_data[['gda']] <- gda

      })
    }

    ## from http://www.disgenet.org/ds/DisGeNET/resultsDisGeNet.tar.gz
    # ## downloaded local DisGeNet.RDS
    # if ("package:bioCancer" %in% search()) {
    #   gda <- readRDS(paste0(system.file(package = "bioCancer"),"/extdata/DisGeNet.RDS"))
    #
    # }else{
    #   gda <- readRDS(file.path(paste(r_path,"/extdata/DisGeNet.RDS", sep="")))
    # }
    # for Local RDC file
    disease2gene=r_data$gda[, c("diseaseId", "geneId")]
    disease2name=r_data$gda[, c("diseaseId", "diseaseName")]
    ###
    ## Use DisGeNet.R API
    # entity = "gene"
    # identifier = "entrez"
    # gda <- doQuery(entity, identifier)
    #
    # disease2gene = gda[,c("c1.cui","c2.geneId")]
    # disease2name = gda[, c("c1.cui", "c1.name")]
    ####
    GDA_enricher <- clusterProfiler::enricher(GeneID, pvalueCutoff = 0.05,TERM2GENE=disease2gene, TERM2NAME=disease2name)
    r_data[['GDA_enricher']] <- GDA_enricher
    options(scipen = 0, digits = 2)
    barplot(GDA_enricher,drop=TRUE,showCategory=10 ,digits=2)
  })
})

## function used to download the plot using plot_downloader
Plot_enrich <- function(){
  options(scipen = 0, digits = 2)
  barplot(r_data$GDA_enricher,drop=TRUE, showCategory=10 ,digits=2)

}

## Disease - Genes - Studies Associations
output$compareClusterDO <- renderPlot({
  shiny::withProgress(message = 'Disease Ontology enrich...', value = 1, {

    genesGroups <- lapply(r_data$GenesClassDetailsForPlots, function(x)rownames(x))
    GroupsID <- lapply(genesGroups,function(x) unname(unlist(bioCancer::translate(x, org.Hs.eg.db::org.Hs.egSYMBOL2EG))))

    if (inherits(try(cdo <- clusterProfiler::compareCluster(GroupsID, fun="enrichDO"), silent=TRUE),"try-error"))
    {print("No enrichment found in any of gene cluster, please check your input...")
      plot(c(0, 1), c(0, 1), ann = F, bty = 'n', type = 'n', xaxt = 'n', yaxt = 'n')
      text(x = 0.5, y = 0.5, paste("No Disease Ontology enrichment found\n",
                                   " in any of gene cluster, \n",
                                   "Please check your input..."),
           cex = 1, col = "red")

    }else{
      cdo <- clusterProfiler::compareCluster(GroupsID, fun="enrichDO")
      r_data[['cdo']] <- cdo
      clusterProfiler::dotplot(cdo)
    }
  })
})

compareClusterDO <- function(){
  clusterProfiler::dotplot(r_data$cdo, title="Disease Ontology Enrichment Comparison")

}


## Reactome Pathway Cluster Enrichment
output$compareClusterReactome <- renderPlot({
  shiny::withProgress(message = 'Reactome Pathway enrich...', value = 1, {
    #   require(reactome.db)
    #  require(ReactomePA)
    genesGroups <- lapply(r_data$GenesClassDetailsForPlots, function(x)rownames(x))
    GroupsID <- lapply(genesGroups,function(x) unname(unlist(bioCancer::translate(x, org.Hs.eg.db::org.Hs.egSYMBOL2EG))))

    if (inherits(try(cdp <- clusterProfiler::compareCluster(GroupsID, fun="enrichPathway"), silent=TRUE),"try-error"))
    { print("No Reactome enrichment found in any of gene cluster, please check your input...")
      text(x = 0.5, y = 0.5, paste("No Reactome Pathway enrichment found\n",
                                   "in any of gene cluster, \n",
                                   "Please check your input..."),
           cex = 1, col = "red")
    }else{
      cdReactome <- clusterProfiler::compareCluster(GroupsID, fun="enrichPathway")
      r_data[['cdReactome']] <- cdReactome
      clusterProfiler::dotplot(cdReactome)
    }
  })
})

compareClusterReactome <- function(){
  clusterProfiler::dotplot(r_data$cdReactome, title="Reactome Pathway Enrichment Comparison")
}
## Gene Ontology (GO) Studies Associations
output$compareClusterGO <- renderPlot({
  shiny::withProgress(message = 'Gene Ontology Enrich...', value = 1, {

    genesGroups <- lapply(r_data$GenesClassDetailsForPlots, function(x)rownames(x))
    GroupsID <- lapply(genesGroups,function(x) unname(unlist(bioCancer::translate(x, org.Hs.eg.db::org.Hs.egSYMBOL2EG))))
    if (inherits(try(cgo <- clusterProfiler::compareCluster(GroupsID, fun="enrichGO",OrgDb='org.Hs.eg.db')),"try-error"))
    {
      print("No Gene Ontology enrichment found in any of gene cluster, please check your input...")
      text(x = 0.5, y = 0.5, paste("No Gene Ontology Pathway enrichment found\n",
                                   "in any of gene cluster, \n",
                                   "Please check your input..."),
           cex = 1, col = "red")
    }else{
      cgo <- clusterProfiler::compareCluster(GroupsID, fun="enrichGO",OrgDb='org.Hs.eg.db')
      r_data[['cgo']] <- cgo
      clusterProfiler::dotplot(r_data$cgo)
    }
  })
})

compareClusterGO <- function(){

  clusterProfiler::dotplot(r_data$cgo, title="GO Enrichment Comparison")
}
## KEGG Pathway Enrichment
output$compareClusterKEGG <- renderPlot({
  shiny::withProgress(message = 'KEGG Pathway Enrich...', value = 1, {

    genesGroups <- lapply(r_data$GenesClassDetailsForPlots, function(x)rownames(x))
    GroupsID <- lapply(genesGroups,function(x) unname(unlist(bioCancer::translate(x, org.Hs.eg.db::org.Hs.egSYMBOL2EG))))
    if (inherits(try(cgo <- clusterProfiler::compareCluster(GroupsID, fun="enrichKEGG")),"try-error"))
    {
      #print("No KEGG enrichment found in any of gene cluster, please check your input...")
      text(x = 0.5, y = 0.5, paste("No KEGG Pathway enrichment found\n",
                                   "in any of gene cluster, \n",
                                   "Please check your input..."),
           cex = 1, col = "red")
    }else{
      ckegg <- clusterProfiler::compareCluster(GroupsID, fun="enrichKEGG")
      r_data[['ckegg']] <- ckegg
      clusterProfiler::dotplot(ckegg)
    }
  })
})

compareClusterKEGG <- function(){
  clusterProfiler::dotplot(r_data$ckegg, title="KEGG Enrichment Comparison")
}

## Cellular Component  Enrichment
output$compareClusterCC<- renderPlot({
  shiny::withProgress(message = 'Cellular Component enrichment...', value = 1, {

    genesGroups <- lapply(r_data$GenesClassDetailsForPlots, function(x)rownames(x))
    GroupsID <- lapply(genesGroups,function(x) unname(unlist(bioCancer::translate(x, org.Hs.eg.db::org.Hs.egSYMBOL2EG))))
    if (inherits(try(cgo <- clusterProfiler::compareCluster(GroupsID, fun="groupGO", OrgDb='org.Hs.eg.db')),"try-error"))
    {
      print("No Cellular Component enrichment found in any of gene cluster, please check your input...")
      text(x = 0.5, y = 0.5, paste("No Cellular Component Pathway enrichment found\n",
                                   "in any of gene cluster, \n",
                                   "Please check your input..."),
           cex = 1, col = "red")
    }else{
      cCC <- clusterProfiler::compareCluster(GroupsID, fun="groupGO", OrgDb='org.Hs.eg.db')
      r_data[['cCC']] <- cCC
      clusterProfiler::dotplot(cCC)
    }
  })
})
compareClusterCC <- function(){
  clusterProfiler::dotplot(r_data$cCC, title="Cellular Component Enrichment Comparison")
}


observeEvent(input$ClassifierHelp_report, {

  cmd1 <- paste0("```{r fig.width=10.46, fig.height=5.54, dpi =72}\n",
                 paste0("get_data(r_data$GenesClassDetails, vars = NULL,
            rows = NULL, na.rm = FALSE)"),
                 "\n",
                 "\n```\n"
  )



  cmd2 <-paste0("```{r fig.width=10.46, fig.height=5.54, dpi =72}\n",
                paste0("options(scipen = 0, digits = 2)
                       if(!is.null(r_data$x))
                       barplot(r_data$x,drop=TRUE, title= 'Genes Diseases Association', showCategory=10 ,digits=2)"),
                "\n",
                "\n```\n"
  )

  cmd3 <-paste0("```{r fig.width=10.46, fig.height=5.54, dpi =72}\n",
                paste0("options(scipen = 0, digits = 2)
                       if(!is.null(r_data$cdo))
                       clusterProfiler::dotplot(r_data$cdo, title='Disease Ontology Enrichment Comparison')"),
                "\n",
                "\n```\n"
                )

  cmd4 <-paste0("```{r fig.width=10.46, fig.height=5.54, dpi =72}\n",
                paste0("options(scipen = 0, digits = 2)
                       if(!is.null(r_data$cdReactome))
                       clusterProfiler::dotplot(r_data$cdReactome, title= 'Reactome Pathway Enrichment Comparison')"),
                "\n",
                "\n```\n"
                )

  cmd5 <-paste0("```{r fig.width=10.46, fig.height=5.54, dpi =72}\n",
                paste0("options(scipen = 0, digits = 2)
                       if(!is.null(r_data$cgo))
                       clusterProfiler::dotplot(r_data$cgo, title= 'Gene Ontology Enrichment Comparison')"),
                "\n",
                "\n```\n"
                )


  cmd6 <-paste0("```{r fig.width=10.46, fig.height=5.54, dpi =72}\n",
                paste0("options(scipen = 0, digits = 2)
                       if(!is.null(r_data$ckegg))
                      clusterProfiler::dotplot(r_data$ckegg, title='KEGG Enrichment Comparison')"),
                "\n",
                "\n```\n"
                )


  cmd7 <-paste0("```{r fig.width=10.46, fig.height=5.54, dpi =72}\n",
                paste0("options(scipen = 0, digits = 2)
                       if(!is.null(r_data$cCC))
                       clusterProfiler::dotplot(r_data$cCC, title='Cellular Component Enrichment Comparison')"),
                "\n",
                "\n```\n"
                )

  update_report_fun(cmd1)
  update_report_fun(cmd2)
  update_report_fun(cmd3)
  update_report_fun(cmd4)
  update_report_fun(cmd5)
  update_report_fun(cmd6)
  update_report_fun(cmd7)
})

## ui for data menu in radiant
do.call(navbarPage,
        c("bioCancer",
          #img(src="imgs/icon.png", style="float:right; padding-right:25px"),
          getOption("cBioPortal.nav_ui"),
          getOption("Enrichment.nav_ui"),
          getOption("radiant.nav_ui"),
          #getOption("Tools.nav_ui"),
          getOption("radiant.shared_ui"),
          help_menu("help_bioCancer_ui")
        )
)

# Customised TRUE-FALSE switch button for Rshiny
# Only sing CSS3 code (No javascript)
#
# Sébastien Rochette
# http://statnmap.com/en/
# April 2016
#
# CSS3 code was found on https://proto.io/freebies/onoff/
# For CSS3 customisation, refer to this website.

#' A function to change the Original checkbox of rshiny
#' into a nice true/false or on/off switch button
#' No javascript involved. Only CSS code.
#' 
#' To be used with CSS script 'button.css' stored in a 'www' folder in your Shiny app folder
#' 
#' @param inputId The input slot that will be used to access the value.
#' @param label Display label for the control, or NULL for no label.
#' @param value Initial value (TRUE or FALSE).
#' @param col Color set of the switch button. Choose between "GB" (Grey-Blue) and "RG" (Red-Green)
#' @param type Text type of the button. Choose between "TF" (TRUE - FALSE), "OO" (ON - OFF) or leave empty for no text.

switchButton <- function(inputId, label=NULL, value=FALSE, col = "GB", type="TF") {
  
  # color class
  if (col != "RG" & col != "GB") {
    stop("Please choose a color between \"RG\" (Red-Green) 
         and \"GB\" (Grey-Blue).")
  }
  if (!type %in% c("OO", "TF", "YN")){
    warning("No known text type (\"OO\", \"TF\" or \"YN\") have been specified, 
            button will be empty of text") 
  }
  if(col == "RG"){colclass <- "RedGreen"}
  if(col == "GB"){colclass <- "GreyBlue"}
  if(type == "OO"){colclass <- paste(colclass,"OnOff")}
  if(type == "TF"){colclass <- paste(colclass,"TrueFalse")}
  if(type == "YN"){colclass <- paste(colclass,"YesNo")}
  
  # No javascript button - total CSS3
  # As there is no javascript, the "checked" value implies to
  # duplicate code for giving the possibility to choose default value
  
  if(value){
    tagList(
      tags$div(class = "form-group shiny-input-container",
               tags$div(class = colclass,
                        #tags$label(label, class = "control-label"),
                        tags$div(class = "onoffswitch",
                                 tags$input(type = "checkbox", name = "onoffswitch", class = "onoffswitch-checkbox",
                                            id = inputId, checked = ""
                                 ),
                                 tags$label(class = "onoffswitch-label", `for` = inputId,
                                            tags$span(class = "onoffswitch-inner"),
                                            tags$span(class = "onoffswitch-switch")
                                 )
                        )
               )
      )
    )
  } else {
    tagList(
      tags$div(class = "form-group shiny-input-container",
               tags$div(class = colclass,
                       # tags$label(label, class = "control-label"),
                        tags$div(class = "onoffswitch",
                                 tags$input(type = "checkbox", name = "onoffswitch", class = "onoffswitch-checkbox",
                                            id = inputId
                                 ),
                                 tags$label(class = "onoffswitch-label", `for` = inputId,
                                            tags$span(class = "onoffswitch-inner"),
                                            tags$span(class = "onoffswitch-switch")
                                 )
                        )
               )
      )
    ) 
  }
  }

output$ui_FIsFilter <- renderUI({
  FIs_Att <- c("activat","inhibit","predicted","catalyze","reaction","phosphoryl","regulat","express",
               "complex","regulat","binding","compound","input","dissociation","indirect","ubiquitinated" )


  selectizeInput("FIs_AttId", label = "FIs Attributes:", choices = FIs_Att,
                 selected = state_multiple("FIs_AttId",FIs_Att, "activat"), multiple = TRUE)

})

output$ui_UseLinker <- renderUI({
  #UseLinkers <- c("FALSE", "TRUE")
  #selectizeInput("UseLinkerId", label = "Use Linkers:", choices = UseLinkers,
  #              selected = "FALSE", multiple = FALSE)
  div(class="row",
      div(class="col-xs-8",
          conditionalPanel("input.UseLinkerId==false",
                           h5('Add interesting genes')),
          conditionalPanel("input.UseLinkerId==true",
                           h5('Add interesting genes', style = "color:#428bca")
          )
      ),
      div(class="col-xs-4",
          switchButton(inputId = "UseLinkerId",
                       value = FALSE, col = "GB", type = "OO")
      )
  )
})


output$ui_ReacLayout <- renderUI({
  Layouts <- c("dot","neato","twopi","circo")


  selectizeInput("ReacLayoutId", label = "Layouts:", choices = Layouts,
                 selected = "dot", multiple = FALSE)

})


# output$ui_NodeAttri_ReactomeFI <- renderUI({
#   ReactomeEnrich <- c("None","Freq. Interaction", "GeneSet", "FreqInt./GeneSet")
#   selectizeInput("NodeAttri_ReactomeID", label= "From ReactomeFI:", choices= ReactomeEnrich,
#                  selected= "None", multiple=FALSE)
# })

output$ui_AnnoGeneSet_ReactomeFI <- renderUI({
  type <- list('None','Pathway', 'Biological Process'=list('BP'),'Cellular Component'= list('CC'), 'Molecular Function' = list('MF'))
  selectizeInput("TypeGeneSetID", label="Reactome GeneSet enrichment:", choices=type,
                 selected ="None", multiple=FALSE
  )
})

output$ui_GeneSetFDR <- renderUI({
  #if(is.null(r_data$MinGeneSetFDR)){
  sliderInput("GeneSetFDRID", "FDR of enrichment", value=0.0005, min =0.0005,
              max=0.05, step=0.0005 )
  #}else{
  #sliderInput("GeneSetFDRID", "FDR", 0.005, min =r_data$MinGeneSetFDR,
  #            max=0.05, step=0.0005 )
  #}
})

output$ui_NodeAttri_Classifier <- renderUI({

  ClassEnrich <- c("None","mRNA","Studies", "mRNA/Studies")
  selectizeInput("NodeAttri_ClassifierID", label= "From Classifier:", choices= ClassEnrich,
                 selected= "None", multiple=FALSE)

})

output$ui_No_Classifier_Run_message <- renderUI({
  # if GeneClassifierdetails is not in r_data
  if(exists("r_data") && is.null(r_data[['GenesClassDetails']])){
  h5("Please run Classification before!",align="center", style = "color:red;font-size:100%")
  }
})

output$ui_NodeAttri_ProfData <- renderUI({

  Dimension <- c("None","CNA","Met_HM27", "Met_HM450","Mutation" )
  selectizeInput("NodeAttri_ProfDataID", label= "Select Profiles Data:", choices= Dimension,
                 selected= "None", multiple=TRUE)
})

output$ui_Freq_MutSlider <- renderUI({
  #div(style="height: 27px;",
  sliderInput("FreqMutSliderID", "Mutation Percentage", 25, min = 1,
              max = 100, step = 1)
  #)

})

output$ui_MetSliderHM450 <- renderUI({
  sliderInput("ThresholdMetHM450ID", "Silencing gene rate HM450", 0.8, min =0,
              max=1, step=0.05 )
})

output$ui_MetSliderHM27 <- renderUI({
  sliderInput("ThresholdMetHM27ID", "Silencing gene rate HM27", 0.8, min =0,
              max=1, step=0.05 )
})



output$ui_Reactome <- renderUI({
  updateSelectizeInput(session, 'StudiesIDReactome', choices = Studies["studyId"],
                       selected = c("brca_tcga","gbm_tcga","lihc_tcga","lusc_tcga"))

  tagList(
    conditionalPanel(condition = "input.plotDiagrammeRSwithButtonId==true",
                     actionButton("ReacGeneListId", "load Reactome Genes")
    ),
    h4("Edges Attributes:", style= "color:blue"),
    wellPanel(
      uiOutput("ui_FIsFilter"),
      uiOutput("ui_UseLinker"),
      uiOutput("ui_ReacLayout")

    ),
    ## Attributes Nodes from geNetClassifier (Only if Class is pressed)
    # conditionalPanel(condition = "input.ClassID == 'Samples'",
    h4("Nodes Attributes:", style= "color:blue"),


    wellPanel(
      wellPanel(
        #uiOutput("ui_NodeAttri_ReactomeFI"),

        #conditionalPanel("input.NodeAttri_ReactomeID =='GeneSet' ||
        #                input.NodeAttri_ReactomeID =='FreqInt./GeneSet'",
        uiOutput("ui_AnnoGeneSet_ReactomeFI"),
        uiOutput("ui_GeneSetFDR")
        # )
      ),

      wellPanel(
        #conditionalPanel(condition = "input.runClassificationBox==true",
        uiOutput("ui_NodeAttri_Classifier"),
        #),
        conditionalPanel(" input.runClassificationBox == false",
                         # input.NodeAttri_ClassifierID != 'None' &&
        #                  input.runSamplingBox == false ||
        #                  input.NodeAttri_ClassifierID != 'None' &&
        #                  input.runSamplingBox == true &&
                         uiOutput('ui_No_Classifier_Run_message')
        )
      ),
      #  conditionalPanel(condition = "input.WheelID=='Zoom'",
      wellPanel(
        selectizeInput('StudiesIDReactome', 'From Which Studies', choices=NULL, multiple = TRUE),

        div(class="row",
            div(class="col-xs-6",
                checkboxInput("ViewProfDataReactomeID", "Availability", value = FALSE)),
            div(class="col-xs-6",
                checkboxInput("getlistProfDataIDReactome", "Load", value = FALSE))
        ),


        #           radioButtons(inputId = "getlistProfDataIDReactome", label = "Profile Data",
        #                        c("Availability"="Availability" ,"Load"="Load"),
        #                        selected = "", inline = TRUE),



        conditionalPanel(condition= "input.getlistProfDataIDReactome==true",
                         uiOutput("ui_NodeAttri_ProfData")
        ),


        #),
        #                 )
        conditionalPanel(condition ="input.getlistProfDataIDReactome==true",
                         uiOutput("ui_Freq_MutSlider"),
                         uiOutput("ui_MetSliderHM450"),
                         uiOutput("ui_MetSliderHM27")
                         #                       div(class="col-xs-6",
                         #                            numericInput("ThresholdMetHM450ID",
                         #                                         "HM450",
                         #                                         "0.8",min = 0.8, max = 1 , step = 0.05)),
                         #                        div(class="col-xs-6",
                         #                            numericInput("ThresholdMetHM27ID",
                         #                                         "HM27",
                         #                                         "0.8",min = 0.8, max = 1 , step = 0.05))
        )
      ),
      #         conditionalPanel(condition= "input.NodeAttri_ProfDataID=='Met_HM450'",
      #                           uiOutput("ui_MetSliderHM450")
      #         ),
      #         conditionalPanel(condition= "input.NodeAttri_ProfDataID %in%'Met_HM27'",
      #                          uiOutput("ui_MetSliderHM27")
      #       )
      #conditionalPanel(condition ="input.NodeAttri_ClassID =='All'",
      #                uiOutput("ui_Freq_MutSlider2")
      #),
      uiOutput("ui_plotDiagrammerSwithButton"),

      div(class="row",
          div(class="col-xs-4",
              checkboxInput("ReacLegendId", "Legend", value=FALSE)
              ),
          div(class="col-xs-4"
              #checkboxInput("ReacRunId", label = p("Plot", style="color:blue"), value = FALSE)
          )
      )

    ),

    tagList(
      h4("Dynamic Network:", style="color:blue"),
      wellPanel(
        uiOutput("ui_visPhysic"),
        uiOutput("ui_plotVisNetworkSwithButton")

        # div(class="row",
        #     div(class="col-xs-4",
        #         checkboxInput("NetworkRunId", label = p("Plot", style= "color:blue"),value = FALSE)),
        #     div(class="col-xs-4"
        #         #checkboxInput("ReacLegendId", "Legend", value=FALSE)
        #     )
        # )
      )
    ),
    #help_modal_km('Networking','ReactomeHelp',inclMD(file.path(r_path,"base/tools/help/Reactome.md")))

    help_and_report(modal_title = "Networking", fun_name = "ReactomeHelp",
                    author = "Karim Mezhoud",
                    help_file = inclRmd(file.path(
                      getOption("radiant.path.bioCancer"),"app/tools/help/Reactome.Rmd")))
  )
})


## View Available Profile Data

output$ReactomeAvailability <- DT::renderDataTable({
  withProgress(message = 'Loading Data...', value = 1, {

    dat <- checkDimensions(StudyID= input$StudiesIDReactome)
    ## remove rownames to column
    dat <- dat %>% tibble::rownames_to_column("Samples")
    # action = DT::dataTableAjax(session, dat, rownames = FALSE, toJSONfun = my_dataTablesJSON)
    displayTable(dat) %>%  DT::formatStyle(names(dat),
                                           color = DT::styleEqual("No", 'red'))#, backgroundColor = 'white', fontWeight = 'bold'

  })
})

## print Structure of Profiles data

output$StrListProfDataReactome <- renderPrint({
  withProgress(message = 'loading Profiles Data... ', value = 1, {

    getListProfData(checked_Studies = input$StudiesIDReactome , geneListLabel =  input$GeneListID)
  })
  if(is.null(r_info$ListProfData)){
    c("Gene List is empty. copy and paste genes from text file (Gene/line)
      or use gene list from examples.")
  }else{
    cat("STUDIES:\n", names(r_info$ListMutData), "\n")
    cat("PROFILES DATA:\n",names(r_info$ListProfData) ,"and Mutation", sep = " " )
    #str(r_data$ListProfData)
    #str(r_data$ListMutData)
  }

})


## load genelist from clipBoard
observe({
  # 'reading' data from clipboard
  if (not_pressed(input$ReacGeneListId)) return()
  isolate({
    r_data[['genelist']] <- c(r_data[['genelist']], 'Reactome_GeneList') %>% unique

  })
})



output$ui_plotVisNetworkSwithButton <- renderUI({
    div(class="row",
        div(class="col-xs-8",
            conditionalPanel(condition = " input.plotVisNetworkSwithButtonId ==false",
                             h5('Run VisNetwork')),
            conditionalPanel(condition = " input.plotVisNetworkSwithButtonId ==true",
                             h5('Run VisNetwork',  style = "color:#428bca"))
        ),
        div(class="col-xs-4",
                             switchButton(inputId = "plotVisNetworkSwithButtonId",
                                          value = FALSE, col = "GB", type = "OO")

        )
    )

})


output$ui_plotDiagrammerSwithButton <- renderUI({
  div(class="row",
      div(class="col-xs-8",
          conditionalPanel(condition = " input.plotDiagrammeRSwithButtonId ==false",
                           h5('Run DiagrammeR')),
          conditionalPanel(condition = " input.plotDiagrammeRSwithButtonId ==true",
                           h5('Run DiagrammeR',  style = "color:#428bca"))
      ),
      div(class="col-xs-4",
          switchButton(inputId = "plotDiagrammeRSwithButtonId",
                       value = FALSE, col = "GB", type = "OO")

      )
  )

})

#' Circular plot of hierarchital data of genetic profile.
#' @return  A circular layout with genetic profile.
#'
#'
#' @seealso https://github.com/armish/metabologram
#' @usage metabologram(treeData,width=600,height=600,main="",showLegend=FALSE,
#'                      legendBreaks=NULL,
#'                      legendColors=NULL,
#'                       fontSize=12,
#'                      legendText="Legend")
#'
#' @param treeData A hierarchical tree data as in example
#' @param width 600
#' @param height 600
#' @param main Title
#' @param showLegend FALSE
#' @param legendBreaks NULL
#' @param legendColors NULL
#' @param fontSize 12
#' @param legendText Legend
#'
#'
#' @examples
#' How <- "runManually"
#' \dontrun{
#'  metabologram(treeData = sampleWheelData, width=600,
#'  height=600, main="title", showLegend = TRUE, fontSize = 10,
#'  legendBreaks=c("NA","Min","Negative", "0", "Positive", "Max"),
#'  legendColors=c("black","blue","cyan","white","yellow","red") ,
#'  legendText="Legend")
#'  }
#'
#' @export
#'
metabologram <- function(treeData,
                         width=600,
                         height=600,
                         main="",
                         showLegend=FALSE,
                         legendBreaks=NULL,
                         legendColors=NULL,
                         fontSize=12,
                         legendText="Legend") {
  x <- list(
    treeData = treeData,
    showLegend = showLegend,
    legendBreaks = legendBreaks,
    legendColors = legendColors,
    legendText = legendText,
    fontSize = fontSize,
    main = main
  )

  # create widget
  htmlwidgets::createWidget(
    name = 'metabologram',
    x,
    width = width,
    height = height,
    package = 'bioCancer'
  )
}

#' Widget output function for use in Shiny
#'
#'@return  A circular plot with genetic profile in Shiny App.
#'
#' @param outputId id
#' @param width 600
#' @param height 600
#' @usage metabologramOutput(outputId, width = 600, height = 500)
#' @examples
#' \dontrun{
#' library(bioCancer)
#' bioCancer::metabologram(treeData = sampleMetabologramData)
#' }
#' @export
metabologramOutput <- function(outputId, width = 600, height = 500) {
  htmlwidgets::shinyWidgetOutput(outputId, 'metabologram', width, height, package = 'bioCancer')
}


#' Widget render function for use in Shiny
#'@return  A circular plot with genetic profile in Shiny App.
#'
#' @param expr expression
#' @param env parent.frame()
#' @param quoted FALSE
#' @usage renderMetabologram(expr, env= parent.frame(),  quoted = FALSE)
#' @examples
#' \dontrun{
#' library(bioCancer)
#' bioCancer::metabologram(treeData = sampleMetabologramData)
#' }
#' @export
renderMetabologram <- function(expr, env = parent.frame(), quoted = FALSE){
   if (!quoted) { expr <- substitute(expr) } # force quoted
  htmlwidgets::shinyRenderWidget(expr, metabologramOutput, env = parent.frame() ,  quoted = TRUE)
}

# #' Sample data for wheel initialization
# #' @metabologram(treeData = sampleMetabologramData)
# #' @examples
# #' \dontrun{
# #' bioCancer::metabologram(treeData = sampleMetabologramData)
# #' }
# #' @export
# sampleMetabologramData <- list(
#   list(
#     name="Metabolites",
#     colour="#FFDDDD",
#     children=list(
#       list(name="M_1", colour="#0000FF"),
#       list(name="M_5", colour="#F3F3FF"),
#       list(name="M_9", colour="#FFF3F3"),
#       list(name="M_b", colour="#FFDDDD"),
#       list(name="M_f", colour="#FF8585")
#     )
#   ),
#   list(
#     name="Genes",
#     colour="#FF6E6E",
#     children=list(
#       list(name="G_1", colour="#B1B1FF"),
#       list(name="G_3", colour="#DDDDFF"),
#       list(name="G_5", colour="#F3F3FF"),
#       list(name="G_7", colour="#FF6E6E"),
#       list(name="G_9", colour="#8585FF"),
#       list(name="G_b", colour="#FF1616"),
#       list(name="G_d", colour="#FF6E6E"),
#       list(name="G_f", colour="#FF0000")
#     )
#   )
# )
#
# #' Sample breaks data
# #' @usage metabologram(treeData = sampleMetabologramData)
# #' @export
# sampleMetabologramBreaks <- c(
#   -3.00, -2.75, -2.50, -2.25, -2.00, -1.75, -1.50, -1.25, -1.00,
#   -0.75, -0.50, -0.25, 0.00,  0.25,  0.50,  0.75,  1.00,
#   1.25,  1.50,  1.75,  2.00,  2.25,  2.50,  2.75, 3.00
# )
#
# #' Sample colors data
# #' @usage metabologram(treeData = sampleMetabologramData)
# #' @export
# sampleMetabologramColors <- c(
#   "#0000FF", "#1616FF", "#2C2CFF", "#4242FF", "#5858FF", "#6E6EFF", "#8585FF",
#   "#9B9BFF", "#B1B1FF", "#C7C7FF", "#DDDDFF", "#F3F3FF", "#FFF3F3", "#FFDDDD",
#   "#FFC7C7", "#FFB1B1", "#FF9B9B", "#FF8585", "#FF6E6E", "#FF5858", "#FF4242",
#   "#FF2C2C", "#FF1616", "#FF0000"
# )

#' Attribute color to a vector of numeric values
#'
#' @usage attriColorVector(Value, vector, colors=c(a,b,c),feet)
#'
#' @param Value numeric
#' @param vector A vector of numeric data
#' @param colors  3 colors
#' @param feet An interval between two numeric value needed to change the color
#'
#' @return A vetor of colors
#'
#' @examples
#' cgds <- cBioPortal(
#' hostname = "www.cbioportal.org",
#' protocol = "https",
#' api = "/api/v2/api-docs"
#' )
#' \dontrun{
#' getDataByGenes( api =  cgds,
#' studyId = "gbm_tcga_pub",
#' genes = c("NF1", "TP53", "ABL1"),
#' by = "hugoGeneSymbol",
#' molecularProfileIds = "gbm_tcga_pub_mrna"
#' )
#'}
#' @export
#' @importFrom grDevices colorRampPalette colors
#'
attriColorVector <- function(Value, vector, colors=c(a,b,c),feet){

  vector <- round(vector, digits = 0)
  Value <- round(Value, digits = 0)
  Max <- max(vector, na.rm=TRUE)
  Min <- min(vector, na.rm=TRUE)
  #   }
  my.colors <- grDevices::colorRampPalette(colors)
  #generates Max-Min colors from the color ramp

  color.df <- data.frame(COLOR_VALUE=seq(Min,Max,feet), color.name=my.colors(length(seq(Min,Max,feet))))
  colorRef <- color.df[which(color.df[,1]==Value),2]
  #colorRef <- paste0(colorRef, collapse =",")
  return(colorRef)
}


### Add Studies to Network

# Genes ranking     class postProb exprsMeanDiff exprsUpDw
# 1 FANCF       1 brca_tcga  1.00000      179.9226        UP
# 2  MLH1       1  gbm_tcga  0.99703      256.3173        UP

#' get object for grViz. Link Studies to genes
#' @usage Studies_obj(df)
#' @param df data frame with gene classes
#'
#' @return grViz object. a data frame with Study attributes
#' @export
#'
#' @examples
#' Studies_obj(data.frame("col1", "col2", "col3", "col4", "col5", "col6"))
#' \dontrun{
#' Genes ranking     class postProb exprsMeanDiff exprsUpDw
#' 1 FANCF       1 brca_tcga  1.00000      179.9226        UP
#' 2  MLH1       1  gbm_tcga  0.99703      256.3173        UP
#' }
Studies_obj <- function(df= df){

  if(is.null(df)){
    msgNoClassifier <- paste("Gene Classes Details is not found, please run gene Classifier before...")
    stop(msgNoClassifier)
  }else{
    names(df) <- c("Gene1", "Gene2","Direction","Annotation","arrowsize" ,"Score")

    df$Gene2 <- "->"
    df$Annotation <- "[arrowhead = None,"
    df$arrowsize <- "color= Gray,alpha=80,"
    df$Score <- "penwidth= 0.2]"

    V <- as.numeric(factor(df$Direction))
    set.seed(17)
    C <- sample(colors(),length(table(df$Direction)))
    dfbis <- data.frame("Gene1"=df$Direction,
                        "Gene2"="[shape=egg,",
                        "Direction" = "style = filled,",
                        "Annotation"= "fillcolor =",
                        "arrowsize"= C[V],
                        "Score"="]"
    )
    df <- rbind(df, dfbis)
    #GenesClassDetails$class <- paste("penwidth=3,color =", C[V],"," ,sep=" ")

    return(df)
  }
}

#' Atribute mutation frequency to nodes
#' @usage Mutation_obj(list,FreqMutThreshold, geneListLabel)
#'
#' @param list A list of data frame with mutation data. Each data frame to study
#' @param FreqMutThreshold threshold Rate of cases (patients) having mutation (0-1).
#' @param geneListLabel file name of geneList examples: "73"
#'
#' @return A dat frame with mutation frequency. Ech column corresponds to a study.
#' @export
#'
#' @examples
#' cgds <- cBioPortal(
#' hostname = "www.cbioportal.org",
#' protocol = "https",
#' api = "/api/v2/api-docs"
#' )
#' \dontrun{
#' getDataByGenes( api =  cgds,
#' studyId = "gbm_tcga_pub",
#' genes = c("NF1", "TP53", "ABL1"),
#' by = "hugoGeneSymbol",
#' molecularProfileIds = "gbm_tcga_pub_mrna"
#' )
#'}
#'
Mutation_obj <- function(list, FreqMutThreshold, geneListLabel){

  df <- getFreqMutData(list = list, geneListLabel)

  if(is.null(df)){
    msgNoFreqMut <- paste("Mutation frequency is not found, please run gene Circomics before...")
    stop(msgNoFreqMut)
  }else{

    df <- df[apply(df, 1, function(x) !all(is.na(x))),]
    c1 <- apply(df,1, function(x)max(x, na.rm=TRUE))
    c2 <- colnames(df)[apply(df,1, function(x)which.max(x))]
    c  <- cbind.data.frame(c2,round(c1, digits=2))

    c <- c %>% tibble::rownames_to_column("Genes")
    colnames(c) <- c("Genes", "Disease", "Percentage")

    V <- as.numeric(factor(c$Disease))
    set.seed(17)
    C <- sample(colors(),length(table(c$Disease)))

    Mut <- cbind.data.frame(c,arrowsize=C[V])
    #BRCA1[shape = box, style= filled, fillcolor="#0007CD", color=red, penwidth=3, peripheries=2 ]
    #names(df) <- c("Gene1", "Gene2","Direction","Annotation","arrowsize" ,"Score")
    Mut$Gene1 <- paste(Mut$Genes,"[", sep=" ")
    Mut$Gene2 <- "shape="
    Mut$Direction <- sapply(Mut$Percentage,function(x)if(x < FreqMutThreshold){
      paste("circle","," ,sep="")
    }else{
      paste("diamond",",",sep="")})
    Mut$Annotation <- "color="
    Mut$Score <- ",fontsize=10]"
    Mut <- Mut[c("Gene1","Gene2","Direction","Annotation","arrowsize","Score")]
    return(Mut)
  }
}

### Attributes for Nodes
#' Attribute shape to nodes
#'
#' @usage attriShape2Gene(gene, genelist)
#' @param gene Gene symbol
#' @param genelist Gene list
#'
#' @return A character "BRCA1[shape = 'circle', "
#' @export
#'
#' @examples
#' how <- "runManually"
#' \dontrun{
#' GeneList <- whichGeneList("73")
#' attriShape2Gene("P53", GeneList)
#' attriShape2Gene("GML",GeneList)
#'}
#'
attriShape2Gene <- function(gene, genelist){

  if(gene %in% genelist){
    paste0(gene, "[shape = 'circle',", sep=" ")
  }else{
    paste0(gene, "[shape = 'box',", sep=" ")
  }

}


#' Attribute interaction frequency to node size
#' @usage Node_obj_FreqIn(geneList)
#' @param geneList A list of gene symbol
#'
#' @return A data frame with node attributes
#' @export
#'
#' @examples
#' r_data <- new.env()
#' r_data[["FreqIn"]] <- structure(list(Genes = c("ATM", "ATR", "BRCA1", "BRCA2", "CHEK1",
#' "CHEK2", "FANCF", "MDC1", "RAD51"), FreqSum = c(0.04, 0.05, 0.05,
#'  0.03, 0.05, 0.04, 0.03, 0.03, 0.02)), .Names = c("Genes", "FreqSum"),
#'  class = "data.frame", row.names = c(NA, -9L))
#'  \dontrun{
#' GeneList <- whichGeneList("DNA_damage_Response")
#' nodeObj <- Node_obj_FreqIn(GeneList)
#'}
#'
Node_obj_FreqIn <- function(geneList){

  FreqIn <- r_data$FreqIn
  FreqIn$Genes<- unname(sapply(FreqIn$Genes,  function(x) attriShape2Gene(x, geneList)))
  FreqIn$FreqSum  <- FreqIn$FreqSum / 10
  FreqIn$FreqSum <- paste0("fixedsize = TRUE, width =",FreqIn$FreqSum,", alpha_fillcolor =",FreqIn$FreqSum,",")
  FreqIn <- cbind(FreqIn, Direction="peripheries=1,")
  FreqIn <- cbind(FreqIn, Annotation="style = filled,")
  FreqIn <- cbind(FreqIn, Arrowsize="alpha_fillcolor = 1,")
  FreqIn <- cbind(FreqIn, Score="fontsize=10]")
  names(FreqIn) <- c("Gene1", "Gene2","Direction","Annotation","arrowsize" ,"Score")

  GeneAttri <- FreqIn
  return(GeneAttri)

}

#' Atrribute genes expression to color nodes
#'
#' @usage Node_obj_mRNA_Classifier(geneList,genesclassdetails)
#' @param geneList A gene list.
#' @param genesclassdetails A dataframe with genes classes and genes expression.
#'
#' @return A data frame with node color attributes
#' @export
#'
#' @examples
#' r_data <- new.env()
#' input <- NULL
#'
#' r_data[["FreqIn"]] <- structure(list(Genes = c("ATM", "ATR", "BRCA1", "BRCA2", "CHEK1",
#' "CHEK2", "FANCF", "MDC1", "RAD51"), FreqSum = c(0.04, 0.05, 0.05,
#'  0.03, 0.05, 0.04, 0.03, 0.03, 0.02)), .Names = c("Genes", "FreqSum"),
#'  class = "data.frame", row.names = c(NA, -9L))
#'
#' GenesClassDetails <- structure(list(Genes = c("FANCF", "MLH1", "MSH2", "ATR", "PARP1",
#' "CHEK2", "RAD51"), ranking = c(1L, 1L, 1L, 2L, 3L, 1L, 2L), class = c("brca_tcga",
#' "gbm_tcga", "lihc_tcga", "lihc_tcga", "lihc_tcga", "lusc_tcga",
#' "lusc_tcga"), postProb = c(1, 0.99, 1, 0.99, 0.99, 1,
#' 0.98), exprsMeanDiff = c(180, 256, -373, -268,
#' -1482, 258, 143), exprsUpDw = c("UP", "UP", "DOWN",
#' "DOWN", "DOWN", "UP", "UP")), .Names = c("Genes", "ranking",
#' "class", "postProb", "exprsMeanDiff", "exprsUpDw"),
#' class = "data.frame", row.names = c(NA,-7L))
#' \dontrun{
#' GeneList <- whichGeneList("DNA_damage_Response")
#' nodeObj <- Node_obj_mRNA_Classifier(GeneList, GenesClassDetails)
#'}
Node_obj_mRNA_Classifier <- function(geneList,genesclassdetails){
  if(is.null(genesclassdetails)){
    msgNoClassifier <- paste("Gene Classes Details is not found, please run gene Classifier before...")
    stop(msgNoClassifier)
  }else{
    GenesClassDetails <- merge(genesclassdetails, r_data$FreqIn, by="Genes")
    GenesClassDetails <- GenesClassDetails[,!(names(GenesClassDetails) %in% "exprsUpDw")]
    GenesClassDetails$FreqSum  <- GenesClassDetails$FreqSum / 10

    GenesClassDetails$Genes <- unname(sapply(GenesClassDetails$Genes,  function(x) attriShape2Gene(x, geneList)))

    ###GenesClassDetails$ranking <- paste("peripheries=",GenesClassDetails$ranking,"," ,sep=" ")
    GenesClassDetails$ranking <- paste("peripheries=","1","," ,sep=" ")
    V <- as.numeric(factor(GenesClassDetails$class))
    set.seed(17)
    C <- sample(colors(),length(table(GenesClassDetails$class)))

    if(is.null(input$NodeAttri_ProfDataID)){
      GenesClassDetails$class <- paste("penwidth=3,color =", C[V],"," ,sep=" ")
    }else{
      GenesClassDetails$class <- paste("penwidth=3,color =", "white","," ,sep=" ")
    }
    GenesClassDetails$postProb <- "style = filled, fillcolor ='"

    GenesClassDetails$exprsMeanDiff <- sapply(GenesClassDetails$exprsMeanDiff, function(x) as.character(attriColorVector(x,GenesClassDetails$exprsMeanDiff ,colors=c("blue","white","red"), feet=1)))

    GenesClassDetails$FreqSum <- paste0("',fixedsize = TRUE, width =",GenesClassDetails$FreqSum,", alpha_fillcolor =",GenesClassDetails$FreqSum,"]")

    # rename column to rbind with edge dataframe
    names(GenesClassDetails) <- c("Gene1", "Gene2","Direction","Annotation","arrowsize" ,"Score")
    #GenesClassDetails_bkp <<- GenesClassDetails
    GeneAttri <- GenesClassDetails
    return(GeneAttri)
  }
}

#' Attribute CNA data to node border
#' @usage Node_obj_CNA_ProfData(list)
#' @param list A list of data frame with CNA data. Each data frame corresponds to a study.
#'
#' @return A data frame with node border attributes
#' @export
#'
#' @examples
#' cgds <- cBioPortal(
#' hostname = "www.cbioportal.org",
#' protocol = "https",
#' api = "/api/v2/api-docs"
#' )
#' \dontrun{
#' getDataByGenes( api =  cgds,
#' studyId = "gbm_tcga_pub",
#' genes = c("NF1", "TP53", "ABL1"),
#' by = "hugoGeneSymbol",
#' molecularProfileIds = "gbm_tcga_pub_mrna"
#' )
#'}
Node_obj_CNA_ProfData <- function(list){

  ListDf <-lapply(list, function(x) apply(x, 2, function(y) as.data.frame(table(y[order(y)]))))
  ListDf2 <-   lapply(ListDf, function(x) lapply(x, function(y) y[,1][which(y[,2]== max(y[,2]))]))
  ListDf3 <- plyr::ldply(ListDf2, data.frame)
  MostFreqCNA_Df <- plyr::ldply(apply(ListDf3,2,function(x) names(which(max(table(x))==table(x))))[-1],data.frame)

  #MostFreqCNA_Df$arrowsize <- paste(MostFreqCNA_Df[,1], MostFreqCNA_Df[,2], sep=":")
  MostFreqCNA_Df[,2] <- gsub("-1", "1, style=dashed", MostFreqCNA_Df[,2] )
  MostFreqCNA_Df[,2] <- gsub("-2", "2, style=dashed", MostFreqCNA_Df[,2] )
  MostFreqCNA_Df[,2] <- gsub("0", "0.5", MostFreqCNA_Df[,2] )
  MostFreqCNA_Df[,2] <- gsub("1", " 1, penwidth=2 ", MostFreqCNA_Df[,2] )
  MostFreqCNA_Df[,2] <- gsub("2", " 2 ", MostFreqCNA_Df[,2])
  MostFreqCNA_Df$arrowsize <- MostFreqCNA_Df[,2]
  MostFreqCNA_Df$Gene1 <- MostFreqCNA_Df$.id
  MostFreqCNA_Df$Gene2 <- "["
  MostFreqCNA_Df$Direction <- "pripheries"
  MostFreqCNA_Df$Annotation <- "="
  MostFreqCNA_Df$Score <- "]"
  MostFreqCNA_Df <- MostFreqCNA_Df[c("Gene1", "Gene2","Direction","Annotation","arrowsize" ,"Score")]

  return(MostFreqCNA_Df)
}

#' Attribute gene Methylation to Nodes
#' @usage Node_obj_Met_ProfData(list, type, threshold)
#'
#' @param list a list of data frame with methylation data
#' @param type HM450 or HM27
#' @param threshold the Rate cases (patients) that have a silencing genes by methylation
#'
#' @return a data frame with node shape attributes
#' @export
#'
#' @examples
#' cgds <- cBioPortal(
#' hostname = "www.cbioportal.org",
#' protocol = "https",
#' api = "/api/v2/api-docs"
#' )
#' \dontrun{
#' getDataByGenes( api =  cgds,
#' studyId = "gbm_tcga_pub",
#' genes = c("NF1", "TP53", "ABL1"),
#' by = "hugoGeneSymbol",
#' molecularProfileIds = "gbm_tcga_pub_mrna"
#' )
#'}
#'
Node_obj_Met_ProfData <- function(list, type, threshold){
  #dfMeansOrCNA<-apply(df,2,function(x) mean(x, na.rm=TRUE))
  #dfMeansOrCNA <- round(dfMeansOrCNA, digits = 0)

  Met_Obj <- lapply(list, function(x) apply(x,2,function(y) mean(y, na.rm=TRUE)))
  Met_Obj <- lapply(Met_Obj, function(x) round(x, digits = 2))
  Met_Obj <- plyr::ldply(Met_Obj)[,-1]

  Met_Obj <- plyr::ldply(Met_Obj,function(x) (max(x, na.rm = TRUE)))

  if(type == "HM450"){
    Met_Obj <- subset(Met_Obj, V1 > threshold)
  } else if( type == "HM27"){
    Met_Obj <- subset(Met_Obj, V1 > threshold)
  }

  if(nrow(Met_Obj)== 0){

  }else{
    Met_Obj$Gene1 <- Met_Obj$.id
    Met_Obj$Gene2 <- "["
    Met_Obj$Direction <- "shape"
    Met_Obj$Annotation <- "="
    Met_Obj$arrowsize <- "invtriangle,"
    Met_Obj$Score <- "fixedsize=true]"
    Met_Obj <- Met_Obj[c("Gene1", "Gene2","Direction","Annotation","arrowsize" ,"Score")]

    #lapply(ListProfData_bkp$Met_HM450, function(x) attriColorGene(x))
    return(Met_Obj)
  }
}

output$ProfDataTable <- DT::renderDataTable({

  GeneList <- whichGeneList(input$GeneListID)

  if (ncol(GeneList)==0){
    dat <- as.data.frame("Gene List is empty. copy and paste genes from text file (Gene/line) or use gene list from examples.")
  }else{
    if(length(GeneList)>500){

      shiny::withProgress(message = 'loading MegaProfData from cBioPortal server...', value = 1, {

        ##### Get Profile Data for selected Case and Genetic Profile
        dat <- getMegaProfData(GeneList,input$GenProfID,input$CasesID, Class="ProfData")
      })
    } else if (inherits(try( #dat <- getProfileData(cgds,GeneList, input$GenProfID,input$CasesID)
                             dat <- cBioPortalData::getDataByGenes(api =  cgds,
                                                   studyId = input$StudiesID,
                                     genes = GeneList,by = "hugoGeneSymbol",
                                     molecularProfileIds = input$GenProfID
                             ),
                             silent=FALSE),"try-error")){
      dat <- as.data.frame("There are some Gene Symbols not supported by cbioportal.
                           Or gene list is empty.
                           Or bioCancer is not connected to cBioPortal server (check connection).")
    }else{
      shiny::withProgress(message = 'loading ProfData from cBioPortal server...', value = 1, {

      #dat <- getProfileData(cgds,GeneList, input$GenProfID,input$CasesID)
      dat <- cBioPortalData::getDataByGenes(api =  cgds,studyId = input$StudiesID,
                            genes = GeneList,by = "hugoGeneSymbol",molecularProfileIds = input$GenProfID)%>%
             .[[1]] |>
              select(-c(uniqueSampleKey, uniquePatientKey, molecularProfileId, sampleId, studyId))
              #tidyr::spread(hugoGeneSymbol, value)

      })
      if(dim(dat)[1]==0){
        ## avoide error when GeneList is empty
        ## Error..No.cancer.study..cancer_study_id...or.genetic.profile..genetic_profile_id..or.case.list.or..case_list..case.set..case_set_id..provid
        dat <- as.data.frame("Gene List is empty. copy and paste genes from text file (Gene/line) or use gene list from examples.")
      }else{
        #dat <- getProfileData(cgds,GeneList, input$GenProfID,input$CasesID)
        ## remove empty row
        dat <-  dat[which(apply(!(apply(dat,1,is.na) ),2,sum)!=0 ),]

        if(is.numeric(dat[2,2])){
          dat <- round(dat, digits = 3)
        }
        #dat <- dat %>% tibble::rownames_to_column("Patients")
        r_info[['ProfData']] <- dat
      }
    }

    displayTable(dat)%>% DT::formatStyle(names(dat),
                                         color = DT::styleEqual("Gene List is empty. copy and paste genes from text file (Gene/line) or use gene list from examples.",
                                                                'red'))#, backgroundColor = 'white', fontWeight = 'bold'

  }

  })

output$dl_ProfData_tab <- shiny::downloadHandler(
  filename = function() { paste0("ProfData_tab.csv") },
  content = function(file) {
    #data_filter <- if (input$show_filter) input$data_filter else ""
    get_data(r_info$ProfData[input$ProfDataTable_rows_all,], vars = NULL,
            rows = NULL, na.rm = FALSE) %>%
      write.csv(file, row.names = FALSE)
  }
)

observeEvent(input$ProfilesHelp_report, {

  cmd <- paste0("```{r fig.width=10.46, fig.height=5.54, dpi =72}\n",
                paste0(" get_data(ProfData[input$ProfDataTable_rows_all,], vars = NULL,
                       rows= NULL, na.rm = FALSE)"),
                "\n",
                "\n```\n"
  )
  update_report_fun(cmd)
})

#' Attribute Color to Value
#' @usage attriColorValue(Value, df, colors=c(a,b,c),feet)
#' @param Value integer
#' @param df data frame with numeric values
#' @param colors a vector of 5 colors
#' @param feet the interval between two successive colors in the palette (0.1)
#'
#' @return Hex Color Code
#' @export
#'
#' @examples
#' cgds <- cBioPortal(
#' hostname = "www.cbioportal.org",
#' protocol = "https",
#' api = "/api/v2/api-docs"
#' )
#' \dontrun{
#' getDataByGenes( api =  cgds,
#' studyId = "gbm_tcga_pub",
#' genes = c("NF1", "TP53", "ABL1"),
#' by = "hugoGeneSymbol",
#' molecularProfileIds = "gbm_tcga_pub_mrna"
#' )
#'}
#'
attriColorValue <- function(Value, df, colors=c(a,b,c),feet){
  #df <- df *100
  df[is.na(df)] <- 0
  if(max(df,na.rm=TRUE)<1){
    ## for Methylation df
    Min <- 0
    Max <- 1
  }else{
    df <- round(df, digits = 0)
    Max <- max(df, na.rm=TRUE)
    Min <- min(df, na.rm=TRUE)
  }
  my.colors <- colorRampPalette(colors)
  #generates Max-Min colors from the color ramp
  color.df<-data.frame(COLOR_VALUE=seq(Min,Max,feet), color.name=my.colors(length(seq(Min,Max,feet))))
  colorRef <- color.df[which(color.df[,1]==Value),2]
  return(colorRef)
}


#' Attribute Color to Gene
#' @usage attriColorGene(df)
#' @param df data frame with mRNA or CNA or mutation frequency or methylation (numeric). Without sampleID column.
#'
#' @return A list colors for every gene
#'
#' @examples
#' cgds <- cBioPortal(
#' hostname = "www.cbioportal.org",
#' protocol = "https",
#' api = "/api/v2/api-docs"
#' )
#' \dontrun{
#' getDataByGenes( api =  cgds,
#' studyId = "gbm_tcga_pub",
#' genes = c("NF1", "TP53", "ABL1"),
#' by = "hugoGeneSymbol",
#' molecularProfileIds = "gbm_tcga_pub_mrna"
#' )
#'}
#' @export
attriColorGene <- function(df){

  if(all(apply(df,2, function(x)class(x)=='integer'))==TRUE
  ){
    ListFreqCNA <- apply(df,2,
                         function(x) as.data.frame(table(x[order(x)])))
    print("getting the most frequent CNA categorie...")
    dfMeansOrCNA <- as.data.frame(lapply(
      ListFreqCNA, function(x) x[,1][which(x[,2]== max(x[,2]))]))

    ## at this step the dfMeansOtCNA is not as numeric
    namedfMeansOrCNA <- names(dfMeansOrCNA)
    dfMeansOrCNA <- as.numeric(as.matrix(dfMeansOrCNA))
    names(dfMeansOrCNA) <- namedfMeansOrCNA

  }else if(all(apply(df,2, function(x)class(x)=='numeric'))==TRUE){
    ## Compute mean of FreqMutData and mRNA Expression
    dfMeansOrCNA <-apply(df,2,function(x) mean(x, na.rm=TRUE))
    dfMeansOrCNA <- round(dfMeansOrCNA, digits = 0)
  }

  ## Set colors if all value are 0 set only black
  if(all(dfMeansOrCNA=="0")||all(dfMeansOrCNA=="NaN")){
    colorls <- lapply(dfMeansOrCNA, function(x)
      attriColorValue(x, dfMeansOrCNA, colors=c("white"), feet=0.1))
    print("setting black color for empty data...")
  }else{
    colorls <- lapply(dfMeansOrCNA, function(x)
      attriColorValue(x, dfMeansOrCNA,
                      colors=c("blue3","white","red"),
                      feet=0.1))
  }
  return(colorls)
}

#' Restructure the list of color attributed to the genes in every dimenssion for every studies
#' @usage reStrColorGene(df)
#' @param df data frame with colors attributed to the genes
#'
#' @return  Hierarchical color attribute: gene > color
#' @export
#'
#' @examples
#' cgds <- cBioPortal(
#' hostname = "www.cbioportal.org",
#' protocol = "https",
#' api = "/api/v2/api-docs"
#' )
#' \dontrun{
#' getDataByGenes( api =  cgds,
#' studyId = "gbm_tcga_pub",
#' genes = c("NF1", "TP53", "ABL1"),
#' by = "hugoGeneSymbol",
#' molecularProfileIds = "gbm_tcga_pub_mrna"
#' )
#'}
reStrColorGene <- function(df){

  colorls <- attriColorGene(df)
  ## extract disease name
  disease_name <- unlist(lapply(strsplit(capture.output(substitute(df)), "\\$"),tail, 1))
  Children <- list(name=disease_name,unname(mapply(function(genes, color){
    list(list(name=genes, colour= color))},names(colorls), colorls)))
  names(Children)[2] <- "children"
  return(Children)

}

## this function restructure the Diseases
#' Restructure the list of color attributed to the genes in every disease
#' @usage reStrDisease(List)
#' @param List of data frame with color attributes
#'
#' @return  Hierarchy of dimensions in the same study: dimensions > gene > color
#'
#' @examples
#' cgds <- cBioPortal(
#' hostname = "www.cbioportal.org",
#' protocol = "https",
#' api = "/api/v2/api-docs"
#' )
#' \dontrun{
#' getDataByGenes( api =  cgds,
#' studyId = "gbm_tcga_pub",
#' genes = c("NF1", "TP53", "ABL1"),
#' by = "hugoGeneSymbol",
#' molecularProfileIds = "gbm_tcga_pub_mrna"
#' )
#'}
#' @export
reStrDisease <- function(List){
  print("restructuring Selected Diseases...")
  child<-lapply(List, function(x)reStrColorGene(x))
  for(i in 1: length(names(child))){
    child[[i]]$name <- names(child)[i]
  }
  child <-unname(child)
  return(child)
}



## This function restructure the Dimensions
#' Restructure the list of color attributed to the genes in every study for every dimensions
#' @usage reStrDimension(LIST)
#' @param LIST list of  hierarchical dimensions
#'
#' @return Hierarchical structure of: Study > dimensions > gene > color
#'
#' @examples
#' cgds <- cBioPortal(
#' hostname = "www.cbioportal.org",
#' protocol = "https",
#' api = "/api/v2/api-docs"
#' )
#' \dontrun{
#' getDataByGenes( api =  cgds,
#' studyId = "gbm_tcga_pub",
#' genes = c("NF1", "TP53", "ABL1"),
#' by = "hugoGeneSymbol",
#' molecularProfileIds = "gbm_tcga_pub_mrna"
#' )
#'}
#' @export
reStrDimension <- function(LIST){
  print("restructuring Dimensions...")
  Parent <- lapply(LIST, function(x)list(name="Dimension",children=reStrDisease(x)))
  for(i in 1: length(names(Parent))){
    Parent[[i]]$name <- names(Parent)[i]
  }
  Parent <- unname(Parent)
  return(Parent)
}


#' Unify row names in data frame with the same order of gene list.
#' @usage UnifyRowNames(x,geneList)
#' @param x data frame with gene symbol in the row name
#' @param geneList a gene list
#'
#' @return a data frame having the gene in row name ordered as in gene list.
#'
#' @examples
#' cgds <- cBioPortal(
#' hostname = "www.cbioportal.org",
#' protocol = "https",
#' api = "/api/v2/api-docs"
#' )
#' \dontrun{
#' getDataByGenes( api =  cgds,
#' studyId = "gbm_tcga_pub",
#' genes = c("NF1", "TP53", "ABL1"),
#' by = "hugoGeneSymbol",
#' molecularProfileIds = "gbm_tcga_pub_mrna"
#' )
#'}
#' @export
UnifyRowNames <- function(x, geneList){
  ## compute the ratio of mutation
  df_MutData <-as.data.frame(table(x$hugoGeneSymbol) /sum(table(x$hugoGeneSymbol))*100)
  ## compute le sum of mutation using table function.
  #df_MutData <-as.data.frame(table(x$hugoGeneSymbol))
  rownames(df_MutData) <- df_MutData$Var1
  ## ordering genes in MutData as in GeneList

  df_GeneList <- as.data.frame(t(geneList))
  #df_GeneList <- as.data.frame(GeneList)
  rownames(df_GeneList) <- df_GeneList[,1]
  df_merge <- merge(df_GeneList, df_MutData, by="row.names",all.x=TRUE)
  Freq_Mut <- df_merge[,c(-2,-3)]
  return(Freq_Mut)
}



#' get mutation frequency
#'
#' @usage getFreqMutData(list, geneListLabel)
#'
#' @param list a list of data frame with mutation data. Each data frame is for one study
#' @param geneListLabel file name of geneList examples: "73"
#'
#' @return a data frame with mutation frequency. gene is in rows and study is in column
#' @export
#'
#' @examples
#' cgds <- cBioPortal(
#' hostname = "www.cbioportal.org",
#' protocol = "https",
#' api = "/api/v2/api-docs"
#' )
#' \dontrun{
#' getDataByGenes( api =  cgds,
#' studyId = "gbm_tcga_pub",
#' genes = c("NF1", "TP53", "ABL1"),
#' by = "hugoGeneSymbol",
#' molecularProfileIds = "gbm_tcga_pub_mrna"
#' )
#'}
getFreqMutData <- function(list, geneListLabel){

  GeneList <- whichGeneList(geneListLabel)

  if(is.null(list)){stop("Select a less one Study.")}

  Freq_ListMutData <- lapply(list,
                             function(x) UnifyRowNames(x, GeneList))

  ## convert the list of correlation matrices to Array
  Freq_ArrayMutData <- array(unlist( Freq_ListMutData),
                             dim = c(nrow(Freq_ListMutData[[1]]),
                                     ncol( Freq_ListMutData[[1]]),
                                     length(Freq_ListMutData)))

  if (inherits(try(dimnames(Freq_ArrayMutData) <-
                   list(Freq_ListMutData[[1]][,1],
                        colnames(Freq_ListMutData[[1]]),
                        names(Freq_ListMutData)),
                   silent=TRUE),"try-error")){
    p("There is a Study without Mutation Data.
      Use Mutation Panel to verify mutations data for selected studies.",
      align="center", style = "color:blue")
  }else{
    dimnames(Freq_ArrayMutData) <-
      list(Freq_ListMutData[[1]][,1],
           colnames(Freq_ListMutData[[1]]),
           names(Freq_ListMutData))
  }
  #   ?getListProfData(Genes= empty)
  if(dim(Freq_ArrayMutData)[3]==1){
    Freq_DfMutData <- as.numeric(Freq_ArrayMutData[,2,])
    names(Freq_DfMutData) <- names(Freq_ArrayMutData[,2,])
    ## ordering gene list as in GeneList from MSigDB:
    ## grouping genes with the same biological process or gene Sets
    Freq_DfMutData <- Freq_DfMutData[GeneList]
    Freq_DfMutData <- data.frame(round(Freq_DfMutData,digits=2))
    names(Freq_DfMutData) <- names(Freq_ListMutData)
  }else{
    Freq_DfMutData <- apply(Freq_ArrayMutData[,2,],2,as.numeric)
    rownames(Freq_DfMutData) <- rownames(Freq_ArrayMutData[,2,])
    ## ordering gene list as in GeneList from MSigDB:
    ## grouping genes with the same biological process or gene Sets
    Freq_DfMutData <- Freq_DfMutData[GeneList,,drop=FALSE]
    Freq_DfMutData <- data.frame(round(Freq_DfMutData,digits=2))
  }

  #Freq_DfMutData <<- Freq_DfMutData
  return(Freq_DfMutData)
}

#' Check wich Cases and genetic profiles are available for selected study
#' @usage checkDimensions(StudyID)
#' @param StudyID Study reference using cBioPortal index
#'
#' @return A data frame with two column (Cases, Genetic profiles). Every row has a dimension (CNA, mRNA...).
#' The data frame is filled with yes/no response.
#'
#'
#' @examples
#' cgds <- cBioPortal(
#' hostname = "www.cbioportal.org",
#' protocol = "https",
#' api = "/api/v2/api-docs"
#' )
#' \dontrun{
#' getDataByGenes( api =  cgds,
#' studyId = "gbm_tcga_pub",
#' genes = c("NF1", "TP53", "ABL1"),
#' by = "hugoGeneSymbol",
#' molecularProfileIds = "gbm_tcga_pub_mrna"
#' )
#'}
#' @export
#'
checkDimensions <- function(StudyID){


    checked_Studies <- StudyID #input$StudiesIDCircos

    # get Cases for selected Studies
    #CasesRefStudies <- unname(unlist(apply(as.data.frame(StudyID),
    #                                       1,function(x) cBioPortalData::sampleLists(cgds,x)[,"sampleListId"])))

    CasesRefStudies <- apply(as.data.frame(StudyID),1,
                             function(x) cBioPortalData::sampleLists(cgds,x) |>
                               pull("sampleListId")) |>
                              as.character()

    ## ger Genetics Profiles for selected Studies
    #GenProfsRefStudies <- unname(unlist(apply(as.data.frame(StudyID),
    #                                      1,function(x) cBioPortalData::molecularProfiles(cgds,x)[,"molecularProfileId"])))
    GenProfsRefStudies <- apply(as.data.frame(StudyID),1,
                               function(x) cBioPortalData::molecularProfiles(cgds,x) |>
                                 pull("molecularProfileId")) |>
                                as.character()


  df <- data.frame(row.names = c("Case_CNA", "GenProf_GISTIC", "Case_mRNA", "GenProf_mRNA", "Case_Met_HM450", "GenProf_Met_HM450",
                                 "Case_Met_HM27", "GenProf_Met_HM27", "Case_RPPA", "GeneProf_RPPA", "Case_miRNA", "GenProf_miRNA",
                                 "Case_Mut","GeneProf_Mut"
  ) )

  for(i in checked_Studies){
    ### get Cases and Genetic Profiles  with cBioPortal references
    GenProf_CNA<- paste(i,"_gistic", sep="")
    Case_CNA   <- paste(i,"_cna", sep="")

    GenProf_Exp<- paste(i,"_rna_seq_v2_mrna", sep="")
    Case_Exp   <- paste(i,"_rna_seq_v2_mrna", sep="")

    GenProf_Met_HM450<- paste(i,"_methylation_hm450", sep="")
    Case_Met_HM450   <- paste(i,"_methylation_hm450", sep="")

    GenProf_Met_HM27<- paste(i,"_methylation_hm27", sep="")
    Case_Met_HM27   <- paste(i,"_methylation_hm27", sep="")

    GenProf_RPPA<- paste(i,"_RPPA_protein_level", sep="")
    Case_RPPA   <- paste(i,"_rppa", sep="")

    GenProf_miRNA<- paste(i,"_mirna", sep="")
    Case_miRNA   <- paste(i,"_microrna", sep="")

    GenProf_Mut<- paste(i,"_mutations", sep="")
    Case_Mut   <- paste(i,"_sequenced", sep="")


    if(length(grep(Case_CNA, CasesRefStudies)!=0)){
      df[1,i] <- "Yes"
    }else{
      df[1,i] <- "No"
    }

    if(length(grep(GenProf_CNA, GenProfsRefStudies)!=0)){
      df[2,i] <- "Yes"
    }else{
      df[2,i] <- "No"
    }

    if(length(grep(Case_Exp, CasesRefStudies)!=0)){
      df[3,i] <- "Yes"
    }else{
      df[3,i] <- "No"
    }

    if(length(grep(GenProf_Exp, GenProfsRefStudies)!=0)){
      df[4,i] <- "Yes"
    }else{
      df[4,i] <- "No"
    }

    if(length(grep(Case_Met_HM450, CasesRefStudies)!=0)){
      df[5,i] <- "Yes"
    }else{
      df[5,i] <- "No"
    }

    if(length(grep(GenProf_Met_HM450, GenProfsRefStudies)!=0)){
      df[6,i] <- "Yes"
    }else{
      df[6,i] <- "No"
    }

    if(length(grep(Case_Met_HM27, CasesRefStudies)!=0)){
      df[7,i] <- "Yes"
    }else{
      df[7,i] <- "No"
    }

    if(length(grep(GenProf_Met_HM27, GenProfsRefStudies)!=0)){
      df[8,i] <- "Yes"
    }else{
      df[8,i] <- "No"
    }

    if(length(grep(Case_RPPA, CasesRefStudies)!=0)){
      df[9,i] <- "Yes"
    }else{
      df[9,i] <- "No"
    }

    if(length(grep(GenProf_RPPA, GenProfsRefStudies)!=0)){
      df[10,i] <- "Yes"
    }else{
      df[10,i] <- "No"
    }

    if(length(grep(Case_miRNA, CasesRefStudies)!=0)){
      df[11,i] <- "Yes"
    }else{
      df[11,i] <- "No"
    }

    if(length(grep(GenProf_miRNA, GenProfsRefStudies)!=0)){
      df[12,i] <- "Yes"
    }else{
      df[12,i] <- "No"
    }

    if(length(grep(Case_Mut, CasesRefStudies)!=0)){
      df[13,i] <- "Yes"
    }else{
      df[13,i] <- "No"
    }

    if(length(grep(GenProf_Mut, GenProfsRefStudies)!=0)){
      df[14,i] <- "Yes"
    }else{
      df[14,i] <- "No"
    }
  }
  names(df)<- checked_Studies
  return(df)
}



#' get samples size of sequensed genes
#' @usage getSequensed_SampleSize(StudiesID)
#' @param StudiesID Studies ID as a vector
#'
#'
#' @return dataframe with sample size for each selected study.
#'
#' @examples
#' \dontrun{
#'  sampleSize <- getSequensed_SampleSize(input$StudiesIDCircos)
#' }
#'
#' @export
getSequensed_SampleSize <- function(StudiesID){

  # get Cases for selected Studies
  dat <- apply(as.data.frame(paste0(StudiesID, "_sequenced")), 1,  #input$StudiesIDCircos
               function(x) nrow(as.data.frame(cBioPortalData::samplesInSampleLists(cgds, x)))) |>
    as.data.frame()

  rownames(dat) <-  StudiesID
  colnames(dat) <- "Samples"
  ## remove rownames to column
  #dat <- dat %>% tibble::rownames_to_column("Studies")

  return(dat)
}

shinyServer(function(input, output, session) {

    ##  trace error
   #options(warn=2, shiny.error= recover)


  ## connect to cBioPortal server
  source(file.path(getOption("radiant.path.bioCancer"),"app/tools/bioCancer/cBioPortal.R"),
         encoding = getOption("radiant.encoding"), local = TRUE)


                      ############################################
                      #    SOURCING FROM  radiant.data PACKAGE   #
                      ############################################

  ## source shared functions
  source(file.path(getOption("radiant.path.data"),"app/global.R"),
         encoding = getOption("radiant.encoding"), local = TRUE)

  # source shared functions
  source(file.path(getOption("radiant.path.data"),"app/init.R"),
        encoding = getOption("radiant.encoding"), local = TRUE)

  source(file.path(getOption("radiant.path.data"),"app/radiant.R"),
         encoding = getOption("radiant.encoding"), local = TRUE)
  #source("help.R", encoding = getOption("radiant.encoding"), local = TRUE)

  ## source data & app tools from radiant.data
  for (file in list.files(c(file.path(getOption("radiant.path.data"),"app/tools/app"),
                            file.path(getOption("radiant.path.data"),"app/tools/data")
  ),
  pattern="\\.(r|R)$", full.names = TRUE))
    source(file, encoding = getOption("radiant.encoding"), local = TRUE)


  ## help ui
  source("help.R", encoding = getOption("radiant.encoding"), local = TRUE)

  output$help_bioCancer_ui <- renderUI({
    sidebarLayout(
      sidebarPanel(
        help_cBioPortal_panel,
        help_enrichment_panel,
        help_data_panel,
        uiOutput("help_text"),
        width = 3
      ),

      mainPanel(
        HTML(paste0("<h2>Select help files to show and search</h2><hr>")),
        htmlOutput("help_cBioPortal"),
        htmlOutput("help_enrichment"),
        htmlOutput("help_data")
      )
    )
  })
                  ############################################
                  #          SETTING NEW  ui_data            #
                  ############################################


  ## Sourcing global state from bioCancer
  source(file.path(getOption("radiant.path.bioCancer"), "app/global.R"),
         encoding = getOption("radiant.encoding"), local = TRUE)

  ## source tools from bioCancer app
  for (file in list.files(c(file.path(getOption("radiant.path.bioCancer"),"app/tools/bioCancer"),
                          file.path(getOption("radiant.path.bioCancer"),"app/tools/help")
                          ),
                          pattern="\\.(r|R)$", full.names = TRUE))
    source(file, encoding = getOption("radiant.encoding"), local = TRUE)


  # If bioCancer is not loaded
  if (!"package:bioCancer" %in% search() &&
      getOption("radiant.path.bioCancer") == "..") {
    ## for shiny-server and development
    for (file in list.files("../../R", pattern="\\.(r|R)$", full.names = TRUE))
      source(file, encoding = getOption("radiant.encoding"), local = TRUE)
  }else {
    ## for use with launcher
    radiant.data::copy_all(bioCancer)
  }

  ##  NOT NEEDED  TO ADD GENE LIST
  #data_path <- file.path( system.file(package = "bioCancer"),"extdata/GeneList")
 # r_data[["DNA_damage_Response"]] <- loadUserData("DNA_damage_Response", file.path(data_path,"DNA_damage_Response"), 'txt')

  r_data$genelist <- "DNA_damage_Response"

  ## save state on refresh or browser close
  saveStateOnRefresh(session)

  # # close browser when bioCancer is stopped
  # # close Rstudio when bioCancer os stopped
  # session$onSessionEnded(function() {
  #    stopApp()
  #    q("no")
  # })
})

#######################################
# Shiny interface for data tabs
#######################################

## show error message from filter dialog
output$ui_filter_error <- renderUI({
  if (is_empty(r_info[["filter_error"]])) return()
  helpText(r_info[["filter_error"]])
})

## data ui and tabs
## state is not available in global environment
## neither are the state_... functions
output$ui_data <- renderUI({
  tagList(
    includeCSS(file.path(getOption("radiant.path.bioCancer"),"app/www/style.css")),
    sidebarLayout(
      sidebarPanel(
        wellPanel(
          uiOutput("ui_datasets"),
          conditionalPanel("input.tabs_data != 'Datasets'",
                           checkboxInput("show_filter", "Filter data", value = state_init("show_filter", FALSE)),
                           conditionalPanel("input.show_filter == true",
                                            returnTextAreaInput("data_filter",
                                                                label = "",
                                                                value = state_init("data_filter"),
                                                                placeholder = "Provide a filter (e.g., Genes == 'ATM') and press return"
                                            ),
                                            uiOutput("ui_filter_error")
                           )
          )
        ),
        conditionalPanel("input.tabs_data == 'Datasets'",
                         ## needed to modify radiant helps
                         # help_modal("Datasets","manage_help",author = "Karim Mezhoud",
                         #           inclMD(file.path(getOption("radiant.path.bioCancer"),"app/tools/help/manage.md"))),

                         uiOutput("ui_Manage")),
        conditionalPanel("input.tabs_data == 'View'",
                         ## needed to modify radiant helps
                         # help_modal("View","view_help",author = "Karim Mezhoud",
                         #           inclMD(file.path(getOption("radiant.path.bioCancer"),"app/tools/help/view.md"))),

                         uiOutput("ui_View")),
        conditionalPanel("input.tabs_data == 'Plots'",
                         ## needed to modify radiant helps
                         #help_modal("Plots","visualize_help",author = "Karim Mezhoud",
                         #          inclMD(file.path(getOption("radiant.path.bioCancer"),"app/tools/help/Plots.md"))),

                         uiOutput("ui_Visualize")),
        conditionalPanel("input.tabs_data == 'Regroup'",
                         ## needed to modify radiant helps
                         #help_modal("Regroup","pivotr_help",author = "Karim Mezhoud",
                         #          inclMD(file.path(getOption("radiant.path.bioCancer"),"app/tools/help/Regroup.Rmd"))),

                         uiOutput("ui_Pivotr")),
        conditionalPanel("input.tabs_data == 'Statistics'",
                         ## needed to modify radiant helps
                         #help_modal("Statistics","explore_help",author = "Karim Mezhoud",
                         #          inclMD(file.path(getOption("radiant.path.bioCancer"),"app/tools/help/Statistics.md"))),

                         uiOutput("ui_Explore")),
        conditionalPanel("input.tabs_data == 'Transform'",
                         ## needed to modify radiant helps
                         #help_modal("Transform","transform_help",author = "Karim Mezhoud",
                         #          inclMD(file.path(getOption("radiant.path.bioCancer"),"app/tools/help/transform.md"))),

                         uiOutput("ui_Transform")),
        conditionalPanel("input.tabs_data == 'Combine'",
                         # needed to modify radiant helps
                         #help_modal("Combine","combine_help",author = "Karim Mezhoud",
                         #          inclMD(file.path(getOption("radiant.path.bioCancer"),"app/tools/help/combine.md"))),

                         uiOutput("ui_Combine"))
      ),
      mainPanel(
        ## add logo to the page
        #img(src='imgs/icon.png', align = "right"),
        tabsetPanel(id = "tabs_data",
                    tabPanel("Datasets",
                             conditionalPanel("input.dman_preview == 'preview'", h2("Data preview"), htmlOutput("man_example")),
                             conditionalPanel("input.dman_preview == 'str'", h2("Data structure"), verbatimTextOutput("man_str")),
                             conditionalPanel("input.dman_preview == 'summary'", h2("Data summary"), verbatimTextOutput("man_summary")),
                             conditionalPanel(condition = "input.man_show_log == true",
                                              h2("Data load and save commands"),
                                              uiOutput("ui_man_log")
                             ),
                             conditionalPanel("input.man_add_descr == false", uiOutput("man_descr_html")),
                             conditionalPanel("input.man_add_descr == true", uiOutput("man_descr_md"))
                    ),
                    tabPanel("View",
                             download_link("dl_view_tab"),
                             DT::dataTableOutput("dataviewer")
                    ),
                    tabPanel("Plots",
                             download_link("dlp_visualize"),
                             plotOutput("visualize", width = "100%", height = "100%")
                    ),
                    tabPanel("Regroup",
                             conditionalPanel("input.pvt_tab == true",
                                              download_link("dl_pivot_tab"),
                                              DT::dataTableOutput("pivotr")
                             ),
                             conditionalPanel("input.pvt_chi2 == true", htmlOutput("pivotr_chi2")),
                             conditionalPanel("input.pvt_plot == true", br(), br(),
                                              download_link("dlp_pivot"),
                                              plotOutput("plot_pivot", width = "100%", height = "100%")
                             )
                    ),
                    tabPanel("Statistics",
                             download_link("dl_explore_tab"),
                             DT::dataTableOutput("explore")
                    ),
                    tabPanel("Transform",
                             htmlOutput("transform_data"),
                             verbatimTextOutput("transform_summary"),
                             uiOutput("ui_tr_log")
                    ),
                    tabPanel("Combine",
                             htmlOutput("cmb_data1"),
                             htmlOutput("cmb_data2"),
                             htmlOutput("cmb_possible"),
                             htmlOutput("cmb_data")
                    )
        )
      )
    )
  )
})

################# Load dataframe (Clinical data, Profile Data, ...) to Workspace
loadInDatasets <- function(fname, header= TRUE){

  objname <- fname

  if(fname=="ProfData"){
    GeneList <- whichGeneList(input$GeneListID)
    dat <- as.data.frame(getProfileData(cgds, GeneList, input$GenProfID,input$CasesID))
    r_data[[objname]] <- dat %>% tibble::rownames_to_column("Patients")
    #r_data[[objname]] <- data.frame(r_data[[objname]] , stringsAsFactors = TRUE)

  }else if (fname=="ClinicalData"){

    ## load only selected column
    # dat <- get_data(r_data$ClinicalData[input$ClinicalDataTable_rows_all,],
    #       vars = input$Clinical_varsID, na.rm = FALSE)
    # r_data[[objname]] <- dat

    ## load all clinical data
    dat <- as.data.frame(getClinicalData(cgds, input$CasesID))
    r_data[[objname]] <- dat %>% tibble::rownames_to_column("Patients")

  }else if (fname=="MutData"){
    GeneList <- whichGeneList(input$GeneListID)
    dat <- as.data.frame((getMutationData(cgds,input$CasesID, input$GenProfID, GeneList)))
    r_data[[objname]] <- dat %>% tibble::rownames_to_column("Patients")
  } else if (fname=="xCNA"){
    dat <- plyr::ldply(r_info$ListProfData$CNA)
    r_data[[objname]] <- dat
  } else if(fname =="xmRNA"){
    dat <- plyr::ldply(r_info$ListProfData$Expression)
    r_data[[objname]] <- dat
  }else if(fname == "xMetHM450"){
    dat <- plyr::ldply(r_info$ListProfData$Met_HM450)
    r_data[[objname]] <- dat
  }else if(fname== "xMetHM27"){
    dat <- plyr::ldply(r_info$ListProfData$Met_HM27)
    r_data[[objname]] <- dat
  }else if (fname=="xMut"){
    dat <- plyr::ldply(r_info$ListMutData)
    r_data[[objname]] <- dat
  } else if(fname== "xFreqMut"){
    dat <- r_info$Freq_DfMutData
    r_data[[objname]] <- dat %>% tibble::rownames_to_column("Genes")
  }else if (fname== "xmiRNA"){
    dat <- plyr::ldply(r_info$ListProfData$miRNA)
    r_data[[objname]] <- dat
  }else if (fname== "xRPPA"){
    dat <- plyr::ldply(r_info$ListProfData$RPPA)
    r_data[[objname]] <- dat
  }
  r_info[[paste0(objname,"_descr")]] <- attr(r_info[[objname]], "description")
  #r_data[['datasetlist']] <- c(objname,r_data[['datasetlist']]) %>% unique
  r_info[['datasetlist']] <- c(objname,r_info[['datasetlist']]) %>% unique
}






loadUserData <- function(fname, uFile, ext,
                         .csv = FALSE,
                         header = TRUE,
                         man_str_as_factor = TRUE,
                         sep = ",",
                         dec = ".") {

  filename <- basename(fname)

  fext <- tools::file_ext(filename) %>% tolower

  ## switch extension if needed
  if (fext == "rds" && ext == "rda") ext <- "rds"
  if (fext == "rda" && ext == "rds") ext <- "rda"

  ## objname is used as the name of the data.frame
  objname <- sub(paste0(".",ext,"$"),"", filename)

  ## if ext isn't in the filename nothing was replaced and so ...
  if (objname == filename) {
    if (fext %in% c("xls","xlsx")) {
      ret <- "### bioCancer does not load xls files directly. Please save the data as a csv file and try again."
    } else {
      ret <- paste0("### The filename extension (",fext,") does not match the specified file-type (",ext,").
                    Please specify the file type you are trying to upload (i.e., csv or rda).")
    }

    upload_error_handler(objname,ret)
    ext <- "---"
  }

  if (ext == 'rda') {
    ## objname will hold the name of the object(s) inside the R datafile
    robjname <- try(load(uFile), silent = TRUE)
    if (is(robjname, 'try-error')) {
      upload_error_handler(objname, "### There was an error loading the data. Please make sure the data are in rda format.")
    } else if (length(robjname) > 1) {
      if (sum(robjname %in% c("r_state", "r_data")) == 2) {
        upload_error_handler(objname,"### To restore state from a state-file select 'state' from the 'Load data of type' drowdown before uploading the file")
        rm(r_state, r_data) ## need to remove the local copies of r_state and r_data
      } else {
        upload_error_handler(objname,"### More than one R object contained in the data.")
      }
    } else {
      r_data[[objname]] <- as.data.frame(get(robjname)) %>% {set_colnames(., gsub("^\\s+|\\s+$", "", names(.)))}
    }
    r_info[[paste0(objname,"_descr")]] <- attr(r_info[[objname]], "description")
    r_info[['datasetlist']] <<- c(objname, r_info[['datasetlist']]) %>% unique
  } else if (ext == 'rds') {
    ## objname will hold the name of the object(s) inside the R datafile
    robj <- try(readRDS(uFile), silent = TRUE)
    if (is(robj, 'try-error')) {
      upload_error_handler(objname, "### There was an error loading the data. Please make sure the data are in rds.")
    } else {
      r_info[[objname]] <- as.data.frame(robj) %>% {set_colnames(., gsub("^\\s+|\\s+$", "", names(.)))}
      r_info[[paste0(objname,"_descr")]] <- attr(r_info[[objname]], "description")
      r_info[['datasetlist']] <<- c(objname, r_info[['datasetlist']]) %>% unique
    }
  } else if (ext == 'csv') {
    r_info[[objname]] <- loadcsv(uFile, .csv = .csv, header = header, sep = sep, saf = man_str_as_factor) %>%
    {if (is.character(.)) upload_error_handler(objname, mess) else .} %>%
    {set_colnames(., gsub("^\\s+|\\s+$", "", names(.)))}

    r_info[[paste0(objname,"_descr")]] <- attr(r_info[[objname]], "description")
    r_info[['datasetlist']] <<- c(objname, r_info[['datasetlist']]) %>% unique

  } else if (ext != "---") {

    ret <- paste0("### The selected filetype is not currently supported (",fext,").")
    upload_error_handler(objname,ret)

  }
  if (ext == 'txt') {
    r_data[[objname]] <- try(read.table(uFile, header=header, sep=sep, dec=dec,
                                        stringsAsFactors=FALSE), silent = TRUE) %>%
                                        { if(is(., 'try-error')){ upload_error_handler(objname,
                                                  "### There was an error loading the data.
                                                  Please make sure the data are in either txt format,
                                                  one gene by row.")
                                          }else{.} } %>% {if(man_str_as_factor){
                                            lapply(., factor)
                                            } else{.} } # %>% tbl_df
    r_data[['genelist']] <- c(objname,r_data[['genelist']]) %>% unique

  }
}


loadClipboard_GeneList <- function(objname = "User_Genes", ret = "", header = FALSE, sep = "\t", tab) {

  dat <- sshhr(try(
    {if (Sys.info()["sysname"] == "Windows") {
      read.table("clipboard", header = header, sep = sep, as.is = TRUE)
    } else if (Sys.info()["sysname"] == "Darwin") {
      read.table(pipe("pbpaste"), header = header, sep = sep, as.is = TRUE)
    } else if (!is_empty(tab)){
      read.table(text = tab, header = header, sep = sep, as.is = TRUE) #load_cdata
    }} %>% as.data.frame(check.names = TRUE), silent = TRUE))
  dat <- t(dat)
  if (is(dat, 'try-error') || nrow(dat) == 0) {
    if (ret == "") ret <- c("### Gene List in clipboard was not well formatted.")
    upload_error_handler(objname,ret)
    r_data[['genelist']] <- c("DNA_damage_Response", r_data[['genelist']]) %>% unique
  } else {
    ret <- paste0("### Clipboard data\nData copied from clipboard on", lubridate::now())
    r_data[[objname]] <- dat
    r_data[[paste0(objname,"_descr")]] <- ret
    r_data[['genelist']] <- c(objname, r_data[['genelist']]) %>% unique
  }

}

options(cBioPortal.nav_ui =
          tagList(
            tabPanel("cBioPortal", uiOutput("cBioPortal"))
            #tabPanel("Dosimetry", uiOutput("dosimetry"))
            #tabPanel("Medical", uiOutput("medical"))

          )
)
options(Enrichment.nav_ui =
          tagList(
            tabPanel("Enrichment", uiOutput("Enrichment"))

          )
          )

# options(Tools.nav_ui =
#           tagList(
#             tabPanel("Tools", uiOutput("Tools"))
#
#           )
# )

## set default plots resolution
plot_width <- function(){
  if (is.null(input$plot_width)){
    r_data$plot_width <- 600
    }else{
      input$plot_width
    }
}

plot_height <- function(){
  if (is.null(input$plot_height)){
    r_data$plot_height <- 600
    }else{ input$plot_height
    }
}


## set default dataset
init_data <- function(env = r_data) {
  ## Based on discussion with Joe Cheng: Datasets can change over time
  ## so the data needs to be reactive value so the other reactive
  ## functions and outputs that depend on these datasets will know when
  ## they are changed

  ## Using an environment to assign data
  ## http://adv-r.had.co.nz/Environments.html#explicit-envs

  ## using a reactiveValues list to keep track of relevant app info
  ## that needs to be reactive
  r_data <- reactiveValues()
  r_info <- reactiveValues()

  #r_info[["datasetlist"]] <- c(epiGenomics, user_CNA, user_MetHM27, user_MetHM450, user_mRNA, user_Mut)

  df_names <- "epigenomics"

  for (dn in df_names) {
    if (file.exists(dn)) {
      df <- load(dn) %>% get()
      dn <- basename(dn) %>%
      {gsub(paste0(".", tools::file_ext(.)), "", ., fixed = TRUE)}
    } else {
      df <- data(list = dn, package = "bioCancer", envir = environment()) %>% get()
      r_info[[paste0(dn, "_lcmd")]] <- glue::glue('{dn} <- data({dn}, package = "bioCancer", envir = environment()) %>% get()\nregister("{dn}")')
    }
    env[[dn]] <- df
    if (!bindingIsActive(as.symbol(dn), env = env)) {
      makeReactiveBinding(dn, env = env)
    }
    r_info[[paste0(dn, "_descr")]] <- attr(df, "description")
  }

  r_info[["datasetlist"]] <- basename(df_names)
  r_info[["url"]] <- NULL
  r_info
}

> Run R-code

The code feature allows you to enter and run R-code with access to all functions and data in Radiant. By clicking the `Run` button, the code will be evaluated and the output will be shown on the right of the R > Code page. To evaluate only a part of the code use the cursor to select a section and press CTRL-return (CMD-return on mac) to create the (partial) output.

You can load an R-code file into Radiant by clicking the `Choose File` button and selecting an .r or .R file or save the R-code shown in the editor by pressing the `Save` button.

As an example you can copy-and-paste the text below into the editor and press `Run` to generate results.

<pre>## get the active dataset and show the first few observations
.getdata() %>% head

## access a specific dataset by name
r_data[['diamonds']] %>% select(price, clarity) %>% head

## add a variable to the diamonds data
dat <- r_data[['diamonds']]
dat$log_price <- log(dat$price)

## show the first observations
dat %>% select(price, log_price) %>% head

## create a histogram of prices
dat %>% ggplot(aes(x = price)) + geom_histogram()

## and a histogram of log-prices
dat %>% ggplot(aes(x = log_price)) + geom_histogram()

## open help in the R-studio viewer from Radiant
help(package = 'radiant')

## if you are familiar with Shiny you can call reactives here
## for example, if you just transformed some variables in Data > Transform
## you can call the transform_main reacive to see the latest result
## this can very useful for debugging
transform_main() %>% head
</pre>

### Overview of Methods used in bioCancer
![Overview Methods used in bioCancer](figures/overview_methods.png)

> Display available Cancer Studies in Table

### Studies Panel

This panel displays in table all available cancer studies hosted and maintained by Memorial Sloan Kettering Cancer Center ([MSKCC](https://www.mskcc.org)). It provides access to data by The Cancer Genome Atlas as well as many carefully curated published data sets. 

Every row lists one study by `Identity`, `name` and `description`.

#### Browse the data

By default only 10 rows of are shown at one time. You can change this setting through the `Show ... entries` dropdown. Press the `Next` and `Previous` buttons at the bottom-right of the screen to navigate through the data.

#### Sort

Click on a column header in the table to sort the data by the values of that variable. Clicking again will toggle between sorting in ascending and descending order. To sort on multiple columns at once press shift and then click on the 2nd, 3rd, etc. column to sort by.

### Filters in Table
The search is possible for numerical or categorical variables. It is possible to match `string` or to use mathematical `operator` to filter data. For more detail see help page in Processing > View panel. 
#### Global Search
the `Filter` box on the left (click the check-box first).
#### Column filter
Every column has its filetr at the column header.

### Download table as csv file
User can download table as csv file. Use the download icon in the top-right of the page.

### Side bar Menu

#### Studies List
The Drop Down Boxes allow user to select one Id by type of data. The first one displays studies by Identity. It means the code listed in the column `cancer_study_id`. The id is simple to decrypte. It is the association of the short name of the cancer followed (\_) by the source of the study.


#### Cases and Genetic Profiles for selected study
When user change the study, automatically the relative cases and genetic profiles are updated.

The ids of cases and genetic profile are composed by cancer\_Source\_TypeOfData.

There are 6 types of data or dimensions: Copy Number Alteration (CNA, gistic), mRNA, Methylation (Met\_HM27, Met\_HM450), Mutation, miRNA, Reverse Phase Protein Activity (RPPA).

#### Gene List Examples

Gene List Example. By default there is one example of gene list (DNA\_damage\_Response). User can load other examples or own gene list in Profiles or Mutation Panels.

> Combine two datasets

There are six _join_ (or _merge_) options available in bioCancer from the [dplyr](http://www.rdocumentation.org/packages/dplyr) package developed by Hadley Wickham and Romain Francois on [GitHub](https://github.com/hadley/dplyr).

The examples below are adapted from [Cheatsheet for dplyr join functions](http://stat545-ubc.github.io/bit001_dplyr-cheatsheet.html) by Jenny Bryan and focus on three small datasets, `superheroes`, `publishers`, and `avengers`, to illustrate the different _join_ types and other ways to combine datasets in R and bioCancer. The data is also available in csv format through the links below:

<a href="https://github.com/vnijs/radiant/blob/gh-pages/examples/superheroes.csv" target = "_blank">superheroes.csv</a>

<a href="https://github.com/vnijs/radiant/blob/gh-pages/examples/publishers.csv" target = "_blank">publishers.csv</a>

<a href="https://github.com/vnijs/radiant/blob/gh-pages/examples/avengers.csv" target = "_blank">avengers.csv</a>


```{r results = 'asis', echo = FALSE}
tab_small <- "class='table table-condensed table-hover' style='width:30%;'"
tab_big <- "class='table table-condensed table-hover' style='width:70%;'"
suppressPackageStartupMessages(library(bioCancer))
knitr::kable(superheroes, align = 'l', format = 'html', caption = "Superheroes",
             table.attr = tab_big)
```

```{r results = 'asis', echo = FALSE}
knitr::kable(publishers, align = 'l', format = 'html', caption = "Publishers",
             table.attr = tab_small)
```

In the screen-shot of the Data > Combine tab below we see the two datasets. The tables share the variable _publisher_ which is automatically selected for the join. Different join options are available from the `Combine type` dropdown. You can also specify a name for the combined dataset in the `Data name` text input box.

![join](figures/join_superheroes_publishers.png)

<br>

### Inner join (superheroes, publishers)

If x = superheroes and y = publishers:

> An inner join returns all rows from x with matching values in y, and all columns from both x and y. If there are multiple matches between x and y, all match combinations are returned.

```{r results = 'asis', echo = FALSE}
inner_join(superheroes, publishers, by = "publisher") %>%
  knitr::kable(., align = 'l', format = 'html', table.attr = tab_big)
```

In the table above we lose _Hellboy_ because, although this hero does appear in `superheroes`, the publisher (_Dark Horse Comics_) does not appear in `publishers`. The join result has all variables from `superheroes`, plus _yr\_founded_, from `publishers`. We can visualize an inner join with the venn-diagram below:

![inner_join](figures/inner_join.png)

The R(adiant) commands are:

```r
# bioCancer
combinedata("superheroes", "publishers", by = "publisher", type = "inner_join")

# R
inner_join(superheroes, publishers, by = "publisher")
```

<br>

### Left join (superheroes, publishers)

> A left join returns all rows from x, and all columns from x and y. If there are multiple matches between x and y, all match combinations are returned.

```{r results = 'asis', echo = FALSE}
left_join(superheroes, publishers, by = "publisher") %>%
  knitr::kable(., align = 'l', format = 'html', table.attr = tab_big)
```

The join result contains `superheroes` with variable `yr_founded` from `publishers`. _Hellboy_, whose publisher does not appear in `publishers`, has an `NA` for _yr_founded_. We can visualize a left join with the venn-diagram below:

![left_join](figures/left_join.png)

The R(adiant) commands are:

```r
# bioCancer
combinedata("superheroes", "publishers", by = "publisher", type = "left_join")

# R
left_join(superheroes, publishers, by = "publisher")
```

<br>

### Right join (superheroes, publishers)

> A right join returns all rows from y, and all columns from y and x. If there are multiple matches between y and x, all match combinations are returned.

```{r results = 'asis', echo = FALSE}
right_join(superheroes, publishers, by = "publisher") %>%
  knitr::kable(., align = 'l', format = 'html', table.attr = tab_big)
```

The join result contains all rows and columns from `publishers` and all variables from `superheroes`. We lose _Hellboy_, whose publisher does not appear in `publishers`. _Image_ is retained in the table but has `NA` values for the variables _name_, _alignment_, and _gender_ from `superheroes`. Notice that a join can change both the row and variable order so you should not rely on these in your analysis. We can visualize a right join with the venn-diagram below:

![right_join](figures/right_join.png)

The R(adiant) commands are:

```r
# bioCancer
combinedata("superheroes", "publishers", by = "publisher", type = "right_join")

# R
right_join(superheroes, publishers, by = "publisher")
```

<br>

### Full join (superheroes, publishers)

> A full join combines two datasets, keeping rows and columns that appear in either.

```{r results = 'asis', echo = FALSE}
full_join(superheroes, publishers, by = "publisher") %>%
  knitr::kable(., align = 'l', format = 'html', table.attr = tab_big)
```

In this table we keep _Hellboy_ (even though _Dark Horse Comics_ is not in `publishers`) and _Image_ (even though the publisher is not listed in `superheroes`) and get variables from both datasets. Observations without a match are assigned the value NA for variables from the _other_ dataset. We can visualize a full join with the venn-diagram below:

![full_join](figures/full_join.png)

The R(adiant) commands are:

```r
# bioCancer
combinedata("superheroes", "publishers", by = "publisher", type = "full_join")

# R
full_join(superheroes, publishers, by = "publisher")
```

### Semi join (superheroes, publishers)

> A semi join keeps only columns from x. Whereas an inner join will return one row of x for each matching row of y, a semi join will never duplicate rows of x.

```{r results = 'asis', echo = FALSE}
semi_join(superheroes, publishers, by = "publisher") %>%
  knitr::kable(., align = 'l', format = 'html', table.attr = tab_big)
```

We get a similar table as with `inner_join` but it contains only the variables in `superheroes`. The R(adiant) commands are:

```r
# bioCancer
combinedata("superheroes", "publishers", by = "publisher", type = "semi_join")

# R
semi_join(superheroes, publishers, by = "publisher")
```

<br>

### Anti join (superheroes, publishers)

> An anti join returns all rows from x without matching values in y, keeping only columns from x

```{r results = 'asis', echo = FALSE}
anti_join(superheroes, publishers, by = "publisher") %>%
  knitr::kable(., align = 'l', format = 'html', table.attr = tab_big)
```

We now get **only** _Hellboy_, the only superhero not in `publishers` and we do not get the variable _yr\_founded_ either. We can visualize an anti join with the venn-diagram below:

![anti_join](figures/anti_join.png)

<br>

### Dataset order

Note that the order of the datasets selected may matter for a join. If we setup the Data > Combine tab as below the results are as follows:

![join order](figures/join_publishers_superheroes.png)

<br>

### Inner join (publishers, superheroes)

```{r results = 'asis', echo = FALSE}
inner_join(publishers, superheroes, by = "publisher") %>%
  knitr::kable(., align = 'l', format = 'html', table.attr = tab_big)
```

Every publisher that has a match in `superheroes` appears multiple times, once for each match. Apart from variable and row order, this is the same result we had for the inner join  shown above.

<br>

### Left and Right join (publishers, superheroes)

Apart from row and variable order, a left join of `publishers` and `superheroes` is equivalent to a right join of `superheroes` and `publishers`. Similarly, a right join of `publishers` and `superheroes` is equivalent to a left join of `superheroes` and `publishers`.

<br>

### Full join (publishers, superheroes)

As you might expect, apart from row and variable order, a full join of `publishers` and `superheroes` is equivalent to a full join of `superheroes` and `publishers`.

<br>

### Semi join (publishers, superheroes)

```{r results = 'asis', echo = FALSE}
semi_join(publishers, superheroes, by = "publisher") %>%
  knitr::kable(., align = 'l', format = 'html', table.attr = tab_small)
```

With semi join the effect of switching the dataset order is more clear. Even though there are multiple matches for each publisher only one is shown. Contrast this with an inner join where "If there are multiple matches between x and y, all match combinations are returned." We see that publisher _Image_ is lost in the table because it is not in `superheroes`.

<br>

### Anti join (publishers, superheroes)

```{r results = 'asis', echo = FALSE}
anti_join(publishers, superheroes, by = "publisher") %>%
  knitr::kable(., align = 'l', format = 'html', table.attr = tab_small)
```

Only publisher _Image_ is retained because both _Marvel_ and _DC_ are in `superheroes`. We keep only variables in `publishers`.

<br>

### Additional tools to combine datasets (avengers, superheroes)

When two datasets have the same columns (or rows) there are additional ways in which we can combine them into a new dataset. We have already used the `superheroes` dataset and will now try to combine it with the `avengers` data. These two datasets have the same number of rows and columns and the columns have the same names.

In the screen-shot of the Data > Combine tab below we see the two datasets. There is no need to select variables to combine the datasets here. Any variables in `Select variables` are ignored in the commands below. Again, you can specify a name for the combined dataset in the `Data name` text input box.

![combine](figures/combine_avengers_superheroes.png)

<br>

### Bind rows

```{r results = 'asis', echo = FALSE}
bind_rows(avengers, superheroes) %>%
  knitr::kable(., align = 'l', format = 'html', table.attr = tab_big)
```

If the `avengers` dataset were meant to extend the list of superheroes we could just stack the two datasets, one below the other. The new datasets has 14 rows and 4 columns. Due to a coding error in the `avengers` dataset (i.e.., _Magneto_ is *not* an _Avenger_) there is a duplicate row in the new combined dataset. Something we probably don't want.

The R(adiant) commands are:

```r
# bioCancer
combinedata("avengers", "superheroes", type = "bind_rows")

# R
bind_rows(avengers, superheroes)
```

<br>

### Bind columns

```{r results = 'asis', echo = FALSE}
bind_cols(avengers, superheroes) %>%
  knitr::kable(., align = 'l', format = 'html', table.attr = tab_big)
```

If the dataset had different columns for the same superheroes we could combine the two datasets, side by side. In bioCancer you will see an error message if you try to bind these columns because they have the same name. Something that we should always avoid. The method can be useful if we *know* the order of the row ids of two dataset are the same but the columns are all different.

<br>

### Intersect

```{r results = 'asis', echo = FALSE}
intersect(avengers, superheroes) %>%
  knitr::kable(., align = 'l', format = 'html', table.attr = tab_big)
```

A good way to check if two datasets with the same columns have duplicate rows is to choose `intersect` from the `Combine type` dropdown. There is indeed one row that is identical in the `avengers` and `superheroes` data (i.e., _Magneto_).

The R(adiant) commands are the same as shown above, except you will need to replace `bind_rows` by `intersect`.

<br>

### Union

```{r results = 'asis', echo = FALSE}
union(avengers, superheroes) %>%
  knitr::kable(., align = 'l', format = 'html', table.attr = tab_big)
```

A `union` of `avengers` and `superheroes` will combine the datasets but will omit duplicate rows (i.e., it will keep only one _copy_ of the row for _Magneto_). Likely what we want here.

The R(adiant) commands are the same as shown above, except you will need to replace `bind_rows` by `union`.

<br>

### Setdiff

```{r results = 'asis', echo = FALSE}
setdiff(avengers, superheroes) %>%
  knitr::kable(., align = 'l', format = 'html', table.attr = tab_big)
```

Finally, a `setdiff` will keep rows from `avengers` that are not in `superheroes`. If we reverse the inputs (i.e., choose `superheroes` from the `Datasets` dropdown and `superheroes` from the `Combine with` dropdown) we will end up with all rows from `superheroes` that are not in `avengers`. In both cases the entry for _Magneto_ will be omitted.

The R(adiant) commands are the same as shown above, except you will need to replace `bind_rows` by `setdiff`.

<br>

--------
For additional discussion see <http://cran.r-project.org/web/packages/dplyr/vignettes/two-table.html>

> Manage data and state: Load data into bioCancer, Save data to disk, Remove a dataset from memory, or Save/Load the full state of the app


### Datasets

When you first start bioCancer a dataset (`epiGenomics`) with information on how it was formatted is shown in `Processing` panel.

It is good practice to add a description of the data and variables to each file you use. For the files that are part of bioCancer you will see a brief overview of the variables etc. below the table of the first 10 rows of the data. If you would like to add a description for your own data check the 'Add/edit data description' check-box. A window will open below the data table where you can add text in
<a href="http://rmarkdown.rstudio.com/authoring_pandoc_markdown.html" target="_blank">markdown</a> format. The descriptions of the data included with bioCancer should serve as a good starting point.

If you would like to rename a dataset loaded in bioCancer check the `Rename data` box, enter a new name for the data, and click the `Rename` button

### Load data

The best way to load and save data for use in bioCancer (and R) is to use the R-data format (rda). These are binary files that can be stored compactly and read into R quickly. Choose `rda` from the `Load data of type` dropdown and click `Choose Files` to locate the file(s) you want to load. If the `rda` file is available online choose `rda (url)` from the dropdown, paste the url into the text input, and press `Load`.

You can get data from a spreadsheet (e.g., Excel or Google sheets) into bioCancer in two ways. First, you can save data from the spreadsheet in csv format and then, in bioCancer, choose `csv` from the `Load data of type` dropdown. Most likely you will have a header row in the csv file with variable names. If the data are not comma separated you can choose semicolon or tab separated. To load a csv file click 'Choose files' and locate the file on your computer. If the `csv` data is available online choose `csv (url)` from the dropdown, paste the url into the text input shown, and press `Load`.

> **Note:** For Windows users with data that contain multibyte characters please make sure your data are in ANSI format so R(adiant) can load the characters correctly.

Alternatively, you can select and copy the data in the spreadsheet using CTRL-C (or CMD-C on mac), go to bioCancer, choose `clipboard` from the dropdown, and click the `Paste data` button. This is a short-cut that can be convenient for smaller datasets that are cleanly formatted. If you see a message in bioCancer that the data were not transferred cleanly try saving the data in csv format and loading it into bioCancer as described above.

To access all data files bundled with bioCancer choose `examples` from the `Load data of type` dropdown and click `Load examples`. These files are used to illustrate the various analysis tools accessible in bioCancer. For example, the catalog sales data is used as an example in the help file for regression (i.e., Regression > Linear (OLS)).

### Save data

As mentioned above, the most convenient way to get data in and out of bioCancer is to use the R-data format (rda). Choose `rda` from the `Save data` dropdown and click the `Save data` button to save selected dataset to file.

It is good practice to add a description of the data and variables to each file you use. For the files that are part of bioCancer you will see a brief overview of the variables etc. below the table of the first 10 rows of the data. If you would like to add a description for your own data check the 'Add/edit data description' check-box. A window will open below that data table where you can add text in
<a href="http://rmarkdown.rstudio.com/authoring_pandoc_markdown.html" target="_blank">markdown</a> format. The descriptions of the data included with bioCancer should serve as a good starting point. When you save the data as an rda file the description you created (or edited) will automatically be added to the file.

Getting data from bioCancer into a spreadsheet can be achieved in two ways. First, you can save data in csv format and load the file into the spreadsheet (i.e., choose `csv` from the `Save data` dropdown and click the `Save data` button). Alternatively, you can copy the data from bioCancer into the clipboard by choosing `clipboard` from the dropdown and clicking the `Copy data` button, open the spreadsheet, and paste the data from bioCancer using CTRL-V (or CMD-V on mac).

### Save and load state

You can save and load the state of the bioCancer app just as you would a data file. The state file (extension rda) will contain (1) the data loaded in bioCancer, (2) settings for the analyses you were working on, (3) and any reports or code from the R-menu. Save the state-file to your hard-disk and when you are ready to continue simply load it by selecting the state radio button and clicking the `Choose file` button.

The best way to save your analyses is to save the state of the app to a file by clicking on the <i title='Save' class='fa fa-save'></i> icon in the navbar and then on `Save state`. Similar functionality is available in `Data > Manage` tab.

This is convenient if you want to save your work to be completed at another time, perhaps on another computer, or to review any assignments you completed using bioCancer. You can also share the file with others that would like to replicate your analyses. As an example, download and then load the state_file [`RadiantState.rda`](https://vnijs.github.io/radiant/examples/RadiantState.rda). Go to `Data > View`, `Data > Visualize` to see some of the settings loaded from the statefile. There is also a report in `R > Report` created using the Radiant interface. The html file <a href="https://vnijs.github.io/radiant/examples/RadiantState.html" target="_blank">`RadiantState.html`</a> contains the output.

A related feature in bioCancer is that state is maintained if you accidentally navigate to another page, close (and reopen) the browser, and/or hit refresh. Use `Reset` in the <i title='Power off' class='fa fa-power-off'></i> menu in the navigation bar to return to a clean/new state.

Loading and saving state also works with Rstudio. If you start bioCancer from Rstudio and use <i title='Power off' class='fa fa-power-off'></i> > `Stop` to stop the app, lists called `r_data` and `r_state` will be put into Rstudio's global workspace. If you start bioCancer again using `bioCancer()` it will use these lists to restore state. This can be convenient if you want to make changes to a data file in Rstudio and load it back into bioCancer. Also, if you load a state file directly into Rstudio it will be used when you start bioCancer to recreate a previous state.

### Remove data from memory

If data are loaded that you no longer need access to in the current session check the `Remove data from memory` box. Then select the data to remove and click the `Remove data` button. One datafile will always remain open.

### Using commands to load and save data

The `loadr` command can be used to load data from a file directly into a bioCancer session and add it to the `Datasets` dropdown. The `saver` command can be used to exact data from bioCancer and save it to disk. Data can be loaded or saved as `rda` or `rds` format depending on the file extension chosen. These commands can be used both inside or without the bioCancer browser interface. See `?loadr` and `?saver` for details.

> Show data in table form

### Datasets

Choose one of the datasets from the `Datasets` dropdown. Files are loaded into bioCancer through the Manage tab.

### Select columns

By default all columns in the data are shown. Click on any variable to focus on it alone. To select several variables use the SHIFT and ARROW keys on your keyboard. On a mac the CMD key can also be used to select multiple variables. The same effect is achieved on windows using the CTRL key. To select all variable use CTRL-A (or CMD-A on mac).

### Browse the data

By default only 10 rows of are shown at one time. You can change this setting through the `Show ... entries` dropdown. Press the `Next` and `Previous` buttons at the bottom-right of the screen to navigate through the data.

### Sort

Click on a column header in the table to sort the data by the values of that variable. Clicking again will toggle between sorting in ascending and descending order. To sort on multiple columns at once press shift and then click on the 2nd, 3rd, etc. column to sort by.

### Filter

There are several ways to select a subset of the data to view. The `Filter` box on the left (click the check-box first) can be used with `>` and `<` signs and you can also combine subset commands. For example, `x > 3 & y == 2` would show only those rows for which the variable `x` has values larger than 3 **and** for which `y` has values equal to 2. Note that in R, and most other programming languages, `=` is used to _assign_ a value and `==` to evaluate if the value of a variable is equal to some other value. In contrast `!=` is used to determine if a variable is _unequal_ to some value. You can also use expressions that have an **or** condition. For example, to select rows where `mutation frequency` is smaller than 20 and larger than 10 use `FreqMut > 10 & FreqMut < 20`. `&` is the symbol for **and**. The table below gives an overview of common operators.


You can also use string matching to select rows. For example, type `grepl("lu", Diseases)` to select rows with `lung` Cancers. This search is case sensitive by default. For case insensitive search you would use `grepl("TCGA", name, ignore.case = TRUE)`. Type your statement in the `Filter`  box and press return to see the result on screen or an error below the box if the expression is invalid.

It is important to note that these filters are _persistent_. A filter entered in one of the Data-tabs will also be applied to other tabs and to any analysis conducted through the bioCancer menus. To deactivate a  filter uncheck the `Filter` check-box. To remove a filter simply erase it.

<table class='table table-condensed table-hover' style='width:60%;'>
 <thead>
  <tr>
   <th style="text-align:left;"> Operator </th>
   <th style="text-align:left;"> Description </th>
   <th style="text-align:left;"> Example </th>
  </tr>
 </thead>
<tbody>
  <tr>
   <td style="text-align:left;"> `<` </td>
   <td style="text-align:left;"> less than </td>
   <td style="text-align:left;"> `price < 5000` </td>
  </tr>
  <tr>
   <td style="text-align:left;"> `<=` </td>
   <td style="text-align:left;"> less than or equal to </td>
   <td style="text-align:left;"> `carat <= 2` </td>
  </tr>
  <tr>
   <td style="text-align:left;"> `>` </td>
   <td style="text-align:left;"> greater than </td>
   <td style="text-align:left;"> `price > 1000` </td>
  </tr>
  <tr>
   <td style="text-align:left;"> `>=` </td>
   <td style="text-align:left;"> greater than or equal to </td>
   <td style="text-align:left;"> `carat >= 2` </td>
  </tr>
  <tr>
   <td style="text-align:left;"> `==` </td>
   <td style="text-align:left;"> exactly equal to </td>
   <td style="text-align:left;"> `cut == 'Fair'` </td>
  </tr>
  <tr>
   <td style="text-align:left;"> `!=` </td>
   <td style="text-align:left;"> not equal to </td>
   <td style="text-align:left;"> `cut != 'Fair'` </td>
  </tr>
  <tr>
   <td style="text-align:left;"> `|` </td>
   <td style="text-align:left;"> x OR y </td>
   <td style="text-align:left;"> `price > 10000 | cut == 'Premium'` </td>
  </tr>
  <tr>
   <td style="text-align:left;"> `&` </td>
   <td style="text-align:left;"> x AND y </td>
   <td style="text-align:left;"> `carat < 2 & cut == 'Fair'` </td>
  </tr>
  <tr>
   <td style="text-align:left;"> `%in%` </td>
   <td style="text-align:left;"> x is one of y </td>
   <td style="text-align:left;"> `cut %in% c('Fair', 'Good')` </td>
  </tr>
</tbody>
</table>

### Column filters and Search

For variables that have a limited number of different values (i.e., a factor) you can select the levels to keep from the column filter below the variable name. For example, to filter on rows with `CNA = -1`  click in the box below the `CNA` column header and select `-1` from the dropdown menu shown. You can also type a string into these column filters followed by return. Note that matching is case-insensitive. In fact, typing `1` would produce the same result because the search will match any part of a string. Similarly, you can type a string to select observations for character variables (e.g., street names).

For numeric variables the column filter boxes have some special features that make them almost as powerful as the `Filter` box. For numerical and integer variables you can use `...` to indicate a range. For example, to select `mRNA` values between 200 and 500  type `200 ... 500` and press return. The range is inclusive of the values typed. Furthermore, if we want to filter on `FreqMut` `20 ...` will show only Studies with mutation frequancy larger than or equal to 20. Numeric variables also have a slider that you can use to define the range of values to keep.

If you want to get _really_ fancy you can use the search box on the top right to search across all columns in the data using **regular expressions**. For example, to find all rows that have an entry in _any_ column ending with the number 72 type `72$` (i.e., the `$` sign is used to indicate the end of an entry). For all rows with entries that start with 60 use `^60` (i.e., the `^` is used to indicate the first character in an entry). Regular expressions are incredibly powerful for search but this is a _big_ topic area. To learn more about regular expressions see this <a href="http://www.regular-expressions.info/tutorial.html" target="_blank">tutorial</a>.

It is important to note that column sorting, column filters, and search are **not** persistent. To store these settings for use in other parts of bioCancer press the `Store` button. You can store the data and settings under a different dataset name by changing the value in the text input to the left of the `Store` button. This feature can also be used to select a subset of variables to keep. Just select the ones you want to keep and press the `Store` button. For more control over the variables you want to keep or remove and to specify their order in the dataset use the `Tools > Transform` tab.

> Create a (reproducible) report

The report feature in Radiant should be used in conjunction with the <i title='Report results' class='fa fa-edit'></i> icons shown on the bottom of the (left) side bar on all analysis pages. When that icon is clicked the command used to create the output is copied into the editor in the R > Report. By default Radiant will paste the code generated for the analysis you just completed at the bottom of the report. However, you can turn off that feature by clicking the `Manual paste (off)` button. The text in the button should now read `Manual paste (on)`. Click the button again to turn manual paste off again. With manual paste on the code is put in the clipboard when you click a book icon and you can paste it where you want in the R > Report editor window.

By clicking the `Knit report` button, the output from the analysis will be recreated on the right of the _R > Report_ page. You can add text, bullets, headers, etc. around the code blocks to describe and explain the results using <a href="http://rmarkdown.rstudio.com/authoring_pandoc_markdown.html" target="_blank">markdown</a>. To evaluate only a part of the report use the cursor to select a section and press CTRL-return (CMD-return on mac) to create the (partial) output.

As an example you can copy-and-paste the text below into the editor. You can also load and (R)markdown file into Radiant by clicking the `Choose File` button and selecting an .md or .Rmd file. Press the `Update` button to see the output.

Finally, you can save the Rmd file open in the editor by pressing the `Save Rmd` button or save the generated output by pressing the `Save HTML` button.

<pre>## Sample report

This is an example of the type of report you can write in Radiant.

* You can create
* bullet lists

1. And numbered
2. lists

### Math

You can even include math if you want:

$$y_t = \\alpha + \\beta x_t + \\epsilon_t$$.

To show the output press the `Update` button.

### Documenting analysis results in Radiant

Below is some code created in Radiant that will generate regression output
for the _diamonds_ data. These are histograms and a scatterplot
/ heatmap of the price of diamonds versus carats. The colors in the plot
reflect the clarity of the diamond.

```{r fig.width=7, fig.height=4}
result <- regression(dataset = 'diamonds', dep_var = 'price',
                     indep_var = 'carat')
summary(result)
plot(result, plots = 'hist')
```

```{r fig.width=7, fig.height=7}
visualize(dataset = 'diamonds', xvar = 'carat', yvar = 'price',
          type = 'scatter', color = 'clarity')
```
</pre>

> Show Clinical Data in Table

Clinical panel displays informations related to patients as `AGE`, `GENDER` and other variables depending on study and type of cancer. Some variables are shared between studies and others are specific. Each row corresponds to one patient.

### Side bar menu

The Clinical Data is specifuic to each Study. When user change the select Study, the Table of the Clincal Data is automatically updated. The panel is aloso listening DropDown box of Cases.

#### Select variables to show

By default all columns in the data are shown. Click on any variable to focus on it alone. To select several variables use the SHIFT and ARROW keys on your keyboard. On a mac the CMD key can also be used to select multiple variables. The same effect is achieved on windows using the CTRL key. To select all variable use CTRL-A (or CMD-A on mac).

#### Load Clinical Data to Datasets (to Processing Panel)

It is interesting to use clinical variables for further analysis using Processing panel tools.

The `Load ClinicalData` loads the clincal data table to `Datasets` in `Processing` panel. Otherwise, user can make all manipulation tools available in `Processing` panel or in Main Menu Page.

With `clipboard` option, user can copy and paste own table from external file (txt, xls, odt).

> Show Mutations Data in Table

Mutation panel displays informations related to gene list mutations. User needs to select a Case`_all` or Case`_sequenced`, and a `genetic Profile` with `mutations`.

#### Select variables to show

By default all columns in the data are shown. Click on any variable to focus on it alone. To select several variables use the SHIFT and ARROW keys on your keyboard. On a mac the CMD key can also be used to select multiple variables. The same effect is achieved on windows using the CTRL key. To select all variable use CTRL-A (or CMD-A on mac).

#### Load Gene List
User can upload gene list examples or upload own gene list.

When user selects `examples` and clic on `Load examples` button, the gene list examples is loaded in DropDown Gene List.

When User selects  `clipboard`, it is possible to copy own gene list from text file (gene symbol by line) and clic on  `Paste Gene List` button. The gene List will be named  `Genes` in DropDown Gene List.

#### Load Mutations to Datasets

It is interesting to get any statistics analysis or transformation with genetic profiles. Any table from `Mutation` panel can be loaded to `Processing` panel by checking `Load Mutations to Datasets` and press the button. The data frame will be named `MutData`.

---
output: 
  html_document: 
    fig_caption: yes
---
> Function Interaction Network Enrichment

### Edges Attributes

#### Function Interactions (FIs) Type

Arrowhead | Reaction | Arrowhead | Reaction 
------------- | -------- | -------- | ------------
-> | activate, express, regulate  | -\| | inhibit
diamond -<>  | complexe |curve | catalyze, reaction
  point -o| phosphorylate | -- | binding, input, compound
 -< | dissociation | .... | predicted, indirect,ubiquitinated

#### Use Linkers
 Picks up as few as possible of linkers that can connect input genes together. For example, if the algorithm finds one gene can link all input genes together, it will not try other genes (not from gene list) that may be used as a linker.
 
 The linker gene hes box format. 
 
#### Layouts 
 
##### dot
 The dot engine flows the directed graph in the direction of rank (i.e., downstream nodes of the same rank are aligned). By default, the direction is from top to bottom 
##### twopi
 The twopi engine provides radial layouts. Nodes are placed on concentric circles depending their distance from a given root node.
 
##### neato
 The neato engine provides spring model layouts. This is a suitable engine if the graph is not too large (less than 100 nodes) and you don't know anything else about it. The neato engine attempts to minimize a global energy function, which is equivalent to statistical multi-dimensional scaling. 
 
##### circo
The circo engine provide circular layouts. This is suitable for certain diagrams of multiple cyclic structures, such as certain telecommunications networks.

### Nodes Attributes

#### From ReactomeFI
The size of node is related to the number of inetractions. If node has multiple interaction, it will has bigger size than node with few interaction. Otherwise, i will be easier to locate important gene in the network. 

#### From Classifier

##### mRNA
Attribute node color using `exprsMeanDiff` values from `Classifier` panel.

##### Studies
Link study to associated genes from `Classifier` table.


#### From Profiles Data

User needs to
* Select studies (`From Which Studies`)
* Load profiles data (`Load`). 
* Select Profiles Data
* Set threshold from Sliders 

#### Legend
<!--
<p align="center"><img src="figures/ReactomeLegend.png"></p>
-->

![Reactome Legend](figures/ReactomeLegend.png)


### Interpretation
![Reactome Network](figures/Reactome_Network.png)


<!-- <p align="center"><img src="/figures/Reactome_Network.png"></p> -->

<!-- <img src="figures/Reactome_Network.png" alt="Smiley face" height="42" width="42">  -->

<!--   <figure> -->
<!--   <img src="figures/Reactome_Network.png" alt="The Pulpit Rock" width="304" height="228"> -->
<!-- </figure>  -->

---
title: "bioCancer: Interactive Multi-OMICS Cancers Data Visualization and Analysis"
author: "\\ Karim Mezhoud \\
         \\ Nuclear Science Center of Tunisia, Nuclear Safety & Security Department "
date: "`r Sys.Date()`"
output: 
  prettydoc::html_pretty:
    toc: true
    theme: cayman
    highlight: github
  pdf_document:
    toc: true
vignette: >
  %\VignetteIndexEntry{bioCancer: Interactive Multi-OMICS Cancers Data Visualization and Analysis}
  %\VignetteEngine{knitr::rmarkdown}
  %\VignetteEncoding{UTF-8}
---


```{r style, echo=FALSE, results="asis", message=FALSE}
knitr::opts_chunk$set(tidy = FALSE,
                      warning = FALSE,
                      message = FALSE)
```


# bioCancer Package 

bioCancer is a platform-independent interface for dynamic interaction with cancer genomics data. The web is implemented in the R language and based on the Shiny package. It runs on any modern Web browser and requires no programming skills, increasing the accessibility to the huge, complex and heterogeneous cancer genomic data. The data are provided from cBioPortal that contains data from 105 cancer genomics studies. The studies are updated monthly, based on the last TCGA production runs. User can access easily to studies, search in clinical data or by genetic profiles. All data are displayed in table which user can filter, combine, download, visualize and get statistics on it. For more global exploring, zoomable circular layout are available to merge and view around twenty matrices in the same plot. The circular layout makes easy and rapid to identify pertinent multi-assays changes in genes through multiple cancers or studies.
The web page implements multiple methods, to classify genes by study or by disease, to cluster studies by biological process or other ontology annotation. From gene list user can predicts functional interaction network. Nodes and edges can be colored and formatted by omics cancer data. User is free to choose which dimension will be included in network and can set some thresholds to view only significant biological scenario.
The web accepts multiple format of input data that can be included by user to compare/analysis with/without cancer studies. All investigation done by user can be saved in session and can be reloaded later or shared with colleagues. The main R plotting features are available and easy to use. User needs only to chose the type of plot and select variables to be viewed. All generated plot is downloadable with a high resolution.
 bioCancer has dynamic sidebar dashboard that changes and displays functionalities depending on user request. It reduces excessive clicking or false queries. It can be launched in local machine with any system with R installed. All navigating panel are well assisted and documented by examples.
bioCancer is free and open to all users and there is no login requirement.

## Pipeline Overview

![Plot_enrich](figures/overview_methods.png)

## How to run bioCancer
```
library(bioCancer)
bioCancer()
```
# Portal Panel

## Display available Cancer Studies in Table

### Studies Panel

This panel displays in table all available cancer studies hosted and maintained by Memorial Sloan Kettering Cancer Center ([MSKCC](https://www.mskcc.org)). It provides access to data by The Cancer Genome Atlas as well as many carefully curated published data sets. 

Every row lists one study by `Identity`, `name` and `description`.

#### Browse the data

By default only 10 rows of are shown at one time. You can change this setting through the `Show ... entries` dropdown. Press the `Next` and `Previous` buttons at the bottom-right of the screen to navigate through the data.

#### Sort

Click on a column header in the table to sort the data by the values of that variable. Clicking again will toggle between sorting in ascending and descending order. To sort on multiple columns at once press shift and then click on the 2nd, 3rd, etc. column to sort by.

### Filters in Table
The search is possible for numerical or categorical variables. It is possible to match `string` or to use mathematical `operator` to filter data. For more detail see help page in Processing > View panel. 
#### Global Search
the `Filter` box on the left (click the check-box first).
#### Column filter
Every column has its filetr at the column header.

### Download table as csv file
User can download table as csv file. Use the download icon in the top-right of the page.

### Side bar Menu

#### Studies List
The Drop Down Boxes allow user to select one Id by type of data. The first one displays studies by Identity. It means the code listed in the column `cancer_study_id`. The id is simple to decrypte. It is the association of the short name of the cancer followed (\_) by the source of the study.


#### Cases and Genetic Profiles for selected study
When user change the study, automatically the relative cases and genetic profiles are updated.

The ids of cases and genetic profile are composed by cancer\_Source\_TypeOfData.

There are 6 types of data or dimensions: Copy Number Alteration (CNA, gistic), mRNA, Methylation (Met\_HM27, Met\_HM450), Mutation, miRNA, Reverse Phase Protein Activity (RPPA).

#### Gene List Examples

Gene List Example. By default there is one example of gene list (DNA\_damage\_Response). User can load other examples or own gene list in Profiles or Mutation Panels.

## Show Clinical Data in Table

Clinical panel displays informations related to patients as `AGE`, `GENDER` and other variables depending on study and type of cancer. Some variables are shared between studies and others are specific. Each row corresponds to one patient.

### Side bar menu

The Clinical Data is specifuic to each Study. When user change the select Study, the Table of the Clincal Data is automatically updated. The panel is aloso listening DropDown box of Cases.

#### Select variables to show

By default all columns in the data are shown. Click on any variable to focus on it alone. To select several variables use the SHIFT and ARROW keys on your keyboard. On a mac the CMD key can also be used to select multiple variables. The same effect is achieved on windows using the CTRL key. To select all variable use CTRL-A (or CMD-A on mac).

#### Load Clinical Data to Datasets (to Processing Panel)

It is interesting to use clinical variables for further analysis using Processing panel tools.

The `Load ClinicalData` loads the clincal data table to `Datasets` in `Processing` panel. Otherwise, user can make all manipulation tools available in `Processing` panel or in Main Menu Page.

With `clipboard` option, user can copy and paste own table from external file (txt, xls, odt).

## Show Profiles Data in Table

Profiles panel displays informations related to gene list. User needs to specify a `Study`, a `Case`, and a `Genetic Profile` to get the right profile. 

It is more practice to select that have all data (case`_all`) and change only the profile. 

There are in general but not always, 6 types of genetic profiles:
* Copy Number Alteration ([CNA](https://en.wikipedia.org/wiki/Copy-number_variation)).
* mRNA expression ([mRNA](https://en.wikipedia.org/wiki/Gene_expression))
* Mutations ([Mut](https://en.wikipedia.org/wiki/Mutation))
* Methylation ([Met](https://en.wikipedia.org/wiki/DNA_methylation)): There are two probes `HM_27` and `HM_450`
* microRNA expression ([miRNA](https://en.wikipedia.org/wiki/MicroRNA))
* Reverse Phase Protein Array ([RPPA](https://en.wikipedia.org/wiki/Reverse_phase_protein_lysate_microarray))

It is possible to find other kind of data related to one of listed types. For example the `log` or [z_score](https://docs.cbioportal.org/user-guide/faq/#what-are-mrna-and-microrna-z-scores) of mRNA expression.

#### Load Gene List
User can upload gene list examples or upload own gene list.

When user selects `examples` and clic on `Load examples` button, the gene list examples is loaded in DropDown Gene List.

When User selects  `clipboard`, it is possible to copy own gene list from text file (gene symbol by line) and clic on  `Paste Gene List` button. The gene List will be named  `Genes` in DropDown Gene List.

#### Load Profiles to Datasets

It is interesting to get any statistics analysis or transformation with genetic profiles. Any table from `Profiles` panel can be loaded to `Processing` panel by checking `Load Profiles to Datasets` and press the button. The data frame will be named `ProfData`.
# Processing Panel

## Manage data and state: Load data into bioCancer, Save data to disk, Remove a dataset from memory, or Save/Load the full state of the app


### Datasets

When you start bioCancer a dataset (`epiGenomics`) with information on how it was formatted is shown in `Processing` panel.

It is good practice to add a description of the data and variables to each file you use. For the files that are part of bioCancer you will see a brief overview of the variables etc. below the table of the first 10 rows of the data. If you would like to add a description for your own data check the 'Add/edit data description' check-box. A window will open below the data table where you can add text in
<a href="https://pandoc.org/MANUAL.html#pandocs-markdown" target="_blank">markdown</a> format. The descriptions of the data included with bioCancer should serve as a good starting point.

If you would like to rename a dataset loaded in bioCancer check the `Rename data` box, enter a new name for the data, and click the `Rename` button

### Load data

The best way to load and save data for use in bioCancer (and R) is to use the R-data format (rda). These are binary files that can be stored compactly and read into R quickly. Choose `rda` from the `Load data of type` dropdown and click `Choose Files` to locate the file(s) you want to load. If the `rda` file is available online choose `rda (url)` from the dropdown, paste the url into the text input, and press `Load`.

You can get data from a spreadsheet (e.g., Excel or Google sheets) into bioCancer in two ways. First, you can save data from the spreadsheet in csv format and then, in bioCancer, choose `csv` from the `Load data of type` dropdown. Most likely you will have a header row in the csv file with variable names. If the data are not comma separated you can choose semicolon or tab separated. To load a csv file click 'Choose files' and locate the file on your computer. If the `csv` data is available online choose `csv (url)` from the dropdown, paste the url into the text input shown, and press `Load`.

> **Note:** For Windows users with data that contain multibyte characters please make sure your data are in ANSI format so bioCancer can load the characters correctly.

Alternatively, you can select and copy the data in the spreadsheet using CTRL-C (or CMD-C on mac), go to bioCancer, choose `clipboard` from the dropdown, and click the `Paste data` button. This is a short-cut that can be convenient for smaller datasets that are cleanly formatted. If you see a message in bioCancer that the data were not transferred cleanly try saving the data in csv format and loading it into bioCancer as described above.

To access all data files bundled with bioCancer choose `examples` from the `Load data of type` dropdown and click `Load examples`. These files are used to illustrate the various analysis tools accessible in bioCancer. For example, the catalog sales data is used as an example in the help file for regression (i.e., Regression > Linear (OLS)).

### Save data

As mentioned above, the most convenient way to get data in and out of bioCancer is to use the R-data format (rda). Choose `rda` from the `Save data` dropdown and click the `Save data` button to save selected dataset to file.

It is good practice to add a description of the data and variables to each file you use. For the files that are part of bioCancer you will see a brief overview of the variables etc. below the table of the first 10 rows of the data. If you would like to add a description for your own data check the 'Add/edit data description' check-box. A window will open below that data table where you can add text in
<a href="https://pandoc.org/MANUAL.html" target="_blank">markdown</a> format. The descriptions of the data included with bioCancer should serve as a good starting point. When you save the data as an rda file the description you created (or edited) will automatically be added to the file.

Getting data from bioCancer into a spreadsheet can be achieved in two ways. First, you can save data in csv format and load the file into the spreadsheet (i.e., choose `csv` from the `Save data` dropdown and click the `Save data` button). Alternatively, you can copy the data from bioCancer into the clipboard by choosing `clipboard` from the dropdown and clicking the `Copy data` button, open the spreadsheet, and paste the data from bioCancer using CTRL-V (or CMD-V on mac).

### Save and load state

You can save and load the state of the bioCancer app just as you would a data file. The state file (extension rda) will contain (1) the data loaded in bioCancer, (2) settings for the analyses you were working on, (3) and any reports or code from the R-menu. Save the state-file to your hard-disk and when you are ready to continue simply load it by selecting the state radio button and clicking the `Choose file` button.

The best way to save your analyses is to save the state of the app to a file by clicking on the <i title='Save' class='fa fa-save'></i> icon in the navbar and then on `Save state`. Similar functionality is available in `Data > Manage` tab.

This is convenient if you want to save your work to be completed at another time, perhaps on another computer, or to review any assignments you completed using bioCancer. You can also share the file with others that would like to replicate your analyses. As an example, download and then load the state_file [`RadiantState.rda`](https://radiant-rstats.github.io/radiant.data/articles/pkgdown/manage.html). Go to `Data > View`, `Data > Visualize` to see some of the settings loaded from the statefile. There is also a report in `R > Report` created using the Radiant interface. The html file <a href="https://radiant-rstats.github.io/radiant.data/articles/pkgdown/manage.html" target="_blank">`RadiantState.html`</a> contains the output.

A related feature in bioCancer is that state is maintained if you accidentally navigate to another page, close (and reopen) the browser, and/or hit refresh. Use `Reset` in the <i title='Power off' class='fa fa-power-off'></i> menu in the navigation bar to return to a clean/new state.

Loading and saving state also works with Rstudio. If you start bioCancer from Rstudio and use <i title='Power off' class='fa fa-power-off'></i> > `Stop` to stop the app, lists called `r_data` and `r_state` will be put into Rstudio's global workspace. If you start bioCancer again using `bioCancer()` it will use these lists to restore state. This can be convenient if you want to make changes to a data file in Rstudio and load it back into bioCancer. Also, if you load a state file directly into Rstudio it will be used when you start bioCancer to recreate a previous state.

### Remove data from memory

If data are loaded that you no longer need access to in the current session check the `Remove data from memory` box. Then select the data to remove and click the `Remove data` button. One datafile will always remain open.

### Using commands to load and save data

The `loadr` command can be used to load data from a file directly into a bioCancer session and add it to the `Datasets` dropdown. The `saver` command can be used to exact data from bioCancer and save it to disk. Data can be loaded or saved as `rda` or `rds` format depending on the file extension chosen. These commands can be used both inside or without the bioCancer browser interface. See `?loadr` and `?saver` for details.


## Show data in table form

### Datasets

Choose one of the datasets from the `Datasets` dropdown. Files are loaded into bioCancer through the Manage tab.

### Select columns

By default all columns in the data are shown. Click on any variable to focus on it alone. To select several variables use the SHIFT and ARROW keys on your keyboard. On a mac the CMD key can also be used to select multiple variables. The same effect is achieved on windows using the CTRL key. To select all variable use CTRL-A (or CMD-A on mac).

### Browse the data

By default only 10 rows of are shown at one time. You can change this setting through the `Show ... entries` dropdown. Press the `Next` and `Previous` buttons at the bottom-right of the screen to navigate through the data.

### Sort

Click on a column header in the table to sort the data by the values of that variable. Clicking again will toggle between sorting in ascending and descending order. To sort on multiple columns at once press shift and then click on the 2nd, 3rd, etc. column to sort by.

### Filter

There are several ways to select a subset of the data to view. The `Filter` box on the left (click the check-box first) can be used with `>` and `<` signs and you can also combine subset commands. For example, `x > 3 & y == 2` would show only those rows for which the variable `x` has values larger than 3 **and** for which `y` has values equal to 2. Note that in R, and most other programming languages, `=` is used to _assign_ a value and `==` to evaluate if the value of a variable is equal to some other value. In contrast `!=` is used to determine if a variable is _unequal_ to some value. You can also use expressions that have an **or** condition. For example, to select rows where `mutation frequency` is smaller than 20 and larger than 10 use `FreqMut > 10 & FreqMut < 20`. `&` is the symbol for **and**. The table below gives an overview of common operators.


You can also use string matching to select rows. For example, type `grepl("lu", Diseases)` to select rows with `lung` Cancers. This search is case sensitive by default. For case insensitive search you would use `grepl("TCGA", name, ignore.case = TRUE)`. Type your statement in the `Filter`  box and press return to see the result on screen or an error below the box if the expression is invalid.

It is important to note that these filters are _persistent_. A filter entered in one of the Data-tabs will also be applied to other tabs and to any analysis conducted through the bioCancer menus. To deactivate a  filter uncheck the `Filter` check-box. To remove a filter simply erase it.

<table class='table table-condensed table-hover' style='width:60%;'>
 <thead>
  <tr>
   <th style="text-align:left;"> Operator </th>
   <th style="text-align:left;"> Description </th>
   <th style="text-align:left;"> Example </th>
  </tr>
 </thead>
<tbody>
  <tr>
   <td style="text-align:left;"> `<` </td>
   <td style="text-align:left;"> less than </td>
   <td style="text-align:left;"> `price < 5000` </td>
  </tr>
  <tr>
   <td style="text-align:left;"> `<=` </td>
   <td style="text-align:left;"> less than or equal to </td>
   <td style="text-align:left;"> `carat <= 2` </td>
  </tr>
  <tr>
   <td style="text-align:left;"> `>` </td>
   <td style="text-align:left;"> greater than </td>
   <td style="text-align:left;"> `price > 1000` </td>
  </tr>
  <tr>
   <td style="text-align:left;"> `>=` </td>
   <td style="text-align:left;"> greater than or equal to </td>
   <td style="text-align:left;"> `carat >= 2` </td>
  </tr>
  <tr>
   <td style="text-align:left;"> `==` </td>
   <td style="text-align:left;"> exactly equal to </td>
   <td style="text-align:left;"> `cut == 'Fair'` </td>
  </tr>
  <tr>
   <td style="text-align:left;"> `!=` </td>
   <td style="text-align:left;"> not equal to </td>
   <td style="text-align:left;"> `cut != 'Fair'` </td>
  </tr>
  <tr>
   <td style="text-align:left;"> `|` </td>
   <td style="text-align:left;"> x OR y </td>
   <td style="text-align:left;"> `price > 10000 | cut == 'Premium'` </td>
  </tr>
  <tr>
   <td style="text-align:left;"> `&` </td>
   <td style="text-align:left;"> x AND y </td>
   <td style="text-align:left;"> `carat < 2 & cut == 'Fair'` </td>
  </tr>
  <tr>
   <td style="text-align:left;"> `%in%` </td>
   <td style="text-align:left;"> x is one of y </td>
   <td style="text-align:left;"> `cut %in% c('Fair', 'Good')` </td>
  </tr>
</tbody>
</table>

### Column filters and Search

For variables that have a limited number of different values (i.e., a factor) you can select the levels to keep from the column filter below the variable name. For example, to filter on rows with `CNA = -1`  click in the box below the `CNA` column header and select `-1` from the dropdown menu shown. You can also type a string into these column filters followed by return. Note that matching is case-insensitive. In fact, typing `1` would produce the same result because the search will match any part of a string. Similarly, you can type a string to select observations for character variables (e.g., street names).

For numeric variables the column filter boxes have some special features that make them almost as powerful as the `Filter` box. For numerical and integer variables you can use `...` to indicate a range. For example, to select `mRNA` values between 200 and 500  type `200 ... 500` and press return. The range is inclusive of the values typed. Furthermore, if we want to filter on `FreqMut` `20 ...` will show only Studies with mutation frequancy larger than or equal to 20. Numeric variables also have a slider that you can use to define the range of values to keep.

If you want to get _really_ fancy you can use the search box on the top right to search across all columns in the data using **regular expressions**. For example, to find all rows that have an entry in _any_ column ending with the number 72 type `72$` (i.e., the `$` sign is used to indicate the end of an entry). For all rows with entries that start with 60 use `^60` (i.e., the `^` is used to indicate the first character in an entry). Regular expressions are incredibly powerful for search but this is a _big_ topic area. To learn more about regular expressions see this <a href="https://www.regular-expressions.info/tutorial.html" target="_blank">tutorial</a>.

It is important to note that column sorting, column filters, and search are **not** persistent. To store these settings for use in other parts of bioCancer press the `Store` button. You can store the data and settings under a different dataset name by changing the value in the text input to the left of the `Store` button. This feature can also be used to select a subset of variables to keep. Just select the ones you want to keep and press the `Store` button. For more control over the variables you want to keep or remove and to specify their order in the dataset use the `Data > Transform` tab.


## Visualize data

### Filter

Use the `Filter` box to select (or omit) specific sets of rows from the data. See the helpfile for Data > View for details.

### Plot-type

Select the plot type you want. Choose histograms or density for one or more single variable plots. For example, with the `epiGenomics` data loaded select `Histogram` and all (X) variables (use CTRL-a or CMD-a). This will create histograms for all variables in your dataset. Scatter plots are used to visualize the relationship between two variables. Select one or more variables to plot on the Y-axis and one or more variables to plot on the X-axis. Line plots are similar to scatter plots but they connect-the-dots and are particularly useful for time-series data. Bar plots are used to show the relationship between a categorical variable (X-axis) and the average value of a numeric variable (Y-axis). Box-plots are also used when you have a numeric Y-variable and a categorical X-variable. They are more informative than bar charts but also require a bit more effort to evaluate.

### Box plots

The upper and lower "hinges" of the box correspond to the first and third quartiles (the 25th and 75th percentiles) in the data. The middle hinge is the median value of the data. The upper whisker extends from the upper hinge (i.e., the top of the box) to the highest value in the data that is within 1.5 x IQR of the upper hinge. IQR is the inter-quartile range, or distance, between the first and third quartiles. The lower whisker extends from the lower hinge to the lowest value in the data within 1.5 x IQR of the lower hinge. Data beyond the end of the whiskers could be outliers and are plotted as points (as suggested by Tukey).

In sum:
1. The upper whisker extends from Q3 to min(max(data), Q3 + 1.5 x IQR)
2. The lower whisker extends from Q1 to max(min(data), Q1 - 1.5 x IQR)

You may have to read the two bullets above a few times before it sinks in. The plot below should help to explain the structure of the box plot.

![Box-plot](figures/boxplot.png)
[Source](https://en.wikipedia.org/wiki/File:Boxplot_vs_PDF.svg)

### Sub-plots and heat-maps

`Facet row` and `Facet column` can be used to split the data into different groups and create separate plots for each group.

If you select a scatter or line plot a `Color` drop-down will be shown. Selecting a `Color` variable will create a type of heat-map where the colors are linked to the values of the `Color` variable. Selecting a categorical variable from the `Color` dropdown for a line plot will split the data into groups and will show a line of a different color for each group.

### Line, loess, and jitter

To add a linear or non-linear regression line to a scatter plot check the Line and/or Loess boxes. If your data take on a limited number of values checking Jitter can be useful to get a better feel for where most of the data points are located. Jitter-ing simply adds a small random value to each data point so they do not overlap completely in the plot(s).

### Axis scale

The relationship between variables depicted in a scatter plot may be non-linear. There are numerous transformations we might apply to the data so this relationship becomes (approximately) linear (see Data > Transform) and easier to estimate. Perhaps the most common data transformation applied to business data is the (natural) log. To see if a log-linear or log-log transformation may be appropriate for your data check the `Log X` and/or `Log Y` boxes.

By default the scale of the y-axis is the same across sub-plots when using `Facet row`. To allow the y-axis to be specific to each sub-plot click the `Scale-y` check-box.

### Flip axes

To switch the variable on the X- and Y-axis check the `Flip` box.

### Plot height and width

To make plots bigger or smaller adjust the values in the height and width boxes on the bottom left.

### Customizing plots in R > Report

To customize a plot first generate the visualize command by clicking the report (book) icon on the bottom left of your screen. The example below illustrates how to customize a command in the `R > Report` tab. Notice that `custom` is set to `TRUE`.

```r
visualize(dataset = "diamonds", yvar = "price", xvar = "carat", type = "scatter", custom = TRUE) +
  ggtitle("A scatterplot") + xlab("price in $")
```

See the ggplot2 documentation page for available options <a href="https://ggplot2.tidyverse.org/" target="_blank">https://docs.ggplot2.org</a>.

## Create pivot tables to explore your data

If you have used pivot-tables in Excel the functionality provided in the Pivot tab should be familiar to you. Similar to the Explore tab, you can generate summary statistics for variables in your data. You can also easily generate frequency tables. Perhaps the most powerful feature in Pivot is that you can describe the data _by_ one or more other variables.

For example, with the `epiGenomics` data select `Genes`, `Diseases` and `CNA`  from the Categorical variables drop-down. You can drag-and-drop the selected variables to change their order. The categories for the first variable will be the column headers. After selecting these three variables a frequency table of  data with different Diseases and Genes. Choose `Row`, `Column`, or `Total` from the Normalize drop-down to normalize the frequencies by row, column, or overall total. If a normalize option is selected it can be convenient to check the `Percentage` box to express the numbers as percentages. Choose `Color bar` or `Heat map` from the Conditional formatting drop-down to emphasize the highest frequency counts.

It is also possible to summarize numerical variables. Select `FreqMut` from the Numerical variables drop-down. This will create the table shown below. Just as in the View tab you can sort the table by clicking on the column headers. You can also use sliders (e.g., click in the input box below `I1`) to limit the view to values in a specified range. To view only information for `CNA` with `0` or `-1` levels click in the input box below the `CNA` header.

![pivotr table](figures/pivotr.png)

You can also create a bar chart based on the generated table (see image above). To download the table to _csv_ format or the plot to a _png_ format click the download icon on the right.

### Filter

Use the `Filter` box to select (or omit) specific sets of rows from the data. See the help file for Data > View for details.

## Summarize and explore your data

Generate summary statistics for one or more variables in your data. The most powerful feature in Explore is that you can easy describe the data _by_ one or more other variables. Where the _Pivot_ tab works best for frequency tables and to summarize a single numerical variable, the _Explore_ tab allows you to summarize multiple variables at the same time using various statistics.

For example, if we select `Genes` from the `xmRNA` dataset we can see the number of observations (n), the mean, the median, etc. etc.

The created summary table can be stored in bioCancer by clicking the `Store` button. This can be useful if you want to create plots using the summarized data. To download the table to _csv_ format click the download icon on the top-right.

You can select options from `Column variable` dropdown to switch between different column headers. Select either the `functions` (e.g., mean, median, etc), the variables (e.g., Genes), or the levels of the (first) `Group by` variable (e.g., Studies).

![explore table](figures/explore.png)

### Filter

Use the `Filter` box to select (or omit) specific sets of rows from the data. See the helpfile for Data > View for details.

### Transform command log

All transformations applied in the _Data > Transform_ tab can be _logged_. If, for example, you apply a `log` transformation to numeric variables the following code is generated and put in the _Transform command log_ window at the bottom of your screen when you click the `Store` button.

<pre>
## transform variable
r_data[["epiGenomics"]] <- mutate_each(r_data[["epiGenomics"]], funs(log), ext = "_log", mRNA, Met450)
</pre>

This is an important feature if you need to recreate your results at some point in the future or you want to re-run a report with new, but similar, data. Even more important is that there is a record of the steps taken to generate all results.

To add commands contained in the command log window to a report in _R > Report_ click the <i title='Report results' class='fa fa-edit'></i> icon.

### Filter

Filter functionality must be turned off when transforming variables. If a filter is active the transform functions will show a warning message. Either remove the filter statement or un-check the `Filter` check-box. Alternatively, navigate to the Data > View tab and click the `Store` button to store the filtered data and select the newly create dataset. Then return to the Transform tab to make the desired variable changes.

### Type

When you select `Type` from the `Transformation type` drop-down another drop-down menu is shown that will allow you to change the type (or class) of one or more variables. For example, you can change a variable of type integer to a variable of type factor. Click the `Store` button to change variable(s) in the data set. A description of the transformations included in bioCancer is provided below.

1. As factor: convert a variable to type factor (i.e., a categorical variable)
2. As number: convert a variable to type numeric
3. As integer: convert a variable to type integer
4. As character: convert a variable to type character (i.e., strings)
5. As date (mdy): convert a variable to a date if the dates are ordered as month-day-year
6. As date (dmy): convert a variable to a date if the dates are ordered as day-month-year
7. As date (ymd): convert a variable to a date if the dates are ordered as year-month-day
8. As date/time (mdy_hms): convert a variable to a date if the dates are ordered as month-day-year-hour-minute-second
9. As date/time (mdy_hm): convert a variable to a date if the dates are ordered as month-day-year-hour-minute
10. As date/time (dmy\_hms): See mdy\_hms
11. As date/time (dmy\_hm): See mdy\_hm
12. As date/time (ymd\_hms): See mdy\_hms
13. As date/time (ymd\_hm): See mdy\_hm

<!--
14. As time (hms): convert variable to class `period` if the time is organized as hour-minute-second
15. As time (hm): convert variable to class `period` if the time is organized as hour-minute
-->

### Transform

When you select `Transform` from the `Transformation type` drop-down another drop-down menu is shown that will allow you to apply common transformations to one or more variables in the data. For example, to take the (natural) log of a variable select the variable(s) you want to transform and choose `Log` from the `Apply function` drop-down. A new variable is created with the extension specified in the 'Variable name extension` text input (e.g,. `_log`). Make sure to press `return` after changing the extension. Click the `Store` button to add the variable(s) to the data set. A description of the transformation functions included in bioCancer is provided below.

1. Log: create a natural log-transformed version of the selected variable (i.e., log(x) or ln(x))
2. Square: multiply a variable by itself (i.e., x^2 or square(x))
3. Square-root: take the square-root of a variable (i.e., x^.5)
4. Absolute: Absolute value of a variable (i.e., abs(x))
5. Center: create a new variable with a mean of zero (i.e., x - mean(x))
6. Standardize: create a new variable with a mean of zero and standard deviation of one (i.e., (x - mean(x))/sd(x))
7. Invert: 1/x
8. Median split: create a new factor with two levels (Above and Below) that splits the variable values at the median
9. Deciles: create a new factor with 10 levels (deciles) that splits the variable values at the 10th, 20th, ..., 90th percentiles.


### Create

Choose `Create` from the `Transformation type` drop-down. This is the most flexible command to create new or transformed variables. However, it also requires some basic knowledge of R-syntax. A new variable can be any function of other variables in the (active) dataset. Some examples are given below. In each example the name to the left of the `=` sign is the name of the new variable. To the right of the `=` sign you can include other variable names and basic R-functions. After you have typed the command press `return` to create the new variable and press `Store` to add it to the dataset.

1. Create a new variable z that is the difference between variables x and y

	z = x - y

2. Create a new variable z that is a transformation of variable x but with mean equal to zero (note that this transformation is also available in the `Transform` drop-down as `Center`):

	z = x - mean(x)

3. Create a new `logical` variable z that takes on the value TRUE when x > y and FALSE otherwise

	z = x > y

4. Create a new `logical` z that takes on the value TRUE when x is equal to y and FALSE otherwise

	z = x == y

5. Create a variable z that is equal to x lagged by 3 periods

	z = log(x,3)

6. Create a categorical variable with two levels

	z = ifelse(x < y, 'smaller', 'bigger')

7. Create a categorical variable with three levels. An alternative approach would be to use the `Recode` function described below

	z = ifelse(x < 60, '< 60', ifelse(x > 65, '> 65', '60-65'))

8. Convert an outlier to a missing value. For example, if we want to remove the maximum value from a variable called `xmRNA` that is equal to 400 we could use an `ifelse` statement and enter the command below in the `Create` box. Press `return` and `Store` to add the new `xmRNA_rc` variable. Note that if we had entered `xmRNA` on the left-hand side of the `=` sign the original variable would have been overwritten


  xmRNA_rc = ifelse(xmRNA > 400, NA, sales)


9. Similarly, if a respondent with ID 3 provided information in the wrong scale on a survey (e.g., income in \$1s rather than in \$1000s) we could use an `ifelse` statement and enter the command below in the `Create` box. As before, press `return` and `Store` to add the new `sales_rc` variable

	income_rc = ifelse(ID == 3, income/1000, income)

10. If multiple respondents made the same scaling mistake (e.g., those with ID 1, 3, and 15) we again use `Create` and enter:

	income_rc = ifelse(ID %in% c(1, 3, 15), income/1000, income)

11. If you have a date in a format not available through the `Type` menu you can use the `parse_date_time` function. For a date formated as "2-1-14" you would specify the command below (note that this format will also be parsed correctly by the `mdy` function in the `Type` menu)

	date = parse\_date\_time(x, "%m%d%y")

12. Determine the time difference between two dates/times in seconds

	time\_diff = as\_duration(time2 - time1)

13. Extract the month from a date variable

	month = month(date)

14. Other attributes that can be extracted from a date or date-time variable are `minute`, `hour`, `day`, `week`, `quarter`, `year`, `wday` (for weekday). For `wday` and `month` it can be convenient to add `label = TRUE` to the call. For example, to extract the weekday from a date variable and use a label rather than a number

	weekday = wday(date, label = TRUE)

15. Calculating the distance between two locations using lat-long information

	trip\_distance = as_distance(lat1, long1, lat2, long2)

Note: For examples 6, 7, and 14 above you may need to change the new variable to type `factor` before using it for further analysis (see `Type` above)

### Recode

To use the recode feature select the variable you want to change and choose `Recode` from the `Transformation type` drop-down. Provide one or more recode commands, separated by a `;`, and press return to see the newly created variable. Note that you can specify the names for the recoded variable in the `Recoded variable name` input box (press return to submit changes). Finally, click `Store` to add the new variable to the data. Some examples are given below.

1. Values below 20 are set to 'Low' and all others to 'High'

	lo:20 = 'Low'; else = 'High'

2. Values above 20 are set to 'High' and all others to 'Low'

	20:hi = 'High'; else = 'Low'

2. Values 1 through 12 are set to 'A', 13:24 to 'B', and the remainder to 'C'

	1:12 = 'A'; 13:24 = 'B'; else = 'C'

3. Collapse age categories for a cross-tab analysis. In the example below '<25' and '25-34' are recoded to '<35', '35-44' and '35-44' are recoded to '35-54', and '55-64' and '>64' are recoded to '>54'

	'<25' = '<35'; '25-34' = '<35'; '35-44' = '35-54'; '45-54' = '35-54'; '55-64' = '>54'; '>64' = '>54'

4. To exclude a particular value (e.g., an outlier in the data) for subsequent analyses we can recode it to a missing value. For example, if we want to remove the maximum value from a variable called `FreqMut` that is equal to 102 we would (1) select the variable `FreqMut` in the `Select variable(s)` box and enter the command below in the `Recode` box. Press `return` and `Store` to add the recoded variable to the data

	102 = NA

5. To recode specific numeric values (e.g., carat) to a new value (1) select the variable `carat` in the `Select variable(s)` box and enter the command below in the `Recode` box to set the value for carat to 2 in all rows where carat is currently larger than or equal to 2. Press `return` and `Store` to add the recoded variable to the data

	2:hi = 2

**Note:** Never use a `=` symbol in a label when using the recode function (e.g., 50:hi = '>= 50') as this will cause an error.

### Rename

Choose `Rename` from the `Transformation type` drop-down, select one or more variables, and enter new names for them in the rename box shown. Separate each name by a `,`. Press return to see the variables with their new names on screen and press `Store` to alter the variable names in the original data.

### Replace

Choose `Replace` from the `Transformation type` drop-down if you want to replace existing variables in the data with new ones created using, for example, Create, Transform, Clipboard, etc.. Select one or more variables to overwrite and the same number of replacement variables. Press `Store` to alter the data.

### Clipboard

It is possible to manipulate your data in a spreadsheet (e.g., Excel or Google sheets) and copy-and-paste the data back into bioCancer. If you don't have the original data in a spreadsheet already use the clipboard feature in _Data > Manage_ so you can paste it into the spreadsheet or click the download icon on the top right of your screen in the _Data > View_ tab. Apply your transformations in the spreadsheet program and then copy the new variable(s), with a header label, to the clipboard (i.e., CTRL-C on windows and CMD-C on mac). Select `Clipboard` from the `Transformation type` drop-down and paste the new data into the `Paste from spreadsheet` box. It is key that new variable(s) have the same number of observations as the data in bioCancer. To add the new variables to the data click `Store`.

> **Note:** Using the clipboard feature for data transformation is discouraged because it is not reproducible.

### Normalize

Choose `Normalize` from the `Transformation type` drop-down to standardize one or more variables. For example, in the epiGenomics data we may want to express mRNA of a Genes per-FreqMut. Select `FreqMut` as the normalizing variable and `mRNA` in the `Select variable(s)` box. You will see summary statistics for the new variable (e.g., `mRNA_FreqMut`) in the main panel. Store changes by clicking the `Store` button.

### Reorder or remove columns

Choose `Reorder/Remove columns` from the `Transformation type` drop-down. Drag-and-drop variables to reorder them in the data. To remove a variable click the $\times$ next to the label. Press `Store` to commit the changes.

### Reorder or remove levels

If a (single) variable of type `factor` is selected in `Select variable(s)`, choose `Reorder/Remove levels` from the `Transformation type` drop-down to reorder and/or remove levels. Drag-and-drop levels to reorder them or click the $\times$ to remove them. Press `Store` to commit the changes. To temporarily exclude levels from the data use the `Filter` box (see the help file linked in the `Data > View` tab).

### Remove missing values

Choose `Remove missing` from the `Transformation type` drop-down to eliminate rows with one or more missing values. If all variables are selected a row with a missing values in **any** column will be removed. If one or more variables are selected only those rows will be removed with missing values for the selected variables. Press `Store` to change the data. If missing values were present you will see the number of observations in the data summary change (i.e., the value of _n_ changes).

### Remove duplicates

It is common to have one or more variables in a dataset that **should** have only unique values (i.e., no duplicates). Customers id's, for example, should be unique unless the dataset contains multiple orders for the same customer. In that case the combination of customer id **and** order id should be unique. To remove duplicate select one or more variables to determine _uniqueness_. Choose `Remove duplicates` from the `Transformation type` drop-down and check how the summary statistics change. Press `Store` to change the data. If there are duplicate rows you will see the number of observations in the data summary change (i.e., the value of _n_ and _n\_distinct_ will change).

### Show duplicates

If there are duplicates in the data use `Show duplicates` to get a better sense for the data points that have the same value in multiple rows. If you want to explore duplicates using the _View_ tab make sure to `Store` them in a different dataset (i.e., make sure **not** to overwrite the data you are working on). If you choose to show duplicates based on all columns in the data only one of the duplicate rows will be shown. These rows are **exactly** the same so showing 2 or 3 isn't helpful. If, however, we look for duplicates based on a subset of the available variables bioCancer will generate a dataset with **all** rows that are deemed similar.


## Combine two datasets

There are six _join_ (or _merge_) options available in bioCancer from the [dplyr](https://www.rdocumentation.org/packages/dplyr) package developed by Hadley Wickham and Romain Francois on [GitHub](https://github.com/tidyverse/dplyr).

The examples below are adapted from [Cheatsheet for dplyr join functions](https://posit.co/resources/cheatsheets/) by Jenny Bryan and focus on three small datasets, `superheroes`, `publishers`, and `avengers`, to illustrate the different _join_ types and other ways to combine datasets in R and bioCancer. The data is also available in csv format through the links below:

<a href="https://github.com/vnijs/radiant/blob/gh-pages/examples/superheroes.csv" target = "_blank">superheroes.csv</a>

<a href="https://github.com/vnijs/radiant/blob/gh-pages/examples/publishers.csv" target = "_blank">publishers.csv</a>

<a href="https://github.com/vnijs/radiant/blob/gh-pages/examples/avengers.csv" target = "_blank">avengers.csv</a>


<table class='table table-condensed table-hover' style='width:70%;'>
<caption>Superheroes</caption>
 <thead>
  <tr>
   <th style="text-align:left;"> name </th>
   <th style="text-align:left;"> alignment </th>
   <th style="text-align:left;"> gender </th>
   <th style="text-align:left;"> publisher </th>
  </tr>
 </thead>
<tbody>
  <tr>
   <td style="text-align:left;"> Magneto </td>
   <td style="text-align:left;"> bad </td>
   <td style="text-align:left;"> male </td>
   <td style="text-align:left;"> Marvel </td>
  </tr>
  <tr>
   <td style="text-align:left;"> Storm </td>
   <td style="text-align:left;"> good </td>
   <td style="text-align:left;"> female </td>
   <td style="text-align:left;"> Marvel </td>
  </tr>
  <tr>
   <td style="text-align:left;"> Mystique </td>
   <td style="text-align:left;"> bad </td>
   <td style="text-align:left;"> female </td>
   <td style="text-align:left;"> Marvel </td>
  </tr>
  <tr>
   <td style="text-align:left;"> Batman </td>
   <td style="text-align:left;"> good </td>
   <td style="text-align:left;"> male </td>
   <td style="text-align:left;"> DC </td>
  </tr>
  <tr>
   <td style="text-align:left;"> Joker </td>
   <td style="text-align:left;"> bad </td>
   <td style="text-align:left;"> male </td>
   <td style="text-align:left;"> DC </td>
  </tr>
  <tr>
   <td style="text-align:left;"> Catwoman </td>
   <td style="text-align:left;"> bad </td>
   <td style="text-align:left;"> female </td>
   <td style="text-align:left;"> DC </td>
  </tr>
  <tr>
   <td style="text-align:left;"> Hellboy </td>
   <td style="text-align:left;"> good </td>
   <td style="text-align:left;"> male </td>
   <td style="text-align:left;"> Dark Horse Comics </td>
  </tr>
</tbody>
</table>

<table class='table table-condensed table-hover' style='width:30%;'>
<caption>Publishers</caption>
 <thead>
  <tr>
   <th style="text-align:left;"> publisher </th>
   <th style="text-align:left;"> yr_founded </th>
  </tr>
 </thead>
<tbody>
  <tr>
   <td style="text-align:left;"> DC </td>
   <td style="text-align:left;"> 1934 </td>
  </tr>
  <tr>
   <td style="text-align:left;"> Marvel </td>
   <td style="text-align:left;"> 1939 </td>
  </tr>
  <tr>
   <td style="text-align:left;"> Image </td>
   <td style="text-align:left;"> 1992 </td>
  </tr>
</tbody>
</table>

In the screen-shot of the Data > Combine tab below we see the two datasets. The tables share the variable _publisher_ which is automatically selected for the join. Different join options are available from the `Combine type` dropdown. You can also specify a name for the combined dataset in the `Data name` text input box.

![join](figures/join_superheroes_publishers.png)

<br>

### Inner join (superheroes, publishers)

If x = superheroes and y = publishers:
> An inner join returns all rows from x with matching values in y, and all columns from both x and y. If there are multiple matches between x and y, all match combinations are returned.

<table class='table table-condensed table-hover' style='width:70%;'>
 <thead>
  <tr>
   <th style="text-align:left;"> name </th>
   <th style="text-align:left;"> alignment </th>
   <th style="text-align:left;"> gender </th>
   <th style="text-align:left;"> publisher </th>
   <th style="text-align:left;"> yr_founded </th>
  </tr>
 </thead>
<tbody>
  <tr>
   <td style="text-align:left;"> Magneto </td>
   <td style="text-align:left;"> bad </td>
   <td style="text-align:left;"> male </td>
   <td style="text-align:left;"> Marvel </td>
   <td style="text-align:left;"> 1939 </td>
  </tr>
  <tr>
   <td style="text-align:left;"> Storm </td>
   <td style="text-align:left;"> good </td>
   <td style="text-align:left;"> female </td>
   <td style="text-align:left;"> Marvel </td>
   <td style="text-align:left;"> 1939 </td>
  </tr>
  <tr>
   <td style="text-align:left;"> Mystique </td>
   <td style="text-align:left;"> bad </td>
   <td style="text-align:left;"> female </td>
   <td style="text-align:left;"> Marvel </td>
   <td style="text-align:left;"> 1939 </td>
  </tr>
  <tr>
   <td style="text-align:left;"> Batman </td>
   <td style="text-align:left;"> good </td>
   <td style="text-align:left;"> male </td>
   <td style="text-align:left;"> DC </td>
   <td style="text-align:left;"> 1934 </td>
  </tr>
  <tr>
   <td style="text-align:left;"> Joker </td>
   <td style="text-align:left;"> bad </td>
   <td style="text-align:left;"> male </td>
   <td style="text-align:left;"> DC </td>
   <td style="text-align:left;"> 1934 </td>
  </tr>
  <tr>
   <td style="text-align:left;"> Catwoman </td>
   <td style="text-align:left;"> bad </td>
   <td style="text-align:left;"> female </td>
   <td style="text-align:left;"> DC </td>
   <td style="text-align:left;"> 1934 </td>
  </tr>
</tbody>
</table>

In the table above we lose _Hellboy_ because, although this hero does appear in `superheroes`, the publisher (_Dark Horse Comics_) does not appear in `publishers`. The join result has all variables from `superheroes`, plus _yr\_founded_, from `publishers`. We can visualize an inner join with the venn-diagram below:

![inner_join](figures/inner_join.png)

The bioCancer commands are:

```r
# bioCancer
combinedata("superheroes", "publishers", by = "publisher", type = "inner_join")

# R
inner_join(superheroes, publishers, by = "publisher")
```

<br>

### Left join (superheroes, publishers)

> A left join returns all rows from x, and all columns from x and y. If there are multiple matches between x and y, all match combinations are returned.

<table class='table table-condensed table-hover' style='width:70%;'>
 <thead>
  <tr>
   <th style="text-align:left;"> name </th>
   <th style="text-align:left;"> alignment </th>
   <th style="text-align:left;"> gender </th>
   <th style="text-align:left;"> publisher </th>
   <th style="text-align:left;"> yr_founded </th>
  </tr>
 </thead>
<tbody>
  <tr>
   <td style="text-align:left;"> Magneto </td>
   <td style="text-align:left;"> bad </td>
   <td style="text-align:left;"> male </td>
   <td style="text-align:left;"> Marvel </td>
   <td style="text-align:left;"> 1939 </td>
  </tr>
  <tr>
   <td style="text-align:left;"> Storm </td>
   <td style="text-align:left;"> good </td>
   <td style="text-align:left;"> female </td>
   <td style="text-align:left;"> Marvel </td>
   <td style="text-align:left;"> 1939 </td>
  </tr>
  <tr>
   <td style="text-align:left;"> Mystique </td>
   <td style="text-align:left;"> bad </td>
   <td style="text-align:left;"> female </td>
   <td style="text-align:left;"> Marvel </td>
   <td style="text-align:left;"> 1939 </td>
  </tr>
  <tr>
   <td style="text-align:left;"> Batman </td>
   <td style="text-align:left;"> good </td>
   <td style="text-align:left;"> male </td>
   <td style="text-align:left;"> DC </td>
   <td style="text-align:left;"> 1934 </td>
  </tr>
  <tr>
   <td style="text-align:left;"> Joker </td>
   <td style="text-align:left;"> bad </td>
   <td style="text-align:left;"> male </td>
   <td style="text-align:left;"> DC </td>
   <td style="text-align:left;"> 1934 </td>
  </tr>
  <tr>
   <td style="text-align:left;"> Catwoman </td>
   <td style="text-align:left;"> bad </td>
   <td style="text-align:left;"> female </td>
   <td style="text-align:left;"> DC </td>
   <td style="text-align:left;"> 1934 </td>
  </tr>
  <tr>
   <td style="text-align:left;"> Hellboy </td>
   <td style="text-align:left;"> good </td>
   <td style="text-align:left;"> male </td>
   <td style="text-align:left;"> Dark Horse Comics </td>
   <td style="text-align:left;"> NA </td>
  </tr>
</tbody>
</table>

The join result contains `superheroes` with variable `yr_founded` from `publishers`. _Hellboy_, whose publisher does not appear in `publishers`, has an `NA` for _yr_founded_. We can visualize a left join with the venn-diagram below:

![left_join](figures/left_join.png)

The bioCancer commands are:

```r
# bioCancer
combinedata("superheroes", "publishers", by = "publisher", type = "left_join")

# R
left_join(superheroes, publishers, by = "publisher")
```

<br>

### Right join (superheroes, publishers)

> A right join returns all rows from y, and all columns from y and x. If there are multiple matches between y and x, all match combinations are returned.

<table class='table table-condensed table-hover' style='width:70%;'>
 <thead>
  <tr>
   <th style="text-align:left;"> name </th>
   <th style="text-align:left;"> alignment </th>
   <th style="text-align:left;"> gender </th>
   <th style="text-align:left;"> publisher </th>
   <th style="text-align:left;"> yr_founded </th>
  </tr>
 </thead>
<tbody>
  <tr>
   <td style="text-align:left;"> Batman </td>
   <td style="text-align:left;"> good </td>
   <td style="text-align:left;"> male </td>
   <td style="text-align:left;"> DC </td>
   <td style="text-align:left;"> 1934 </td>
  </tr>
  <tr>
   <td style="text-align:left;"> Joker </td>
   <td style="text-align:left;"> bad </td>
   <td style="text-align:left;"> male </td>
   <td style="text-align:left;"> DC </td>
   <td style="text-align:left;"> 1934 </td>
  </tr>
  <tr>
   <td style="text-align:left;"> Catwoman </td>
   <td style="text-align:left;"> bad </td>
   <td style="text-align:left;"> female </td>
   <td style="text-align:left;"> DC </td>
   <td style="text-align:left;"> 1934 </td>
  </tr>
  <tr>
   <td style="text-align:left;"> Magneto </td>
   <td style="text-align:left;"> bad </td>
   <td style="text-align:left;"> male </td>
   <td style="text-align:left;"> Marvel </td>
   <td style="text-align:left;"> 1939 </td>
  </tr>
  <tr>
   <td style="text-align:left;"> Storm </td>
   <td style="text-align:left;"> good </td>
   <td style="text-align:left;"> female </td>
   <td style="text-align:left;"> Marvel </td>
   <td style="text-align:left;"> 1939 </td>
  </tr>
  <tr>
   <td style="text-align:left;"> Mystique </td>
   <td style="text-align:left;"> bad </td>
   <td style="text-align:left;"> female </td>
   <td style="text-align:left;"> Marvel </td>
   <td style="text-align:left;"> 1939 </td>
  </tr>
  <tr>
   <td style="text-align:left;"> NA </td>
   <td style="text-align:left;"> NA </td>
   <td style="text-align:left;"> NA </td>
   <td style="text-align:left;"> Image </td>
   <td style="text-align:left;"> 1992 </td>
  </tr>
</tbody>
</table>

The join result contains all rows and columns from `publishers` and all variables from `superheroes`. We lose _Hellboy_, whose publisher does not appear in `publishers`. _Image_ is retained in the table but has `NA` values for the variables _name_, _alignment_, and _gender_ from `superheroes`. Notice that a join can change both the row and variable order so you should not rely on these in your analysis. We can visualize a right join with the venn-diagram below:

![right_join](figures/right_join.png)

The bioCancer commands are:

```r
# bioCancer
combinedata("superheroes", "publishers", by = "publisher", type = "right_join")

# R
right_join(superheroes, publishers, by = "publisher")
```

<br>

### Full join (superheroes, publishers)

> A full join combines two datasets, keeping rows and columns that appear in either.

<table class='table table-condensed table-hover' style='width:70%;'>
 <thead>
  <tr>
   <th style="text-align:left;"> name </th>
   <th style="text-align:left;"> alignment </th>
   <th style="text-align:left;"> gender </th>
   <th style="text-align:left;"> publisher </th>
   <th style="text-align:left;"> yr_founded </th>
  </tr>
 </thead>
<tbody>
  <tr>
   <td style="text-align:left;"> Magneto </td>
   <td style="text-align:left;"> bad </td>
   <td style="text-align:left;"> male </td>
   <td style="text-align:left;"> Marvel </td>
   <td style="text-align:left;"> 1939 </td>
  </tr>
  <tr>
   <td style="text-align:left;"> Storm </td>
   <td style="text-align:left;"> good </td>
   <td style="text-align:left;"> female </td>
   <td style="text-align:left;"> Marvel </td>
   <td style="text-align:left;"> 1939 </td>
  </tr>
  <tr>
   <td style="text-align:left;"> Mystique </td>
   <td style="text-align:left;"> bad </td>
   <td style="text-align:left;"> female </td>
   <td style="text-align:left;"> Marvel </td>
   <td style="text-align:left;"> 1939 </td>
  </tr>
  <tr>
   <td style="text-align:left;"> Batman </td>
   <td style="text-align:left;"> good </td>
   <td style="text-align:left;"> male </td>
   <td style="text-align:left;"> DC </td>
   <td style="text-align:left;"> 1934 </td>
  </tr>
  <tr>
   <td style="text-align:left;"> Joker </td>
   <td style="text-align:left;"> bad </td>
   <td style="text-align:left;"> male </td>
   <td style="text-align:left;"> DC </td>
   <td style="text-align:left;"> 1934 </td>
  </tr>
  <tr>
   <td style="text-align:left;"> Catwoman </td>
   <td style="text-align:left;"> bad </td>
   <td style="text-align:left;"> female </td>
   <td style="text-align:left;"> DC </td>
   <td style="text-align:left;"> 1934 </td>
  </tr>
  <tr>
   <td style="text-align:left;"> Hellboy </td>
   <td style="text-align:left;"> good </td>
   <td style="text-align:left;"> male </td>
   <td style="text-align:left;"> Dark Horse Comics </td>
   <td style="text-align:left;"> NA </td>
  </tr>
  <tr>
   <td style="text-align:left;"> NA </td>
   <td style="text-align:left;"> NA </td>
   <td style="text-align:left;"> NA </td>
   <td style="text-align:left;"> Image </td>
   <td style="text-align:left;"> 1992 </td>
  </tr>
</tbody>
</table>

In this table we keep _Hellboy_ (even though _Dark Horse Comics_ is not in `publishers`) and _Image_ (even though the publisher is not listed in `superheroes`) and get variables from both datasets. Observations without a match are assigned the value NA for variables from the _other_ dataset. We can visualize a full join with the venn-diagram below:

![full_join](figures/full_join.png)

The bioCancer commands are:

```r
# bioCancer
combinedata("superheroes", "publishers", by = "publisher", type = "full_join")

# R
full_join(superheroes, publishers, by = "publisher")
```

### Semi join (superheroes, publishers)

> A semi join keeps only columns from x. Whereas an inner join will return one row of x for each matching row of y, a semi join will never duplicate rows of x.

<table class='table table-condensed table-hover' style='width:70%;'>
 <thead>
  <tr>
   <th style="text-align:left;"> name </th>
   <th style="text-align:left;"> alignment </th>
   <th style="text-align:left;"> gender </th>
   <th style="text-align:left;"> publisher </th>
  </tr>
 </thead>
<tbody>
  <tr>
   <td style="text-align:left;"> Batman </td>
   <td style="text-align:left;"> good </td>
   <td style="text-align:left;"> male </td>
   <td style="text-align:left;"> DC </td>
  </tr>
  <tr>
   <td style="text-align:left;"> Joker </td>
   <td style="text-align:left;"> bad </td>
   <td style="text-align:left;"> male </td>
   <td style="text-align:left;"> DC </td>
  </tr>
  <tr>
   <td style="text-align:left;"> Catwoman </td>
   <td style="text-align:left;"> bad </td>
   <td style="text-align:left;"> female </td>
   <td style="text-align:left;"> DC </td>
  </tr>
  <tr>
   <td style="text-align:left;"> Magneto </td>
   <td style="text-align:left;"> bad </td>
   <td style="text-align:left;"> male </td>
   <td style="text-align:left;"> Marvel </td>
  </tr>
  <tr>
   <td style="text-align:left;"> Storm </td>
   <td style="text-align:left;"> good </td>
   <td style="text-align:left;"> female </td>
   <td style="text-align:left;"> Marvel </td>
  </tr>
  <tr>
   <td style="text-align:left;"> Mystique </td>
   <td style="text-align:left;"> bad </td>
   <td style="text-align:left;"> female </td>
   <td style="text-align:left;"> Marvel </td>
  </tr>
</tbody>
</table>

We get a similar table as with `inner_join` but it contains only the variables in `superheroes`. The bioCancer commands are:

```r
# bioCancer
combinedata("superheroes", "publishers", by = "publisher", type = "semi_join")

# R
semi_join(superheroes, publishers, by = "publisher")
```

<br>

### Anti join (superheroes, publishers)

> An anti join returns all rows from x without matching values in y, keeping only columns from x

<table class='table table-condensed table-hover' style='width:70%;'>
 <thead>
  <tr>
   <th style="text-align:left;"> name </th>
   <th style="text-align:left;"> alignment </th>
   <th style="text-align:left;"> gender </th>
   <th style="text-align:left;"> publisher </th>
  </tr>
 </thead>
<tbody>
  <tr>
   <td style="text-align:left;"> Hellboy </td>
   <td style="text-align:left;"> good </td>
   <td style="text-align:left;"> male </td>
   <td style="text-align:left;"> Dark Horse Comics </td>
  </tr>
</tbody>
</table>

We now get **only** _Hellboy_, the only superhero not in `publishers` and we do not get the variable _yr\_founded_ either. We can visualize an anti join with the venn-diagram below:

![anti_join](figures/anti_join.png)

<br>

### Dataset order

Note that the order of the datasets selected may matter for a join. If we setup the Data > Combine tab as below the results are as follows:

![join order](figures/join_publishers_superheroes.png)

<br>

### Inner join (publishers, superheroes)

<table class='table table-condensed table-hover' style='width:70%;'>
 <thead>
  <tr>
   <th style="text-align:left;"> publisher </th>
   <th style="text-align:left;"> yr_founded </th>
   <th style="text-align:left;"> name </th>
   <th style="text-align:left;"> alignment </th>
   <th style="text-align:left;"> gender </th>
  </tr>
 </thead>
<tbody>
  <tr>
   <td style="text-align:left;"> DC </td>
   <td style="text-align:left;"> 1934 </td>
   <td style="text-align:left;"> Batman </td>
   <td style="text-align:left;"> good </td>
   <td style="text-align:left;"> male </td>
  </tr>
  <tr>
   <td style="text-align:left;"> DC </td>
   <td style="text-align:left;"> 1934 </td>
   <td style="text-align:left;"> Joker </td>
   <td style="text-align:left;"> bad </td>
   <td style="text-align:left;"> male </td>
  </tr>
  <tr>
   <td style="text-align:left;"> DC </td>
   <td style="text-align:left;"> 1934 </td>
   <td style="text-align:left;"> Catwoman </td>
   <td style="text-align:left;"> bad </td>
   <td style="text-align:left;"> female </td>
  </tr>
  <tr>
   <td style="text-align:left;"> Marvel </td>
   <td style="text-align:left;"> 1939 </td>
   <td style="text-align:left;"> Magneto </td>
   <td style="text-align:left;"> bad </td>
   <td style="text-align:left;"> male </td>
  </tr>
  <tr>
   <td style="text-align:left;"> Marvel </td>
   <td style="text-align:left;"> 1939 </td>
   <td style="text-align:left;"> Storm </td>
   <td style="text-align:left;"> good </td>
   <td style="text-align:left;"> female </td>
  </tr>
  <tr>
   <td style="text-align:left;"> Marvel </td>
   <td style="text-align:left;"> 1939 </td>
   <td style="text-align:left;"> Mystique </td>
   <td style="text-align:left;"> bad </td>
   <td style="text-align:left;"> female </td>
  </tr>
</tbody>
</table>

Every publisher that has a match in `superheroes` appears multiple times, once for each match. Apart from variable and row order, this is the same result we had for the inner join  shown above.

<br>

### Left and Right join (publishers, superheroes)

Apart from row and variable order, a left join of `publishers` and `superheroes` is equivalent to a right join of `superheroes` and `publishers`. Similarly, a right join of `publishers` and `superheroes` is equivalent to a left join of `superheroes` and `publishers`.

<br>

### Full join (publishers, superheroes)

As you might expect, apart from row and variable order, a full join of `publishers` and `superheroes` is equivalent to a full join of `superheroes` and `publishers`.

<br>

### Semi join (publishers, superheroes)

<table class='table table-condensed table-hover' style='width:30%;'>
 <thead>
  <tr>
   <th style="text-align:left;"> publisher </th>
   <th style="text-align:left;"> yr_founded </th>
  </tr>
 </thead>
<tbody>
  <tr>
   <td style="text-align:left;"> Marvel </td>
   <td style="text-align:left;"> 1939 </td>
  </tr>
  <tr>
   <td style="text-align:left;"> DC </td>
   <td style="text-align:left;"> 1934 </td>
  </tr>
</tbody>
</table>

With semi join the effect of switching the dataset order is more clear. Even though there are multiple matches for each publisher only one is shown. Contrast this with an inner join where "If there are multiple matches between x and y, all match combinations are returned." We see that publisher _Image_ is lost in the table because it is not in `superheroes`.

<br>

### Anti join (publishers, superheroes)

<table class='table table-condensed table-hover' style='width:30%;'>
 <thead>
  <tr>
   <th style="text-align:left;"> publisher </th>
   <th style="text-align:left;"> yr_founded </th>
  </tr>
 </thead>
<tbody>
  <tr>
   <td style="text-align:left;"> Image </td>
   <td style="text-align:left;"> 1992 </td>
  </tr>
</tbody>
</table>

Only publisher _Image_ is retained because both _Marvel_ and _DC_ are in `superheroes`. We keep only variables in `publishers`.

<br>

### Additional tools to combine datasets (avengers, superheroes)

When two datasets have the same columns (or rows) there are additional ways in which we can combine them into a new dataset. We have already used the `superheroes` dataset and will now try to combine it with the `avengers` data. These two datasets have the same number of rows and columns and the columns have the same names.

In the screen-shot of the Data > Combine tab below we see the two datasets. There is no need to select variables to combine the datasets here. Any variables in `Select variables` are ignored in the commands below. Again, you can specify a name for the combined dataset in the `Data name` text input box.

![combine](figures/combine_avengers_superheroes.png)

<br>

### Bind rows

<table class='table table-condensed table-hover' style='width:70%;'>
 <thead>
  <tr>
   <th style="text-align:left;"> name </th>
   <th style="text-align:left;"> alignment </th>
   <th style="text-align:left;"> gender </th>
   <th style="text-align:left;"> publisher </th>
  </tr>
 </thead>
<tbody>
  <tr>
   <td style="text-align:left;"> Thor </td>
   <td style="text-align:left;"> good </td>
   <td style="text-align:left;"> male </td>
   <td style="text-align:left;"> Marvel </td>
  </tr>
  <tr>
   <td style="text-align:left;"> Iron Man </td>
   <td style="text-align:left;"> good </td>
   <td style="text-align:left;"> male </td>
   <td style="text-align:left;"> Marvel </td>
  </tr>
  <tr>
   <td style="text-align:left;"> Hulk </td>
   <td style="text-align:left;"> good </td>
   <td style="text-align:left;"> male </td>
   <td style="text-align:left;"> Marvel </td>
  </tr>
  <tr>
   <td style="text-align:left;"> Hawkeye </td>
   <td style="text-align:left;"> good </td>
   <td style="text-align:left;"> male </td>
   <td style="text-align:left;"> Marvel </td>
  </tr>
  <tr>
   <td style="text-align:left;"> Black Widow </td>
   <td style="text-align:left;"> good </td>
   <td style="text-align:left;"> female </td>
   <td style="text-align:left;"> Marvel </td>
  </tr>
  <tr>
   <td style="text-align:left;"> Captain America </td>
   <td style="text-align:left;"> good </td>
   <td style="text-align:left;"> male </td>
   <td style="text-align:left;"> Marvel </td>
  </tr>
  <tr>
   <td style="text-align:left;"> Magneto </td>
   <td style="text-align:left;"> bad </td>
   <td style="text-align:left;"> male </td>
   <td style="text-align:left;"> Marvel </td>
  </tr>
  <tr>
   <td style="text-align:left;"> Magneto </td>
   <td style="text-align:left;"> bad </td>
   <td style="text-align:left;"> male </td>
   <td style="text-align:left;"> Marvel </td>
  </tr>
  <tr>
   <td style="text-align:left;"> Storm </td>
   <td style="text-align:left;"> good </td>
   <td style="text-align:left;"> female </td>
   <td style="text-align:left;"> Marvel </td>
  </tr>
  <tr>
   <td style="text-align:left;"> Mystique </td>
   <td style="text-align:left;"> bad </td>
   <td style="text-align:left;"> female </td>
   <td style="text-align:left;"> Marvel </td>
  </tr>
  <tr>
   <td style="text-align:left;"> Batman </td>
   <td style="text-align:left;"> good </td>
   <td style="text-align:left;"> male </td>
   <td style="text-align:left;"> DC </td>
  </tr>
  <tr>
   <td style="text-align:left;"> Joker </td>
   <td style="text-align:left;"> bad </td>
   <td style="text-align:left;"> male </td>
   <td style="text-align:left;"> DC </td>
  </tr>
  <tr>
   <td style="text-align:left;"> Catwoman </td>
   <td style="text-align:left;"> bad </td>
   <td style="text-align:left;"> female </td>
   <td style="text-align:left;"> DC </td>
  </tr>
  <tr>
   <td style="text-align:left;"> Hellboy </td>
   <td style="text-align:left;"> good </td>
   <td style="text-align:left;"> male </td>
   <td style="text-align:left;"> Dark Horse Comics </td>
  </tr>
</tbody>
</table>

If the `avengers` dataset were meant to extend the list of superheroes we could just stack the two datasets, one below the other. The new datasets has 14 rows and 4 columns. Due to a coding error in the `avengers` dataset (i.e.., _Magneto_ is *not* an _Avenger_) there is a duplicate row in the new combined dataset. Something we probably don't want.

The bioCancer commands are:

```r
# bioCancer
combinedata("avengers", "superheroes", type = "bind_rows")

# R
bind_rows(avengers, superheroes)
```

<br>

### Bind columns

<table class='table table-condensed table-hover' style='width:70%;'>
 <thead>
  <tr>
   <th style="text-align:left;"> name </th>
   <th style="text-align:left;"> alignment </th>
   <th style="text-align:left;"> gender </th>
   <th style="text-align:left;"> publisher </th>
   <th style="text-align:left;"> name </th>
   <th style="text-align:left;"> alignment </th>
   <th style="text-align:left;"> gender </th>
   <th style="text-align:left;"> publisher </th>
  </tr>
 </thead>
<tbody>
  <tr>
   <td style="text-align:left;"> Thor </td>
   <td style="text-align:left;"> good </td>
   <td style="text-align:left;"> male </td>
   <td style="text-align:left;"> Marvel </td>
   <td style="text-align:left;"> Magneto </td>
   <td style="text-align:left;"> bad </td>
   <td style="text-align:left;"> male </td>
   <td style="text-align:left;"> Marvel </td>
  </tr>
  <tr>
   <td style="text-align:left;"> Iron Man </td>
   <td style="text-align:left;"> good </td>
   <td style="text-align:left;"> male </td>
   <td style="text-align:left;"> Marvel </td>
   <td style="text-align:left;"> Storm </td>
   <td style="text-align:left;"> good </td>
   <td style="text-align:left;"> female </td>
   <td style="text-align:left;"> Marvel </td>
  </tr>
  <tr>
   <td style="text-align:left;"> Hulk </td>
   <td style="text-align:left;"> good </td>
   <td style="text-align:left;"> male </td>
   <td style="text-align:left;"> Marvel </td>
   <td style="text-align:left;"> Mystique </td>
   <td style="text-align:left;"> bad </td>
   <td style="text-align:left;"> female </td>
   <td style="text-align:left;"> Marvel </td>
  </tr>
  <tr>
   <td style="text-align:left;"> Hawkeye </td>
   <td style="text-align:left;"> good </td>
   <td style="text-align:left;"> male </td>
   <td style="text-align:left;"> Marvel </td>
   <td style="text-align:left;"> Batman </td>
   <td style="text-align:left;"> good </td>
   <td style="text-align:left;"> male </td>
   <td style="text-align:left;"> DC </td>
  </tr>
  <tr>
   <td style="text-align:left;"> Black Widow </td>
   <td style="text-align:left;"> good </td>
   <td style="text-align:left;"> female </td>
   <td style="text-align:left;"> Marvel </td>
   <td style="text-align:left;"> Joker </td>
   <td style="text-align:left;"> bad </td>
   <td style="text-align:left;"> male </td>
   <td style="text-align:left;"> DC </td>
  </tr>
  <tr>
   <td style="text-align:left;"> Captain America </td>
   <td style="text-align:left;"> good </td>
   <td style="text-align:left;"> male </td>
   <td style="text-align:left;"> Marvel </td>
   <td style="text-align:left;"> Catwoman </td>
   <td style="text-align:left;"> bad </td>
   <td style="text-align:left;"> female </td>
   <td style="text-align:left;"> DC </td>
  </tr>
  <tr>
   <td style="text-align:left;"> Magneto </td>
   <td style="text-align:left;"> bad </td>
   <td style="text-align:left;"> male </td>
   <td style="text-align:left;"> Marvel </td>
   <td style="text-align:left;"> Hellboy </td>
   <td style="text-align:left;"> good </td>
   <td style="text-align:left;"> male </td>
   <td style="text-align:left;"> Dark Horse Comics </td>
  </tr>
</tbody>
</table>

If the dataset had different columns for the same superheroes we could combine the two datasets, side by side. In bioCancer you will see an error message if you try to bind these columns because they have the same name. Something that we should always avoid. The method can be useful if we *know* the order of the row ids of two dataset are the same but the columns are all different.

<br>

### Intersect

<table class='table table-condensed table-hover' style='width:70%;'>
<tbody>
  <tr>

  </tr>
</tbody>
</table>

A good way to check if two datasets with the same columns have duplicate rows is to choose `intersect` from the `Combine type` dropdown. There is indeed one row that is identical in the `avengers` and `superheroes` data (i.e., _Magneto_).

The biCancer commands are the same as shown above, except you will need to replace `bind_rows` by `intersect`.

<br>

### Union

<table class='table table-condensed table-hover' style='width:70%;'>
<tbody>
  <tr>
   <td style="text-align:left;"> Thor </td>
   <td style="text-align:left;"> good </td>
   <td style="text-align:left;"> male </td>
   <td style="text-align:left;"> Marvel </td>
   <td style="text-align:left;"> Magneto </td>
   <td style="text-align:left;"> bad </td>
   <td style="text-align:left;"> male </td>
   <td style="text-align:left;"> Marvel </td>
  </tr>
  <tr>
   <td style="text-align:left;"> Iron Man </td>
   <td style="text-align:left;"> good </td>
   <td style="text-align:left;"> male </td>
   <td style="text-align:left;"> Marvel </td>
   <td style="text-align:left;"> Storm </td>
   <td style="text-align:left;"> good </td>
   <td style="text-align:left;"> female </td>
   <td style="text-align:left;"> Marvel </td>
  </tr>
  <tr>
   <td style="text-align:left;"> Hulk </td>
   <td style="text-align:left;"> good </td>
   <td style="text-align:left;"> male </td>
   <td style="text-align:left;"> Marvel </td>
   <td style="text-align:left;"> Mystique </td>
   <td style="text-align:left;"> bad </td>
   <td style="text-align:left;"> female </td>
   <td style="text-align:left;"> Marvel </td>
  </tr>
  <tr>
   <td style="text-align:left;"> Hawkeye </td>
   <td style="text-align:left;"> good </td>
   <td style="text-align:left;"> male </td>
   <td style="text-align:left;"> Marvel </td>
   <td style="text-align:left;"> Batman </td>
   <td style="text-align:left;"> good </td>
   <td style="text-align:left;"> male </td>
   <td style="text-align:left;"> DC </td>
  </tr>
  <tr>
   <td style="text-align:left;"> Black Widow </td>
   <td style="text-align:left;"> good </td>
   <td style="text-align:left;"> female </td>
   <td style="text-align:left;"> Marvel </td>
   <td style="text-align:left;"> Joker </td>
   <td style="text-align:left;"> bad </td>
   <td style="text-align:left;"> male </td>
   <td style="text-align:left;"> DC </td>
  </tr>
  <tr>
   <td style="text-align:left;"> Captain America </td>
   <td style="text-align:left;"> good </td>
   <td style="text-align:left;"> male </td>
   <td style="text-align:left;"> Marvel </td>
   <td style="text-align:left;"> Catwoman </td>
   <td style="text-align:left;"> bad </td>
   <td style="text-align:left;"> female </td>
   <td style="text-align:left;"> DC </td>
  </tr>
  <tr>
   <td style="text-align:left;"> Magneto </td>
   <td style="text-align:left;"> bad </td>
   <td style="text-align:left;"> male </td>
   <td style="text-align:left;"> Marvel </td>
   <td style="text-align:left;"> Hellboy </td>
   <td style="text-align:left;"> good </td>
   <td style="text-align:left;"> male </td>
   <td style="text-align:left;"> Dark Horse Comics </td>
  </tr>
</tbody>
</table>

A `union` of `avengers` and `superheroes` will combine the datasets but will omit duplicate rows (i.e., it will keep only one _copy_ of the row for _Magneto_). Likely what we want here.

The bioCancer commands are the same as shown above, except you will need to replace `bind_rows` by `union`.

<br>

### Setdiff

<table class='table table-condensed table-hover' style='width:70%;'>
 <thead>
  <tr>
   <th style="text-align:left;"> name </th>
   <th style="text-align:left;"> alignment </th>
   <th style="text-align:left;"> gender </th>
   <th style="text-align:left;"> publisher </th>
  </tr>
 </thead>
<tbody>
  <tr>
   <td style="text-align:left;"> Thor </td>
   <td style="text-align:left;"> good </td>
   <td style="text-align:left;"> male </td>
   <td style="text-align:left;"> Marvel </td>
  </tr>
  <tr>
   <td style="text-align:left;"> Iron Man </td>
   <td style="text-align:left;"> good </td>
   <td style="text-align:left;"> male </td>
   <td style="text-align:left;"> Marvel </td>
  </tr>
  <tr>
   <td style="text-align:left;"> Hulk </td>
   <td style="text-align:left;"> good </td>
   <td style="text-align:left;"> male </td>
   <td style="text-align:left;"> Marvel </td>
  </tr>
  <tr>
   <td style="text-align:left;"> Hawkeye </td>
   <td style="text-align:left;"> good </td>
   <td style="text-align:left;"> male </td>
   <td style="text-align:left;"> Marvel </td>
  </tr>
  <tr>
   <td style="text-align:left;"> Black Widow </td>
   <td style="text-align:left;"> good </td>
   <td style="text-align:left;"> female </td>
   <td style="text-align:left;"> Marvel </td>
  </tr>
  <tr>
   <td style="text-align:left;"> Captain America </td>
   <td style="text-align:left;"> good </td>
   <td style="text-align:left;"> male </td>
   <td style="text-align:left;"> Marvel </td>
  </tr>
  <tr>
   <td style="text-align:left;"> Magneto </td>
   <td style="text-align:left;"> bad </td>
   <td style="text-align:left;"> male </td>
   <td style="text-align:left;"> Marvel </td>
  </tr>
</tbody>
</table>

Finally, a `setdiff` will keep rows from `avengers` that are not in `superheroes`. If we reverse the inputs (i.e., choose `superheroes` from the `Datasets` dropdown and `superheroes` from the `Combine with` dropdown) we will end up with all rows from `superheroes` that are not in `avengers`. In both cases the entry for _Magneto_ will be omitted.

The bioCancer commands are the same as shown above, except you will need to replace `bind_rows` by `setdiff`.

<br>

--------
For additional discussion see <https://dplyr.tidyverse.org/articles/two-table.html>

# Enrichment Panel

## Show multi-Omics Data in Circular Layout

The world `Circomics` comes from the association between `Circos` and `Omics`.

[Circos](http://circos.ca/) is a package for visualizing data and information with circular layouts. User can visualize multiple matrices of [Omics](https://en.wikipedia.org/wiki/Omics) data at the same time and makes easy the exploring of relationships between dimensions using coloring sectors.

This function uses [CoffeeWheel](https://github.com/armish/coffeewheel) package developped by Dr. ARman Aksoy.

#### Studies in Wheel
User needs to:
* Choice in which Studies is interested.
* Visualize the availability of dimensions by checking `Availability`. 
+ The output is a table with Yes/No availability.
* Load Omics data for selected Studies by checking `Load`. The output is a list of loaded dimensions for selected Studies.

When Profiles Data are loaded, the button `Load Profiles in Datasets` appears. It uploads all Profiles Data to `Processing` panel for more exploring or analysis.


`Legend` checkbox displays the meaning of the color palette.

#### Load Profiles in Datasets

For every dimension, the tables are merged by study and saved as: `xCNA`, `xMetHM27`, `xMetHM450`, `xmiRNA`, `xmRNA`, `xMut`, `xRPPA` in Datasets (Processing panel).

## Genes / Diseases / Pathways Classification and clustering

### Classification
The classifier uses `geNetClassifier` methods [1] to classify genes by disease based only on gene expression (mRNA). The approach is implemented in an R package, named [geNetClassifier](https://bioconductor.org/packages/release/bioc/html/geNetClassifier.html), available as an open access tool in [Bioconductor](https://bioconductor.org/).
All proccess are resumed into 5 steps:
* Select Studies
* get sample size by  `processing` > `Samples` 
* Set the sample size and the posterior probability
* Select one `Case` and one `Genetic Profile` for every study. **Respect the order of studies**. it is recommanded to use `_v2_mrna` for all genetic profiles.
* Run classifier by `processing` > `Classifier`

The ranking is built by ordering the genes decreasingly by their pos- terior probability for each study (class). Each gene is assigned to a class in which has the best ranking. As a result of this process, even if a gene is found associated to several classes during the expression analysis, each gene can only be on the ranking of one class [1]. 
The resulting output is a table (Table 1) that associates genes to study and displays `PostProb` and gene expression sign `exprsUpDw`.  The `exprsMeanDiff` value is the expression difference between the mean for each gene in the given class and the mean in the closest class.

**Table1: Ranking Genes by Study**
![Classifier table](figures/Classifier_Table.png)

### Plot Clusters

#### Gene Diseases Association
`GeneList/Diseases` predicts Wich disease are involving your GeneList. It uses annotations from [DisGeNET](https://www.disgenet.org/) [2] and Methods from [clusterProfiler](https://bioconductor.org/packages/release/bioc/html/clusterProfiler.html) package [3].  

The `GeneList/Diseases` association uses gene list as input. The assess of this prediction is based on two parameters:
* The number of genes that are involving in the disease (x-axis)
* The P-value of this association (color). 
In the following example,  there are two annotation related to Breast cancer which  involve more than 130 genes and has small P-Value.

**Figure 1: Genes / Diseases Association**
![Plot_enrich](figures/Plot_enrich.png)

The `Diseases Onthology` uses genes/Study groups computed by `Classifier` (Table 1).
The dotplot position indicates wish Diseases are annotated for genes/study [4].
The dot size indicates the ratio of genes involved in the disease for the same genes groups (lihc_tcga has 2/3 genes involved for the 4 disease). The color indicates the P-Value.

**Figure 2: Diseases Onthology**
![DO](figures/compareClusterDO.png) 

The same process is possible with Gene Onthology (GO) and KEGG.

**Figure 3: GO Pathway Enrishment**
![GO](figures/compareClusterGO.png) 

**Figure 4: KEGG Pathway Enrishment **
![KEGG](figures/compareClusterKEGG.png) 


## Function Interaction Network Enrichment

### Edges Attributes

#### Function Interactions (FIs) Type

Arrowhead | Reaction | Arrowhead | Reaction 
------------- | -------- | -------- | ------------
-> | activate, express, regulate  | -\| | inhibit
diamond -<>  | complexe |curve | catalyze, reaction
  point -o| phosphorylate | -- | binding, input, compound
 -< | dissociation | .... | predicted, indirect,ubiquitinated

#### Use Linkers
 Picks up as few as possible of linkers that can connect input genes together. For example, if the algorithm finds one gene can link all input genes together, it will not try other genes (not from gene list) that may be used as a linker.
 
 The linker gene hes box format. 
 
#### Layouts 
 
##### dot
 The dot engine flows the directed graph in the direction of rank (i.e., downstream nodes of the same rank are aligned). By default, the direction is from top to bottom 
##### twopi
 The twopi engine provides radial layouts. Nodes are placed on concentric circles depending their distance from a given root node.
 
##### neato
 The neato engine provides spring model layouts. This is a suitable engine if the graph is not too large (less than 100 nodes) and you don't know anything else about it. The neato engine attempts to minimize a global energy function, which is equivalent to statistical multi-dimensional scaling. 
 
##### circo
The circo engine provide circular layouts. This is suitable for certain diagrams of multiple cyclic structures, such as certain telecommunications networks.

### Nodes Attributes

#### From ReactomeFI
The size of node is related to the number of inetractions. If node has multiple interaction, it will has bigger size than node with few interaction. Otherwise, i will be easier to locate important gene in the network. 

#### From Classifier

##### mRNA
Attribute node color using `exprsMeanDiff` values from `Classifier` panel.

##### Studies
Link study to associated genes from `Classifier` table.


#### From Profiles Data

User needs to
* Select studies (`From Which Studies`)
* Load profiles data (`Load`). 
* Select Profiles Data
* Set threshold from Sliders 

#### Legend
![Reactome Legend](figures/ReactomeLegend.png)

### Interpretation

![Reactome Network](figures/Reactome_Network.png)



#### References
[1] Aibar S, Fontanillo C, Droste C, Roson-Burgo B, Campos-Laborie F, Hernandez-Rivas J and De Las Rivas J (2015). “Analyse multiple disease subtypes and build associated gene networks using genome-wide expression profiles.” BMC Genomics, 16(Suppl 5:S3). https://dx.doi.org/10.1186/1471-2164-16-S5-S3.

[2] Piñero, J., Queralt-Rosinach, N., Bravo, A., Deu-Pons, J., Bauer-Mehren, A., Baron, M., Ferran Sanz, and Furlong, L. I. (2015). DisGeNET: a discovery platform for the dynamical exploration of human diseases and their genes. Database: The Journal of Biological Databases and Curation, 2015, bav028. https://doi.org/10.1093/database/bav028

[3] Yu G, Wang L, Han Y and He Q (2012). “clusterProfiler: an R package for comparing biological themes among gene clusters.” OMICS: A Journal of Integrative Biology, 16(5), pp. 284-287. https://dx.doi.org/10.1089/omi.2011.0118. 

[4] Yu G, Wang L, Yan G and He Q (2015). “DOSE: an R/Bioconductor package for Disease Ontology Semantic and Enrichment analysis.” Bioinformatics, 31(4), pp. 608-609. https://dx.doi.org/10.1093/bioinformatics/btu684, https://bioinformatics.oxfordjournals.org/content/31/4/608. 

> Visualize data

### Filter

Use the `Filter` box to select (or omit) specific sets of rows from the data. See the helpfile for Data > View for details.

### Plot-type

Select the plot type you want. Choose histograms or density for one or more single variable plots. For example, with the `epiGenomics` data loaded select `Histogram` and all (X) variables (use CTRL-a or CMD-a). This will create histograms for all variables in your dataset. Scatter plots are used to visualize the relationship between two variables. Select one or more variables to plot on the Y-axis and one or more variables to plot on the X-axis. Line plots are similar to scatter plots but they connect-the-dots and are particularly useful for time-series data. Bar plots are used to show the relationship between a categorical variable (X-axis) and the average value of a numeric variable (Y-axis). Box-plots are also used when you have a numeric Y-variable and a categorical X-variable. They are more informative than bar charts but also require a bit more effort to evaluate.

### Box plots

The upper and lower "hinges" of the box correspond to the first and third quartiles (the 25th and 75th percentiles) in the data. The middle hinge is the median value of the data. The upper whisker extends from the upper hinge (i.e., the top of the box) to the highest value in the data that is within 1.5 x IQR of the upper hinge. IQR is the inter-quartile range, or distance, between the first and third quartiles. The lower whisker extends from the lower hinge to the lowest value in the data within 1.5 x IQR of the lower hinge. Data beyond the end of the whiskers could be outliers and are plotted as points (as suggested by Tukey).

In sum:
1. The upper whisker extends from Q3 to min(max(data), Q3 + 1.5 x IQR)
2. The lower whisker extends from Q1 to max(min(data), Q1 - 1.5 x IQR)

You may have to read the two bullets above a few times before it sinks in. The plot below should help to explain the structure of the box plot.

![Box-plot](figures/boxplot.png)
[Source](http://en.wikipedia.org/wiki/File:Boxplot_vs_PDF.svg)

### Sub-plots and heat-maps

`Facet row` and `Facet column` can be used to split the data into different groups and create separate plots for each group.

If you select a scatter or line plot a `Color` drop-down will be shown. Selecting a `Color` variable will create a type of heat-map where the colors are linked to the values of the `Color` variable. Selecting a categorical variable from the `Color` dropdown for a line plot will split the data into groups and will show a line of a different color for each group.

### Line, loess, and jitter

To add a linear or non-linear regression line to a scatter plot check the Line and/or Loess boxes. If your data take on a limited number of values checking Jitter can be useful to get a better feel for where most of the data points are located. Jitter-ing simply adds a small random value to each data point so they do not overlap completely in the plot(s).

### Axis scale

The relationship between variables depicted in a scatter plot may be non-linear. There are numerous transformations we might apply to the data so this relationship becomes (approximately) linear (see Data > Transform) and easier to estimate. Perhaps the most common data transformation applied to business data is the (natural) log. To see if a log-linear or log-log transformation may be appropriate for your data check the `Log X` and/or `Log Y` boxes.

By default the scale of the y-axis is the same across sub-plots when using `Facet row`. To allow the y-axis to be specific to each sub-plot click the `Scale-y` check-box.

### Flip axes

To switch the variable on the X- and Y-axis check the `Flip` box.

### Plot height and width

To make plots bigger or smaller adjust the values in the height and width boxes on the bottom left.

### Customizing plots in R > Report

To customize a plot first generate the `visualize` command by clicking the report icon on the bottom left of your screen. The example below illustrates how to customize a command in the `R > Report` tab. Notice that `custom` is set to `TRUE`.

```r
visualize(dataset = "epiGenomics", yvar = "mRNA", xvar = "Diseases", type = "scatter", custom = TRUE) +
  ggtitle("A scatterplot") + xlab("Diseases $")
```

**Some common commands:**

* Add a title: `+ ggtitle("my title")`
* Change label: `+ xlab("my X-axis label")` or `+ ylab("my X-axis label")`
* Remove legend: `+ theme(legend.position = "none")`
* Change legend title: `+ guides(color = guide_legend(title = "New title"))` or `+ guides(fill = guide_legend(title = "New title"))`
* Rotate tick labels: `+ theme(axis.text.x = element_text(angle = 90, hjust = 1))`
* Set plot limits: `+ ylim(15, 20)` or `+ xlim("VS1","VS2")`

See the ggplot2 documentation page for additional options <a href="http://docs.ggplot2.org/" target="_blank">http://docs.ggplot2.org</a>.

> Show Profiles Data in Table

Profiles panel displays informations related to gene list. User needs to specify a `Study`, a `Case`, and a `Genetic Profile` to get the right profile. 

It is more practice to select that have all data (case`_all`) and change only the profile. 

There are in general but not always, 6 types of genetic profiles:
* Copy Number Alteration ([CNA](https://en.wikipedia.org/wiki/Copy-number_variation)).
* mRNA expression ([mRNA](https://en.wikipedia.org/wiki/Gene_expression))
* Mutations ([Mut](https://en.wikipedia.org/wiki/Mutation))
* Methylation ([Met](https://en.wikipedia.org/wiki/DNA_methylation)): There are two probes `HM_27` and `HM_450`
* microRNA expression ([miRNA](https://en.wikipedia.org/wiki/MicroRNA))
* Reverse Phase Protein Array ([RPPA](https://en.wikipedia.org/wiki/Reverse_phase_protein_lysate_microarray))

It is possible to find other kind of data related to one of listed types. For example the `log` or [z_score](http://www.cbioportal.org/faq.jsp#what-are-mrna-and-microrna-z-scores) of mRNA expression.

#### Load Gene List
User can upload gene list examples or upload own gene list.

When user selects `examples` and clic on `Load examples` button, the gene list examples is loaded in DropDown Gene List.

When User selects  `clipboard`, it is possible to copy own gene list from text file (gene symbol by line) and clic on  `Paste Gene List` button. The gene List will be named  `Genes` in DropDown Gene List.

#### Load Profiles to Datasets

It is interesting to get any statistics analysis or transformation with genetic profiles. Any table from `Profiles` panel can be loaded to `Processing` panel by checking `Load Profiles to Datasets` and press the button. The data frame will be named `ProfData`.

> Summarize and explore your data


<a href="https://github.com/radiant-rstats/radiant.data/blob/master/data/diamonds.rda" target = "_blank">diamonds.rda</a>


Generate summary statistics for one or more variables in your data. The most powerful feature in Explore is that you can easy describe the data _by_ one or more other variables. Where the _Pivot_ tab works best for frequency tables and to summarize a single numerical variable, the _Explore_ tab allows you to summarize multiple variables at the same time using various statistics.

For example, if we select `Genes` from the `xmRNA` dataset we can see the number of observations (n), the mean, the median, etc. etc.

The created summary table can be stored in bioCancer by clicking the `Store` button. This can be useful if you want to create plots using the summarized data. To download the table to _csv_ format click the download icon on the top-right.

You can select options from `Column variable` dropdown to switch between different column headers. Select either the `functions` (e.g., mean, median, etc), the variables (e.g., Genes), or the levels of the (first) `Group by` variable (e.g., Studies).

![explore table](figures/explore.png)

### Filter

Use the `Filter` box to select (or omit) specific sets of rows from the data. See the helpfile for Data > View for details.

> Create pivot tables to explore your data

If you have used pivot-tables in Excel the functionality provided in the Pivot tab should be familiar to you. Similar to the Explore tab, you can generate summary statistics for variables in your data. You can also easily generate frequency tables. Perhaps the most powerful feature in Pivot is that you can describe the data _by_ one or more other variables.

For example, with the `epiGenomics` data select `Genes`, `Diseases` and `CNA`  from the Categorical variables drop-down. You can drag-and-drop the selected variables to change their order. The categories for the first variable will be the column headers. After selecting these three variables a frequency table of  data with different Diseases and Genes. Choose `Row`, `Column`, or `Total` from the Normalize drop-down to normalize the frequencies by row, column, or overall total. If a normalize option is selected it can be convenient to check the `Percentage` box to express the numbers as percentages. Choose `Color bar` or `Heat map` from the Conditional formatting drop-down to emphasize the highest frequency counts.

It is also possible to summarize numerical variables. Select `FreqMut` from the Numerical variables drop-down. This will create the table shown below. Just as in the View tab you can sort the table by clicking on the column headers. You can also use sliders (e.g., click in the input box below `I1`) to limit the view to values in a specified range. To view only information for `CNA` with `0` or `-1` levels click in the input box below the `CNA` header.

![pivotr table](figures/pivotr.png)

You can also create a bar chart based on the generated table (see image above). To download the table to _csv_ format or the plot to a _png_ format click the download icon on the right.

### Filter

Use the `Filter` box to select (or omit) specific sets of rows from the data. See the help file for Data > View for details.

### Transform command log

All transformations applied in the _Tools > Transform_ tab can be _logged_. If, for example, you apply a `log` transformation to numeric variables the following code is generated and put in the _Transform command log_ window at the bottom of your screen when you click the `Store` button.

<pre>
## transform variable
r_data[["epiGenomics"]] <- mutate_each(r_data[["epiGenomics"]], funs(log), ext = "_log", mRNA, Met450)
</pre>

This is an important feature if you need to recreate your results or you want to re-run a report with new, but similar, data. Even more important is that there is a record of the steps taken to generate all results.

To add commands contained in the command log window to a report in _R > Report_ click the <i title='Report results' class='fa fa-edit'></i> icon.

### Filter

If a filter has been specified it will be ignored for (most) functions available in _Tools > Transform_. To create a new dataset based on a filter navigate to the _Workspace > View_ tab and click the `Store` button. Alternatively, create new dataset based on a Filter select `Holdout sample` from the `Transformation type` dropdown.

### Type

When you select `Type` from the `Transformation type` drop-down another drop-down menu is shown that will allow you to change the type (or class) of one or more variables. For example, you can change a variable of type integer to a variable of type factor. Click the `Store` button to change variable(s) in the data set. A description of the transformations included in bioCancer is provided below.

1. As factor: convert a variable to type factor (i.e., a categorical variable)
2. As number: convert a variable to type numeric
3. As integer: convert a variable to type integer
4. As character: convert a variable to type character (i.e., strings)
5. As date (mdy): convert a variable to a date if the dates are ordered as month-day-year
6. As date (dmy): convert a variable to a date if the dates are ordered as day-month-year
7. As date (ymd): convert a variable to a date if the dates are ordered as year-month-day
8. As date/time (mdy_hms): convert a variable to a date if the dates are ordered as month-day-year-hour-minute-second
9. As date/time (mdy_hm): convert a variable to a date if the dates are ordered as month-day-year-hour-minute
10. As date/time (dmy\_hms): See mdy\_hms
11. As date/time (dmy\_hm): See mdy\_hm
12. As date/time (ymd\_hms): See mdy\_hms
13. As date/time (ymd\_hm): See mdy\_hm

<!--
14. As time (hms): convert variable to class `period` if the time is organized as hour-minute-second
15. As time (hm): convert variable to class `period` if the time is organized as hour-minute
-->

### Transform

When you select `Transform` from the `Transformation type` drop-down another drop-down menu is shown that will allow you to apply common transformations to one or more variables in the data. For example, to take the (natural) log of a variable select the variable(s) you want to transform and choose `Log` from the `Apply function` drop-down. A new variable is created with the extension specified in the 'Variable name extension` text input (e.g,. `_log`). Make sure to press `return` after changing the extension. Click the `Store` button to add the variable(s) to the data set. A description of the transformation functions included in bioCancer is provided below.

1. Ln: create a natural log-transformed version of the selected variable (i.e., log(x) or ln(x))
2. Square: multiply a variable by itself (i.e., x^2 or square(x))
3. Square-root: take the square-root of a variable (i.e., x^.5)
4. Absolute: Absolute value of a variable (i.e., abs(x))
5. Center: create a new variable with a mean of zero (i.e., x - mean(x))
6. Standardize: create a new variable with a mean of zero and standard deviation of one (i.e., (x - mean(x))/sd(x))
7. Invert: 1/x
8. Median split: create a new factor with two levels (Above and Below) that splits the variable values at the median
9. Deciles: create a new factor with 10 levels (deciles) that splits the variable values at the 10th, 20th, ..., 90th percentiles.

### Create

Choose `Create` from the `Transformation type` drop-down. This is the most flexible command to create new or transformed variables. However, it also requires some basic knowledge of R-syntax. A new variable can be any function of other variables in the (active) dataset. Some examples are given below. In each example the name to the left of the `=` sign is the name of the new variable. To the right of the `=` sign you can include other variable names and basic R-functions. After you type the command press `return` to create the new variable. If the result is as expected press `Store` to add it to the dataset.

**Note:** If one or more variables is selected from the list in `Select variables` they will be used to group the data before creating the new variable (see example 1. below). If this is not the intended result make sure that no variables are selected when creating the new variable

1. Create a new variable p that is equal to the mean of price. To calculate the mean of price per group (e.g., per level of clarity) simply select clarity from the `Select variables` list

	z = mean(x)

2. Create a new variable z that is the difference between variables x and y

	z = x - y

3. Create a new variable z that is a transformation of variable x but with mean equal to zero (note that this transformation is also available in the `Transform` drop-down as `Center`):

	z = x - mean(x)

4. Create a new `logical` variable z that takes on the value TRUE when x > y and FALSE otherwise

	z = x > y

5. Create a new `logical` z that takes on the value TRUE when x is equal to y and FALSE otherwise

	z = x == y

6. Create a variable z that is equal to x lagged by 3 periods

	z = lag(x,3)

7. Create a categorical variable with two levels

	z = ifelse(x < y, 'smaller', 'bigger')

8. Create a categorical variable with three levels. An alternative approach would be to use the `Recode` function described below

	z = ifelse(x < 60, '< 60', ifelse(x > 65, '> 65', '60-65'))

9. Convert an outlier to a missing value. For example, if we want to remove the maximum value from a variable called `xmRNA` that is equal to 400 we could use an `ifelse` statement and enter the command below in the `Create` box. Press `return` and `Store` to add the new `xmRNA_rc` variable. Note that if we had entered `xmTNA` on the left-hand side of the `=` sign the original variable would have been overwritten

  xmRNA_rc = ifelse(xmRNA > 400, NA, sales)



10. Similarly, if a respondent with ID 3 provided information in the wrong scale on a survey (e.g., income in \$1s rather than in \$1000s) we could use an `ifelse` statement and enter the command below in the `Create` box. As before, press `return` and `Store` to add the new `sales_rc` variable

	income_rc = ifelse(ID == 3, income/1000, income)

11. If multiple respondents made the same scaling mistake (e.g., those with ID 1, 3, and 15) we again use `Create` and enter:

	income_rc = ifelse(ID %in% c(1, 3, 15), income/1000, income)

12. If you have a date in a format not available through the `Type` menu you can use the `parse_date_time` function. For a date formated as "2-1-14" you would specify the command below (note that this format will also be parsed correctly by the `mdy` function in the `Type` menu)

	date = parse\_date\_time(x, "%m%d%y")

13. Determine the time difference between two dates/times in seconds

	time\_diff = as\_duration(time2 - time1)

14. Extract the month from a date variable

	month = month(date)

15. Other attributes that can be extracted from a date or date-time variable are `minute`, `hour`, `day`, `week`, `quarter`, `year`, `wday` (for weekday). For `wday` and `month` it can be convenient to add `label = TRUE` to the call. For example, to extract the weekday from a date variable and use a label rather than a number

	weekday = wday(date, label = TRUE)

16. Calculate the distance between two locations using lat-long information

	trip\_distance = as_distance(lat1, long1, lat2, long2)

17. Calculate quintiles for a variable `recency` by using the `xtile` command as shown below. To create deciles replace "5" by "10".

	rec\_iq = xtile(recency, 5)

Note: For examples 7, 8, and 15 above you may need to change the new variable to type `factor` before using it for further analysis (see `Type` above)

## Bin

The `Bin` option is a convenience function for the `xtile` command mentioned above when you want to create multiple quitile/decile/... variables. To calculate quintiles enter "5" as the `Nr bins`. The `reverse` option replaces 1 by 5, 2 by 4, ..., 5 by 1. Choose an appropriate variable name extension for the new variables.

### Clipboard

It is possible to manipulate your data in a spreadsheet (e.g., Excel or Google sheets) and copy-and-paste the data back into Radiant. If you don't have the original data in a spreadsheet already use the clipboard feature in _Workspace > Datasets_ so you can paste it into the spreadsheet or click the download icon on the top right of your screen in the _Workspace > View_ tab. Apply your transformations in the spreadsheet program and then copy the new variable(s), with a header label, to the clipboard (i.e., CTRL-C on windows and CMD-C on mac). Select `Clipboard` from the `Transformation type` drop-down and paste the new data into the `Paste from spreadsheet` box. It is key that new variable(s) have the same number of observations as the data in Radiant. To add the new variables to the data click `Store`.

> **Note:** Using the clipboard feature for data transformation is discouraged because it is not reproducible.

### Normalize

Choose `Normalize` from the `Transformation type` drop-down to standardize one or more variables. For example, in the diamonds data we may want to express price of a diamond per-carat. Select `carat` as the normalizing variable and `price` in the `Select variable(s)` box. You will see summary statistics for the new variable (e.g., `price_carat`) in the main panel. Store changes by clicking the `Store` button.


### Recode

To use the recode feature select the variable you want to change and choose `Recode` from the `Transformation type` drop-down. Provide one or more recode commands, separated by a `;`, and press return to see the newly created variable. Note that you can specify the names for the recoded variable in the `Recoded variable name` input box (press return to submit changes). Finally, click `Store` to add the new variable to the data. Some examples are given below.

1. Values below 20 are set to 'Low' and all others to 'High'

	lo:20 = 'Low'; else = 'High'

2. Values above 20 are set to 'High' and all others to 'Low'

	20:hi = 'High'; else = 'Low'

2. Values 1 through 12 are set to 'A', 13:24 to 'B', and the remainder to 'C'

	1:12 = 'A'; 13:24 = 'B'; else = 'C'

3. Collapse age categories for a cross-tab analysis. In the example below '<25' and '25-34' are recoded to '<35', '35-44' and '35-44' are recoded to '35-54', and '55-64' and '>64' are recoded to '>54'

	'<25' = '<35'; '25-34' = '<35'; '35-44' = '35-54'; '45-54' = '35-54'; '55-64' = '>54'; '>64' = '>54'

4. To exclude a particular value (e.g., an outlier in the data) for subsequent analyses we can recode it to a missing value. For example, if we want to remove the maximum value from a variable called `FreqMut` that is equal to 102 we would (1) select the variable `FreqMut` in the `Select variable(s)` box and enter the command below in the `Recode` box. Press `return` and `Store` to add the recoded variable to the data

	102 = NA

5. To recode specific numeric values (e.g., carat) to a new value (1) select the variable `carat` in the `Select variable(s)` box and enter the command below in the `Recode` box to set the value for carat to 2 in all rows where carat is currently larger than or equal to 2. Press `return` and `Store` to add the recoded variable to the data

	2:hi = 2

**Note:** Never use a `=` symbol in a label when using the recode function (e.g., 50:hi = '>= 50') as this will cause an error.

### Rename

Choose `Rename` from the `Transformation type` drop-down, select one or more variables, and enter new names for them in the rename box shown. Separate each name by a `,`. Press return to see the variables with their new names on screen and press `Store` to alter the variable names in the original data.

### Replace

Choose `Replace` from the `Transformation type` drop-down if you want to replace existing variables in the data with new ones created using, for example, Create, Transform, Clipboard, etc.. Select one or more variables to overwrite and the same number of replacement variables. Press `Store` to alter the data.

### Clipboard

It is possible to manipulate your data in a spreadsheet (e.g., Excel or Google sheets) and copy-and-paste the data back into bioCancer. If you don't have the original data in a spreadsheet already use the clipboard feature in _Workspace > Datasets_ so you can paste it into the spreadsheet or click the download icon on the top right of your screen in the _Workspace > View_ tab. Apply your transformations in the spreadsheet program and then copy the new variable(s), with a header label, to the clipboard (i.e., CTRL-C on windows and CMD-C on mac). Select `Clipboard` from the `Transformation type` drop-down and paste the new data into the `Paste from spreadsheet` box. It is key that new variable(s) have the same number of observations as the data in bioCancer. To add the new variables to the data click `Store`.

> **Note:** Using the clipboard feature for data transformation is discouraged because it is not reproducible.

### Normalize

Choose `Normalize` from the `Transformation type` drop-down to standardize one or more variables. For example, in the epiGenomics data we may want to express mRNA of a Genes per-FreqMut. Select `FreqMut` as the normalizing variable and `mRNA` in the `Select variable(s)` box. You will see summary statistics for the new variable (e.g., `mRNA_FreqMut`) in the main panel. Store changes by clicking the `Store` button.

### Reorder or remove levels

If a (single) variable of type `factor` is selected in `Select variable(s)`, choose `Reorder/Remove levels` from the `Transformation type` drop-down to reorder and/or remove levels. Drag-and-drop levels to reorder them or click the $\times$ to remove them. Press `Store` to commit the changes. To temporarily exclude levels from the data use the `Filter` box (see the help file linked in the `Data > View` tab).


### Reorder or remove columns

Choose `Reorder/Remove columns` from the `Transformation type` drop-down. Drag-and-drop variables to reorder them in the data. To remove a variable click the $\times$ next to the label. Press `Store` to commit the changes.

### Remove missing values

Choose `Remove missing` from the `Transformation type` drop-down to eliminate rows with one or more missing values. If all variables are selected a row with a missing values in **any** column will be removed. If one or more variables are selected only those rows will be removed with missing values for the selected variables. Press `Store` to change the data. If missing values were present you will see the number of observations in the data summary change (i.e., the value of _n_ changes).

### Remove duplicates

It is common to have one or more variables in a dataset that **should** have only unique values (i.e., no duplicates). Customers id's, for example, should be unique unless the dataset contains multiple orders for the same customer. In that case the combination of customer id **and** order id should be unique. To remove duplicate select one or more variables to determine _uniqueness_. Choose `Remove duplicates` from the `Transformation type` drop-down and check how the summary statistics change. Press `Store` to change the data. If there are duplicate rows you will see the number of observations in the data summary change (i.e., the value of _n_ and _n\_distinct_ will change).

### Show duplicates


If there are duplicates in the data use `Show duplicates` to get a better sense for the data points that have the same value in multiple rows. If you want to explore duplicates using the _View_ tab make sure to `Store` them in a different dataset (i.e., make sure **not** to overwrite the data you are working on). If you choose to show duplicates based on all columns in the data only one of the duplicate rows will be shown. These rows are **exactly** the same so showing 2 or 3 isn't helpful. If, however, we look for duplicates based on a subset of the available variables Radiant will generate a dataset with **all** rows that are deemed similar.

## Training variable

To create a variable that can be used to randomly filter a dataset for analysis (or training) and holdout, select `Training variable` from the `Transformation type` dropdown. Specify either the number of observations to use for training (i.e., `Size` > 1) or a proportion of observations to select (i.e., `Size` > 1). The new variable will have a value "1" for training and "0" holdout.

## Holdout sample

To create a holdout sample based on (the reverse of) a filter select `Holdout sample` from the `Transformation type` dropdown. By default the opposite of the active filter is used. For example, is analysis is conducted on all observations where `data < "2015-1-1"` then the holdout sample will be based on the filter `data >= "2015-1-1"` if the `Reverse filter` box is checked.

> Genes / Diseases / Pathways Classification and clustering

### Classification
The classifier uses `geNetClassifier` methods [1] to classify genes by disease based only on gene expression (mRNA). The approach is implemented in an R package, named [geNetClassifier](http://bioconductor.org/packages/release/bioc/html/geNetClassifier.html), available as an open access tool in [Bioconductor](http://bioconductor.org/).
All proccess are resumed into 5 steps:
* Select Studies
* get sample size by  checking `Sampling` 
* Set the sample size and the posterior probability
* Run classifier by checking `Classification`

The ranking is built by ordering the genes decreasingly by their pos- terior probability for each study (class). Each gene is assigned to a class in which has the best ranking. As a result of this process, even if a gene is found associated to several classes during the expression analysis, each gene can only be on the ranking of one class [1]. 
The resulting output is a table (Table 1) that associates genes to study and displays `PostProb` and gene expression sign `exprsUpDw`.  The `exprsMeanDiff` value is the expression difference between the mean for each gene in the given class and the mean in the closest class.

**Table1: Ranking Genes by Study**
![Classifier table](figures/Classifier_Table.png)

### Plot Clusters

#### Gene Diseases Association
`GeneList/Diseases` predicts Wich disease are involving your GeneList. It uses annotations from [DisGeNET](http://www.disgenet.org/web/DisGeNET/menu;jsessionid=1bxru0uf4yelm16ipuhie2qhij) [2] and Methods from [clusterProfiler](http://bioconductor.org/packages/release/bioc/html/clusterProfiler.html) package [3].  

The `GeneList/Diseases` association uses gene list as input. The assess of this prediction is based on two parameters:
* The number of genes that are involving in the disease (x-axis)
* The P-value of this association (color). 
In the following example,  there are two annotation related to Breast cancer which  involve more than 130 genes and has small P-Value.

**Figure 1: Genes / Diseases Association**
![Plot_enrich](figures/Plot_enrich.png)

The `Diseases Onthology` uses genes/Study groups computed by `Classifier` (Table 1).
The dotplot position indicates wish Diseases are annotated for genes/study [4].
The dot size indicates the ratio of genes involved in the disease for the same genes groups (lihc_tcga has 2/3 genes involved for the 4 disease). The color indicates the P-Value.

**Figure 2: Diseases Onthology**
![DO](figures/compareClusterDO.png) 

The same process is possible with Gene Onthology (GO) and KEGG.

**Figure 3: GO Pathway Enrishment**
![GO](figures/compareClusterGO.png) 

**Figure 4: KEGG Pathway Enrishment **
![KEGG](figures/compareClusterKEGG.png) 


#### References
[1] Aibar S, Fontanillo C, Droste C, Roson-Burgo B, Campos-Laborie F, Hernandez-Rivas J and De Las Rivas J (2015). “Analyse multiple disease subtypes and build associated gene networks using genome-wide expression profiles.” BMC Genomics, 16(Suppl 5:S3). http://dx.doi.org/10.1186/1471-2164-16-S5-S3.

[2] Piñero, J., Queralt-Rosinach, N., Bravo, À., Deu-Pons, J., Bauer-Mehren, A., Baron, M., Ferran Sanz, and Furlong, L. I. (2015). DisGeNET: a discovery platform for the dynamical exploration of human diseases and their genes. Database: The Journal of Biological Databases and Curation, 2015, bav028. http://doi.org/10.1093/database/bav028

[3] Yu G, Wang L, Han Y and He Q (2012). “clusterProfiler: an R package for comparing biological themes among gene clusters.” OMICS: A Journal of Integrative Biology, 16(5), pp. 284-287. http://dx.doi.org/10.1089/omi.2011.0118. 

[4] Yu G, Wang L, Yan G and He Q (2015). “DOSE: an R/Bioconductor package for Disease Ontology Semantic and Enrichment analysis.” Bioinformatics, 31(4), pp. 608-609. http://dx.doi.org/10.1093/bioinformatics/btu684, http://bioinformatics.oxfordjournals.org/content/31/4/608. 

> Save, reset, or quit

This page provides another option to save the state of the app to disk. See the help file for the Data > Manage page for more details. To reset the app to a _clean_ state press the `Reset` button. Finally, to cleanly exit from Radiant click the `Quit` button.

> Show multi-Omics Data in Circular Layout

The world `Circomics` comes from the association between `Circos` and `Omics`.

[Circos](http://circos.ca/) is a package for visualizing data and information with circular layouts. User can visualize multiple matrices of [Omics](https://en.wikipedia.org/wiki/Omics) data at the same time and makes easy the exploring of relationships between dimensions using coloring sectors.

This function uses [CoffeeWheel](https://github.com/armish/coffeewheel) package developped by Dr. Arman Aksoy.

#### Studies in Wheel
User needs to:
* Choice in which Studies is interested.
* Visualize the availability of dimensions by checking `Availability`. 
+ The output is a table with Yes/No availability.
* Load Omics data for selected Studies by checking `Load`. The output is a list of loaded dimensions for selected Studies.

When Profiles Data are loaded, the button `Load Profiles in Datasets` appears. It uploads all Profiles Data to `Processing` panel for more exploring or analysis.

#### Availability 
`Availability` checkbox checks existing genetic profiles for each selected study. Tis function displays result in table.

![Availibility](figures/Circomics_Availibility.png)

#### (Push) Load Profiles data in Datasets (to Processing Panel)

For every dimension, the tables are merged by study and saved as: `xCNA`, `xMetHM27`, `xMetHM450`, `xmiRNA`, `xmRNA`, `xMut`, `xRPPA` in Datasets (Processing panel).

#### Pull User Data in circular Layout
Comparing experimental analysis to existing cancer genomics data could be used to predict the risk of cancer disorder using epigenmics profiles. 
User can import its experimental data from `Processing` panel and pull them to circular layout. In the following case, we pulled `xCNA` and `xMut` (User data) dataframes to circular layout with `luad_tcga_pub` and `blca_tcga_pub` studies. 
User can `remove` and `pull` him data for all existing dimension.
`Legend` checkbox displays the meaning of the color palette.

![Mutation Frequency of two cancers studies compared to User Data](figures/Circomics.png)


##### Format of user data
Mutation: A data frame with at less two column named `gene_symbol` and `mutation`.
All other dimensions: A data frame with:
first column named `id.` that has the study/cancer reference
the remain columns named by the `gene symbol` and have the value of the dimension for each study.

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/Reactome.R
\name{Node_obj_Met_ProfData}
\alias{Node_obj_Met_ProfData}
\title{Attribute gene Methylation to Nodes}
\usage{
Node_obj_Met_ProfData(list, type, threshold)
}
\arguments{
\item{list}{a list of data frame with methylation data}

\item{type}{HM450 or HM27}

\item{threshold}{the Rate cases (patients) that have a silencing genes by methylation}
}
\value{
a data frame with node shape attributes
}
\description{
Attribute gene Methylation to Nodes
}
\examples{
cgds <- cBioPortal(
hostname = "www.cbioportal.org",
protocol = "https",
api = "/api/v2/api-docs"
)
\dontrun{
getDataByGenes( api =  cgds,
studyId = "gbm_tcga_pub",
genes = c("NF1", "TP53", "ABL1"),
by = "hugoGeneSymbol",
molecularProfileIds = "gbm_tcga_pub_mrna"
)
}

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/Reactome.R
\name{Node_obj_mRNA_Classifier}
\alias{Node_obj_mRNA_Classifier}
\title{Atrribute genes expression to color nodes}
\usage{
Node_obj_mRNA_Classifier(geneList,genesclassdetails)
}
\arguments{
\item{geneList}{A gene list.}

\item{genesclassdetails}{A dataframe with genes classes and genes expression.}
}
\value{
A data frame with node color attributes
}
\description{
Atrribute genes expression to color nodes
}
\examples{
r_data <- new.env()
input <- NULL

r_data[["FreqIn"]] <- structure(list(Genes = c("ATM", "ATR", "BRCA1", "BRCA2", "CHEK1",
"CHEK2", "FANCF", "MDC1", "RAD51"), FreqSum = c(0.04, 0.05, 0.05,
 0.03, 0.05, 0.04, 0.03, 0.03, 0.02)), .Names = c("Genes", "FreqSum"),
 class = "data.frame", row.names = c(NA, -9L))

GenesClassDetails <- structure(list(Genes = c("FANCF", "MLH1", "MSH2", "ATR", "PARP1",
"CHEK2", "RAD51"), ranking = c(1L, 1L, 1L, 2L, 3L, 1L, 2L), class = c("brca_tcga",
"gbm_tcga", "lihc_tcga", "lihc_tcga", "lihc_tcga", "lusc_tcga",
"lusc_tcga"), postProb = c(1, 0.99, 1, 0.99, 0.99, 1,
0.98), exprsMeanDiff = c(180, 256, -373, -268,
-1482, 258, 143), exprsUpDw = c("UP", "UP", "DOWN",
"DOWN", "DOWN", "UP", "UP")), .Names = c("Genes", "ranking",
"class", "postProb", "exprsMeanDiff", "exprsUpDw"),
class = "data.frame", row.names = c(NA,-7L))
\dontrun{
GeneList <- whichGeneList("DNA_damage_Response")
nodeObj <- Node_obj_mRNA_Classifier(GeneList, GenesClassDetails)
}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/Enrich.R
\name{getSequensed_SampleSize}
\alias{getSequensed_SampleSize}
\title{get samples size of sequensed genes}
\usage{
getSequensed_SampleSize(StudiesID)
}
\arguments{
\item{StudiesID}{Studies ID as a vector}
}
\value{
dataframe with sample size for each selected study.
}
\description{
get samples size of sequensed genes
}
\examples{
\dontrun{
 sampleSize <- getSequensed_SampleSize(input$StudiesIDCircos)
}

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/Enrich.R
\name{reStrColorGene}
\alias{reStrColorGene}
\title{Restructure the list of color attributed to the genes in every dimenssion for every studies}
\usage{
reStrColorGene(df)
}
\arguments{
\item{df}{data frame with colors attributed to the genes}
}
\value{
Hierarchical color attribute: gene > color
}
\description{
Restructure the list of color attributed to the genes in every dimenssion for every studies
}
\examples{
cgds <- cBioPortal(
hostname = "www.cbioportal.org",
protocol = "https",
api = "/api/v2/api-docs"
)
\dontrun{
getDataByGenes( api =  cgds,
studyId = "gbm_tcga_pub",
genes = c("NF1", "TP53", "ABL1"),
by = "hugoGeneSymbol",
molecularProfileIds = "gbm_tcga_pub_mrna"
)
}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/phantomJS.R
\name{widgetThumbnail}
\alias{widgetThumbnail}
\title{Capture html output widget as .png in R}
\usage{
widgetThumbnail(p, thumbName, width = 1024, height = 1024)
}
\arguments{
\item{p}{is the html widget}

\item{thumbName}{is the name of the new png file}

\item{width}{1024}

\item{height}{1024}
}
\value{
3 files .html, .js and .png
}
\description{
Capture html output widget as .png in R
}
\examples{
How <- "runManually"
\dontrun{
# Load package
library(networkD3)
library(htmlwidgets)
# Create fake data
src <- c("A", "A", "A", "A", "B", "B", "C", "C", "D")
target <- c("B", "C", "D", "J", "E", "F", "G", "H", "I")
networkData <- data.frame(src, target)
# Plot
plot = simpleNetwork(networkData)
# Save html as png
widgetThumbnail(p = plot, thumbName = "plot", width = 1024, height = 1024)
}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/metabologram.R
\name{metabologramOutput}
\alias{metabologramOutput}
\title{Widget output function for use in Shiny}
\usage{
metabologramOutput(outputId, width = 600, height = 500)
}
\arguments{
\item{outputId}{id}

\item{width}{600}

\item{height}{600}
}
\value{
A circular plot with genetic profile in Shiny App.
}
\description{
Widget output function for use in Shiny
}
\examples{
\dontrun{
library(bioCancer)
bioCancer::metabologram(treeData = sampleMetabologramData)
}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/Reactome.R
\name{Node_obj_FreqIn}
\alias{Node_obj_FreqIn}
\title{Attribute interaction frequency to node size}
\usage{
Node_obj_FreqIn(geneList)
}
\arguments{
\item{geneList}{A list of gene symbol}
}
\value{
A data frame with node attributes
}
\description{
Attribute interaction frequency to node size
}
\examples{
r_data <- new.env()
r_data[["FreqIn"]] <- structure(list(Genes = c("ATM", "ATR", "BRCA1", "BRCA2", "CHEK1",
"CHEK2", "FANCF", "MDC1", "RAD51"), FreqSum = c(0.04, 0.05, 0.05,
 0.03, 0.05, 0.04, 0.03, 0.03, 0.02)), .Names = c("Genes", "FreqSum"),
 class = "data.frame", row.names = c(NA, -9L))
 \dontrun{
GeneList <- whichGeneList("DNA_damage_Response")
nodeObj <- Node_obj_FreqIn(GeneList)
}

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/bioCancer.R
\docType{data}
\name{epiGenomics}
\alias{epiGenomics}
\title{Default dataset of bioCancer}
\format{
An object of class \code{data.frame} with 48 rows and 7 columns.
}
\usage{
epiGenomics
}
\description{
Default dataset of bioCancer
}
\author{
Karim Mezhoud \email{kmezhoud@gmail.com}
}
\keyword{datasets}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/bioCancer.R
\docType{data}
\name{user_MetHM27}
\alias{user_MetHM27}
\title{Example of Methylation HM27 dataset}
\format{
An object of class \code{data.frame} with 600 rows and 13 columns.
}
\usage{
user_MetHM27
}
\description{
Example of Methylation HM27 dataset
}
\author{
Karim Mezhoud \email{kmezhoud@gmail.com}
}
\keyword{datasets}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/AnnotationFuncs.R
\name{pickGO}
\alias{pickGO}
\title{Cleans up result from org.Xx.egGO and returns specific GO identifiers}
\usage{
pickGO(l, evidence = NA, category = NA)
}
\arguments{
\item{l}{Character vector, or list of GO identifiers.}

\item{evidence}{Character vector, filters on which kind of evidence to return; for a larger list see \code{\link{getEvidenceCodes}}. \\*
 Evidence codes may be: \code{c('IMP','IGI','IPI','ISS','IDA','IEP','IEA','TAS','NAS','ND','IC')}. \\*
Leave as \code{NA} to ignore filtering on this part.}

\item{category}{Character vector, filters on which ontology to return: biological process (BP), cellular component (CC), or molecular function (MF). \\*
Leave as \code{NA} to ignore filtering on this part.}
}
\value{
List with only the picked elements.
}
\description{
Cleans up result from org.Xx.egGO and returns GO identifier for  either
biological process (BP), cellular component (CC), or molecular function (MF).
Can be used on list of GOs from \code{\link{translate}}, or a single list of GOs from an annotation package.
May reduce list, if the (sub)list does not contain the chosen class!
}
\examples{
library(org.Bt.eg.db)
genes <- c(280705, 280706, 100327208)
translate(genes, org.Bt.egSYMBOL)

symbols <- c("SERPINA1","KERA","CD5")
refseq <- translate(symbols, from=org.Bt.egSYMBOL2EG, to=org.Bt.egREFSEQ)
# Pick the proteins:
pickRefSeq(refseq, priorities=c('NP','XP'), reduce='all')

# If you wanted do do some further mapping on the result from
# translate, simply use lapply.

library(GO.db)
GO <- translate(genes, org.Bt.egGO)
# Get all biological processes:
\dontrun{
pickGO(GO, category='BP')
 # $`280705`
 # [1] "GO:0006826" "GO:0006879"
 # $`280706`
# [1] "GO:0006590" "GO:0007165" "GO:0042446"
# Get all ontologies with experimental evidence:
pickGO(GO, evidence=c('IMP','IGI','IPI','ISS','IDA','IEP','IEA'))
 # $`280705`
 # [1] "GO:0006826" "GO:0006879" "GO:0005615" "GO:0008199"
 # $`280706`
 # [1] "GO:0006590" "GO:0007165" "GO:0042446" "GO:0005615" "GO:0005179" "GO:0042393"
}
}
\seealso{
\code{\link{pickRefSeq}}, \code{\link{getEvidenceCodes}}, \code{\link{translate}}
}
\author{
Stefan McKinnon Edwards \email{stefan.hoj-edwards@agrsci.dk}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/coffeewheel.R
\name{coffeewheelOutput}
\alias{coffeewheelOutput}
\title{Widget output function for use in Shiny}
\usage{
coffeewheelOutput(outputId, width=700, height=700)
}
\arguments{
\item{outputId}{id}

\item{width}{700}

\item{height}{700}
}
\value{
A circular layout with genetic profile in Shiny App.
}
\description{
Widget output function for use in Shiny
}
\examples{
How <- "runManually"
\dontrun{
coffeewheel(treeData = sampleWheelData)
}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/AnnotationFuncs.R
\name{translate}
\alias{translate}
\title{Translate between different identifiers}
\usage{
translate(
  values,
  from,
  to = NULL,
  reduce = c("all", "first", "last"),
  return.list = TRUE,
  remove.missing = TRUE,
  simplify = FALSE,
  ...
)
}
\arguments{
\item{values}{Vector of annotations that needs translation. Coerced to character vector.}

\item{from}{Type of annotation \code{values} are given in. NB! take care in the
orientation of the package, ie. if you have RefSeq annotations, use
\code{org.Bt.egREFSEQ2EG} or (in some cases) \code{revmap(org.Bt.egREFSEQ)}.}

\item{to}{Desired goal, eg. \code{org.Bt.egENSEMBLPROT}. If \code{NULL} (default), goal
if the packages primary annotation (eg. entrez gene for org.Bt.eg.db).
Throws a warning if the organisms in \code{from} and \code{to} are not the same.}

\item{reduce}{Reducing method, either return all annotations (one-to-many relation)
or the first or last found annotation. The reducing step is applied
after translating to the goal:
\code{all}: returns all annotations
\code{first} or \code{last}: choose first or last of arbitrarily ordered list.}

\item{return.list}{Logical, when \code{TRUE}, returns the translation as a list where names}

\item{remove.missing}{Logical, whether to remove non-translated values, defaults \code{TRUE}.}

\item{simplify}{Logical, unlists the result. Defaults to FALSE. Usefull when using \code{translate} in
a \code{lapply} or \code{sapply}.}

\item{...}{Additional arguments sent to \code{\link{pickGO}} if \code{from} returns GO set.}
}
\value{
List; names of elements are \code{values} and the elements are the translated elements,
       or \code{NULL} if not translatable with \code{remove.missing = TRUE}.
}
\description{
Function for translating from one annotation to another, eg. from RefSeq to
Ensemble.  This function takes a vector of annotation values and translates
first to the primary annotation in the Biocore Data Team package (ie. entrez gene identifier for org.Bt.eg.db)
and then to the desired product, while removing non-translated annotations
and optionally reducing the result so there is only a one-to-one relation.
}
\details{
If you want to do some further mapping on the result, you will have to use
either \code{unlist} og \code{lapply}, where the first returns all the end-products
of the first mapping, returning a new list, and the latter produces a list-within-list.

If \code{from} returns GO identifiers (e.g. \code{from = org.Bt.egGO}), then the
returned resultset is more complex and consists of several layers of lists instead of
the usual list of character vectors. If \code{to} has also been specified, the GO IDs
must be extracted (internally) and you have the option of filtering for evidence and category at this point.
See \code{\link{pickGO}}.
}
\note{
Requires user to deliver the annotation packages such as org.Bt.egREFSEQ.
}
\examples{
library(org.Bt.eg.db)
genes <- c(280705, 280706, 100327208)
translate(genes, org.Bt.egSYMBOL)

symbols <- c("SERPINA1","KERA","CD5")
refseq <- translate(symbols, from=org.Bt.egSYMBOL2EG, to=org.Bt.egREFSEQ)
# Pick the proteins:
pickRefSeq(refseq, priorities=c('NP','XP'), reduce='all')

# If you wanted do do some further mapping on the result from
# translate, simply use lapply.

library(GO.db)
GO <- translate(genes, org.Bt.egGO)
}
\seealso{
\code{\link{pickRefSeq}}, \code{\link{pickGO}}
}
\author{
Stefan McKinnon Edwards \email{stefan.hoj-edwards@agrsci.dk}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/AnnotationFuncs.R
\name{.pickRef}
\alias{.pickRef}
\title{Secret function that does the magic for pickRefSeq.}
\usage{
.pickRef(l, priorities, reduce = c("all", "first", "last"))
}
\arguments{
\item{l}{List.}

\item{priorities}{How to prioritize.}

\item{reduce}{How to reduce.}
}
\value{
List.
}
\description{
Do not use it, use \code{\link{pickRefSeq}}!
}
\note{
Hey, you found a secret function! Keep it that way!
}
\seealso{
\code{\link{pickRefSeq}}
}
\author{
Stefan McKinnon Edwards \email{stefan.hoj-edwards@agrsci.dk}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/Reactome.R
\name{Mutation_obj}
\alias{Mutation_obj}
\title{Atribute mutation frequency to nodes}
\usage{
Mutation_obj(list,FreqMutThreshold, geneListLabel)
}
\arguments{
\item{list}{A list of data frame with mutation data. Each data frame to study}

\item{FreqMutThreshold}{threshold Rate of cases (patients) having mutation (0-1).}

\item{geneListLabel}{file name of geneList examples: "73"}
}
\value{
A dat frame with mutation frequency. Ech column corresponds to a study.
}
\description{
Atribute mutation frequency to nodes
}
\examples{
cgds <- cBioPortal(
hostname = "www.cbioportal.org",
protocol = "https",
api = "/api/v2/api-docs"
)
\dontrun{
getDataByGenes( api =  cgds,
studyId = "gbm_tcga_pub",
genes = c("NF1", "TP53", "ABL1"),
by = "hugoGeneSymbol",
molecularProfileIds = "gbm_tcga_pub_mrna"
)
}

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/dyNetwork.R
\name{Node_df_FreqIn}
\alias{Node_df_FreqIn}
\title{Attributes size to Nodes depending on number of interaction}
\usage{
Node_df_FreqIn(genelist, freqIn)
}
\arguments{
\item{genelist}{a vector of genes}

\item{freqIn}{dataframe with Node interaction frequencies}
}
\value{
A data frame with nodes size attributes
}
\description{
Attributes size to Nodes depending on number of interaction
}
\examples{
Node_df_FreqIn
\dontrun{
r_data <- new.env()
r_data[["FreqIn"]] <- structure(list(Genes = c("ATM", "ATR", "BRCA1", "BRCA2", "CHEK1",
"CHEK2", "FANCF", "MDC1", "RAD51"), FreqSum = c(0.04, 0.05, 0.05,
 0.03, 0.05, 0.04, 0.03, 0.03, 0.02)), .Names = c("Genes", "FreqSum"),
 class = "data.frame", row.names = c(NA, -9L))
GeneList <- whichGeneList("DNA_damage_Response")
node_df <- Node_df_FreqIn(GeneList, r_data$FreqIn)
}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/geNetClassifier.R
\name{getList_GenProfs}
\alias{getList_GenProfs}
\title{get list of genetic profiles of each selected study in Classifier panel}
\usage{
getList_GenProfs(checked_Studies)
}
\arguments{
\item{checked_Studies}{checked studies}
}
\value{
A list of genetics profiles
}
\description{
get list of genetic profiles of each selected study in Classifier panel
}
\examples{
cgds <- cBioPortal(
hostname = "www.cbioportal.org",
protocol = "https",
api = "/api/v2/api-docs"
)
\dontrun{
getDataByGenes( api =  cgds,
studyId = "gbm_tcga_pub",
genes = c("NF1", "TP53", "ABL1"),
by = "hugoGeneSymbol",
molecularProfileIds = "gbm_tcga_pub_mrna"
)
}

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/AnnotationFuncs.R
\name{getEvidenceCodes}
\alias{getEvidenceCodes}
\title{Returns GO evidence codes.}
\usage{
getEvidenceCodes()
}
\value{
Matrix of two columns, first column with codes, second column with description of codes.
}
\description{
Returns GO evidence codes.
}
\examples{
getEvidenceCodes()
}
\references{
\code{?org.Bt.egGO}
}
\seealso{
\code{\link{pickGO}}
}
\author{
Stefan McKinnon Edwards \email{stefan.hoj-edwards@agrsci.dk}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/coffeewheel.R
\name{renderCoffeewheel}
\alias{renderCoffeewheel}
\title{Widget render function for use in Shiny}
\usage{
renderCoffeewheel(expr,env =  parent.frame(),  quoted = FALSE)
}
\arguments{
\item{expr}{id}

\item{env}{parent.frame()}

\item{quoted}{FALSE}
}
\value{
A circular layout with genetic profile in Shiny App.
}
\description{
Widget render function for use in Shiny
}
\examples{
How <- "runManually"
\dontrun{
coffeewheel(treeData = sampleWheelData)
}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/phantomJS.R
\name{findPhantom}
\alias{findPhantom}
\title{Check if PhantomJS is installed. Similar to webshot}
\usage{
findPhantom()
}
\value{
Logic object
}
\description{
Check if PhantomJS is installed. Similar to webshot
}
\examples{
How <- "runManually"
\dontrun{
findPhantom()
}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/Portal.R
\name{displayTable}
\alias{displayTable}
\title{Display dataframe in table using DT package}
\usage{
displayTable(df)
}
\arguments{
\item{df}{a dataframe}
}
\value{
A table
}
\description{
Display dataframe in table using DT package
}
\examples{
cgds <- cBioPortal(
hostname = "www.cbioportal.org",
protocol = "https",
api = "/api/v2/api-docs"
)
\dontrun{
getDataByGenes( api =  cgds,
studyId = "gbm_tcga_pub",
genes = c("NF1", "TP53", "ABL1"),
by = "hugoGeneSymbol",
molecularProfileIds = "gbm_tcga_pub_mrna"
)
}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/AnnotationFuncs.R
\name{pickRefSeq}
\alias{pickRefSeq}
\title{Picks a prioritised RefSeq identifier from a list of identifiers}
\usage{
pickRefSeq(
  l,
  priorities = c("NP", "XP", "NM", "XM"),
  reduce = c("all", "first", "last")
)
}
\arguments{
\item{l}{Vector or list of RefSeqs accessions to pick from.  If list given, applies the
prioritation to each element in the list.}

\item{priorities}{Character vector of prioritised prefixes to pick by. Eg. \code{c("NP","NM")}
returns RefSeqs starting 'NP', and if none found, those starting
'NM'.  If no RefSeqs are found according to the priorities, Null
is returned, unless the last element in priorities is '*'.
Uses grepl, so see these for pattern matching.
Default: c('NP','XP','NM','XM')}

\item{reduce}{Reducing method, either return all annotations (one-to-many relation)
or the first or last found annotation.  The reducing step is applied
after translating to the goal:
\code{all}: returns all annotations
\code{first} or \code{last}: choose first or last of arbitrarily ordered list.}
}
\value{
If vector given, returns vector.  If list given, returns list without element where nothing could be picked.
}
\description{
When translating to RefSeq, typically multiple identifiers are returned,
referring to different types of products, such as genomic molecule, mature
mRNA or the protein, and they can be predicted, properties that can be read
from the prefix (\url{https://www.ncbi.nlm.nih.gov/refseq/}).  E.g. "XM_" is
predicted mRNA and "NP_" is a protein. Run \code{?org.Bt.egREFSEQ}.
}
\examples{
library(org.Bt.eg.db)
symbols <- c("SERPINA1","KERA","CD5")
refseq <- translate(symbols, from=org.Bt.egSYMBOL2EG, to=org.Bt.egREFSEQ)
mRNA <- pickRefSeq(refseq, priorities=c('NM','XM'))
proteins <- pickRefSeq(refseq, priorities=c('NP','XP'))
}
\author{
Stefan McKinnon Edwards \email{stefan.hoj-edwards@agrsci.dk}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/dyNetwork.R
\name{attriShape2Node}
\alias{attriShape2Node}
\title{Attributes shape to Nodes}
\usage{
attriShape2Node(gene, genelist)
}
\arguments{
\item{gene}{symbol "TP53"}

\item{genelist}{a vector of gene symbol}
}
\value{
A data frame with egdes attributes
}
\description{
Attributes shape to Nodes
}
\examples{
GeneList <- c("DKK3" , "NBN"  , "MYO6" , "TP53" , "PML"  , "IFI16" ,"BRCA1")
NodeShape <- attriShape2Gene("DKK3", GeneList)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/metabologram.R
\name{renderMetabologram}
\alias{renderMetabologram}
\title{Widget render function for use in Shiny}
\usage{
renderMetabologram(expr, env= parent.frame(),  quoted = FALSE)
}
\arguments{
\item{expr}{expression}

\item{env}{parent.frame()}

\item{quoted}{FALSE}
}
\value{
A circular plot with genetic profile in Shiny App.
}
\description{
Widget render function for use in Shiny
}
\examples{
\dontrun{
library(bioCancer)
bioCancer::metabologram(treeData = sampleMetabologramData)
}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/Reactome.R
\name{attriColorVector}
\alias{attriColorVector}
\title{Attribute color to a vector of numeric values}
\usage{
attriColorVector(Value, vector, colors=c(a,b,c),feet)
}
\arguments{
\item{Value}{numeric}

\item{vector}{A vector of numeric data}

\item{colors}{3 colors}

\item{feet}{An interval between two numeric value needed to change the color}
}
\value{
A vetor of colors
}
\description{
Attribute color to a vector of numeric values
}
\examples{
cgds <- cBioPortal(
hostname = "www.cbioportal.org",
protocol = "https",
api = "/api/v2/api-docs"
)
\dontrun{
getDataByGenes( api =  cgds,
studyId = "gbm_tcga_pub",
genes = c("NF1", "TP53", "ABL1"),
by = "hugoGeneSymbol",
molecularProfileIds = "gbm_tcga_pub_mrna"
)
}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/bioCancer.R
\docType{package}
\name{bioCancer}
\alias{-package}
\alias{bioCancer}
\title{Launch bioCancer with default browser}
\usage{
bioCancer()
}
\value{
web page of bioCancer Shiny App
}
\description{
The Main function to run bioCancer App
}
\examples{
ShinyApp <-  1
\dontrun{
bioCancer()
}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/Portal.R
\name{whichGeneList}
\alias{whichGeneList}
\title{Verify which gene list is selected}
\usage{
whichGeneList(geneListLabel)
}
\arguments{
\item{geneListLabel}{The label of GeneList. There are three cases:
 "Genes" user gene list,
 "Reactome_GeneList" GeneList plus genes from reactomeFI
"file name" from Examples}
}
\value{
Gene List label
}
\description{
Verify which gene list is selected
}
\examples{
How <- "runManually"
\dontrun{
whichGeneList("102")
}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/AnnotationFuncs.R
\name{.dbEscapeString}
\alias{.dbEscapeString}
\title{Private Escape string}
\usage{
.dbEscapeString(str, raise.error = TRUE)
}
\arguments{
\item{str}{String to test}

\item{raise.error}{Logical, whether to raise an error or not.}
}
\value{
Invisible logical
}
\description{
Does not escape strings, but raises an error if any character expect normal letters and underscores are found in the string.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/AnnotationFuncs.R
\name{removeNAs}
\alias{removeNAs}
\title{Removes entries equal \code{NA} from list or vector}
\usage{
removeNAs(l)
}
\arguments{
\item{l}{Vector or list.}
}
\description{
Removes entries equal \code{NA}, but not mixed entries containing, amongst others, \code{NA}.
Good for use after \code{\link{mapLists}} that might return entries equal \code{NA}.
}
\examples{
removeNAs(list('a'=NA, 'b'=c(NA, 'B'), 'c'='C'))
}
\author{
Stefan McKinnon Edwards \email{stefan.hoj-edwards@agrsci.dk}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/Enrich.R
\name{attriColorValue}
\alias{attriColorValue}
\title{Attribute Color to Value}
\usage{
attriColorValue(Value, df, colors=c(a,b,c),feet)
}
\arguments{
\item{Value}{integer}

\item{df}{data frame with numeric values}

\item{colors}{a vector of 5 colors}

\item{feet}{the interval between two successive colors in the palette (0.1)}
}
\value{
Hex Color Code
}
\description{
Attribute Color to Value
}
\examples{
cgds <- cBioPortal(
hostname = "www.cbioportal.org",
protocol = "https",
api = "/api/v2/api-docs"
)
\dontrun{
getDataByGenes( api =  cgds,
studyId = "gbm_tcga_pub",
genes = c("NF1", "TP53", "ABL1"),
by = "hugoGeneSymbol",
molecularProfileIds = "gbm_tcga_pub_mrna"
)
}

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/metabologram.R
\name{metabologram}
\alias{metabologram}
\title{Circular plot of hierarchital data of genetic profile.}
\usage{
metabologram(treeData,width=600,height=600,main="",showLegend=FALSE,
                     legendBreaks=NULL,
                     legendColors=NULL,
                      fontSize=12,
                     legendText="Legend")
}
\arguments{
\item{treeData}{A hierarchical tree data as in example}

\item{width}{600}

\item{height}{600}

\item{main}{Title}

\item{showLegend}{FALSE}

\item{legendBreaks}{NULL}

\item{legendColors}{NULL}

\item{fontSize}{12}

\item{legendText}{Legend}
}
\value{
A circular layout with genetic profile.
}
\description{
Circular plot of hierarchital data of genetic profile.
}
\examples{
How <- "runManually"
\dontrun{
 metabologram(treeData = sampleWheelData, width=600,
 height=600, main="title", showLegend = TRUE, fontSize = 10,
 legendBreaks=c("NA","Min","Negative", "0", "Positive", "Max"),
 legendColors=c("black","blue","cyan","white","yellow","red") ,
 legendText="Legend")
 }

}
\seealso{
https://github.com/armish/metabologram
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/switchButton.R
\name{switchButton}
\alias{switchButton}
\title{A function to change the Original checkbox of rshiny
into a nice true/false or on/off switch button
No javascript involved. Only CSS code.}
\usage{
switchButton(inputId, label = NULL, value = FALSE, col = "GB", type = "TF")
}
\arguments{
\item{inputId}{The input slot that will be used to access the value.}

\item{label}{Display label for the control, or NULL for no label.}

\item{value}{Initial value (TRUE or FALSE).}

\item{col}{Color set of the switch button. Choose between "GB" (Grey-Blue) and "RG" (Red-Green)}

\item{type}{Text type of the button. Choose between "TF" (TRUE - FALSE), "OO" (ON - OFF) or leave empty for no text.}
}
\description{
To be used with CSS script 'button.css' stored in a 'www' folder in your Shiny app folder
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/coffeewheel.R
\name{coffeewheel}
\alias{coffeewheel}
\title{This is an htmlwidgets-based visualization tool for hierarchical data.
It is zoomable, meaning that you can interact with the hierarchy and zoom in/out accordingly.}
\usage{
coffeewheel(treeData, width=600, height=600, main="", partitionAttribute="value")
}
\arguments{
\item{treeData}{A hierarchical tree data as in example}

\item{width}{600}

\item{height}{600}

\item{main}{Title}

\item{partitionAttribute}{"value"}
}
\value{
A circular layout with genetic profile.
}
\description{
This is an htmlwidgets-based visualization tool for hierarchical data.
It is zoomable, meaning that you can interact with the hierarchy and zoom in/out accordingly.
}
\examples{
How <- "runManually"
\dontrun{
 coffeewheel(treeData = sampleWheelData)
 }
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/AnnotationFuncs.R
\name{AnnotationFuncs}
\alias{AnnotationFuncs}
\title{Annotation translation functions}
\description{
\tabular{ll}{
Package:  \tab  AnnotationFuncs\cr
Type:  \tab  Package\cr
Version:  \tab  1.3.0\cr
Date:  \tab  2011-06-10\cr
License:  \tab  GPL-2\cr
LazyLoad:  \tab  yes\cr
}
}
\details{
Functions for handling translations between different identifieres using
the Biocore Data Team data-packages (e.g. \code{org.Bt.eg.db}).
Primary functions are \code{\link{translate}} for translating
and \code{\link{getOrthologs}} for efficient lookup of homologes
using the Inparanoid databases.
Other functions include functions for selecting Refseqs or Gene Ontologies (GO).
}
\examples{
library(org.Bt.eg.db)
gene.symbols <- c('DRBP1','SERPINA1','FAKE','BLABLA')
# Find entrez identifiers of these genes.
eg <- translate(gene.symbols, org.Bt.egSYMBOL2EG)
# Note that not all symbols were translated.

# Go directly to Refseq identifiers.
refseq <- translate(gene.symbols, from=org.Bt.egSYMBOL2EG, to=org.Bt.egREFSEQ)
# Pick the proteins:
 pickRefSeq(refseq, priorities=c('NP','XP'), reduce='all')
}
\references{
\url{https://www.iysik.com/index.php?page=annotation-functions}
}
\seealso{
\code{\link{translate}}, \code{\link{getOrthologs}}
}
\author{
Stefan McKinnon Edwards  \email{stefan.hoj-edwards@agrsci.dk}
}
\keyword{package}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/AnnotationFuncs.R
\name{getOrthologs}
\alias{getOrthologs}
\title{Performs quicker lookup for orthologs in homologe data packages}
\usage{
getOrthologs(
  values,
  mapping,
  genus,
  threshold = 1,
  pre.from = NULL,
  pre.to = NULL,
  post.from = NULL,
  post.to = NULL,
  ...
)
}
\arguments{
\item{values}{Vector, coerced to character vector, of values needed mapping by homology.}

\item{mapping}{Homology mapping object, such as \code{hom.Hs.inpBOSTA} or \code{revmap(hom.Hs.inpBOSTA)}.}

\item{genus}{Character vector. 5 character INPARANOID style genus name of the mapping object, e.g. 'BOSTA' for both \code{hom.Hs.inpBOSTA} and \code{revmap(hom.Hs.inpBOSTA)}.}

\item{threshold}{Numeric value between 0 and 1. Only clustered homologues with a parwise score above the threshold is included.
The native implementation has this set to 1.}

\item{pre.from}{Mapping object if \code{values} needs translation before mapping.
E.g. \code{values} are entrez and \code{hom.Hs.inpBOSTA} requires ENSEMBLPROT, \code{hom.Hs.inpAPIME} requires Refseq (?).
Arguments \code{from} and \code{to} are just like in \code{\link{translate}}.}

\item{pre.to}{Second part of translation before mapping.}

\item{post.from}{Translate the result from homology mapping to a desired id; just like in \code{\link{translate}}.}

\item{post.to}{Second part of translation after mapping.}

\item{...}{Additional arguments sent to \code{\link{translate}}.}
}
\value{
List. Names of list corresponds to \code{values}, except those that could not be mapped nor translated.
              Entries are character vectors.
}
\description{
Using the INPARANOID data packages such as \code{hom.Hs.inp.db} is very, very slow and can take up to 11 min (on this particular developers workstation).
This function introduces a new method that can do it in just 20 seconds (on the developers workstation).
In addition, it includes options for translating between different identifers both before and after the mapping.
}
\examples{
tmp <-1

}
\references{
\code{?hom.Hs.inp.db} - \url{https://inparanoidb.sbc.su.se/}

 Berglund, A.C., Sjolund, E., Ostlund, G., Sonnhammer, E.L.L. (2008)
 InParanoid 6: eukaryotic ortholog clusters with inparalogs
 \emph{Nucleic Acids Res.} \bold{36}:D263--266

 O'Brien, K.P., Maido, R., Sonnhammer, E.L.L (2005)
 Inparanoid: A Comprehensive Database of Eukaryotic Orthologs
 \emph{NAR} \bold{33}:D476--D480

 Remm, M., Storm, C.E.V, Sonnhammer, E.L.L (2001)
 Automatic clustering of orthologs and in-paralogs from pairwise species comparisons
 \emph{J. Mol. Biol.} \bold{314}:1041--1052
}
\seealso{
\code{\link{translate}}, \code{\link{.getTableName}}, \code{\link{mapLists}}
}
\author{
Stefan McKinnon Edwards \email{stefan.hoj-edwards@agrsci.dk}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/AnnotationFuncs.R
\name{mapLists}
\alias{mapLists}
\title{Replaces contents of list A with elements of list B}
\usage{
mapLists(A, B, removeNAs = TRUE)
}
\arguments{
\item{A}{List, elements are coerced to character for mapping to B.}

\item{B}{List.}

\item{removeNAs}{Boolean, whether to remove the \code{NA}s that occur because an element was not found in \code{B}.}
}
\value{
List.
}
\description{
Combines two lists, \code{A} and \code{B}, such that \code{names(A)} are preserved, mapping to the
values of \code{B}, using \code{names(B)} as look up.  Ie. replaces values in \code{A} with values
in \code{B}, using \code{names(B)} as look up for values in \code{A}.
Once more?  See examples.
\emph{NB!} None-mapped entries are returned as NA, but can be removed using \code{\link{removeNAs}}.
}
\examples{
A <- list('a1'='alpha','a2'='beta','a3'=c('gamma','delta'))
B <- list('alpha'='b1', 'gamma'=c('b2', 'b3'), 'delta'='b4')
mapLists(A, B)
}
\seealso{
\code{\link{removeNAs}}
}
\author{
Stefan McKinnon Edwards \email{stefan.hoj-edwards@agrsci.dk}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/getListProfData.R
\name{getListProfData}
\alias{getListProfData}
\title{get list of data frame with profiles data (CNA,mRNA, Methylation, Mutation...)}
\usage{
getListProfData(checked_Studies, geneListLabel)
}
\arguments{
\item{checked_Studies}{checked studies in corresponding panel (input$StudiesIDCircos, input$StudiesIDReactome).}

\item{geneListLabel}{The label of GeneList. There are three cases:
 "Genes" user gene list,
 "Reactome_GeneList" GeneList plus genes from reactomeFI
"file name" from Examples}
}
\value{
A LIST of profiles data (CNA, mRNA, Methylation, Mutation, miRNA, RPPA).
        Each dimension content a list of studies.
}
\description{
get list of data frame with profiles data (CNA,mRNA, Methylation, Mutation...)
}
\examples{
cgds <- cBioPortal(
hostname = "www.cbioportal.org",
protocol = "https",
api = "/api/v2/api-docs"
)
\dontrun{
getDataByGenes( api =  cgds,
studyId = "gbm_tcga_pub",
genes = c("NF1", "TP53", "ABL1"),
by = "hugoGeneSymbol",
molecularProfileIds = "gbm_tcga_pub_mrna"
)
}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/radiant.R
\name{returnTextAreaInput}
\alias{returnTextAreaInput}
\title{Return message when the filter formula is not correct (mRNA > 500)}
\usage{
returnTextAreaInput(inputId,
                          label= NULL,
                          rows = 2,
                         placeholder = NULL,
                         resize= "vertical",
                         value = "")
}
\arguments{
\item{inputId}{The ID of the object}

\item{label}{Text describes the box area}

\item{rows}{Number of rows}

\item{placeholder}{Error message if needed}

\item{resize}{orientation of text}

\item{value}{default text in the area box}
}
\value{
text message
}
\description{
Return message when the filter formula is not correct (mRNA > 500)
}
\examples{
ShinyApp <-  1
\dontrun{
returnTextAreaInput(inputId = "data-filter",
                    label = "Error message",
                    rows =  2,
                    placeholder = "Provide a filter (e.g., Genes == 'ATM') and press return",
                    resize = "vertical",
                    value="")
}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/dyNetwork.R
\name{Node_Diseases_obj}
\alias{Node_Diseases_obj}
\title{Attributes color and shape to Nodes of Diseases}
\usage{
Node_Diseases_obj(genesclassdetails)
}
\arguments{
\item{genesclassdetails}{a dataframe from geNetClassifier function}
}
\value{
A data frame with nodes Shapes and colors
}
\description{
Attributes color and shape to Nodes of Diseases
}
\examples{
GenesClassDetails <- structure(list(Genes = c("FANCF", "MLH1", "MSH2", "ATR", "PARP1",
"CHEK2", "RAD51"), ranking = c(1L, 1L, 1L, 2L, 3L, 1L, 2L), class = c("brca_tcga",
"gbm_tcga", "lihc_tcga", "lihc_tcga", "lihc_tcga", "lusc_tcga",
"lusc_tcga"), postProb = c(1, 0.99, 1, 0.99, 0.99, 1,
0.98), exprsMeanDiff = c(180, 256, -373, -268,
-1482, 258, 143), exprsUpDw = c("UP", "UP", "DOWN",
"DOWN", "DOWN", "UP", "UP")), .Names = c("Genes", "ranking",
"class", "postProb", "exprsMeanDiff", "exprsUpDw"),
class = "data.frame", row.names = c(NA,-7L))
Node_Diseases_df <- Node_Diseases_obj(genesclassdetails= GenesClassDetails)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/Reactome.R
\name{Studies_obj}
\alias{Studies_obj}
\title{get object for grViz. Link Studies to genes}
\usage{
Studies_obj(df)
}
\arguments{
\item{df}{data frame with gene classes}
}
\value{
grViz object. a data frame with Study attributes
}
\description{
get object for grViz. Link Studies to genes
}
\examples{
Studies_obj(data.frame("col1", "col2", "col3", "col4", "col5", "col6"))
\dontrun{
Genes ranking     class postProb exprsMeanDiff exprsUpDw
1 FANCF       1 brca_tcga  1.00000      179.9226        UP
2  MLH1       1  gbm_tcga  0.99703      256.3173        UP
}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/geNetClassifier.R
\name{getGenesClassification}
\alias{getGenesClassification}
\title{get genes classification}
\usage{
getGenesClassification(checked_Studies, GeneList,
 samplesize, threshold, listGenProfs, listCases)
}
\arguments{
\item{checked_Studies}{checked studies}

\item{GeneList}{gene list}

\item{samplesize}{sample size}

\item{threshold}{p-value threshold}

\item{listGenProfs}{list of genetic profiles}

\item{listCases}{list of cases}
}
\value{
A table with genes classed by study
}
\description{
get genes classification
}
\examples{
cgds <- cBioPortal(
hostname = "www.cbioportal.org",
protocol = "https",
api = "/api/v2/api-docs"
)
\dontrun{
getDataByGenes( api =  cgds,
studyId = "gbm_tcga_pub",
genes = c("NF1", "TP53", "ABL1"),
by = "hugoGeneSymbol",
molecularProfileIds = "gbm_tcga_pub_mrna"
)
}

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/AnnotationFuncs.R
\name{.getTableName}
\alias{.getTableName}
\title{Gets the table name from the INPARANOID style genus names.}
\usage{
.getTableName(genus)
}
\arguments{
\item{genus}{5 character INPARANOID genus name, such as "BOSTA", "HOMSA" or "MUSMU".}
}
\value{
Table name for genus.
}
\description{
Gets the table name from the INPARANOID style genus names.
}
\references{
\url{https://www.bioconductor.org/packages/release/bioc/html/AnnotationDbi.html}
}
\author{
Stefan McKinnon Edwards \email{stefanm.edwards@agrsci.dk}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/Reactome.R
\name{attriShape2Gene}
\alias{attriShape2Gene}
\title{Attribute shape to nodes}
\usage{
attriShape2Gene(gene, genelist)
}
\arguments{
\item{gene}{Gene symbol}

\item{genelist}{Gene list}
}
\value{
A character "BRCA1[shape = 'circle', "
}
\description{
Attribute shape to nodes
}
\examples{
how <- "runManually"
\dontrun{
GeneList <- whichGeneList("73")
attriShape2Gene("P53", GeneList)
attriShape2Gene("GML",GeneList)
}

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/Enrich.R
\name{checkDimensions}
\alias{checkDimensions}
\title{Check wich Cases and genetic profiles are available for selected study}
\usage{
checkDimensions(StudyID)
}
\arguments{
\item{StudyID}{Study reference using cBioPortal index}
}
\value{
A data frame with two column (Cases, Genetic profiles). Every row has a dimension (CNA, mRNA...).
The data frame is filled with yes/no response.
}
\description{
Check wich Cases and genetic profiles are available for selected study
}
\examples{
cgds <- cBioPortal(
hostname = "www.cbioportal.org",
protocol = "https",
api = "/api/v2/api-docs"
)
\dontrun{
getDataByGenes( api =  cgds,
studyId = "gbm_tcga_pub",
genes = c("NF1", "TP53", "ABL1"),
by = "hugoGeneSymbol",
molecularProfileIds = "gbm_tcga_pub_mrna"
)
}
}
